{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module IsabelleExport.Test(Rat, Num, Nat, Poly, test, test2) where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;

newtype Int = Int_of_integer Integer;

integer_of_int :: Int -> Integer;
integer_of_int (Int_of_integer k) = k;

equal_int :: Int -> Int -> Bool;
equal_int k l = integer_of_int k == integer_of_int l;

instance Eq Int where {
  a == b = equal_int a b;
};

newtype Rat = Frct (Int, Int);

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

equal_rat :: Rat -> Rat -> Bool;
equal_rat a b = quotient_of a == quotient_of b;

instance Eq Rat where {
  a == b = equal_rat a b;
};

times_int :: Int -> Int -> Int;
times_int k l = Int_of_integer (integer_of_int k * integer_of_int l);

data Num = One | Bit0 Num | Bit1 Num;

sgn_integer :: Integer -> Integer;
sgn_integer k =
  (if k == (0 :: Integer) then (0 :: Integer)
    else (if k < (0 :: Integer) then (-1 :: Integer) else (1 :: Integer)));

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if l == (0 :: Integer) then ((0 :: Integer), k)
           else ((apsnd . (\ a b -> a * b)) . sgn_integer) l
                  (if sgn_integer k == sgn_integer l then divMod (abs k) (abs l)
                    else let {
                           (r, s) = divMod (abs k) (abs l);
                         } in (if s == (0 :: Integer)
                                then (negate r, (0 :: Integer))
                                else (negate r - (1 :: Integer),
                                       Prelude.abs l - s)))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_int :: Int -> Int -> Int;
divide_int k l =
  Int_of_integer (divide_integer (integer_of_int k) (integer_of_int l));

uminus_int :: Int -> Int;
uminus_int k = Int_of_integer (negate (integer_of_int k));

zero_int :: Int;
zero_int = Int_of_integer (0 :: Integer);

less_int :: Int -> Int -> Bool;
less_int k l = integer_of_int k < integer_of_int l;

mod_integer :: Integer -> Integer -> Integer;
mod_integer k l = snd (divmod_integer k l);

mod_int :: Int -> Int -> Int;
mod_int k l =
  Int_of_integer (mod_integer (integer_of_int k) (integer_of_int l));

abs_int :: Int -> Int;
abs_int i = (if less_int i zero_int then uminus_int i else i);

gcd_int :: Int -> Int -> Int;
gcd_int (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (Prelude.gcd x y);
gcd_int k l =
  abs_int
    (if equal_int l zero_int then k
      else gcd_int l (mod_int (abs_int k) (abs_int l)));

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int zero_int (snd p)
    then let {
           a = gcd_int (fst p) (snd p);
         } in (divide_int (fst p) a, divide_int (snd p) a)
    else (if equal_int (snd p) zero_int
           then (zero_int, Int_of_integer (1 :: Integer))
           else let {
                  a = uminus_int (gcd_int (fst p) (snd p));
                } in (divide_int (fst p) a, divide_int (snd p) a)));

times_rat :: Rat -> Rat -> Rat;
times_rat p q = Frct (let {
                        a = quotient_of p;
                        (aa, c) = a;
                        b = quotient_of q;
                        (ba, d) = b;
                      } in normalize (times_int aa ba, times_int c d));

class Times a where {
  times :: a -> a -> a;
};

class (Times a) => Dvd a where {
};

instance Times Rat where {
  times = times_rat;
};

instance Dvd Rat where {
};

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

data Nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5
  | Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC
  | NibbleD | NibbleE | NibbleF;

string_of_digit :: Nat -> [Prelude.Char];
string_of_digit n =
  (if equal_nat n zero_nat then ['0']
    else (if equal_nat n one_nat then ['1']
           else (if equal_nat n (nat_of_integer (2 :: Integer)) then ['2']
                  else (if equal_nat n (nat_of_integer (3 :: Integer))
                         then ['3']
                         else (if equal_nat n (nat_of_integer (4 :: Integer))
                                then ['4']
                                else (if equal_nat n
   (nat_of_integer (5 :: Integer))
                                       then ['5']
                                       else (if equal_nat n
          (nat_of_integer (6 :: Integer))
      then ['6']
      else (if equal_nat n (nat_of_integer (7 :: Integer)) then ['7']
             else (if equal_nat n (nat_of_integer (8 :: Integer)) then ['8']
                    else ['9'])))))))));

mod_nat :: Nat -> Nat -> Nat;
mod_nat m n = Nat (mod_integer (integer_of_nat m) (integer_of_nat n));

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

shows_string :: [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
shows_string = (\ a b -> a ++ b);

showsp_nat :: Nat -> Nat -> [Prelude.Char] -> [Prelude.Char];
showsp_nat p n =
  (if less_nat n (nat_of_integer (10 :: Integer))
    then shows_string (string_of_digit n)
    else showsp_nat p (divide_nat n (nat_of_integer (10 :: Integer))) .
           shows_string
             (string_of_digit (mod_nat n (nat_of_integer (10 :: Integer)))));

nat :: Int -> Nat;
nat k = Nat (max (0 :: Integer) (integer_of_int k));

showsp_int :: Nat -> Int -> [Prelude.Char] -> [Prelude.Char];
showsp_int p i =
  (if less_int i zero_int
    then shows_string ['-'] . showsp_nat p (nat (uminus_int i))
    else showsp_nat p (nat i));

showsp_rat :: Nat -> Rat -> [Prelude.Char] -> [Prelude.Char];
showsp_rat p x =
  let {
    (d, n) = quotient_of x;
  } in (if equal_int n (Int_of_integer (1 :: Integer)) then showsp_int p d
         else (showsp_int p d . shows_string ['/']) . showsp_int p n);

shows_prec_rat :: Nat -> Rat -> [Prelude.Char] -> [Prelude.Char];
shows_prec_rat = showsp_rat;

shows_sep ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      ([Prelude.Char] -> [Prelude.Char]) ->
        [a] -> [Prelude.Char] -> [Prelude.Char];
shows_sep s sep [] = shows_string [];
shows_sep s sep [x] = s x;
shows_sep s sep (x : v : va) = (s x . sep) . shows_sep s sep (v : va);

shows_list_gen ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      [Prelude.Char] ->
        [Prelude.Char] ->
          [Prelude.Char] ->
            [Prelude.Char] -> [a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_gen showsx e l s r xs =
  (if null xs then shows_string e
    else (shows_string l . shows_sep showsx (shows_string s) xs) .
           shows_string r);

showsp_list ::
  forall a.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      Nat -> [a] -> [Prelude.Char] -> [Prelude.Char];
showsp_list s p xs =
  shows_list_gen (s zero_nat) ['[', ']'] ['['] [',', ' '] [']'] xs;

shows_list_rat :: [Rat] -> [Prelude.Char] -> [Prelude.Char];
shows_list_rat = showsp_list shows_prec_rat zero_nat;

class Showa a where {
  shows_prec :: Nat -> a -> [Prelude.Char] -> [Prelude.Char];
  shows_list :: [a] -> [Prelude.Char] -> [Prelude.Char];
};

instance Showa Rat where {
  shows_prec = shows_prec_rat;
  shows_list = shows_list_rat;
};

one_rat :: Rat;
one_rat = Frct (Int_of_integer (1 :: Integer), Int_of_integer (1 :: Integer));

class One a where {
  one :: a;
};

instance One Rat where {
  one = one_rat;
};

uminus_rat :: Rat -> Rat;
uminus_rat p = Frct (let {
                       a = quotient_of p;
                       (aa, b) = a;
                     } in (uminus_int aa, b));

minus_int :: Int -> Int -> Int;
minus_int k l = Int_of_integer (integer_of_int k - integer_of_int l);

minus_rat :: Rat -> Rat -> Rat;
minus_rat p q =
  Frct (let {
          a = quotient_of p;
          (aa, c) = a;
          b = quotient_of q;
          (ba, d) = b;
        } in normalize
               (minus_int (times_int aa d) (times_int ba c), times_int c d));

zero_rat :: Rat;
zero_rat = Frct (zero_int, Int_of_integer (1 :: Integer));

plus_int :: Int -> Int -> Int;
plus_int k l = Int_of_integer (integer_of_int k + integer_of_int l);

plus_rat :: Rat -> Rat -> Rat;
plus_rat p q =
  Frct (let {
          a = quotient_of p;
          (aa, c) = a;
          b = quotient_of q;
          (ba, d) = b;
        } in normalize
               (plus_int (times_int aa d) (times_int ba c), times_int c d));

class Uminus a where {
  uminus :: a -> a;
};

class Minus a where {
  minus :: a -> a -> a;
};

class Zero a where {
  zero :: a;
};

class Plus a where {
  plus :: a -> a -> a;
};

class (Plus a) => Semigroup_add a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Times a, Zero a) => Mult_zero a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class (One a, Times a) => Power a where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Ab_semigroup_mult a, Monoid_mult a, Dvd a) => Comm_monoid_mult a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Comm_semiring_1_cancel a) => Comm_semiring_1_cancel_crossproduct a where {
};

class (Semiring_0 a) => Semiring_no_zero_divisors a where {
};

class (Semiring_1 a,
        Semiring_no_zero_divisors a) => Semiring_1_no_zero_divisors a where {
};

class (Semiring_no_zero_divisors a) => Semiring_no_zero_divisors_cancel a where {
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (Ab_group_add a, Semiring_0_cancel a) => Ring a where {
};

class (Ring a,
        Semiring_no_zero_divisors_cancel a) => Ring_no_zero_divisors a where {
};

class (Group_add a, Numeral a) => Neg_numeral a where {
};

class (Neg_numeral a, Ring a, Semiring_1_cancel a) => Ring_1 a where {
};

class (Semiring_1_no_zero_divisors a, Ring_1 a,
        Ring_no_zero_divisors a) => Ring_1_no_zero_divisors a where {
};

class (Comm_semiring_0_cancel a, Ring a) => Comm_ring a where {
};

class (Comm_ring a, Comm_semiring_1_cancel a, Ring_1 a) => Comm_ring_1 a where {
};

class (Semiring_1_no_zero_divisors a,
        Comm_semiring_1_cancel a) => Semidom a where {
};

class (Comm_ring_1 a, Ring_1_no_zero_divisors a, Semidom a,
        Comm_semiring_1_cancel_crossproduct a) => Idom a where {
};

instance Plus Rat where {
  plus = plus_rat;
};

instance Semigroup_add Rat where {
};

instance Cancel_semigroup_add Rat where {
};

instance Ab_semigroup_add Rat where {
};

instance Minus Rat where {
  minus = minus_rat;
};

instance Cancel_ab_semigroup_add Rat where {
};

instance Zero Rat where {
  zero = zero_rat;
};

instance Monoid_add Rat where {
};

instance Comm_monoid_add Rat where {
};

instance Cancel_comm_monoid_add Rat where {
};

instance Mult_zero Rat where {
};

instance Semigroup_mult Rat where {
};

instance Semiring Rat where {
};

instance Semiring_0 Rat where {
};

instance Semiring_0_cancel Rat where {
};

instance Ab_semigroup_mult Rat where {
};

instance Comm_semiring Rat where {
};

instance Comm_semiring_0 Rat where {
};

instance Comm_semiring_0_cancel Rat where {
};

instance Power Rat where {
};

instance Monoid_mult Rat where {
};

instance Numeral Rat where {
};

instance Semiring_numeral Rat where {
};

instance Zero_neq_one Rat where {
};

instance Semiring_1 Rat where {
};

instance Semiring_1_cancel Rat where {
};

instance Comm_monoid_mult Rat where {
};

instance Comm_semiring_1 Rat where {
};

instance Comm_semiring_1_cancel Rat where {
};

instance Comm_semiring_1_cancel_crossproduct Rat where {
};

instance Semiring_no_zero_divisors Rat where {
};

instance Semiring_1_no_zero_divisors Rat where {
};

instance Semiring_no_zero_divisors_cancel Rat where {
};

instance Uminus Rat where {
  uminus = uminus_rat;
};

instance Group_add Rat where {
};

instance Ab_group_add Rat where {
};

instance Ring Rat where {
};

instance Ring_no_zero_divisors Rat where {
};

instance Neg_numeral Rat where {
};

instance Ring_1 Rat where {
};

instance Ring_1_no_zero_divisors Rat where {
};

instance Comm_ring Rat where {
};

instance Comm_ring_1 Rat where {
};

instance Semidom Rat where {
};

instance Idom Rat where {
};

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i zero_int then zero_int
    else (if less_int zero_int i then Int_of_integer (1 :: Integer)
           else uminus_int (Int_of_integer (1 :: Integer))));

inverse_rat :: Rat -> Rat;
inverse_rat p =
  Frct (let {
          a = quotient_of p;
          (aa, b) = a;
        } in (if equal_int aa zero_int
               then (zero_int, Int_of_integer (1 :: Integer))
               else (times_int (sgn_int aa) b, abs_int aa)));

divide_rat :: Rat -> Rat -> Rat;
divide_rat p q = Frct (let {
                         a = quotient_of p;
                         (aa, c) = a;
                         b = quotient_of q;
                         (ba, d) = b;
                       } in normalize (times_int aa d, times_int c ba));

class Divide a where {
  divide :: a -> a -> a;
};

class (Divide a) => Inverse a where {
  inverse :: a -> a;
};

class (Idom a) => Ufd a where {
};

class (Inverse a, Ring_1_no_zero_divisors a) => Division_ring a where {
};

class (Divide a, Semidom a,
        Semiring_no_zero_divisors_cancel a) => Semidom_divide a where {
};

class (Idom a, Semidom_divide a) => Idom_divide a where {
};

class (Division_ring a, Idom_divide a, Ufd a) => Field a where {
};

instance Ufd Rat where {
};

instance Divide Rat where {
  divide = divide_rat;
};

instance Inverse Rat where {
  inverse = inverse_rat;
};

instance Division_ring Rat where {
};

instance Semidom_divide Rat where {
};

instance Idom_divide Rat where {
};

instance Field Rat where {
};

shows_prec_nat :: Nat -> Nat -> [Prelude.Char] -> [Prelude.Char];
shows_prec_nat = showsp_nat;

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

show_factor :: Nat -> [Prelude.Char];
show_factor va =
  (if equal_nat va zero_nat then []
    else (if equal_nat (minus_nat va one_nat) zero_nat then ['x']
           else ['x', '^'] ++
                  shows_prec_nat zero_nat
                    (suc (suc (minus_nat (minus_nat va one_nat) one_nat))) []));

show_coeff_factor ::
  forall a. (One a, Eq a, Showa a) => a -> Nat -> [Prelude.Char];
show_coeff_factor c n =
  (if equal_nat n zero_nat then shows_prec zero_nat c []
    else (if c == one then show_factor n
           else shows_prec zero_nat c [] ++ show_factor n));

show_poly_main ::
  forall a. (One a, Zero a, Eq a, Showa a) => Nat -> [a] -> [Prelude.Char];
show_poly_main uu [] = ['0'];
show_poly_main n [c] = show_coeff_factor c n;
show_poly_main n (c : v : va) =
  (if c == zero then show_poly_main (suc n) (v : va)
    else show_coeff_factor c n ++
           [' ', '+', ' '] ++ show_poly_main (suc n) (v : va));

newtype Poly a = Poly [a];

coeffs :: forall a. (Zero a) => Poly a -> [a];
coeffs (Poly x) = x;

show_poly ::
  forall a. (One a, Zero a, Eq a, Showa a) => Poly a -> [Prelude.Char];
show_poly p = show_poly_main zero_nat (coeffs p);

showsp_poly ::
  forall a.
    (One a, Zero a, Eq a,
      Showa a) => Nat -> Poly a -> [Prelude.Char] -> [Prelude.Char];
showsp_poly p x = shows_string (show_poly x);

shows_prec_poly ::
  forall a.
    (One a, Zero a, Eq a,
      Showa a) => Nat -> Poly a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_poly p x = showsp_poly p x;

shows_list_poly ::
  forall a.
    (One a, Zero a, Eq a,
      Showa a) => [Poly a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_poly ps = showsp_list shows_prec_poly zero_nat ps;

instance (One a, Zero a, Eq a, Showa a) => Showa (Poly a) where {
  shows_prec = shows_prec_poly;
  shows_list = shows_list_poly;
};

data Ffield_ext a b =
  Ffield_ext (a -> a -> a) (a -> a -> a) (a -> a) (a -> a -> a) (a -> Nat -> a)
    (a -> a) (a -> a -> a) a a Int (Int -> a) (a -> Int) b;

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

last :: forall a. [a] -> a;
last (x : xs) = (if null xs then x else last xs);

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

hd :: forall a. [a] -> a;
hd (x21 : x22) = x21;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

cCons :: forall a. (Zero a, Eq a) => a -> [a] -> [a];
cCons x xs = (if null xs && x == zero then [] else x : xs);

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

nth_default :: forall a. a -> [a] -> Nat -> a;
nth_default dflt xs n = (if less_nat n (size_list xs) then nth xs n else dflt);

coeff :: forall a. (Zero a) => Poly a -> Nat -> a;
coeff p = nth_default zero (coeffs p);

monom :: forall a. (Zero a, Eq a) => a -> Nat -> Poly a;
monom a n = Poly (if a == zero then [] else replicate n zero ++ [a]);

pCons :: forall a. (Zero a, Eq a) => a -> Poly a -> Poly a;
pCons a p = Poly (cCons a (coeffs p));

smult :: forall a. (Eq a, Idom a) => a -> Poly a -> Poly a;
smult a p = Poly (if a == zero then [] else map (times a) (coeffs p));

degree :: forall a. (Zero a) => Poly a -> Nat;
degree p = minus_nat (size_list (coeffs p)) one_nat;

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat m n = (divide_nat m n, mod_nat m n);

showsp_prod ::
  forall a b.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      (Nat -> b -> [Prelude.Char] -> [Prelude.Char]) ->
        Nat -> (a, b) -> [Prelude.Char] -> [Prelude.Char];
showsp_prod s1 s2 p (x, y) =
  (((shows_string ['('] . s1 one_nat x) . shows_string [',', ' ']) .
    s2 one_nat y) .
    shows_string [')'];

shows_prec_prod ::
  forall a b.
    (Showa a, Showa b) => Nat -> (a, b) -> [Prelude.Char] -> [Prelude.Char];
shows_prec_prod = showsp_prod shows_prec shows_prec;

plus_coeffs :: forall a. (Comm_monoid_add a, Eq a) => [a] -> [a] -> [a];
plus_coeffs xs [] = xs;
plus_coeffs [] (v : va) = v : va;
plus_coeffs (x : xs) (y : ys) = cCons (plus x y) (plus_coeffs xs ys);

plus_poly :: forall a. (Comm_monoid_add a, Eq a) => Poly a -> Poly a -> Poly a;
plus_poly p q = Poly (plus_coeffs (coeffs p) (coeffs q));

numeral :: forall a. (Numeral a) => Num -> a;
numeral (Bit1 n) = let {
                     m = numeral n;
                   } in plus (plus m m) one;
numeral (Bit0 n) = let {
                     m = numeral n;
                   } in plus m m;
numeral One = one;

of_nat :: forall a. (Semiring_1 a) => Nat -> a;
of_nat n =
  (if equal_nat n zero_nat then zero
    else let {
           (m, q) = divmod_nat n (nat_of_integer (2 :: Integer));
           ma = times (numeral (Bit0 One)) (of_nat m);
         } in (if equal_nat q zero_nat then ma else plus ma one));

minusa :: forall a b. Ffield_ext a b -> a -> a -> a;
minusa
  (Ffield_ext plus minus uminus mult power inverse_f divide zero one
    characteristic of_int_f to_int_f more)
  = minus;

minus_poly_rev_f :: forall a. Ffield_ext a () -> [a] -> [a] -> [a];
minus_poly_rev_f f (x : xs) (y : ys) = minusa f x y : minus_poly_rev_f f xs ys;
minus_poly_rev_f f xs [] = xs;

zeroa :: forall a b. Ffield_ext a b -> a;
zeroa (Ffield_ext plus minus uminus mult power inverse_f divide zero one
        characteristic of_int_f to_int_f more)
  = zero;

cCons_f :: forall a. (Eq a) => Ffield_ext a () -> a -> [a] -> [a];
cCons_f f x xs = (if null xs && x == zeroa f then [] else x : xs);

mult :: forall a b. Ffield_ext a b -> a -> a -> a;
mult (Ffield_ext plus minus uminus mult power inverse_f divide zero one
       characteristic of_int_f to_int_f more)
  = mult;

divmod_poly_one_main_f ::
  forall a. (Eq a) => Ffield_ext a () -> [a] -> [a] -> [a] -> Nat -> ([a], [a]);
divmod_poly_one_main_f f q r d n =
  (if equal_nat n zero_nat then (q, r)
    else let {
           a = hd r;
           n1 = minus_nat n one_nat;
           qqq = cCons_f f a q;
           rr = tl (if a == zeroa f then r
                     else minus_poly_rev_f f r (map (mult f a) d));
         } in divmod_poly_one_main_f f qqq rr d n1);

degree_poly_f :: forall a. [a] -> Nat;
degree_poly_f pp = minus_nat (size_list pp) one_nat;

divmod_poly_one_f ::
  forall a. (Eq a) => Ffield_ext a () -> [a] -> [a] -> ([a], [a]);
divmod_poly_one_f f p q =
  let {
    dp = degree_poly_f p;
    dq = degree_poly_f q;
    (qu, re) =
      divmod_poly_one_main_f f [] (reverse p) (reverse q)
        (minus_nat (plus_nat one_nat dp) dq);
  } in (qu, reverse (dropWhile (\ a -> zeroa f == a) re));

list_to_poly :: forall a. (Comm_monoid_add a, Eq a) => [a] -> Poly a;
list_to_poly xs = Poly (reverse (dropWhile (\ a -> zero == a) (reverse xs)));

leading_coeff_f :: forall a. Ffield_ext a () -> [a] -> a;
leading_coeff_f f pp = (if null pp then zeroa f else last pp);

smult_poly_f :: forall a. (Eq a) => Ffield_ext a () -> a -> [a] -> [a];
smult_poly_f f a pp = (if a == zeroa f then [] else map (mult f a) pp);

inverse_f :: forall a b. Ffield_ext a b -> a -> a;
inverse_f
  (Ffield_ext plus minus uminus mult power inverse_f divide zero one
    characteristic of_int_f to_int_f more)
  = inverse_f;

power :: forall a. (Power a) => a -> Nat -> a;
power a n =
  (if equal_nat n zero_nat then one
    else times a (power a (minus_nat n one_nat)));

of_int :: forall a. (Ring_1 a) => Int -> a;
of_int k =
  (if equal_int k zero_int then zero
    else (if less_int k zero_int then uminus (of_int (uminus_int k))
           else let {
                  l = times (numeral (Bit0 One))
                        (of_int (divide_int k (Int_of_integer (2 :: Integer))));
                  j = mod_int k (Int_of_integer (2 :: Integer));
                } in (if equal_int j zero_int then l else plus l one)));

fieldRec :: forall a. (Field a) => Ffield_ext a ();
fieldRec =
  Ffield_ext plus minus uminus times power inverse divide zero one zero_int
    of_int (\ _ -> zero_int) ();

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

pdivmod_impl ::
  forall a. (Field a, Eq a) => Poly a -> Poly a -> (Poly a, Poly a);
pdivmod_impl p1 p2 =
  map_prod list_to_poly list_to_poly
    (if null (coeffs p2) then ([], coeffs p1)
      else let {
             lc = leading_coeff_f fieldRec (coeffs p2);
             ilc = inverse_f fieldRec lc;
             q = smult_poly_f fieldRec ilc (coeffs p2);
             a = divmod_poly_one_f fieldRec (coeffs p1) q;
             (qu, aa) = a;
           } in (smult_poly_f fieldRec ilc qu, aa));

test :: Integer -> [Prelude.Char];
test x =
  let {
    n = nat_of_integer x;
  } in shows_prec_prod zero_nat
         (pdivmod_impl (monom (of_nat n) n)
           (plus_poly
             (monom (of_nat (divide_nat n (nat_of_integer (2 :: Integer))))
               (divide_nat n (nat_of_integer (2 :: Integer))))
             (monom one_rat one_nat)))
         [];

is_zero :: forall a. (Zero a) => Poly a -> Bool;
is_zero p = null (coeffs p);

uminus_poly :: forall a. (Ab_group_add a) => Poly a -> Poly a;
uminus_poly p = Poly (map uminus (coeffs p));

minus_poly :: forall a. (Ab_group_add a, Eq a) => Poly a -> Poly a -> Poly a;
minus_poly p q = plus_poly p (uminus_poly q);

zero_poly :: forall a. (Zero a) => Poly a;
zero_poly = Poly [];

fold_coeffs :: forall a b. (Zero a) => (a -> b -> b) -> Poly a -> b -> b;
fold_coeffs f p = foldr f (coeffs p);

pdivmod :: forall a. (Field a, Eq a) => Poly a -> Poly a -> (Poly a, Poly a);
pdivmod p q =
  (if is_zero q then (zero_poly, p)
    else fold_coeffs
           (\ a (s, r) ->
             let {
               b = divide (coeff (pCons a r) (degree q)) (coeff q (degree q));
             } in (pCons b s, minus_poly (pCons a r) (smult b q)))
           p (zero_poly, zero_poly));

test2 :: Integer -> [Prelude.Char];
test2 x =
  let {
    n = nat_of_integer x;
  } in shows_prec_prod zero_nat
         (pdivmod (monom (of_nat n) n)
           (plus_poly
             (monom (of_nat (divide_nat n (nat_of_integer (2 :: Integer))))
               (divide_nat n (nat_of_integer (2 :: Integer))))
             (monom one_rat one_nat)))
         [];

}
