{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  Foo(Nat, Char, Lab, Xml, Xml_error, Input, Sum_bot, Proof, parse_cert_problem)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Uint;
import qualified Array;
import qualified IArray;
import qualified Uint32;
import qualified Data_Bits;

newtype Int = Int_of_integer Integer;

integer_of_int :: Int -> Integer;
integer_of_int (Int_of_integer k) = k;

equal_int :: Int -> Int -> Bool;
equal_int k l = integer_of_int k == integer_of_int l;

instance Eq Int where {
  a == b = equal_int a b;
};

times_int :: Int -> Int -> Int;
times_int k l = Int_of_integer (integer_of_int k * integer_of_int l);

class Times a where {
  times :: a -> a -> a;
};

class (Times a) => Dvd a where {
};

instance Times Int where {
  times = times_int;
};

instance Dvd Int where {
};

data Num = One | Bit0 Num | Bit1 Num;

one_int :: Int;
one_int = Int_of_integer (1 :: Integer);

class One a where {
  onea :: a;
};

instance One Int where {
  onea = one_int;
};

plus_int :: Int -> Int -> Int;
plus_int k l = Int_of_integer (integer_of_int k + integer_of_int l);

class Plus a where {
  plus :: a -> a -> a;
};

instance Plus Int where {
  plus = plus_int;
};

zero_int :: Int;
zero_int = Int_of_integer (0 :: Integer);

class Zero a where {
  zeroa :: a;
};

instance Zero Int where {
  zeroa = zero_int;
};

class (Plus a) => Semigroup_add a where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

instance Semigroup_add Int where {
};

instance Numeral Int where {
};

class (One a, Times a) => Power a where {
};

instance Power Int where {
};

less_eq_int :: Int -> Int -> Bool;
less_eq_int k l = integer_of_int k <= integer_of_int l;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

less_int :: Int -> Int -> Bool;
less_int k l = integer_of_int k < integer_of_int l;

instance Ord Int where {
  less_eq = less_eq_int;
  less = less_int;
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

instance Ab_semigroup_add Int where {
};

instance Semigroup_mult Int where {
};

instance Semiring Int where {
};

class (Ord a) => Quasi_order a where {
};

class (Quasi_order a) => Weak_order a where {
};

class (Ord a) => Preorder a where {
};

class (Preorder a, Weak_order a) => Order a where {
};

instance Quasi_order Int where {
};

instance Weak_order Int where {
};

instance Preorder Int where {
};

instance Order Int where {
};

class (Times a, Zero a) => Mult_zero a where {
};

instance Mult_zero Int where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

instance Monoid_add Int where {
};

instance Comm_monoid_add Int where {
};

instance Semiring_0 Int where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

instance Monoid_mult Int where {
};

instance Semiring_numeral Int where {
};

instance Zero_neq_one Int where {
};

instance Semiring_1 Int where {
};

ceq_int :: Maybe (Int -> Int -> Bool);
ceq_int = Just equal_int;

class Ceq a where {
  ceq :: Maybe (a -> a -> Bool);
};

instance Ceq Int where {
  ceq = ceq_int;
};

newtype Phantom a b = Phantom b;

data Set_impla = Set_Choose | Set_Collect | Set_DList | Set_RBT | Set_Monada;

set_impl_int :: Phantom Int Set_impla;
set_impl_int = Phantom Set_RBT;

class Set_impl a where {
  set_impl :: Phantom a Set_impla;
};

instance Set_impl Int where {
  set_impl = set_impl_int;
};

class (Order a) => Linorder a where {
};

instance Linorder Int where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

instance Ab_semigroup_mult Int where {
};

instance Comm_semiring Int where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

instance Comm_semiring_0 Int where {
};

class (Ab_semigroup_mult a, Monoid_mult a, Dvd a) => Comm_monoid_mult a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

instance Comm_monoid_mult Int where {
};

instance Comm_semiring_1 Int where {
};

data Ordera = Eqa | Lt | Gt;

comparator_of :: forall a. (Eq a, Linorder a) => a -> a -> Ordera;
comparator_of x y = (if less x y then Lt else (if x == y then Eqa else Gt));

compare_int :: Int -> Int -> Ordera;
compare_int = comparator_of;

ccompare_int :: Maybe (Int -> Int -> Ordera);
ccompare_int = Just compare_int;

class Ccompare a where {
  ccompare :: Maybe (a -> a -> Ordera);
};

instance Ccompare Int where {
  ccompare = ccompare_int;
};

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

instance Times Nat where {
  times = times_nat;
};

instance Dvd Nat where {
};

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

instance One Nat where {
  onea = one_nat;
};

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

instance Plus Nat where {
  plus = plus_nat;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

instance Zero Nat where {
  zeroa = zero_nat;
};

instance Semigroup_add Nat where {
};

instance Numeral Nat where {
};

instance Power Nat where {
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

class Minus a where {
  minus :: a -> a -> a;
};

instance Minus Nat where {
  minus = minus_nat;
};

sgn_integer :: Integer -> Integer;
sgn_integer k =
  (if k == (0 :: Integer) then (0 :: Integer)
    else (if k < (0 :: Integer) then (-1 :: Integer) else (1 :: Integer)));

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if l == (0 :: Integer) then ((0 :: Integer), k)
           else ((apsnd . (\ a b -> a * b)) . sgn_integer) l
                  (if sgn_integer k == sgn_integer l then divMod (abs k) (abs l)
                    else (case divMod (abs k) (abs l) of {
                           (r, s) ->
                             (if s == (0 :: Integer)
                               then (negate r, (0 :: Integer))
                               else (negate r - (1 :: Integer),
                                      Prelude.abs l - s));
                         }))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

class Divide a where {
  divide :: a -> a -> a;
};

instance Divide Nat where {
  divide = divide_nat;
};

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_nat :: Nat -> Nat -> Nat;
modulo_nat m n = Nat (modulo_integer (integer_of_nat m) (integer_of_nat n));

class (Divide a, Dvd a) => Modulo a where {
  modulo :: a -> a -> a;
};

instance Modulo Nat where {
  modulo = modulo_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

class (Semiring_0 a) => Semiring_no_zero_divisors a where {
};

class (Semiring_1 a,
        Semiring_no_zero_divisors a) => Semiring_1_no_zero_divisors a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Comm_semiring_1_cancel a,
        Semiring_1_no_zero_divisors a) => Semidom a where {
};

instance Ab_semigroup_add Nat where {
};

instance Monoid_add Nat where {
};

instance Comm_monoid_add Nat where {
};

instance Mult_zero Nat where {
};

instance Semigroup_mult Nat where {
};

instance Semiring Nat where {
};

instance Semiring_0 Nat where {
};

instance Semiring_no_zero_divisors Nat where {
};

instance Monoid_mult Nat where {
};

instance Semiring_numeral Nat where {
};

instance Zero_neq_one Nat where {
};

instance Semiring_1 Nat where {
};

instance Semiring_1_no_zero_divisors Nat where {
};

instance Cancel_semigroup_add Nat where {
};

instance Cancel_ab_semigroup_add Nat where {
};

instance Cancel_comm_monoid_add Nat where {
};

instance Semiring_0_cancel Nat where {
};

instance Ab_semigroup_mult Nat where {
};

instance Comm_semiring Nat where {
};

instance Comm_semiring_0 Nat where {
};

instance Comm_semiring_0_cancel Nat where {
};

instance Semiring_1_cancel Nat where {
};

instance Comm_monoid_mult Nat where {
};

instance Comm_semiring_1 Nat where {
};

instance Comm_semiring_1_cancel Nat where {
};

instance Semidom Nat where {
};

instance Quasi_order Nat where {
};

instance Weak_order Nat where {
};

instance Preorder Nat where {
};

instance Order Nat where {
};

instance Linorder Nat where {
};

compare_nat :: Nat -> Nat -> Ordera;
compare_nat = comparator_of;

class Compare a where {
  compare :: a -> a -> Ordera;
};

instance Compare Nat where {
  compare = compare_nat;
};

ceq_nat :: Maybe (Nat -> Nat -> Bool);
ceq_nat = Just equal_nat;

instance Ceq Nat where {
  ceq = ceq_nat;
};

set_impl_nat :: Phantom Nat Set_impla;
set_impl_nat = Phantom Set_RBT;

instance Set_impl Nat where {
  set_impl = set_impl_nat;
};

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

bit_cut_integer :: Integer -> (Integer, Bool);
bit_cut_integer k =
  (if k == (0 :: Integer) then ((0 :: Integer), False)
    else (case divMod (abs k) (abs (2 :: Integer)) of {
           (r, s) ->
             ((if (0 :: Integer) < k then r else negate r - s),
               s == (1 :: Integer));
         }));

data Char = Char Bool Bool Bool Bool Bool Bool Bool Bool;

char_of_integer :: Integer -> Char;
char_of_integer k =
  (case bit_cut_integer k of {
    (q0, b0) ->
      (case bit_cut_integer q0 of {
        (q1, b1) ->
          (case bit_cut_integer q1 of {
            (q2, b2) ->
              (case bit_cut_integer q2 of {
                (q3, b3) ->
                  (case bit_cut_integer q3 of {
                    (q4, b4) ->
                      (case bit_cut_integer q4 of {
                        (q5, b5) ->
                          (case bit_cut_integer q5 of {
                            (q6, b6) ->
                              let {
                                a = bit_cut_integer q6;
                              } in (case a of {
                                     (_, aa) -> Char b0 b1 b2 b3 b4 b5 b6 aa;
                                   });
                          });
                      });
                  });
              });
          });
      });
  });

of_bool :: forall a. (Zero_neq_one a) => Bool -> a;
of_bool True = onea;
of_bool False = zeroa;

one_integer :: Integer;
one_integer = (1 :: Integer);

instance Zero Integer where {
  zeroa = (0 :: Integer);
};

instance One Integer where {
  onea = one_integer;
};

instance Zero_neq_one Integer where {
};

integer_of_char :: Char -> Integer;
integer_of_char (Char b0 b1 b2 b3 b4 b5 b6 b7) =
  ((((((of_bool b7 * (2 :: Integer) + of_bool b6) * (2 :: Integer) +
        of_bool b5) *
        (2 :: Integer) +
       of_bool b4) *
       (2 :: Integer) +
      of_bool b3) *
      (2 :: Integer) +
     of_bool b2) *
     (2 :: Integer) +
    of_bool b1) *
    (2 :: Integer) +
    of_bool b0;

implode :: [Char] -> String;
implode cs =
  map (let chr k | (0 <= k && k < 128) = Prelude.toEnum k :: Prelude.Char in chr . Prelude.fromInteger)
    (map integer_of_char cs);

lit_of_digit :: Nat -> String;
lit_of_digit n = implode [char_of_integer ((48 :: Integer) + integer_of_nat n)];

showsl_lit :: String -> String -> String;
showsl_lit = (\ a b -> a ++ b);

showsl_nat :: Nat -> String -> String;
showsl_nat n =
  (if less_nat n (nat_of_integer (10 :: Integer))
    then showsl_lit (lit_of_digit n)
    else showsl_nat (divide_nat n (nat_of_integer (10 :: Integer))) .
           showsl_lit
             (lit_of_digit (modulo_nat n (nat_of_integer (10 :: Integer)))));

showsl_sep ::
  forall a.
    (a -> String -> String) -> (String -> String) -> [a] -> String -> String;
showsl_sep s sep [] = showsl_lit "";
showsl_sep s sep [x] = s x;
showsl_sep s sep (x : v : va) = (s x . sep) . showsl_sep s sep (v : va);

showsl_list_gen ::
  forall a.
    (a -> String -> String) ->
      String -> String -> String -> String -> [a] -> String -> String;
showsl_list_gen showslx e l s r xs =
  (if null xs then showsl_lit e
    else (showsl_lit l . showsl_sep showslx (showsl_lit s) xs) . showsl_lit r);

default_showsl_list ::
  forall a. (a -> String -> String) -> [a] -> String -> String;
default_showsl_list sl = showsl_list_gen sl "[]" "[" ", " "]";

showsl_list_nat :: [Nat] -> String -> String;
showsl_list_nat xs = default_showsl_list showsl_nat xs;

class Showl a where {
  showsl :: a -> String -> String;
  showsl_list :: [a] -> String -> String;
};

instance Showl Nat where {
  showsl = showsl_nat;
  showsl_list = showsl_list_nat;
};

class (Semiring_no_zero_divisors a) => Semiring_no_zero_divisors_cancel a where {
};

class (Divide a, Semidom a,
        Semiring_no_zero_divisors_cancel a) => Semidom_divide a where {
};

instance Semiring_no_zero_divisors_cancel Nat where {
};

instance Semidom_divide Nat where {
};

class (Semidom_divide a) => Algebraic_semidom a where {
};

class (Comm_semiring_1_cancel a, Modulo a) => Semiring_modulo a where {
};

class (Algebraic_semidom a, Semiring_modulo a) => Semidom_modulo a where {
};

instance Algebraic_semidom Nat where {
};

instance Semiring_modulo Nat where {
};

instance Semidom_modulo Nat where {
};

class (Compare a, Linorder a) => Compare_order a where {
};

instance Compare_order Nat where {
};

ccompare_nat :: Maybe (Nat -> Nat -> Ordera);
ccompare_nat = Just compare_nat;

instance Ccompare Nat where {
  ccompare = ccompare_nat;
};

newtype Rat = Frct (Int, Int);

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

equal_rat :: Rat -> Rat -> Bool;
equal_rat a b = quotient_of a == quotient_of b;

instance Eq Rat where {
  a == b = equal_rat a b;
};

divide_int :: Int -> Int -> Int;
divide_int k l =
  Int_of_integer (divide_integer (integer_of_int k) (integer_of_int l));

uminus_int :: Int -> Int;
uminus_int k = Int_of_integer (negate (integer_of_int k));

gcd_int :: Int -> Int -> Int;
gcd_int (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (Prelude.gcd x y);

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int zero_int (snd p)
    then let {
           a = gcd_int (fst p) (snd p);
         } in (divide_int (fst p) a, divide_int (snd p) a)
    else (if equal_int (snd p) zero_int then (zero_int, one_int)
           else let {
                  a = uminus_int (gcd_int (fst p) (snd p));
                } in (divide_int (fst p) a, divide_int (snd p) a)));

times_rat :: Rat -> Rat -> Rat;
times_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) -> normalize (times_int aa ba, times_int c d);
                      });
             }));

instance Times Rat where {
  times = times_rat;
};

instance Dvd Rat where {
};

abs_int :: Int -> Int;
abs_int i = (if less_int i zero_int then uminus_int i else i);

abs_rat :: Rat -> Rat;
abs_rat p = Frct (let {
                    a = quotient_of p;
                  } in (case a of {
                         (aa, b) -> (abs_int aa, b);
                       }));

class Abs a where {
  absa :: a -> a;
};

instance Abs Rat where {
  absa = abs_rat;
};

one_rat :: Rat;
one_rat = Frct (one_int, one_int);

instance One Rat where {
  onea = one_rat;
};

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i zero_int then zero_int
    else (if less_int zero_int i then one_int else uminus_int one_int));

sgn_rat :: Rat -> Rat;
sgn_rat p = Frct (sgn_int (fst (quotient_of p)), one_int);

class Sgn a where {
  sgn :: a -> a;
};

instance Sgn Rat where {
  sgn = sgn_rat;
};

uminus_rat :: Rat -> Rat;
uminus_rat p = Frct (let {
                       a = quotient_of p;
                     } in (case a of {
                            (aa, b) -> (uminus_int aa, b);
                          }));

minus_int :: Int -> Int -> Int;
minus_int k l = Int_of_integer (integer_of_int k - integer_of_int l);

minus_rat :: Rat -> Rat -> Rat;
minus_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) ->
                          normalize
                            (minus_int (times_int aa d) (times_int ba c),
                              times_int c d);
                      });
             }));

zero_rat :: Rat;
zero_rat = Frct (zero_int, one_int);

plus_rat :: Rat -> Rat -> Rat;
plus_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) ->
                          normalize
                            (plus_int (times_int aa d) (times_int ba c),
                              times_int c d);
                      });
             }));

class Uminus a where {
  uminus :: a -> a;
};

class (Comm_semiring_1_cancel a) => Comm_semiring_1_cancel_crossproduct a where {
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (Ab_group_add a, Semiring_0_cancel a) => Ring a where {
};

class (Ring a,
        Semiring_no_zero_divisors_cancel a) => Ring_no_zero_divisors a where {
};

class (Group_add a, Numeral a) => Neg_numeral a where {
};

class (Neg_numeral a, Ring a, Semiring_1_cancel a) => Ring_1 a where {
};

class (Ring_1 a, Ring_no_zero_divisors a,
        Semiring_1_no_zero_divisors a) => Ring_1_no_zero_divisors a where {
};

class (Comm_semiring_0_cancel a, Ring a) => Comm_ring a where {
};

class (Comm_ring a, Comm_semiring_1_cancel a, Ring_1 a) => Comm_ring_1 a where {
};

class (Comm_ring_1 a, Ring_1_no_zero_divisors a, Semidom a,
        Comm_semiring_1_cancel_crossproduct a) => Idom a where {
};

instance Plus Rat where {
  plus = plus_rat;
};

instance Semigroup_add Rat where {
};

instance Cancel_semigroup_add Rat where {
};

instance Ab_semigroup_add Rat where {
};

instance Minus Rat where {
  minus = minus_rat;
};

instance Cancel_ab_semigroup_add Rat where {
};

instance Zero Rat where {
  zeroa = zero_rat;
};

instance Monoid_add Rat where {
};

instance Comm_monoid_add Rat where {
};

instance Cancel_comm_monoid_add Rat where {
};

instance Mult_zero Rat where {
};

instance Semigroup_mult Rat where {
};

instance Semiring Rat where {
};

instance Semiring_0 Rat where {
};

instance Semiring_0_cancel Rat where {
};

instance Ab_semigroup_mult Rat where {
};

instance Comm_semiring Rat where {
};

instance Comm_semiring_0 Rat where {
};

instance Comm_semiring_0_cancel Rat where {
};

instance Power Rat where {
};

instance Monoid_mult Rat where {
};

instance Numeral Rat where {
};

instance Semiring_numeral Rat where {
};

instance Zero_neq_one Rat where {
};

instance Semiring_1 Rat where {
};

instance Semiring_1_cancel Rat where {
};

instance Comm_monoid_mult Rat where {
};

instance Comm_semiring_1 Rat where {
};

instance Comm_semiring_1_cancel Rat where {
};

instance Comm_semiring_1_cancel_crossproduct Rat where {
};

instance Semiring_no_zero_divisors Rat where {
};

instance Semiring_1_no_zero_divisors Rat where {
};

instance Semiring_no_zero_divisors_cancel Rat where {
};

instance Uminus Rat where {
  uminus = uminus_rat;
};

instance Group_add Rat where {
};

instance Ab_group_add Rat where {
};

instance Ring Rat where {
};

instance Ring_no_zero_divisors Rat where {
};

instance Neg_numeral Rat where {
};

instance Ring_1 Rat where {
};

instance Ring_1_no_zero_divisors Rat where {
};

instance Comm_ring Rat where {
};

instance Comm_ring_1 Rat where {
};

instance Semidom Rat where {
};

instance Idom Rat where {
};

inverse_rat :: Rat -> Rat;
inverse_rat p =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, b) ->
                 (if equal_int aa zero_int then (zero_int, one_int)
                   else (times_int (sgn_int aa) b, abs_int aa));
             }));

divide_rat :: Rat -> Rat -> Rat;
divide_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) -> normalize (times_int aa d, times_int c ba);
                      });
             }));

class (Divide a) => Inverse a where {
  inverse :: a -> a;
};

class (Inverse a, Ring_1_no_zero_divisors a) => Division_ring a where {
};

class (Idom a, Semidom_divide a) => Idom_divide a where {
};

class (Division_ring a, Idom_divide a) => Field a where {
};

instance Divide Rat where {
  divide = divide_rat;
};

instance Inverse Rat where {
  inverse = inverse_rat;
};

instance Division_ring Rat where {
};

instance Semidom_divide Rat where {
};

instance Idom_divide Rat where {
};

instance Field Rat where {
};

less_eq_rat :: Rat -> Rat -> Bool;
less_eq_rat p q =
  let {
    a = quotient_of p;
  } in (case a of {
         (aa, c) ->
           let {
             b = quotient_of q;
           } in (case b of {
                  (ba, d) -> less_eq_int (times_int aa d) (times_int c ba);
                });
       });

less_rat :: Rat -> Rat -> Bool;
less_rat p q =
  let {
    a = quotient_of p;
  } in (case a of {
         (aa, c) ->
           let {
             b = quotient_of q;
           } in (case b of {
                  (ba, d) -> less_int (times_int aa d) (times_int c ba);
                });
       });

class (Abs a, Minus a, Uminus a, Zero a, Ord a) => Abs_if a where {
};

instance Ord Rat where {
  less_eq = less_eq_rat;
  less = less_rat;
};

instance Abs_if Rat where {
};

instance Quasi_order Rat where {
};

instance Weak_order Rat where {
};

instance Preorder Rat where {
};

instance Order Rat where {
};

instance Linorder Rat where {
};

compare_rat :: Rat -> Rat -> Ordera;
compare_rat = comparator_of;

instance Compare Rat where {
  compare = compare_rat;
};

class (Semiring_1 a) => Semiring_char_0 a where {
};

class (Semiring_char_0 a, Ring_1 a) => Ring_char_0 a where {
};

instance Semiring_char_0 Rat where {
};

instance Ring_char_0 Rat where {
};

class (Order a) => No_bot a where {
};

instance No_bot Rat where {
};

class (Order a) => No_top a where {
};

instance No_top Rat where {
};

ceq_rat :: Maybe (Rat -> Rat -> Bool);
ceq_rat = Just equal_rat;

instance Ceq Rat where {
  ceq = ceq_rat;
};

set_impl_rat :: Phantom Rat Set_impla;
set_impl_rat = Phantom Set_RBT;

instance Set_impl Rat where {
  set_impl = set_impl_rat;
};

class (Abs a, Sgn a, Idom a) => Idom_abs_sgn a where {
};

instance Idom_abs_sgn Rat where {
};

class (Ab_semigroup_add a, Order a) => Ordered_ab_semigroup_add a where {
};

class (Ordered_ab_semigroup_add a) => Strict_ordered_ab_semigroup_add a where {
};

class (Cancel_ab_semigroup_add a,
        Strict_ordered_ab_semigroup_add a) => Ordered_cancel_ab_semigroup_add a where {
};

class (Semigroup_mult a, Order a,
        Mult_zero a) => Ordered_semigroup_mult_zero a where {
};

class (Comm_monoid_add a,
        Ordered_ab_semigroup_add a) => Ordered_comm_monoid_add a where {
};

class (Ordered_comm_monoid_add a, Semiring a) => Ordered_semiring a where {
};

class (Ordered_semigroup_mult_zero a, Ordered_semiring a,
        Semiring_0 a) => Ordered_semiring_0 a where {
};

class (Ordered_cancel_ab_semigroup_add a, Ordered_semiring_0 a,
        Semiring_0_cancel a) => Ordered_cancel_semiring a where {
};

class (Ordered_cancel_ab_semigroup_add a) => Ordered_ab_semigroup_add_imp_le a where {
};

class (Comm_monoid_add a,
        Strict_ordered_ab_semigroup_add a) => Strict_ordered_comm_monoid_add a where {
};

class (Ordered_cancel_ab_semigroup_add a, Ordered_comm_monoid_add a,
        Strict_ordered_comm_monoid_add a) => Ordered_cancel_comm_monoid_add a where {
};

class (Cancel_comm_monoid_add a, Ordered_ab_semigroup_add_imp_le a,
        Ordered_cancel_comm_monoid_add a) => Ordered_ab_semigroup_monoid_add_imp_le a where {
};

class (Ab_group_add a,
        Ordered_ab_semigroup_monoid_add_imp_le a) => Ordered_ab_group_add a where {
};

class (Ordered_ab_group_add a, Ordered_cancel_semiring a,
        Ring a) => Ordered_ring a where {
};

instance Ordered_ab_semigroup_add Rat where {
};

instance Strict_ordered_ab_semigroup_add Rat where {
};

instance Ordered_cancel_ab_semigroup_add Rat where {
};

instance Ordered_semigroup_mult_zero Rat where {
};

instance Ordered_comm_monoid_add Rat where {
};

instance Ordered_semiring Rat where {
};

instance Ordered_semiring_0 Rat where {
};

instance Ordered_cancel_semiring Rat where {
};

instance Ordered_ab_semigroup_add_imp_le Rat where {
};

instance Strict_ordered_comm_monoid_add Rat where {
};

instance Ordered_cancel_comm_monoid_add Rat where {
};

instance Ordered_ab_semigroup_monoid_add_imp_le Rat where {
};

instance Ordered_ab_group_add Rat where {
};

instance Ordered_ring Rat where {
};

class (Field a, Ring_char_0 a) => Field_char_0 a where {
};

instance Field_char_0 Rat where {
};

class (Order a, Zero_neq_one a) => Zero_less_one a where {
};

instance Zero_less_one Rat where {
};

class (Field a, Idom_abs_sgn a) => Field_abs_sgn a where {
};

instance Field_abs_sgn Rat where {
};

class (Order a) => Dense_order a where {
};

instance Dense_order Rat where {
};

class (Ordered_ab_semigroup_add a,
        Linorder a) => Linordered_ab_semigroup_add a where {
};

class (Linordered_ab_semigroup_add a,
        Ordered_ab_semigroup_add_imp_le a) => Linordered_cancel_ab_semigroup_add a where {
};

class (Linordered_cancel_ab_semigroup_add a,
        Ordered_ab_semigroup_monoid_add_imp_le a,
        Ordered_cancel_semiring a) => Linordered_semiring a where {
};

class (Linordered_semiring a) => Linordered_semiring_strict a where {
};

class (Linordered_semiring a, Semiring_1 a,
        Zero_less_one a) => Linordered_semiring_1 a where {
};

class (Linordered_semiring_1 a,
        Linordered_semiring_strict a) => Linordered_semiring_1_strict a where {
};

class (Abs a, Ordered_ab_group_add a) => Ordered_ab_group_add_abs a where {
};

class (Linordered_cancel_ab_semigroup_add a,
        Ordered_ab_group_add a) => Linordered_ab_group_add a where {
};

class (Linordered_ab_group_add a, Ordered_ab_group_add_abs a, Abs_if a,
        Linordered_semiring a, Ordered_ring a) => Linordered_ring a where {
};

class (Linordered_ring a, Linordered_semiring_strict a,
        Ring_no_zero_divisors a) => Linordered_ring_strict a where {
};

class (Comm_semiring_0 a, Ordered_semiring a) => Ordered_comm_semiring a where {
};

class (Comm_semiring_0_cancel a, Ordered_cancel_semiring a,
        Ordered_comm_semiring a) => Ordered_cancel_comm_semiring a where {
};

class (Linordered_semiring_strict a,
        Ordered_cancel_comm_semiring a) => Linordered_comm_semiring_strict a where {
};

class (Semiring_char_0 a, Linorder a, Comm_semiring_1 a,
        Ordered_comm_semiring a,
        Zero_less_one a) => Linordered_nonzero_semiring a where {
};

class (Linordered_comm_semiring_strict a, Linordered_nonzero_semiring a,
        Semidom a) => Linordered_semidom a where {
};

class (Comm_ring a, Ordered_cancel_comm_semiring a,
        Ordered_ring a) => Ordered_comm_ring a where {
};

class (Ordered_ab_group_add_abs a, Ordered_ring a) => Ordered_ring_abs a where {
};

class (Ring_char_0 a, Idom_abs_sgn a, Linordered_ring_strict a,
        Linordered_semidom a, Linordered_semiring_1_strict a,
        Ordered_comm_ring a, Ordered_ring_abs a) => Linordered_idom a where {
};

instance Linordered_ab_semigroup_add Rat where {
};

instance Linordered_cancel_ab_semigroup_add Rat where {
};

instance Linordered_semiring Rat where {
};

instance Linordered_semiring_strict Rat where {
};

instance Linordered_semiring_1 Rat where {
};

instance Linordered_semiring_1_strict Rat where {
};

instance Ordered_ab_group_add_abs Rat where {
};

instance Linordered_ab_group_add Rat where {
};

instance Linordered_ring Rat where {
};

instance Linordered_ring_strict Rat where {
};

instance Ordered_comm_semiring Rat where {
};

instance Ordered_cancel_comm_semiring Rat where {
};

instance Linordered_comm_semiring_strict Rat where {
};

instance Linordered_nonzero_semiring Rat where {
};

instance Linordered_semidom Rat where {
};

instance Ordered_comm_ring Rat where {
};

instance Ordered_ring_abs Rat where {
};

instance Linordered_idom Rat where {
};

class (Ord a) => Non_strict_order a where {
};

class (Ab_semigroup_add a, Monoid_add a,
        Non_strict_order a) => Ordered_ab_semigroup a where {
};

class (Semiring_0 a, Ordered_ab_semigroup a) => Ordered_semiring_0a a where {
};

class (Semiring_1 a, Ordered_semiring_0a a) => Ordered_semiring_1 a where {
};

class (Comm_semiring_1 a, Ordered_semiring_1 a) => Poly_carrier a where {
};

instance Non_strict_order Rat where {
};

instance Ordered_ab_semigroup Rat where {
};

instance Ordered_semiring_0a Rat where {
};

instance Ordered_semiring_1 Rat where {
};

instance Poly_carrier Rat where {
};

class (Dense_order a, Linorder a) => Dense_linorder a where {
};

class (Dense_linorder a, No_bot a,
        No_top a) => Unbounded_dense_linorder a where {
};

class (Field_abs_sgn a, Field_char_0 a, Unbounded_dense_linorder a,
        Linordered_idom a) => Linordered_field a where {
};

instance Dense_linorder Rat where {
};

instance Unbounded_dense_linorder Rat where {
};

instance Linordered_field Rat where {
};

ccompare_rat :: Maybe (Rat -> Rat -> Ordera);
ccompare_rat = Just compare_rat;

instance Ccompare Rat where {
  ccompare = ccompare_rat;
};

class (Linordered_field a) => Archimedean_field a where {
};

class (Poly_carrier a) => Large_ordered_semiring_1 a where {
};

class (Archimedean_field a,
        Large_ordered_semiring_1 a) => Floor_ceiling a where {
  floor :: a -> Int;
};

floor_rat :: Rat -> Int;
floor_rat p = let {
                a = quotient_of p;
              } in (case a of {
                     (aa, b) -> divide_int aa b;
                   });

instance Archimedean_field Rat where {
};

instance Large_ordered_semiring_1 Rat where {
};

instance Floor_ceiling Rat where {
  floor = floor_rat;
};

less_eq_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_eq_list (x : xs) (y : ys) = less x y || x == y && less_eq_list xs ys;
less_eq_list [] xs = True;
less_eq_list (x : xs) [] = False;

less_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_list (x : xs) (y : ys) = less x y || x == y && less_list xs ys;
less_list [] (x : xs) = True;
less_list xs [] = False;

instance (Eq a, Order a) => Ord [a] where {
  less_eq = less_eq_list;
  less = less_list;
};

comparator_list :: forall a. (a -> a -> Ordera) -> [a] -> [a] -> Ordera;
comparator_list comp_a (x : xa) (y : ya) =
  (case comp_a x y of {
    Eqa -> comparator_list comp_a xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_list comp_a (x : xa) [] = Gt;
comparator_list comp_a [] (y : ya) = Lt;
comparator_list comp_a [] [] = Eqa;

compare_list :: forall a. (Compare a) => [a] -> [a] -> Ordera;
compare_list = comparator_list compare;

instance (Compare a) => Compare [a] where {
  compare = compare_list;
};

instance (Eq a, Order a) => Quasi_order [a] where {
};

instance (Eq a, Order a) => Weak_order [a] where {
};

instance (Eq a, Order a) => Preorder [a] where {
};

instance (Eq a, Order a) => Order [a] where {
};

instance (Eq a, Linorder a) => Linorder [a] where {
};

showsl_lista :: forall a. (Showl a) => [a] -> String -> String;
showsl_lista xs = showsl_list xs;

showsl_list_list :: forall a. (Showl a) => [[a]] -> String -> String;
showsl_list_list xs = default_showsl_list showsl_lista xs;

instance (Showl a) => Showl [a] where {
  showsl = showsl_lista;
  showsl_list = showsl_list_list;
};

instance (Compare_order a, Eq a) => Compare_order [a] where {
};

ccompare_list :: forall a. (Ccompare a) => Maybe ([a] -> [a] -> Ordera);
ccompare_list = (case ccompare of {
                  Nothing -> Nothing;
                  Just comp_a -> Just (comparator_list comp_a);
                });

instance (Ccompare a) => Ccompare [a] where {
  ccompare = ccompare_list;
};

newtype Mini_alg = Abs_mini_alg (Rat, (Rat, Nat));

newtype Mini_alg_unique = Abs_mini_alg_unique Mini_alg;

newtype Real = Real_of_u Mini_alg_unique;

rep_mini_alg_unique :: Mini_alg_unique -> Mini_alg;
rep_mini_alg_unique (Abs_mini_alg_unique x) = x;

rep_mini_alg :: Mini_alg -> (Rat, (Rat, Nat));
rep_mini_alg (Abs_mini_alg x) = x;

ma_identity :: Mini_alg -> Mini_alg -> Bool;
ma_identity xa xc = rep_mini_alg xa == rep_mini_alg xc;

mau_equal :: Mini_alg_unique -> Mini_alg_unique -> Bool;
mau_equal xa xc = ma_identity (rep_mini_alg_unique xa) (rep_mini_alg_unique xc);

equal_real :: Real -> Real -> Bool;
equal_real (Real_of_u r1) (Real_of_u r2) = mau_equal r1 r2;

instance Eq Real where {
  a == b = equal_real a b;
};

ma_compatible :: Mini_alg -> Mini_alg -> Bool;
ma_compatible xa xc =
  (case rep_mini_alg xa of {
    (_, (q1, b1)) ->
      (\ (_, (q2, b2)) ->
        equal_rat q1 zero_rat || (equal_rat q2 zero_rat || equal_nat b1 b2));
  })
    (rep_mini_alg xc);

mau_compatible :: Mini_alg_unique -> Mini_alg_unique -> Bool;
mau_compatible xa xc =
  ma_compatible (rep_mini_alg_unique xa) (rep_mini_alg_unique xc);

numeral :: forall a. (Numeral a) => Num -> a;
numeral (Bit1 n) = let {
                     m = numeral n;
                   } in plus (plus m m) onea;
numeral (Bit0 n) = let {
                     m = numeral n;
                   } in plus m m;
numeral One = onea;

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat m n = (divide_nat m n, modulo_nat m n);

of_nat :: forall a. (Semiring_1 a) => Nat -> a;
of_nat n =
  (if equal_nat n zero_nat then zeroa
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (m, q) -> let {
                       ma = times (numeral (Bit0 One)) (of_nat m);
                     } in (if equal_nat q zero_nat then ma else plus ma onea);
         }));

ma_normalize :: (Rat, (Rat, Nat)) -> (Rat, (Rat, Nat));
ma_normalize x =
  (case x of {
    (a, b) ->
      (case b of {
        (ba, c) ->
          (if equal_rat ba zero_rat then (a, (zero_rat, zero_nat))
            else (a, (ba, c)));
      });
  });

ma_times :: Mini_alg -> Mini_alg -> Mini_alg;
ma_times xb xc =
  Abs_mini_alg
    ((case rep_mini_alg xb of {
       (p1, (q1, b1)) ->
         (\ (p2, (q2, b2)) ->
           (if equal_rat q1 zero_rat
             then ma_normalize (times_rat p1 p2, (times_rat p1 q2, b2))
             else ma_normalize
                    (plus_rat (times_rat p1 p2)
                       (times_rat (times_rat (of_nat b2) q1) q2),
                      (plus_rat (times_rat p1 q2) (times_rat q1 p2), b1))));
     })
      (rep_mini_alg xc));

mau_times :: Mini_alg_unique -> Mini_alg_unique -> Mini_alg_unique;
mau_times xb xc =
  Abs_mini_alg_unique
    (ma_times (rep_mini_alg_unique xb) (rep_mini_alg_unique xc));

times_real :: Real -> Real -> Real;
times_real (Real_of_u r1) (Real_of_u r2) =
  (if mau_compatible r1 r2 then Real_of_u (mau_times r1 r2)
    else (error :: forall a. String -> (() -> a) -> a) "different base"
           (\ _ -> times_real (Real_of_u r1) (Real_of_u r2)));

instance Times Real where {
  times = times_real;
};

instance Dvd Real where {
};

ma_of_rat :: Rat -> Mini_alg;
ma_of_rat xa = Abs_mini_alg (xa, (zero_rat, zero_nat));

mau_of_rat :: Rat -> Mini_alg_unique;
mau_of_rat xa = Abs_mini_alg_unique (ma_of_rat xa);

one_real :: Real;
one_real = Real_of_u (mau_of_rat one_rat);

instance One Real where {
  onea = one_real;
};

ma_plus :: Mini_alg -> Mini_alg -> Mini_alg;
ma_plus xb xc =
  Abs_mini_alg
    ((case rep_mini_alg xb of {
       (p1, (q1, b1)) ->
         (\ (p2, (q2, b2)) ->
           (if equal_rat q1 zero_rat then (plus_rat p1 p2, (q2, b2))
             else ma_normalize (plus_rat p1 p2, (plus_rat q1 q2, b1))));
     })
      (rep_mini_alg xc));

mau_plus :: Mini_alg_unique -> Mini_alg_unique -> Mini_alg_unique;
mau_plus xb xc =
  Abs_mini_alg_unique
    (ma_plus (rep_mini_alg_unique xb) (rep_mini_alg_unique xc));

plus_real :: Real -> Real -> Real;
plus_real (Real_of_u r1) (Real_of_u r2) =
  (if mau_compatible r1 r2 then Real_of_u (mau_plus r1 r2)
    else (error :: forall a. String -> (() -> a) -> a) "different base"
           (\ _ -> plus_real (Real_of_u r1) (Real_of_u r2)));

instance Plus Real where {
  plus = plus_real;
};

zero_real :: Real;
zero_real = Real_of_u (mau_of_rat zero_rat);

instance Zero Real where {
  zeroa = zero_real;
};

instance Semigroup_add Real where {
};

instance Numeral Real where {
};

instance Power Real where {
};

ma_uminus :: Mini_alg -> Mini_alg;
ma_uminus xa =
  Abs_mini_alg (case rep_mini_alg xa of {
                 (p1, (q1, b1)) -> (uminus_rat p1, (uminus_rat q1, b1));
               });

mau_uminus :: Mini_alg_unique -> Mini_alg_unique;
mau_uminus xa = Abs_mini_alg_unique (ma_uminus (rep_mini_alg_unique xa));

uminus_real :: Real -> Real;
uminus_real (Real_of_u r) = Real_of_u (mau_uminus r);

minus_real :: Real -> Real -> Real;
minus_real x y = plus_real x (uminus_real y);

sqrt_int_maina :: Int -> Int -> (Int, Bool);
sqrt_int_maina x n =
  let {
    x2 = times_int x x;
  } in (if less_eq_int x2 n then (x, equal_int x2 n)
         else sqrt_int_maina
                (divide_int (plus_int (divide_int n x) x)
                  (Int_of_integer (2 :: Integer)))
                n);

ceiling :: forall a. (Floor_ceiling a) => a -> Int;
ceiling x = uminus_int (floor (uminus x));

power :: forall a. (Power a) => a -> Nat -> a;
power a n =
  (if equal_nat n zero_nat then onea
    else times a (power a (minus_nat n one_nat)));

newtype Proper_base = Abs_proper_base Int;

into_base :: Int -> Proper_base;
into_base xa =
  Abs_proper_base
    (if less_eq_int (Int_of_integer (2 :: Integer)) xa then xa
      else Int_of_integer (2 :: Integer));

rep_proper_base :: Proper_base -> Int;
rep_proper_base (Abs_proper_base x) = x;

square_base :: Proper_base -> Proper_base;
square_base xa =
  Abs_proper_base (times_int (rep_proper_base xa) (rep_proper_base xa));

get_base :: Proper_base -> Int;
get_base x = rep_proper_base x;

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

log_main :: Proper_base -> Int -> (Nat, Int);
log_main b x =
  (if less_int x (get_base b) then (zero_nat, one_int)
    else (case log_main (square_base b) x of {
           (z, bz) -> let {
                        l = times_nat (nat_of_integer (2 :: Integer)) z;
                        bz1 = times_int bz (get_base b);
                      } in (if less_int x bz1 then (l, bz) else (suc l, bz1));
         }));

log_ceiling :: Int -> Int -> Nat;
log_ceiling b x = (case log_main (into_base b) x of {
                    (y, by) -> (if equal_int x by then y else suc y);
                  });

nat :: Int -> Nat;
nat k = Nat (max (0 :: Integer) (integer_of_int k));

start_value :: Int -> Nat -> Int;
start_value n p =
  power (Int_of_integer (2 :: Integer))
    (nat (ceiling
           (divide_rat (of_nat (log_ceiling (Int_of_integer (2 :: Integer)) n))
             (of_nat p))));

sqrt_int_main :: Int -> (Int, Bool);
sqrt_int_main x =
  sqrt_int_maina (start_value x (nat_of_integer (2 :: Integer))) x;

sqrt_int_ceiling_pos :: Int -> Int;
sqrt_int_ceiling_pos x = (case sqrt_int_main x of {
                           (y, True) -> y;
                           (y, False) -> plus_int y one_int;
                         });

sqrt_int_floor_pos :: Int -> Int;
sqrt_int_floor_pos x = fst (sqrt_int_main x);

int_of_nat :: Nat -> Int;
int_of_nat n = Int_of_integer (integer_of_nat n);

ma_floor :: Mini_alg -> Int;
ma_floor xa =
  (case rep_mini_alg xa of {
    (p, (q, b)) ->
      (case (quotient_of p, quotient_of q) of {
        ((z1, n1), (z2, n2)) ->
          let {
            z2n1 = times_int z2 n1;
            z1n2 = times_int z1 n2;
            n12 = times_int n1 n2;
            prod = times_int (times_int z2n1 z2n1) (int_of_nat b);
          } in divide_int
                 (plus_int z1n2
                   (if less_eq_int zero_int z2n1 then sqrt_int_floor_pos prod
                     else uminus_int (sqrt_int_ceiling_pos prod)))
                 n12;
      });
  });

mau_floor :: Mini_alg_unique -> Int;
mau_floor xa = ma_floor (rep_mini_alg_unique xa);

floor_real :: Real -> Int;
floor_real (Real_of_u r) = mau_floor r;

ratreal :: Rat -> Real;
ratreal = Real_of_u . mau_of_rat;

of_int :: Int -> Rat;
of_int a = Frct (a, one_int);

real_lt :: Real -> Real -> Bool;
real_lt x y =
  let {
    fx = floor_real x;
    fy = floor_real y;
  } in (if less_int fx fy then True
         else (if less_int fy fx then False
                else real_lt
                       (times_real x
                         (ratreal (of_int (Int_of_integer (1024 :: Integer)))))
                       (times_real y
                         (ratreal
                           (of_int (Int_of_integer (1024 :: Integer)))))));

ma_ge_0 :: Mini_alg -> Bool;
ma_ge_0 xa =
  (case rep_mini_alg xa of {
    (p, (q, b)) ->
      let {
        bqq = times_rat (times_rat (of_nat b) q) q;
        pp = times_rat p p;
      } in less_eq_rat zero_rat p && less_eq_rat bqq pp ||
             less_eq_rat zero_rat q && less_eq_rat pp bqq;
  });

mau_ge_0 :: Mini_alg_unique -> Bool;
mau_ge_0 xa = ma_ge_0 (rep_mini_alg_unique xa);

ge_0 :: Real -> Bool;
ge_0 (Real_of_u x) = mau_ge_0 x;

less_eq_real :: Real -> Real -> Bool;
less_eq_real (Real_of_u x) (Real_of_u y) =
  equal_real (Real_of_u x) (Real_of_u y) ||
    (if mau_compatible x y then ge_0 (minus_real (Real_of_u y) (Real_of_u x))
      else real_lt (Real_of_u x) (Real_of_u y));
less_eq_real x y = ge_0 (minus_real y x);

less_real :: Real -> Real -> Bool;
less_real (Real_of_u x) (Real_of_u y) =
  not (equal_real (Real_of_u x) (Real_of_u y)) &&
    (if mau_compatible x y then ge_0 (minus_real (Real_of_u y) (Real_of_u x))
      else real_lt (Real_of_u x) (Real_of_u y));
less_real x y = not (equal_real x y) && ge_0 (minus_real y x);

instance Ord Real where {
  less_eq = less_eq_real;
  less = less_real;
};

instance Ab_semigroup_add Real where {
};

instance Semigroup_mult Real where {
};

instance Semiring Real where {
};

instance Quasi_order Real where {
};

instance Weak_order Real where {
};

instance Preorder Real where {
};

instance Order Real where {
};

instance Mult_zero Real where {
};

instance Monoid_add Real where {
};

instance Comm_monoid_add Real where {
};

instance Semiring_0 Real where {
};

instance Monoid_mult Real where {
};

instance Semiring_numeral Real where {
};

instance Zero_neq_one Real where {
};

instance Semiring_1 Real where {
};

ceq_real :: Maybe (Real -> Real -> Bool);
ceq_real = Just equal_real;

instance Ceq Real where {
  ceq = ceq_real;
};

set_impl_real :: Phantom Real Set_impla;
set_impl_real = Phantom Set_RBT;

instance Set_impl Real where {
  set_impl = set_impl_real;
};

instance Linorder Real where {
};

instance Ab_semigroup_mult Real where {
};

instance Comm_semiring Real where {
};

instance Comm_semiring_0 Real where {
};

instance Comm_monoid_mult Real where {
};

instance Comm_semiring_1 Real where {
};

compare_real :: Real -> Real -> Ordera;
compare_real = comparator_of;

ccompare_real :: Maybe (Real -> Real -> Ordera);
ccompare_real = Just compare_real;

instance Ccompare Real where {
  ccompare = ccompare_real;
};

data Term a b = Var b | Fun a [Term a b];

instance (Eq a, Eq b) => Eq (Term a b) where {
  a == b = equal_term a b;
};

equal_term :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
equal_term (Var x1) (Fun x21 x22) = False;
equal_term (Fun x21 x22) (Var x1) = False;
equal_term (Fun x21 x22) (Fun y21 y22) = x21 == y21 && x22 == y22;
equal_term (Var x1) (Var y1) = x1 == y1;

newtype Mat_impl a = Abs_mat_impl (Nat, (Nat, IArray.IArray (IArray.IArray a)));

rep_mat_impl ::
  forall a. Mat_impl a -> (Nat, (Nat, IArray.IArray (IArray.IArray a)));
rep_mat_impl (Abs_mat_impl x) = x;

length :: forall a. IArray.IArray a -> Nat;
length asa = nat_of_integer (IArray.length asa);

sub :: forall a. IArray.IArray a -> Nat -> a;
sub asa n = IArray.sub (asa, integer_of_nat n);

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

list_of :: forall a. IArray.IArray a -> [a];
list_of asa = map (sub asa) (upt zero_nat (length asa));

equal_iarray :: forall a. (Eq a) => IArray.IArray a -> IArray.IArray a -> Bool;
equal_iarray asa bs = list_of asa == list_of bs;

instance (Eq a) => Eq (IArray.IArray a) where {
  a == b = equal_iarray a b;
};

mat_equal_impl :: forall a. (Eq a) => Mat_impl a -> Mat_impl a -> Bool;
mat_equal_impl xa xc =
  (case rep_mat_impl xa of {
    (nr1, (nc1, m1)) ->
      (\ (nr2, (nc2, m2)) ->
        equal_nat nr1 nr2 && equal_nat nc1 nc2 && equal_iarray m1 m2);
  })
    (rep_mat_impl xc);

newtype Mat a = Mat_impl (Mat_impl a);

equal_mat :: forall a. (Eq a) => Mat a -> Mat a -> Bool;
equal_mat (Mat_impl m1) (Mat_impl m2) = mat_equal_impl m1 m2;

instance (Eq a) => Eq (Mat a) where {
  a == b = equal_mat a b;
};

equal_char :: Char -> Char -> Bool;
equal_char (Char x1 x2 x3 x4 x5 x6 x7 x8) (Char y1 y2 y3 y4 y5 y6 y7 y8) =
  x1 == y1 &&
    x2 == y2 &&
      x3 == y3 && x4 == y4 && x5 == y5 && x6 == y6 && x7 == y7 && x8 == y8;

instance Eq Char where {
  a == b = equal_char a b;
};

shows_prec_char :: Nat -> Char -> [Char] -> [Char];
shows_prec_char p c = (\ a -> c : a);

shows_string :: [Char] -> [Char] -> [Char];
shows_string = (\ a b -> a ++ b);

shows_list_char :: [Char] -> [Char] -> [Char];
shows_list_char cs = shows_string cs;

class Showa a where {
  shows_prec :: Nat -> a -> [Char] -> [Char];
  shows_list :: [a] -> [Char] -> [Char];
};

instance Showa Char where {
  shows_prec = shows_prec_char;
  shows_list = shows_list_char;
};

nat_of_char :: Char -> Nat;
nat_of_char c = Nat (integer_of_char c);

less_eq_char :: Char -> Char -> Bool;
less_eq_char c1 c2 = less_eq_nat (nat_of_char c1) (nat_of_char c2);

less_char :: Char -> Char -> Bool;
less_char c1 c2 = less_nat (nat_of_char c1) (nat_of_char c2);

instance Ord Char where {
  less_eq = less_eq_char;
  less = less_char;
};

instance Quasi_order Char where {
};

instance Weak_order Char where {
};

instance Preorder Char where {
};

instance Order Char where {
};

instance Linorder Char where {
};

compare_char :: Char -> Char -> Ordera;
compare_char = comparator_of;

instance Compare Char where {
  compare = compare_char;
};

showsl_list_char :: [Char] -> String -> String;
showsl_list_char cs s = showsl_lit (implode cs) s;

showsl_char :: Char -> String -> String;
showsl_char c = showsl_lit (implode [c]);

instance Showl Char where {
  showsl = showsl_char;
  showsl_list = showsl_list_char;
};

instance Compare_order Char where {
};

ccompare_char :: Maybe (Char -> Char -> Ordera);
ccompare_char = Just compare_char;

instance Ccompare Char where {
  ccompare = ccompare_char;
};

data Lab a b = Lab (Lab a b) b | FunLab (Lab a b) [Lab a b] | UnLab a
  | Sharp (Lab a b);

instance (Eq a, Eq b) => Eq (Lab a b) where {
  a == b = equal_lab a b;
};

equal_lab :: forall a b. (Eq a, Eq b) => Lab a b -> Lab a b -> Bool;
equal_lab (UnLab x3) (Sharp x4) = False;
equal_lab (Sharp x4) (UnLab x3) = False;
equal_lab (FunLab x21 x22) (Sharp x4) = False;
equal_lab (Sharp x4) (FunLab x21 x22) = False;
equal_lab (FunLab x21 x22) (UnLab x3) = False;
equal_lab (UnLab x3) (FunLab x21 x22) = False;
equal_lab (Lab x11 x12) (Sharp x4) = False;
equal_lab (Sharp x4) (Lab x11 x12) = False;
equal_lab (Lab x11 x12) (UnLab x3) = False;
equal_lab (UnLab x3) (Lab x11 x12) = False;
equal_lab (Lab x11 x12) (FunLab x21 x22) = False;
equal_lab (FunLab x21 x22) (Lab x11 x12) = False;
equal_lab (Sharp x4) (Sharp y4) = equal_lab x4 y4;
equal_lab (UnLab x3) (UnLab y3) = x3 == y3;
equal_lab (FunLab x21 x22) (FunLab y21 y22) = equal_lab x21 y21 && x22 == y22;
equal_lab (Lab x11 x12) (Lab y11 y12) = equal_lab x11 y11 && x12 == y12;

comparator_lab ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> Lab a b -> Lab a b -> Ordera;
comparator_lab comp_f comp_l (Sharp x) (Sharp ye) =
  comparator_lab comp_f comp_l x ye;
comparator_lab comp_f comp_l (Sharp x) (UnLab yd) = Gt;
comparator_lab comp_f comp_l (Sharp x) (FunLab yb yc) = Gt;
comparator_lab comp_f comp_l (Sharp x) (Lab y ya) = Gt;
comparator_lab comp_f comp_l (UnLab x) (Sharp ye) = Lt;
comparator_lab comp_f comp_l (UnLab x) (UnLab yd) = comp_f x yd;
comparator_lab comp_f comp_l (UnLab x) (FunLab yb yc) = Gt;
comparator_lab comp_f comp_l (UnLab x) (Lab y ya) = Gt;
comparator_lab comp_f comp_l (FunLab x xa) (Sharp ye) = Lt;
comparator_lab comp_f comp_l (FunLab x xa) (UnLab yd) = Lt;
comparator_lab comp_f comp_l (FunLab x xa) (FunLab yb yc) =
  (case comparator_lab comp_f comp_l x yb of {
    Eqa -> comparator_list (comparator_lab comp_f comp_l) xa yc;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_lab comp_f comp_l (FunLab x xa) (Lab y ya) = Gt;
comparator_lab comp_f comp_l (Lab x xa) (Sharp ye) = Lt;
comparator_lab comp_f comp_l (Lab x xa) (UnLab yd) = Lt;
comparator_lab comp_f comp_l (Lab x xa) (FunLab yb yc) = Lt;
comparator_lab comp_f comp_l (Lab x xa) (Lab y ya) =
  (case comparator_lab comp_f comp_l x y of {
    Eqa -> comp_l xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });

compare_lab ::
  forall a b. (Compare a, Compare b) => Lab a b -> Lab a b -> Ordera;
compare_lab = comparator_lab compare compare;

le_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
le_of_comp acomp x y = (case acomp x y of {
                         Eqa -> True;
                         Lt -> True;
                         Gt -> False;
                       });

less_eq_lab :: forall a b. (Compare a, Compare b) => Lab a b -> Lab a b -> Bool;
less_eq_lab = le_of_comp compare_lab;

lt_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
lt_of_comp acomp x y = (case acomp x y of {
                         Eqa -> False;
                         Lt -> True;
                         Gt -> False;
                       });

less_lab :: forall a b. (Compare a, Compare b) => Lab a b -> Lab a b -> Bool;
less_lab = lt_of_comp compare_lab;

instance (Compare a, Compare b) => Ord (Lab a b) where {
  less_eq = less_eq_lab;
  less = less_lab;
};

instance (Compare a, Compare b) => Compare (Lab a b) where {
  compare = compare_lab;
};

instance (Compare a, Compare b) => Quasi_order (Lab a b) where {
};

instance (Compare a, Compare b) => Weak_order (Lab a b) where {
};

instance (Compare a, Compare b) => Preorder (Lab a b) where {
};

instance (Compare a, Compare b) => Order (Lab a b) where {
};

ceq_lab :: forall a b. (Eq a, Eq b) => Maybe (Lab a b -> Lab a b -> Bool);
ceq_lab = Just equal_lab;

instance (Eq a, Eq b) => Ceq (Lab a b) where {
  ceq = ceq_lab;
};

set_impl_lab :: forall a b. Phantom (Lab a b) Set_impla;
set_impl_lab = Phantom Set_RBT;

instance Set_impl (Lab a b) where {
  set_impl = set_impl_lab;
};

instance (Compare a, Compare b) => Linorder (Lab a b) where {
};

showsl_lab :: forall a b. (Showl a, Showl b) => Lab a b -> String -> String;
showsl_lab (UnLab f) = showsl f;
showsl_lab (Lab f l) =
  ((showsl_lab f . showsl_lit "[") . showsl l) . showsl_lit "]";
showsl_lab (Sharp f) = showsl_lab f . showsl_lit "#";
showsl_lab (FunLab f l) =
  showsl_lab f . default_showsl_list id (map showsl_lab l);

showsl_list_lab ::
  forall a b. (Showl a, Showl b) => [Lab a b] -> String -> String;
showsl_list_lab xs = default_showsl_list showsl_lab xs;

instance (Showl a, Showl b) => Showl (Lab a b) where {
  showsl = showsl_lab;
  showsl_list = showsl_list_lab;
};

instance (Compare a, Compare b) => Compare_order (Lab a b) where {
};

ccompare_lab ::
  forall a b. (Compare a, Compare b) => Maybe (Lab a b -> Lab a b -> Ordera);
ccompare_lab = Just compare_lab;

instance (Compare a, Compare b) => Ccompare (Lab a b) where {
  ccompare = ccompare_lab;
};

data Hints = Hints [Int] | Simplex;

default_hints :: Hints;
default_hints = Simplex;

class Default a where {
  defaulta :: a;
};

instance Default Hints where {
  defaulta = default_hints;
};

newtype Monom a = Abs_monom [(a, Nat)];

rep_monom :: forall a. (Linorder a) => Monom a -> [(a, Nat)];
rep_monom (Abs_monom x) = x;

equal_monom :: forall a. (Eq a, Linorder a) => Monom a -> Monom a -> Bool;
equal_monom xa xc = rep_monom xa == rep_monom xc;

instance (Eq a, Linorder a) => Eq (Monom a) where {
  a == b = equal_monom a b;
};

less_eq_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less_eq y1 y2;

less_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less y1 y2;

instance (Ord a, Ord b) => Ord (a, b) where {
  less_eq = less_eq_prod;
  less = less_prod;
};

comparator_prod ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> (a, b) -> (a, b) -> Ordera;
comparator_prod comp_a comp_b (x, xa) (y, ya) = (case comp_a x y of {
          Eqa -> comp_b xa ya;
          Lt -> Lt;
          Gt -> Gt;
        });

compare_prod ::
  forall a b. (Compare a, Compare b) => (a, b) -> (a, b) -> Ordera;
compare_prod = comparator_prod compare compare;

instance (Compare a, Compare b) => Compare (a, b) where {
  compare = compare_prod;
};

instance (Order a, Order b) => Quasi_order (a, b) where {
};

instance (Order a, Order b) => Weak_order (a, b) where {
};

instance (Preorder a, Preorder b) => Preorder (a, b) where {
};

instance (Order a, Order b) => Order (a, b) where {
};

equality_prod ::
  forall a b. (a -> a -> Bool) -> (b -> b -> Bool) -> (a, b) -> (a, b) -> Bool;
equality_prod eq_a eq_b (x, xa) (y, ya) = eq_a x y && eq_b xa ya;

ceq_prod :: forall a b. (Ceq a, Ceq b) => Maybe ((a, b) -> (a, b) -> Bool);
ceq_prod = (case ceq of {
             Nothing -> Nothing;
             Just eq_a -> (case ceq of {
                            Nothing -> Nothing;
                            Just eq_b -> Just (equality_prod eq_a eq_b);
                          });
           });

instance (Ceq a, Ceq b) => Ceq (a, b) where {
  ceq = ceq_prod;
};

of_phantom :: forall a b. Phantom a b -> b;
of_phantom (Phantom x) = x;

set_impl_choose2 :: Set_impla -> Set_impla -> Set_impla;
set_impl_choose2 Set_Monada Set_Monada = Set_Monada;
set_impl_choose2 Set_RBT Set_RBT = Set_RBT;
set_impl_choose2 Set_DList Set_DList = Set_DList;
set_impl_choose2 Set_Collect Set_Collect = Set_Collect;
set_impl_choose2 x y = Set_Choose;

set_impl_prod ::
  forall a b. (Set_impl a, Set_impl b) => Phantom (a, b) Set_impla;
set_impl_prod =
  Phantom
    (set_impl_choose2 (of_phantom (set_impl :: Phantom a Set_impla))
      (of_phantom (set_impl :: Phantom b Set_impla)));

instance (Set_impl a, Set_impl b) => Set_impl (a, b) where {
  set_impl = set_impl_prod;
};

instance (Linorder a, Linorder b) => Linorder (a, b) where {
};

instance (Compare_order a, Compare_order b) => Compare_order (a, b) where {
};

ccompare_prod ::
  forall a b. (Ccompare a, Ccompare b) => Maybe ((a, b) -> (a, b) -> Ordera);
ccompare_prod =
  (case ccompare of {
    Nothing -> Nothing;
    Just comp_a -> (case ccompare of {
                     Nothing -> Nothing;
                     Just comp_b -> Just (comparator_prod comp_a comp_b);
                   });
  });

instance (Ccompare a, Ccompare b) => Ccompare (a, b) where {
  ccompare = ccompare_prod;
};

data Arctic = MinInfty | Num_arc Int;

equal_arctic :: Arctic -> Arctic -> Bool;
equal_arctic MinInfty (Num_arc x2) = False;
equal_arctic (Num_arc x2) MinInfty = False;
equal_arctic (Num_arc x2) (Num_arc y2) = equal_int x2 y2;
equal_arctic MinInfty MinInfty = True;

instance Eq Arctic where {
  a == b = equal_arctic a b;
};

one_arctic :: Arctic;
one_arctic = Num_arc zero_int;

instance One Arctic where {
  onea = one_arctic;
};

plus_arctic :: Arctic -> Arctic -> Arctic;
plus_arctic MinInfty y = y;
plus_arctic (Num_arc v) MinInfty = Num_arc v;
plus_arctic (Num_arc x) (Num_arc y) = Num_arc (max x y);

instance Plus Arctic where {
  plus = plus_arctic;
};

zero_arctic :: Arctic;
zero_arctic = MinInfty;

instance Zero Arctic where {
  zeroa = zero_arctic;
};

instance Semigroup_add Arctic where {
};

instance Numeral Arctic where {
};

times_arctic :: Arctic -> Arctic -> Arctic;
times_arctic MinInfty y = MinInfty;
times_arctic (Num_arc v) MinInfty = MinInfty;
times_arctic (Num_arc x) (Num_arc y) = Num_arc (plus_int x y);

instance Times Arctic where {
  times = times_arctic;
};

instance Power Arctic where {
};

instance Ab_semigroup_add Arctic where {
};

instance Semigroup_mult Arctic where {
};

instance Semiring Arctic where {
};

instance Mult_zero Arctic where {
};

instance Monoid_add Arctic where {
};

instance Comm_monoid_add Arctic where {
};

instance Semiring_0 Arctic where {
};

instance Monoid_mult Arctic where {
};

instance Semiring_numeral Arctic where {
};

instance Zero_neq_one Arctic where {
};

instance Semiring_1 Arctic where {
};

ceq_arctic :: Maybe (Arctic -> Arctic -> Bool);
ceq_arctic = Just equal_arctic;

instance Ceq Arctic where {
  ceq = ceq_arctic;
};

set_impl_arctic :: Phantom Arctic Set_impla;
set_impl_arctic = Phantom Set_RBT;

instance Set_impl Arctic where {
  set_impl = set_impl_arctic;
};

comparator_arctic :: Arctic -> Arctic -> Ordera;
comparator_arctic (Num_arc x) (Num_arc y) = comparator_of x y;
comparator_arctic (Num_arc x) MinInfty = Gt;
comparator_arctic MinInfty (Num_arc y) = Lt;
comparator_arctic MinInfty MinInfty = Eqa;

compare_arctic :: Arctic -> Arctic -> Ordera;
compare_arctic = comparator_arctic;

ccompare_arctic :: Maybe (Arctic -> Arctic -> Ordera);
ccompare_arctic = Just compare_arctic;

instance Ccompare Arctic where {
  ccompare = ccompare_arctic;
};

data Sharp a = Flat a | Sharpa a;

equal_sharp :: forall a. (Eq a) => Sharp a -> Sharp a -> Bool;
equal_sharp (Flat x1) (Sharpa x2) = False;
equal_sharp (Sharpa x2) (Flat x1) = False;
equal_sharp (Sharpa x2) (Sharpa y2) = x2 == y2;
equal_sharp (Flat x1) (Flat y1) = x1 == y1;

instance (Eq a) => Eq (Sharp a) where {
  a == b = equal_sharp a b;
};

comparator_sharp ::
  forall a. (a -> a -> Ordera) -> Sharp a -> Sharp a -> Ordera;
comparator_sharp comp_l (Sharpa x) (Sharpa ya) = comp_l x ya;
comparator_sharp comp_l (Sharpa x) (Flat y) = Gt;
comparator_sharp comp_l (Flat x) (Sharpa ya) = Lt;
comparator_sharp comp_l (Flat x) (Flat y) = comp_l x y;

ccompare_sharp ::
  forall a. (Ccompare a) => Maybe (Sharp a -> Sharp a -> Ordera);
ccompare_sharp = (case ccompare of {
                   Nothing -> Nothing;
                   Just comp_l -> Just (comparator_sharp comp_l);
                 });

instance (Ccompare a) => Ccompare (Sharp a) where {
  ccompare = ccompare_sharp;
};

data Mapping_impla = Mapping_Choose | Mapping_Assoc_List | Mapping_RBT
  | Mapping_Mapping;

mapping_impl_sharp :: forall a. Phantom (Sharp a) Mapping_impla;
mapping_impl_sharp = Phantom Mapping_RBT;

class Mapping_impl a where {
  mapping_impl :: Phantom a Mapping_impla;
};

instance Mapping_impl (Sharp a) where {
  mapping_impl = mapping_impl_sharp;
};

data Arctic_delta a = MinInfty_delta | Num_arc_delta a;

equal_arctic_delta ::
  forall a. (Eq a) => Arctic_delta a -> Arctic_delta a -> Bool;
equal_arctic_delta MinInfty_delta (Num_arc_delta x2) = False;
equal_arctic_delta (Num_arc_delta x2) MinInfty_delta = False;
equal_arctic_delta (Num_arc_delta x2) (Num_arc_delta y2) = x2 == y2;
equal_arctic_delta MinInfty_delta MinInfty_delta = True;

instance (Eq a) => Eq (Arctic_delta a) where {
  a == b = equal_arctic_delta a b;
};

one_arctic_delta :: forall a. (Linordered_field a) => Arctic_delta a;
one_arctic_delta = Num_arc_delta zeroa;

instance (Linordered_field a) => One (Arctic_delta a) where {
  onea = one_arctic_delta;
};

plus_arctic_delta ::
  forall a.
    (Linordered_field a) => Arctic_delta a -> Arctic_delta a -> Arctic_delta a;
plus_arctic_delta MinInfty_delta y = y;
plus_arctic_delta (Num_arc_delta v) MinInfty_delta = Num_arc_delta v;
plus_arctic_delta (Num_arc_delta x) (Num_arc_delta y) = Num_arc_delta (max x y);

instance (Linordered_field a) => Plus (Arctic_delta a) where {
  plus = plus_arctic_delta;
};

zero_arctic_delta :: forall a. (Linordered_field a) => Arctic_delta a;
zero_arctic_delta = MinInfty_delta;

instance (Linordered_field a) => Zero (Arctic_delta a) where {
  zeroa = zero_arctic_delta;
};

instance (Linordered_field a) => Semigroup_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Numeral (Arctic_delta a) where {
};

times_arctic_delta ::
  forall a.
    (Linordered_field a) => Arctic_delta a -> Arctic_delta a -> Arctic_delta a;
times_arctic_delta MinInfty_delta y = MinInfty_delta;
times_arctic_delta (Num_arc_delta v) MinInfty_delta = MinInfty_delta;
times_arctic_delta (Num_arc_delta x) (Num_arc_delta y) =
  Num_arc_delta (plus x y);

instance (Linordered_field a) => Times (Arctic_delta a) where {
  times = times_arctic_delta;
};

instance (Linordered_field a) => Power (Arctic_delta a) where {
};

instance (Linordered_field a) => Ab_semigroup_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Semigroup_mult (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring (Arctic_delta a) where {
};

instance (Linordered_field a) => Mult_zero (Arctic_delta a) where {
};

instance (Linordered_field a) => Monoid_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Comm_monoid_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_0 (Arctic_delta a) where {
};

instance (Linordered_field a) => Monoid_mult (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_numeral (Arctic_delta a) where {
};

instance (Linordered_field a) => Zero_neq_one (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_1 (Arctic_delta a) where {
};

ceq_arctic_delta ::
  forall a. (Eq a) => Maybe (Arctic_delta a -> Arctic_delta a -> Bool);
ceq_arctic_delta = Just equal_arctic_delta;

instance (Eq a) => Ceq (Arctic_delta a) where {
  ceq = ceq_arctic_delta;
};

set_impl_arctic_delta :: forall a. Phantom (Arctic_delta a) Set_impla;
set_impl_arctic_delta = Phantom Set_RBT;

instance Set_impl (Arctic_delta a) where {
  set_impl = set_impl_arctic_delta;
};

comparator_arctic_delta ::
  forall a. (a -> a -> Ordera) -> Arctic_delta a -> Arctic_delta a -> Ordera;
comparator_arctic_delta comp_a (Num_arc_delta x) (Num_arc_delta y) = comp_a x y;
comparator_arctic_delta comp_a (Num_arc_delta x) MinInfty_delta = Gt;
comparator_arctic_delta comp_a MinInfty_delta (Num_arc_delta y) = Lt;
comparator_arctic_delta comp_a MinInfty_delta MinInfty_delta = Eqa;

compare_arctic_delta ::
  forall a. (Compare a) => Arctic_delta a -> Arctic_delta a -> Ordera;
compare_arctic_delta = comparator_arctic_delta compare;

ccompare_arctic_delta ::
  forall a. (Compare a) => Maybe (Arctic_delta a -> Arctic_delta a -> Ordera);
ccompare_arctic_delta = Just compare_arctic_delta;

instance (Compare a) => Ccompare (Arctic_delta a) where {
  ccompare = ccompare_arctic_delta;
};

data Itself a = Type;

data Color = R | B;

data Rbta a b = Empty | Branch Color (Rbta a b) a b (Rbta a b);

newtype Rbt b a = RBT (Rbta b a);

newtype Mapping_rbt b a = Mapping_RBTa (Rbta b a);

newtype Set_dlist a = Abs_dlist [a];

data Set a = Collect_set (a -> Bool) | DList_set (Set_dlist a)
  | RBT_set (Mapping_rbt a ()) | Set_Monad [a] | Complement (Set a);

data Xml = XML [Char] [([Char], [Char])] [Xml] | XML_text [Char];

newtype Vec_impl a = Abs_vec_impl (Nat, IArray.IArray a);

newtype Vec a = Vec_impl (Vec_impl a);

data Xmldoc = XMLDOC [[Char]] Xml;

newtype Alist b a = Alist [(b, a)];

data Hint a = Default | Base a | Distribute Nat [Hint a] | Erase Nat (Hint a)
  | LexStrict [Hint a] | LexWeak [Hint a];

data Formula a = Atom a | NegAtom a | Conjunction [Formula a]
  | Disjunction [Formula a];

data Trans_var a = Pre a | Post a | Intermediate a;

data Transition_rule a b c d =
  Transition d d (Formula (Term a (Trans_var b, c)));

data Lts_impl a b c d e =
  Lts_Impl [d] [(e, Transition_rule a b c d)] [(d, Formula (Term a (b, c)))];

data Sum a b = Inl a | Inr b;

data Order_tag = Lex | Mul;

data Mapping a b = Assoc_List_Mapping (Alist a b)
  | RBT_Mapping (Mapping_rbt a b) | Mapping (a -> Maybe b);

data Xml_error a = TagMismatch [String] | Fatal a;

data Domain = Natural Nat | Integera | Arctic | Arctic_rat | Int_mat Nat Nat
  | Arctic_mat Nat | Arctic_rat_mat Nat | Rational Rat Nat | Rat_mat Nat Nat
  | Mini_Alg Real Nat | Mini_Alg_mat Nat Nat;

data Enat = Enat Nat | Infinity_enat;

data Tpoly a b = PVar a | PNum b | PSum [Tpoly a b] | PMult [Tpoly a b];

data Reduction_order_input a = RPO_Input [((a, Nat), (Nat, Order_tag))]
  | KBO_Input ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat);

data Ta_rule a b = TA_rule b [a] a;

data Tree_automaton a b = Tree_Automaton [a] [Ta_rule a b] [(a, a)];

data Sig = LessF | LeF | SumF Nat | ConstF Int | ProdF Nat | EqF;

data Ty = BoolT | IntT;

data Complexity_measure a b = Derivational_Complexity [(a, Nat)]
  | Runtime_Complexity [(a, Nat)] [(a, Nat)];

data Equation_literal a b = Equation (Term a b, Term a b)
  | Inequality (Term a b, Term a b);

newtype Complexity_class = Comp_Poly Nat;

data Location = H | A | Ba | Ra;

data Ctxt a b = Hole | More a [Term a b] (Ctxt a b) [Term a b];

data Fp_strategy a b = Outermost | Context_Sensitive [((a, Nat), [Nat])]
  | Forbidden_Patterns [(Ctxt a b, (Term a b, Location))];

data Start_term = Full | Constructor_Based;

data Strategy a b = No_Strategy | Innermost | Innermost_Q [Term a b];

data Input a b =
  DP_input Bool [(Term a b, Term a b)] (Strategy a b) [(Term a b, Term a b)]
  | Inn_TRS_input (Strategy a b) [(Term a b, Term a b)] [(Term a b, Term a b)]
      Start_term
  | CPX_input (Strategy a b) [(Term a b, Term a b)] [(Term a b, Term a b)]
      (Complexity_measure a b) Complexity_class
  | COMP_input [(Term a b, Term a b)] [(Term a b, Term a b)]
  | OCOMP_input [(Term a b, Term a b)] [(Term a b, Term a b)]
      [(Term a b, Term a b)] (Reduction_order_input a)
  | EQ_input [(Term a b, Term a b)] (Equation_literal a b)
  | FP_TRS_input (Fp_strategy a b) [(Term a b, Term a b)]
  | CTRS_input [((Term a b, Term a b), [(Term a b, Term a b)])]
  | TA_input (Tree_automaton [Char] a) [(Term a b, Term a b)]
  | AC_input [(Term a b, Term a b)] [a] [a]
  | LTS_input (Lts_impl Sig b Ty [Char] [Char])
  | LTS_safety_input (Lts_impl Sig b Ty [Char] [Char]) [[Char]]
  | Unknown_input [Char];

data Const_string_sound_proof a b =
  Const_string_sound_proof b [(a, a)] [(Term a b, Term a b)]
    [(Term a b, Term a b)];

data Siga = ConstFa Nat | SumFa | ProdFa | MaxF;

data Af_entry = Collapse Nat | AFList [Nat];

data Redtriple_impl a = Int_carrier [((a, Nat), (Int, [Int]))]
  | Int_nl_carrier [((a, Nat), [(Monom Nat, Int)])]
  | Rat_carrier [((a, Nat), (Rat, [Rat]))]
  | Rat_nl_carrier Rat [((a, Nat), [(Monom Nat, Rat)])]
  | Real_carrier [((a, Nat), (Real, [Real]))]
  | Real_nl_carrier Real [((a, Nat), [(Monom Nat, Real)])]
  | Arctic_carrier [((a, Nat), (Arctic, [Arctic]))]
  | Arctic_rat_carrier [((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]))]
  | Int_mat_carrier Nat Nat [((a, Nat), (Mat Int, [Mat Int]))]
  | Rat_mat_carrier Nat Nat [((a, Nat), (Mat Rat, [Mat Rat]))]
  | Real_mat_carrier Nat Nat [((a, Nat), (Mat Real, [Mat Real]))]
  | Arctic_mat_carrier Nat [((a, Nat), (Mat Arctic, [Mat Arctic]))]
  | Arctic_rat_mat_carrier Nat
      [((a, Nat), (Mat (Arctic_delta Rat), [Mat (Arctic_delta Rat)]))]
  | RPO [((a, Nat), (Nat, Order_tag))] [((a, Nat), Af_entry)]
  | KBO ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) [((a, Nat), Af_entry)]
  | ACKBO ([((a, Nat), (Nat, (Nat, Bool)))], Nat) [((a, Nat), Af_entry)]
  | WPO [((a, Nat), (Nat, [Nat]))] (Redtriple_impl a)
  | Max_poly [((a, Nat), Term Siga Nat)];

data Complex_constant_removal_prf a b =
  Complex_Constant_Removal_Proof (Term a b)
    [((Term a b, Term a b), (Term a b, Term a b))];

data List_order_type = MS_Ext | Max_Ext | Min_Ext | Dms_Ext;

data Root_redtriple_impl a =
  SCNP List_order_type [((a, Nat), [(Nat, Nat)])] (Redtriple_impl a);

data Cond_constraint a b = CC_cond Bool (Term a b, Term a b)
  | CC_rewr (Term a b) (Term a b)
  | CC_impl [Cond_constraint a b] (Cond_constraint a b)
  | CC_all b (Cond_constraint a b);

data Cond_constraint_prf a b = Final
  | Delete_Condition (Cond_constraint a b) (Cond_constraint_prf a b)
  | Different_Constructor (Cond_constraint a b)
  | Same_Constructor (Cond_constraint a b) (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Variable_Equation b (Term a b) (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Funarg_Into_Var (Cond_constraint a b) Nat b (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Simplify_Condition (Cond_constraint a b) [(b, Term a b)]
      (Cond_constraint a b) (Cond_constraint_prf a b)
  | Induction (Cond_constraint a b) [Cond_constraint a b]
      [((Term a b, Term a b),
         ([(Term a b, [b])], (Cond_constraint a b, Cond_constraint_prf a b)))];

data Cond_red_pair_prf a b =
  Cond_Red_Pair_Prf a
    [(Cond_constraint a b, ([(Term a b, Term a b)], Cond_constraint_prf a b))]
    Nat Nat;

data ArithFun = Arg Nat | Const Nat | Sum [ArithFun] | Max [ArithFun]
  | Min [ArithFun] | Prod [ArithFun]
  | IfEqual ArithFun ArithFun ArithFun ArithFun;

data Sl_inter a = SL_Inter Nat [((a, Nat), ArithFun)];

data Sl_variant a b = Rootlab (Maybe (a, Nat)) | Finitelab (Sl_inter a)
  | QuasiFinitelab (Sl_inter a) b;

data Generic_assm_proof a b c d e f g h =
  SN_assm_proof
    (Bool,
      ([Term (Lab a b) c],
        ([(Term (Lab a b) c, Term (Lab a b) c)],
          [(Term (Lab a b) c, Term (Lab a b) c)])))
    d
  | Finite_assm_proof
      (Bool,
        (Bool,
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([Term (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  [(Term (Lab a b) c, Term (Lab a b) c)]))))))
      e
  | SN_FP_assm_proof
      ([(Ctxt (Lab a b) c, (Term (Lab a b) c, Location))],
        [(Term (Lab a b) c, Term (Lab a b) c)])
      f
  | Not_SN_assm_proof
      (Bool, ([Term (Lab a b) c], [(Term (Lab a b) c, Term (Lab a b) c)])) d
  | Infinite_assm_proof
      (Bool,
        (Bool,
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([Term (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  [(Term (Lab a b) c, Term (Lab a b) c)]))))))
      e
  | Not_RelSN_assm_proof
      (Bool,
        ([Term (Lab a b) c],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      f
  | Not_SN_FP_assm_proof
      ([(Ctxt (Lab a b) c, (Term (Lab a b) c, Location))],
        [(Term (Lab a b) c, Term (Lab a b) c)])
      g
  | Complexity_assm_proof
      ([Term (Lab a b) c],
        ([(Term (Lab a b) c, Term (Lab a b) c)],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            (Complexity_measure (Lab a b) c, Complexity_class))))
      d
  | Unknown_assm_proof [Char] h;

data Join_info a =
  Guided
    [(Term a [Char],
       ([([Nat], ((Term a [Char], Term a [Char]), Term a [Char]))],
         (Term a [Char],
           [([Nat], ((Term a [Char], Term a [Char]), Term a [Char]))])))]
  | Join_NF | Join_BFS Nat;

newtype ProjL a = Projection [((a, Nat), Nat)];

data Ta_relation a = Decision_Proc_Old | Decision_Proc | Id_Relation
  | Some_Relation [(a, a)];

data Boundstype = Roof | Match;

data Bounds_info a b =
  Bounds_Info Boundstype Nat [b] (Tree_automaton b (a, Nat)) (Ta_relation b);

data Trs_termination_proof a b c =
  DP_Trans Bool Bool [(Term (Lab a b) c, Term (Lab a b) c)]
    (Dp_termination_proof a b c)
  | Rule_Removal (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | String_Reversal (Trs_termination_proof a b c)
  | Constant_String (Const_string_sound_proof (Lab a b) c)
      (Trs_termination_proof a b c)
  | Bounds (Bounds_info (Lab a b) c)
  | Uncurry
      (Lab a b,
        ([((Lab a b, Nat), [Lab a b])],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | Semlab (Sl_variant (Lab a b) c) [Term (Lab a b) c]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | R_is_Empty
  | Fcc [Ctxt (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_termination_proof a b c)
  | Split [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
      (Trs_termination_proof a b c)
  | Switch_Innermost (Join_info (Lab a b)) (Trs_termination_proof a b c)
  | Drop_Equality (Trs_termination_proof a b c)
  | Remove_Nonapplicable_Rules [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_termination_proof a b c)
  | Permuting_AFS [((Lab a b, Nat), Af_entry)] (Trs_termination_proof a b c)
  | Assume_SN
      (Bool,
        ([Term (Lab a b) c],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [Generic_assm_proof a b c (Trs_termination_proof a b c)
         (Dp_termination_proof a b c) (Fptrs_termination_proof a b c) ()
         (Unknown_proof a b c)];

data Fptrs_termination_proof a b c =
  Assume_FP_SN
    ([(Ctxt (Lab a b) c, (Term (Lab a b) c, Location))],
      [(Term (Lab a b) c, Term (Lab a b) c)])
    [Generic_assm_proof a b c (Trs_termination_proof a b c)
       (Dp_termination_proof a b c) (Fptrs_termination_proof a b c) ()
       (Unknown_proof a b c)];

data Dp_termination_proof a b c = P_is_Empty
  | Subterm_Criterion_Proc (ProjL (Lab a b))
      [((Term (Lab a b) c, Term (Lab a b) c),
         [([Nat], ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))])]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Gen_Subterm_Criterion_Proc [((Lab a b, Nat), [Nat])]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Redpair_Proc
      (Sum (Root_redtriple_impl (Lab a b)) (Redtriple_impl (Lab a b)))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Redpair_UR_Proc
      (Sum (Root_redtriple_impl (Lab a b)) (Redtriple_impl (Lab a b)))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Usable_Rules_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      (Dp_termination_proof a b c)
  | Dep_Graph_Proc
      [(Maybe (Dp_termination_proof a b c),
         [(Term (Lab a b) c, Term (Lab a b) c)])]
  | Mono_Redpair_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Mono_URM_Redpair_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Mono_Redpair_UR_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Size_Change_Subterm_Proc
      [((Term (Lab a b) c, Term (Lab a b) c), ([(Nat, Nat)], [(Nat, Nat)]))]
  | Size_Change_Redpair_Proc (Redtriple_impl (Lab a b))
      (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      [((Term (Lab a b) c, Term (Lab a b) c), ([(Nat, Nat)], [(Nat, Nat)]))]
  | Uncurry_Proc (Maybe Nat)
      (Lab a b,
        ([((Lab a b, Nat), [Lab a b])],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Fcc_Proc (Lab a b) [Ctxt (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Split_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
      (Dp_termination_proof a b c)
  | Semlab_Proc (Sl_variant (Lab a b) c) [(Term (Lab a b) c, Term (Lab a b) c)]
      [Term (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      (Dp_termination_proof a b c)
  | Switch_Innermost_Proc (Join_info (Lab a b)) (Dp_termination_proof a b c)
  | Rewriting_Proc (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      (Term (Lab a b) c, Term (Lab a b) c) (Term (Lab a b) c, Term (Lab a b) c)
      (Term (Lab a b) c, Term (Lab a b) c) (Term (Lab a b) c, Term (Lab a b) c)
      [Nat] (Dp_termination_proof a b c)
  | Instantiation_Proc (Term (Lab a b) c, Term (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Forward_Instantiation_Proc (Term (Lab a b) c, Term (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      (Dp_termination_proof a b c)
  | Narrowing_Proc (Term (Lab a b) c, Term (Lab a b) c) [Nat]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Assume_Finite
      (Bool,
        (Bool,
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([Term (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  [(Term (Lab a b) c, Term (Lab a b) c)]))))))
      [Generic_assm_proof a b c (Trs_termination_proof a b c)
         (Dp_termination_proof a b c) (Fptrs_termination_proof a b c) ()
         (Unknown_proof a b c)]
  | Unlab_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Q_Reduction_Proc [Term (Lab a b) c] (Dp_termination_proof a b c)
  | Complex_Constant_Removal_Proc (Complex_constant_removal_prf (Lab a b) c)
      (Dp_termination_proof a b c)
  | General_Redpair_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Cond_red_pair_prf (Lab a b) c)
      [Dp_termination_proof a b c]
  | To_Trs_Proc (Trs_termination_proof a b c);

data Unknown_proof a b c =
  Assume_Unknown [Char]
    [Generic_assm_proof a b c (Trs_termination_proof a b c)
       (Dp_termination_proof a b c) (Fptrs_termination_proof a b c) ()
       (Unknown_proof a b c)];

data Cr_proof a b c = SN_WCR (Join_info (Lab a b)) (Trs_termination_proof a b c)
  | Weakly_Orthogonal | Strongly_Closed Nat
  | Rule_Labeling [((Term (Lab a b) c, Term (Lab a b) c), Nat)]
      [(Term (Lab a b) [Char],
         ([([Nat],
             ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
               Term (Lab a b) [Char]))],
           (Term (Lab a b) [Char],
             [([Nat],
                ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                  Term (Lab a b) [Char]))])))]
      (Maybe (Trs_termination_proof a b c))
  | Rule_Labeling_Conv [((Term (Lab a b) c, Term (Lab a b) c), Nat)]
      [(Term (Lab a b) [Char],
         (Term (Lab a b) [Char],
           ([([Nat],
               ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                 (Bool, Term (Lab a b) [Char])))],
             ([([Nat],
                 ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                   Term (Lab a b) [Char]))],
               ([([Nat],
                   ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                     (Bool, Term (Lab a b) [Char])))],
                 (Term (Lab a b) [Char],
                   ([([Nat],
                       ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                         (Bool, Term (Lab a b) [Char])))],
                     ([([Nat],
                         ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                           Term (Lab a b) [Char]))],
                       [([Nat],
                          ((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                            (Bool, Term (Lab a b) [Char])))]))))))))]
      (Maybe (Nat, Trs_termination_proof a b c))
  | Redundant_Rules [(Term (Lab a b) c, Term (Lab a b) c)] Nat
      [[([Nat],
          ((Term (Lab a b) c, Term (Lab a b) c), (Bool, Term (Lab a b) c)))]]
      (Cr_proof a b c)
  | Parallel_Closed (Maybe Nat)
  | Critical_Pair_Closing_System [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_termination_proof a b c) Nat
  | Persistent_Decomposition [(Lab a b, ([[Char]], [Char]))]
      [([(Term (Lab a b) c, Term (Lab a b) c)], Cr_proof a b c)];

data Ring_ext a b = Ring_ext a (a -> a -> a) b;

newtype Sum_bot a b = Sumbot (Sum a b);

data Non_join_info a b c = Diff_NFs
  | Tcap_Non_Unif (Term a b -> Term a b -> b -> Term a b)
  | Tree_Aut_Intersect_Empty (Tree_automaton c a) (Ta_relation c)
      (Tree_automaton c a) (Ta_relation c)
  | Finite_Model_Gt (Sl_variant a b) | Reduction_Pair_Gt (Redtriple_impl a)
  | Usable_Rules_Reach_NJ (Non_join_info a b c)
  | Usable_Rules_Reach_Unif_NJ
      (Sum [(Term a b, Term a b)] [(Term a b, Term a b)]) (Non_join_info a b c)
  | Argument_Filter_NJ [((a, Nat), Af_entry)] (Non_join_info a b c)
  | Grounding [(b, Term a b)] (Non_join_info a b c)
  | Subterm_NJ [Nat] (Non_join_info a b c);

data Ncr_proof a b c d = SN_NWCR (Trs_termination_proof a b c)
  | Non_Join (Term (Lab a b) c)
      [([Nat], ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))]
      [([Nat], ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))]
      (Non_join_info (Lab a b) c d)
  | NCR_Disj_Subtrs [(Term (Lab a b) c, Term (Lab a b) c)] (Ncr_proof a b c d)
  | NCR_Redundant_Rules [(Term (Lab a b) c, Term (Lab a b) c)] Nat
      (Ncr_proof a b c d)
  | NCR_Persistent_Decomposition [(Lab a b, ([[Char]], [Char]))]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Ncr_proof a b c d);

data Rule_removal_nonterm_reltrs_prf a b =
  Rule_removal_nonterm_reltrs_prf (Maybe [(Term a b, Term a b)])
    (Maybe [(Term a b, Term a b)]);

newtype Dp_trans_nontermination_tt_prf a b c = DP_trans_nontermination_tt_prf
  [(Term (Lab a b) c, Term (Lab a b) c)];

data Const_string_complete_proof a b =
  Const_string_complete_proof b [(a, a)] [(Term a b, Term a b)];

newtype Rule_removal_nonterm_trs_prf a b = Rule_removal_nonterm_trs_prf
  [(Term a b, Term a b)];

newtype Q_increase_nonterm_trs_prf a b = Q_increase_nonterm_trs_prf [Term a b];

newtype Dp_q_reduction_nonterm_prf a b = DP_q_reduction_nonterm_prf [Term a b];

newtype Instantiation_complete_proc_prf a b = Instantiation_complete_proc_prf
  [(Term a b, Term a b)];

data Rule_removal_nonterm_dp_prf a b =
  Rule_removal_nonterm_dp_prf (Maybe [(Term a b, Term a b)])
    (Maybe [(Term a b, Term a b)]);

newtype Q_increase_nonterm_dp_prf a b = Q_increase_nonterm_dp_prf [Term a b];

data Rewriting_complete_proc_prf a b =
  Rewriting_complete_proc_prf (Maybe [(Term a b, Term a b)])
    (Term a b, Term a b) (Term a b, Term a b) (Term a b, Term a b)
    (Term a b, Term a b) [Nat];

data Narrowing_complete_proc_prf a b =
  Narrowing_complete_proc_prf (Term a b, Term a b) [Nat] [(Term a b, Term a b)];

data Pat_rule_pos = Pat_Base | Pat_Pump | Pat_Close;

data Pat_eqv_prf a b = Pat_Dom_Renaming [(b, Term a b)]
  | Pat_Irrelevant [(b, Term a b)] [(b, Term a b)]
  | Pat_Simplify [(b, Term a b)] [(b, Term a b)];

data Pat_rule_prf a b = Pat_OrigRule (Term a b, Term a b) Bool
  | Pat_InitPump (Pat_rule_prf a b) [(b, Term a b)] [(b, Term a b)]
  | Pat_InitPumpCtxt (Pat_rule_prf a b) [(b, Term a b)] [Nat] b
  | Pat_Equiv (Pat_rule_prf a b) Bool (Pat_eqv_prf a b)
  | Pat_Narrow (Pat_rule_prf a b) (Pat_rule_prf a b) [Nat]
  | Pat_Inst (Pat_rule_prf a b) [(b, Term a b)] Pat_rule_pos
  | Pat_Rewr (Pat_rule_prf a b)
      (Term a b, [([Nat], ((Term a b, Term a b), Term a b))]) Pat_rule_pos b
  | Pat_Exp_Sigma (Pat_rule_prf a b) Nat;

data Non_loop_prf a b =
  Non_loop_prf (Pat_rule_prf a b) [(b, Term a b)] [(b, Term a b)] Nat Nat [Nat];

data Dp_loop_prf a b =
  DP_loop_prf (Term a b) [([Nat], ((Term a b, Term a b), (Bool, Term a b)))]
    [(b, Term a b)] (Ctxt a b);

data Not_wn_ta_prf a b = Not_wn_ta_prf (Tree_automaton b a) (Ta_relation b);

data Dp_proof_step a = OC1 ([a], [a]) Bool
  | OC2 ([a], [a]) ([a], [a]) ([a], [a]) [a] [a] [a]
  | OC2p ([a], [a]) ([a], [a]) ([a], [a]) [a] [a] [a]
  | OC3 ([a], [a]) ([a], [a]) ([a], [a]) [a] [a]
  | OC3p ([a], [a]) ([a], [a]) ([a], [a]) [a] [a]
  | OCDP1 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a])
  | OCDP2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a])
  | WPEQ (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
  | Lift (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
  | DPOC1_1 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a]) [a] [a]
  | DPOC1_2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a]) [a] [a] [a]
  | DPOC2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a]) [a] [a]
  | DPOC3_1 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a]) [a] [a]
  | DPOC3_2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      ([a], [a]) [a] [a] [a]
  | DPDP1_1 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a]))) [a] [a]
  | DPDP1_2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a]))) [a] [a]
  | DPDP2_1 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a]))) [a] [a]
  | DPDP2_2 (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a])))
      (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a]))) [a]
      [a];

data Non_loop_srs_proof a = SE_OC ([a], [a]) [a] [a] [Dp_proof_step a]
  | SE_DP (([a], ((Nat, (Nat, [a])), [a])), ([a], ((Nat, (Nat, [a])), [a]))) [a]
      [a] [Dp_proof_step a];

data Uncurry_nt_proof a b c =
  Uncurry_nt_proof
    (Lab a b,
      ([((Lab a b, Nat), [Lab a b])],
        ([(Term (Lab a b) c, Term (Lab a b) c)],
          [(Term (Lab a b) c, Term (Lab a b) c)])))
    [(Term (Lab a b) c, Term (Lab a b) c)];

data Trs_loop_prf a b =
  TRS_loop_prf (Term a b) [([Nat], ((Term a b, Term a b), Term a b))]
    [(b, Term a b)] (Ctxt a b);

data Rel_trs_loop_prf a b =
  Rel_trs_loop_prf (Term a b)
    [([Nat], ((Term a b, Term a b), (Bool, Term a b)))] [(b, Term a b)]
    (Ctxt a b);

data Reltrs_nontermination_proof a b c = Rel_Loop (Rel_trs_loop_prf (Lab a b) c)
  | Rel_TRS_String_Reversal (Reltrs_nontermination_proof a b c)
  | Rel_Not_Well_Formed
  | Rel_Rule_Removal (Rule_removal_nonterm_reltrs_prf (Lab a b) c)
      (Reltrs_nontermination_proof a b c)
  | Rel_R_Not_SN (Trs_nontermination_proof a b c)
  | Rel_TRS_Assume_Not_SN
      (Bool,
        ([Term (Lab a b) c],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [Generic_assm_proof a b c (Trs_nontermination_proof a b c)
         (Dp_nontermination_proof a b c) (Reltrs_nontermination_proof a b c)
         (Trs_nontermination_proof a b c) (Neg_unknown_proof a b c)];

data Trs_nontermination_proof a b c = TRS_Loop (Trs_loop_prf (Lab a b) c)
  | TRS_Not_Well_Formed
  | TRS_Rule_Removal (Rule_removal_nonterm_trs_prf (Lab a b) c)
      (Trs_nontermination_proof a b c)
  | TRS_String_Reversal (Trs_nontermination_proof a b c)
  | TRS_Constant_String (Const_string_complete_proof (Lab a b) c)
      (Trs_nontermination_proof a b c)
  | TRS_DP_Trans (Dp_trans_nontermination_tt_prf a b c)
      (Dp_nontermination_proof a b c)
  | TRS_Termination_Switch (Join_info (Lab a b))
      (Trs_nontermination_proof a b c)
  | TRS_Nonloop (Non_loop_prf (Lab a b) c)
  | TRS_Nonloop_SRS (Non_loop_srs_proof (Lab a b))
  | TRS_Q_Increase (Q_increase_nonterm_trs_prf (Lab a b) c)
      (Trs_nontermination_proof a b c)
  | TRS_Uncurry (Uncurry_nt_proof a b c) (Trs_nontermination_proof a b c)
  | TRS_Not_WN_Tree_Automaton (Not_wn_ta_prf (Lab a b) c)
  | TRS_Assume_Not_SN
      (Bool, ([Term (Lab a b) c], [(Term (Lab a b) c, Term (Lab a b) c)]))
      [Generic_assm_proof a b c (Trs_nontermination_proof a b c)
         (Dp_nontermination_proof a b c) (Reltrs_nontermination_proof a b c)
         (Trs_nontermination_proof a b c) (Neg_unknown_proof a b c)]
  | FPTRS_Assume_Not_SN
      ([(Ctxt (Lab a b) c, (Term (Lab a b) c, Location))],
        [(Term (Lab a b) c, Term (Lab a b) c)])
      [Generic_assm_proof a b c (Trs_nontermination_proof a b c)
         (Dp_nontermination_proof a b c) (Reltrs_nontermination_proof a b c)
         (Trs_nontermination_proof a b c) (Neg_unknown_proof a b c)];

data Dp_nontermination_proof a b c = DP_Loop (Dp_loop_prf (Lab a b) c)
  | DP_Nonloop (Non_loop_prf (Lab a b) c)
  | DP_Rule_Removal (Rule_removal_nonterm_dp_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Q_Increase (Q_increase_nonterm_dp_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Q_Reduction (Dp_q_reduction_nonterm_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Termination_Switch (Join_info (Lab a b)) (Dp_nontermination_proof a b c)
  | DP_Instantiation (Instantiation_complete_proc_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Rewriting (Rewriting_complete_proc_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Narrowing (Narrowing_complete_proc_prf (Lab a b) c)
      (Dp_nontermination_proof a b c)
  | DP_Assume_Infinite
      (Bool,
        (Bool,
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([Term (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  [(Term (Lab a b) c, Term (Lab a b) c)]))))))
      [Generic_assm_proof a b c (Trs_nontermination_proof a b c)
         (Dp_nontermination_proof a b c) (Reltrs_nontermination_proof a b c)
         (Trs_nontermination_proof a b c) (Neg_unknown_proof a b c)];

data Neg_unknown_proof a b c =
  Assume_NT_Unknown [Char]
    [Generic_assm_proof a b c (Trs_nontermination_proof a b c)
       (Dp_nontermination_proof a b c) (Reltrs_nontermination_proof a b c)
       (Trs_nontermination_proof a b c) (Neg_unknown_proof a b c)];

data Oc_irule a b = OC_Deduce (Term a b) (Term a b) (Term a b)
  | OC_Orientl (Term a b) (Term a b) | OC_Orientr (Term a b) (Term a b)
  | OC_Delete (Term a b) | OC_Compose (Term a b) (Term a b) (Term a b)
  | OC_Simplifyl (Term a b) (Term a b) (Term a b)
  | OC_Simplifyr (Term a b) (Term a b) (Term a b)
  | OC_Collapse (Term a b) (Term a b) (Term a b);

newtype Ordered_completion_proof a b c = OKB [Oc_irule (Lab a b) c];

data Quasi_reductive_proof a b c =
  Unravel
    [(((Term (Lab a b) c, Term (Lab a b) c),
        [(Term (Lab a b) c, Term (Lab a b) c)]),
       [(Term (Lab a b) c, Term (Lab a b) c)])]
    (Trs_termination_proof a b c);

data Nonreachability_proof a b = Nonreachable_Tcap | Nonreachable_Gtcap
  | Nonreachable_ETAC [(a, Nat)] a a (Tree_automaton (Term a b) a)
  | Nonreachable_Subst_Approx [(Term a b, Term a b)] (Nonreachability_proof a b)
  | Nonreachable_Reverse (Nonreachability_proof a b);

data Nonjoinability_proof a b = Nonjoinable_Tcap
  | Nonjoinable_Ground_NF (Nonreachability_proof a b);

data Infeasibility_proof a b =
  Infeasible_Compound_Conditions a (Nonreachability_proof a b)
  | Infeasible_Equation (Term a b) (Term a b) (Nonreachability_proof a b)
  | Infeasible_Subset [(Term a b, Term a b)] (Infeasibility_proof a b)
  | Infeasible_Rhss_Equal (Term a b) (Term a b) (Term a b)
      (Nonjoinability_proof a b)
  | Infeasible_Trans (Term a b) (Term a b) (Term a b)
      (Nonreachability_proof a b);

data Ccr_transformation a b c =
  Inline_Conditions_CCRT
    [((Term (Lab a b) c, Term (Lab a b) c),
       [(Term (Lab a b) c, Term (Lab a b) c)])]
    [(((Term (Lab a b) c, Term (Lab a b) c),
        [(Term (Lab a b) c, Term (Lab a b) c)]),
       [(Term (Lab a b) c, Term (Lab a b) c)])]
  | Infeasible_Rule_Removal_CCRT
      [(((Term (Lab a b) c, Term (Lab a b) c),
          [(Term (Lab a b) c, Term (Lab a b) c)]),
         Infeasibility_proof (Lab a b) c)];

data Cstep_proof a b =
  Cstep_step ((Term a b, Term a b), [(Term a b, Term a b)]) [Nat]
    (b -> Term a b) (Term a b) (Term a b) [[Cstep_proof a b]];

data Conditional_ncr_proof a b c d = Unconditional_CNCR (Ncr_proof a b c d)
  | Transformation_CNCR (Ccr_transformation a b c)
      (Conditional_ncr_proof a b c d)
  | Non_Join_CNCR (Term (Lab a b) c) (Term (Lab a b) c) (Term (Lab a b) c)
      [Cstep_proof (Lab a b) c] [Cstep_proof (Lab a b) c]
      (Non_join_info (Lab a b) c d);

data Completion_proof a b c =
  SN_WCR_Eq (Join_info (Lab a b)) (Trs_termination_proof a b c)
    [((Term (Lab a b) c, Term (Lab a b) c),
       [([Nat],
          ((Term (Lab a b) c, Term (Lab a b) c), (Bool, Term (Lab a b) c)))])]
    (Maybe [((Term (Lab a b) c, Term (Lab a b) c),
              [([Nat],
                 ((Term (Lab a b) c, Term (Lab a b) c),
                   (Bool, Term (Lab a b) c)))])]);

data Equational_disproof a b c =
  Completion_and_Normalization_Different [(Term (Lab a b) c, Term (Lab a b) c)]
    (Completion_proof a b c)
  | Convertible_Instance
      [((Term (Lab a b) c, Term (Lab a b) c),
         [([Nat],
            ((Term (Lab a b) c, Term (Lab a b) c),
              (Bool, Term (Lab a b) c)))])];

data Ao_infeasibility_proof a b =
  AO_Infeasibility_Proof (Infeasibility_proof a b)
  | AO_Lhss_Equal (Term a b) (Term a b) (Term a b) (Nonjoinability_proof a b);

data Context_joinable_proof a b =
  Contextual_Join (Term a b) [Cstep_proof a b] [Cstep_proof a b];

data Unfeasible_proof a b =
  UnfeasibleOverlap (Term a b) (Term a b) (Term a b) [Cstep_proof a b]
    [Cstep_proof a b] ((Term a b, Term a b), [(Term a b, Term a b)])
    ((Term a b, Term a b), [(Term a b, Term a b)]);

data Conditional_cr_proof a b c = Unconditional_CR (Cr_proof a b c)
  | Unravel_CR
      [(((Term (Lab a b) c, Term (Lab a b) c),
          [(Term (Lab a b) c, Term (Lab a b) c)]),
         [(Term (Lab a b) c, Term (Lab a b) c)])]
      (Cr_proof a b c)
  | Transformation_CR (Ccr_transformation a b c) (Conditional_cr_proof a b c)
  | Almost_Orthogonal_CR
  | Almost_Orthogonal_Modulo_Infeasibility_CR
      [([(Term (Lab a b) c, Term (Lab a b) c)],
         Infeasibility_proof (Lab a b) c)]
  | Almost_Orthogonal_Modulo_Infeasibility_CRa
      [([(Term (Lab a b) c, Term (Lab a b) c)],
         ([(Term (Lab a b) c, Term (Lab a b) c)],
           Ao_infeasibility_proof (Lab a b) c))]
  | AL94_CR (Quasi_reductive_proof a b c)
      [(Term (Lab a b) c,
         (Term (Lab a b) c,
           ([(Term (Lab a b) c, Term (Lab a b) c)],
             Context_joinable_proof (Lab a b) c)))]
      [([(Term (Lab a b) c, Term (Lab a b) c)],
         Infeasibility_proof (Lab a b) c)]
      [(c -> Term (Lab a b) c, Unfeasible_proof (Lab a b) c)];

data Ac_dependency_pairs_proof a b =
  AC_dependency_pairs_proof [(Term a b, Term a b)] [(Term a b, Term a b)]
    [(Term a b, Term a b)] [(Term a b, Term a b)];

data Ac_dp_termination_proof a b = AC_P_is_Empty
  | AC_Subterm_Proc [((a, Nat), [Nat])] [(Term a b, Term a b)]
      (Ac_dp_termination_proof a b)
  | AC_Redpair_UR_Proc (Redtriple_impl a) [(Term a b, Term a b)]
      [(Term a b, Term a b)] (Ac_dp_termination_proof a b)
  | AC_Mono_Redpair_UR_Proc (Redtriple_impl a) [(Term a b, Term a b)]
      [(Term a b, Term a b)] [(Term a b, Term a b)]
      (Ac_dp_termination_proof a b)
  | AC_Dep_Graph_Proc
      [(Maybe (Ac_dp_termination_proof a b), [(Term a b, Term a b)])];

data Ac_termination_proof a b c =
  AC_DP_Trans (Ac_dependency_pairs_proof (Lab a b) c)
    (Ac_dp_termination_proof (Lab a b) c) (Ac_dp_termination_proof (Lab a b) c)
  | AC_DP_Trans_Single (Ac_dependency_pairs_proof (Lab a b) c)
      (Ac_dp_termination_proof (Lab a b) c)
  | AC_Rule_Removal (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Ac_termination_proof a b c)
  | AC_R_is_Empty;

data Fresh_variable_addition_info a b c d =
  Fresh_Variable_Addition_Info b c [(d, Formula (Term a (Trans_var b, c)))];

data Transition_removal_info a b c d e =
  Transition_removal_info (Sharp c -> a) [d] b a (d -> Hint e);

data Location_addition_info a b c d e =
  Location_Addition_Info d d e (Transition_rule a b c d);

data Art_edge_impl a b c = Cover_Edge a c | Children_Edge [(b, (a, c))];

data Art_node_impl a b c d e f g =
  Art_Node e (Formula (Term a (b, c))) d (Art_edge_impl e f g);

data Art_impl_ext a b c d e f g h =
  Art_impl_ext [e] [Art_node_impl a b c d e f g] h;

data Invariant_proof a b c d e f g =
  Impact [(d, Formula (Term a (b, c)))] (Art_impl_ext a b c d e f (Hint g) ());

data Cooperation_proof a b c d e f = Triviala
  | Invariants_Update (Invariant_proof a b c (Sharp d) [Char] e f)
      (Cooperation_proof a b c d e f)
  | Location_Addition (Location_addition_info a b c (Sharp d) e)
      (Cooperation_proof a b c d e f)
  | Fresh_Variable_Addition (Fresh_variable_addition_info a b c e)
      (Cooperation_proof a b c d e f)
  | Transition_Removal (Transition_removal_info [Term a (b, c)] c d e f)
      (Cooperation_proof a b c d e f)
  | Scc_Decomp [([Sharp d], Cooperation_proof a b c d e f)]
  | Cut_Transition_Split [([e], Cooperation_proof a b c d e f)];

data Termination_proof a b c d e f = Trivialb
  | Via_Cooperation
      [([(Sharp e, Transition_rule a b c (Sharp d))],
         Cooperation_proof a b c d (Sharp e) f)]
  | Invariants_Update_LTS (Invariant_proof a b c d [Char] e f)
      (Termination_proof a b c d e f);

data Eq_proof a b = Refl (Term a b) | Sym (Eq_proof a b)
  | Trans (Eq_proof a b) (Eq_proof a b)
  | Assm (Term a b, Term a b) (b -> Term a b) | Cong a [Eq_proof a b];

data Equational_proof a b c = Equational_Proof_Tree (Eq_proof (Lab a b) c)
  | Completion_and_Normalization [(Term (Lab a b) c, Term (Lab a b) c)]
      (Completion_proof a b c)
  | Conversion
      [([Nat],
         ((Term (Lab a b) c, Term (Lab a b) c), (Bool, Term (Lab a b) c)))]
  | Conversion_With_History
      [((Term (Lab a b) c, Term (Lab a b) c),
         [([Nat],
            ((Term (Lab a b) c, Term (Lab a b) c),
              (Bool, Term (Lab a b) c)))])];

data Dt_transformation_info a b =
  DT_Transformation_Info [((Term a b, Term a b), (Term a b, Term a b))]
    [((Term a b, Term a b), (Term a b, Term a b))] [Term a b];

data Wdp_trans_info a b =
  WDP_Trans_Info (Set (a, Nat)) [((Term a b, Term a b), (Term a b, Term a b))]
    [((Term a b, Term a b), (Term a b, Term a b))] [Term a b];

data Complexity_proof a b c =
  Rule_Shift_Complexity (Redtriple_impl (Lab a b))
    [(Term (Lab a b) c, Term (Lab a b) c)]
    (Maybe [(Term (Lab a b) c, Term (Lab a b) c)]) (Complexity_proof a b c)
  | RisEmpty_Complexity
  | Remove_Nonapplicable_Rules_Complexity [(Term (Lab a b) c, Term (Lab a b) c)]
      (Complexity_proof a b c)
  | Matchbounds_Complexity (Bounds_info (Lab a b) c)
  | Matchbounds_Rel_Complexity (Bounds_info (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)] (Complexity_proof a b c)
  | DT_Transformation (Dt_transformation_info (Lab a b) c)
      (Complexity_proof a b c)
  | WDP_Transformation (Wdp_trans_info (Lab a b) c) (Complexity_proof a b c)
  | Complexity_Assumption
      ([Term (Lab a b) c],
        ([(Term (Lab a b) c, Term (Lab a b) c)],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            (Complexity_measure (Lab a b) c, Complexity_class))))
      [Generic_assm_proof a b c (Complexity_proof a b c) () () () ()]
  | Usable_Rules_Complexity [(Term (Lab a b) c, Term (Lab a b) c)]
      (Complexity_proof a b c)
  | Split_Complexity [(Term (Lab a b) c, Term (Lab a b) c)]
      (Complexity_proof a b c) (Complexity_proof a b c);

data Safety_proof a b c d e f g = Trivial
  | Invariant_Assertion (Invariant_proof a b c d e f g)
      (Safety_proof a b c d e f g);

data Proof a b c = TRS_Termination_Proof (Trs_termination_proof a b c)
  | Complexity_Proof (Complexity_proof a b c)
  | DP_Termination_Proof (Dp_termination_proof a b c)
  | DP_Nontermination_Proof (Dp_nontermination_proof a b c)
  | TRS_Nontermination_Proof (Trs_nontermination_proof a b c)
  | FP_Termination_Proof (Fptrs_termination_proof a b c)
  | Relative_TRS_Nontermination_Proof (Reltrs_nontermination_proof a b c)
  | TRS_Confluence_Proof (Cr_proof a b c)
  | TRS_Non_Confluence_Proof (Ncr_proof a b c c)
  | Completion_Proof (Completion_proof a b c)
  | Ordered_Completion_Proof (Ordered_completion_proof a b c)
  | Equational_Proof (Equational_proof a b c)
  | Equational_Disproof (Equational_disproof a b c)
  | Quasi_Reductive_Proof (Quasi_reductive_proof a b c)
  | Conditional_CR_Proof (Conditional_cr_proof a b c)
  | Conditional_Non_CR_Proof (Conditional_ncr_proof a b c c)
  | Tree_Automata_Closed_Proof (Ta_relation [Char])
  | AC_Termination_Proof (Ac_termination_proof a b c)
  | LTS_Termination_Proof (Termination_proof Sig c Ty [Char] [Char] Hints)
  | LTS_Safety_Proof (Safety_proof Sig c Ty [Char] [Char] [Char] Hints)
  | Unknown_Proof (Unknown_proof a b c)
  | Unknown_Disproof (Neg_unknown_proof a b c);

data Monoid_ext a b = Monoid_ext (a -> a -> a) a b;

data Interpretation a = Int_linear_poly ((a, Nat), (Int, [Int]))
  | Rat_linear_poly ((a, Nat), (Rat, [Rat]))
  | Arctic_linear_poly ((a, Nat), (Arctic, [Arctic]))
  | Arctic_rat_linear_poly ((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]))
  | Real_linear_poly ((a, Nat), (Real, [Real]))
  | Int_matrix ((a, Nat), (Mat Int, [Mat Int]))
  | Rat_matrix ((a, Nat), (Mat Rat, [Mat Rat]))
  | Arctic_matrix ((a, Nat), (Mat Arctic, [Mat Arctic]))
  | Arctic_rat_matrix
      ((a, Nat), (Mat (Arctic_delta Rat), [Mat (Arctic_delta Rat)]))
  | Real_matrix ((a, Nat), (Mat Real, [Mat Real]))
  | Int_non_linear_poly ((a, Nat), [(Monom Nat, Int)])
  | Rat_non_linear_poly ((a, Nat), [(Monom Nat, Rat)])
  | Real_non_linear_poly ((a, Nat), [(Monom Nat, Real)]);

data Partial_object_ext a b = Partial_object_ext (Set a) b;

tag :: Xml -> [Char];
tag (XML name uu uv) = name;
tag (XML_text uw) = [];

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

returna :: forall a b. a -> Sum_bot b a;
returna x = Sumbot (Inr x);

errora :: forall a b. a -> Sum_bot a b;
errora x = Sumbot (Inl x);

int_of_digit :: Char -> Sum_bot [Char] Int;
int_of_digit x =
  (if equal_char x (Char False False False False True True False False)
    then returna zero_int
    else (if equal_char x (Char True False False False True True False False)
           then returna one_int
           else (if equal_char x
                      (Char False True False False True True False False)
                  then returna (Int_of_integer (2 :: Integer))
                  else (if equal_char x
                             (Char True True False False True True False False)
                         then returna (Int_of_integer (3 :: Integer))
                         else (if equal_char x
                                    (Char False False True False True True False
                                      False)
                                then returna (Int_of_integer (4 :: Integer))
                                else (if equal_char x
   (Char True False True False True True False False)
                                       then returna
      (Int_of_integer (5 :: Integer))
                                       else (if equal_char x
          (Char False True True False True True False False)
      then returna (Int_of_integer (6 :: Integer))
      else (if equal_char x (Char True True True False True True False False)
             then returna (Int_of_integer (7 :: Integer))
             else (if equal_char x
                        (Char False False False True True True False False)
                    then returna (Int_of_integer (8 :: Integer))
                    else (if equal_char x
                               (Char True False False True True True False
                                 False)
                           then returna (Int_of_integer (9 :: Integer))
                           else errora
                                  [x, Char False False False False False True
False False,
                                    Char True False False True False True True
                                      False,
                                    Char True True False False True True True
                                      False,
                                    Char False False False False False True
                                      False False,
                                    Char False True True True False True True
                                      False,
                                    Char True True True True False True True
                                      False,
                                    Char False False True False True True True
                                      False,
                                    Char False False False False False True
                                      False False,
                                    Char True False False False False True True
                                      False,
                                    Char False False False False False True
                                      False False,
                                    Char False False True False False True True
                                      False,
                                    Char True False False True False True True
                                      False,
                                    Char True True True False False True True
                                      False,
                                    Char True False False True False True True
                                      False,
                                    Char False False True False True True True
                                      False]))))))))));

binda :: forall a b c. Sum_bot a b -> (b -> Sum_bot a c) -> Sum_bot a c;
binda (Sumbot a) f = (case a of {
                       Inl b -> Sumbot (Inl b);
                       Inr aa -> f aa;
                     });

int_of_string_aux :: Int -> [Char] -> Sum_bot [Char] Int;
int_of_string_aux n [] = returna n;
int_of_string_aux n (d : s) =
  binda (int_of_digit d)
    (\ m ->
      int_of_string_aux
        (plus_int (times_int (Int_of_integer (10 :: Integer)) n) m) s);

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

take :: forall a. Nat -> [a] -> [a];
take n [] = [];
take n (x : xs) =
  (if equal_nat n zero_nat then [] else x : take (minus_nat n one_nat) xs);

int_of_string :: [Char] -> Sum_bot [Char] Int;
int_of_string s =
  (if null s
    then errora
           [Char True True False False False True True False,
             Char True False False False False True True False,
             Char False True True True False True True False,
             Char False True True True False True True False,
             Char True True True True False True True False,
             Char False False True False True True True False,
             Char False False False False False True False False,
             Char True True False False False True True False,
             Char True True True True False True True False,
             Char False True True True False True True False,
             Char False True True False True True True False,
             Char True False True False False True True False,
             Char False True False False True True True False,
             Char False False True False True True True False,
             Char False False False False False True False False,
             Char True False True False False True True False,
             Char True False True True False True True False,
             Char False False False False True True True False,
             Char False False True False True True True False,
             Char True False False True True True True False,
             Char False False False False False True False False,
             Char True True False False True True True False,
             Char False False True False True True True False,
             Char False True False False True True True False,
             Char True False False True False True True False,
             Char False True True True False True True False,
             Char True True True False False True True False,
             Char False False False False False True False False,
             Char True False False True False True True False,
             Char False True True True False True True False,
             Char False False True False True True True False,
             Char True True True True False True True False,
             Char False False False False False True False False,
             Char False True True True False True True False,
             Char True False True False True True True False,
             Char True False True True False True True False,
             Char False True False False False True True False,
             Char True False True False False True True False,
             Char False True False False True True True False]
    else (if take one_nat s ==
               [Char True False True True False True False False]
           then binda (int_of_string_aux zero_int (tl s))
                  (\ i -> returna (minus_int zero_int i))
           else int_of_string_aux zero_int s));

shows_prec_list :: forall a. (Showa a) => Nat -> [a] -> [Char] -> [Char];
shows_prec_list p xs = shows_list xs;

shows_attr :: ([Char], [Char]) -> [Char] -> [Char];
shows_attr av =
  shows_prec_list zero_nat (fst av) .
    shows_string
      ([Char True False True True True True False False,
         Char False True False False False True False False] ++
        snd av ++ [Char False True False False False True False False]);

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

shows_attrs :: [([Char], [Char])] -> [Char] -> [Char];
shows_attrs asa =
  foldr (\ a ->
          shows_string [Char False False False False False True False False] .
            shows_attr a)
    asa;

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

shows_XML_indent :: [Char] -> Nat -> Xml -> [Char] -> [Char];
shows_XML_indent ind i (XML n a c) =
  shows_string [Char False True False True False False False False] .
    shows_string ind .
      shows_string [Char False False True True True True False False] .
        shows_prec_list zero_nat n .
          shows_attrs a .
            (if null c
              then shows_string
                     [Char True True True True False True False False,
                       Char False True True True True True False False]
              else shows_string
                     [Char False True True True True True False False] .
                     foldr (shows_XML_indent
                             (replicate i
                                (Char False False False False False True False
                                  False) ++
                               ind)
                             i)
                       c .
                       shows_string
                         [Char False True False True False False False False] .
                         shows_string ind .
                           shows_string
                             [Char False False True True True True False False,
                               Char True True True True False True False
                                 False] .
                             shows_prec_list zero_nat n .
                               shows_string
                                 [Char False True True True True True False
                                    False]);
shows_XML_indent ind i (XML_text t) = shows_string t;

shows_prec_xml :: Nat -> Xml -> [Char] -> [Char];
shows_prec_xml d xml = shows_XML_indent [] (nat_of_integer (2 :: Integer)) xml;

text :: [Char] -> Xml -> Sum_bot [Char] [Char];
text tag (XML n atts [XML_text t]) =
  (if n == tag && null atts then returna t
    else errora
           (concat
             [[Char True True False False False True True False,
                Char True True True True False True True False,
                Char True False True False True True True False,
                Char False False True True False True True False,
                Char False False True False False True True False,
                Char False False False False False True False False,
                Char False True True True False True True False,
                Char True True True True False True True False,
                Char False False True False True True True False,
                Char False False False False False True False False,
                Char True False True False False True True False,
                Char False False False True True True True False,
                Char False False True False True True True False,
                Char False True False False True True True False,
                Char True False False False False True True False,
                Char True True False False False True True False,
                Char False False True False True True True False,
                Char False False False False False True False False,
                Char False False True False True True True False,
                Char True False True False False True True False,
                Char False False False True True True True False,
                Char False False True False True True True False,
                Char False False False False False True False False,
                Char False True True False False True True False,
                Char True True True True False True True False,
                Char False True False False True True True False,
                Char False False False False False True False False],
               tag,
               [Char False False False False False True False False,
                 Char False True True False False True True False,
                 Char False True False False True True True False,
                 Char True True True True False True True False,
                 Char True False True True False True True False,
                 Char False False False False False True False False],
               [Char False True False True False False False False],
               shows_prec_xml zero_nat (XML n atts [XML_text t]) []]));
text tag (XML v va []) =
  errora
    (concat
      [[Char True True False False False True True False,
         Char True True True True False True True False,
         Char True False True False True True True False,
         Char False False True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False True False False True True True False,
         Char False False False False False True False False],
        tag,
        [Char False False False False False True False False,
          Char False True True False False True True False,
          Char False True False False True True True False,
          Char True True True True False True True False,
          Char True False True True False True True False,
          Char False False False False False True False False],
        [Char False True False True False False False False],
        shows_prec_xml zero_nat (XML v va []) []]);
text tag (XML v va (XML ve vf vg : vd)) =
  errora
    (concat
      [[Char True True False False False True True False,
         Char True True True True False True True False,
         Char True False True False True True True False,
         Char False False True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False True False False True True True False,
         Char False False False False False True False False],
        tag,
        [Char False False False False False True False False,
          Char False True True False False True True False,
          Char False True False False True True True False,
          Char True True True True False True True False,
          Char True False True True False True True False,
          Char False False False False False True False False],
        [Char False True False True False False False False],
        shows_prec_xml zero_nat (XML v va (XML ve vf vg : vd)) []]);
text tag (XML v va (vc : ve : vf)) =
  errora
    (concat
      [[Char True True False False False True True False,
         Char True True True True False True True False,
         Char True False True False True True True False,
         Char False False True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False True False False True True True False,
         Char False False False False False True False False],
        tag,
        [Char False False False False False True False False,
          Char False True True False False True True False,
          Char False True False False True True True False,
          Char True True True True False True True False,
          Char True False True True False True True False,
          Char False False False False False True False False],
        [Char False True False True False False False False],
        shows_prec_xml zero_nat (XML v va (vc : ve : vf)) []]);
text tag (XML_text v) =
  errora
    (concat
      [[Char True True False False False True True False,
         Char True True True True False True True False,
         Char True False True False True True True False,
         Char False False True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False True False False True True True False,
         Char False False False False False True False False],
        tag,
        [Char False False False False False True False False,
          Char False True True False False True True False,
          Char False True False False True True True False,
          Char True True True True False True True False,
          Char True False True True False True True False,
          Char False False False False False True False False],
        [Char False True False True False False False False],
        shows_prec_xml zero_nat (XML_text v) []]);

int :: [Char] -> Xml -> Sum_bot [Char] Int;
int tag x = binda (text tag x) int_of_string;

nata :: [Char] -> Xml -> Sum_bot [Char] Nat;
nata tag x =
  binda (text tag x)
    (\ txt -> binda (int_of_string txt) (\ i -> returna (nat i)));

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

options ::
  forall a. [([Char], Xml -> Sum_bot [Char] a)] -> Xml -> Sum_bot [Char] a;
options ps x =
  (case map_of ps (tag x) of {
    Nothing ->
      errora
        (concat
          [[Char True False True False False True True False,
             Char False False False True True True True False,
             Char False False False False True True True False,
             Char True False True False False True True False,
             Char True True False False False True True False,
             Char False False True False True True True False,
             Char True False True False False True True False,
             Char False False True False False True True False,
             Char False False False False False True False False,
             Char True True True True False True True False,
             Char False True True True False True True False,
             Char True False True False False True True False,
             Char False False False False False True False False,
             Char True True True True False True True False,
             Char False True True False False True True False,
             Char False True False True True True False False,
             Char False False False False False True False False],
            concatMap
              (\ p ->
                fst p ++ [Char False False False False False True False False])
              ps,
            [Char False True False True False False False False],
            [Char False True False False False True True False,
              Char True False True False True True True False,
              Char False False True False True True True False,
              Char False False False False False True False False,
              Char False True True False False True True False,
              Char True True True True False True True False,
              Char True False True False True True True False,
              Char False True True True False True True False,
              Char False False True False False True True False],
            [Char False True False True False False False False],
            shows_prec_xml zero_nat x []]);
    Just p -> p x;
  });

change ::
  forall a b. (Xml -> Sum_bot [Char] a) -> (a -> b) -> Xml -> Sum_bot [Char] b;
change p f x = binda (p x) (returna . f);

list2elements :: forall a. [a] -> Maybe (a, a);
list2elements [x, y] = Just (x, y);
list2elements [] = Nothing;
list2elements [v] = Nothing;
list2elements (v : vb : vd : ve) = Nothing;

fail :: forall a. [Char] -> Xml -> Sum_bot [Char] a;
fail tag xml =
  errora
    (concat
      [[Char True True False False False True True False,
         Char True True True True False True True False,
         Char True False True False True True True False,
         Char False False True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char False True True True False True True False,
         Char True True False False True True True False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False True False False True True True False,
         Char True False True True False True True False,
         Char False False False False False True False False,
         Char False False True False True True True False,
         Char False False False True False True True False,
         Char True False True False False True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True True True True False True True False,
         Char False False True True False True True False,
         Char False False True True False True True False,
         Char True True True True False True True False,
         Char True True True False True True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True True True False False True True False,
         Char False False False False False True False False,
         Char False False False True True True True False,
         Char True False True True False True True False,
         Char False False True True False True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False False True True False True True False,
         Char True False True False False True True False,
         Char True False True True False True True False,
         Char True False True False False True True False,
         Char False True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False False False True False True False False,
         Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False False False True True True False,
         Char True False True False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False],
        tag, [Char True False False True False True False False],
        [Char False True False True False False False False],
        shows_prec_xml zero_nat xml []]);

pair ::
  forall a b c.
    [Char] ->
      (Xml -> Sum_bot [Char] a) ->
        (Xml -> Sum_bot [Char] b) -> (a -> b -> c) -> Xml -> Sum_bot [Char] c;
pair tag p1 p2 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list2elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, cs2) ->
                 binda (p1 cs1)
                   (\ a -> binda (p2 cs2) (\ b -> returna (f a b)));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

rat :: Xml -> Sum_bot [Char] Rat;
rat = options
        [([Char True False False True False True True False,
            Char False True True True False True True False,
            Char False False True False True True True False,
            Char True False True False False True True False,
            Char True True True False False True True False,
            Char True False True False False True True False,
            Char False True False False True True True False],
           change
             (int [Char True False False True False True True False,
                    Char False True True True False True True False,
                    Char False False True False True True True False,
                    Char True False True False False True True False,
                    Char True True True False False True True False,
                    Char True False True False False True True False,
                    Char False True False False True True True False])
             of_int),
          ([Char False True False False True True True False,
             Char True False False False False True True False,
             Char False False True False True True True False,
             Char True False False True False True True False,
             Char True True True True False True True False,
             Char False True True True False True True False,
             Char True False False False False True True False,
             Char False False True True False True True False],
            pair [Char False True False False True True True False,
                   Char True False False False False True True False,
                   Char False False True False True True True False,
                   Char True False False True False True True False,
                   Char True True True True False True True False,
                   Char False True True True False True True False,
                   Char True False False False False True True False,
                   Char False False True True False True True False]
              (int [Char False True True True False True True False,
                     Char True False True False True True True False,
                     Char True False True True False True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char True False False False False True True False,
                     Char False False True False True True True False,
                     Char True True True True False True True False,
                     Char False True False False True True True False])
              (int [Char False False True False False True True False,
                     Char True False True False False True True False,
                     Char False True True True False True True False,
                     Char True True True True False True True False,
                     Char True False True True False True True False,
                     Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char True False False False False True True False,
                     Char False False True False True True True False,
                     Char True True True True False True True False,
                     Char False True False False True True True False])
              (\ x y -> divide_rat (of_int x) (of_int y)))];

drop :: forall a. Nat -> [a] -> [a];
drop n [] = [];
drop n (x : xs) =
  (if equal_nat n zero_nat then x : xs else drop (minus_nat n one_nat) xs);

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

last :: forall a. [a] -> a;
last (x : xs) = (if null xs then x else last xs);

empty :: forall a b. (Linorder a) => Rbt a b;
empty = RBT Empty;

leaf :: forall a. [Char] -> a -> Xml -> Sum_bot [Char] a;
leaf tag x (XML name atts cs) =
  (if name == tag && null atts && null cs then returna x
    else fail tag (XML name atts cs));
leaf tag x (XML_text v) = fail tag (XML_text v);

map_sum_bot :: forall a b c. (a -> Sum_bot b c) -> [a] -> Sum_bot b [c];
map_sum_bot f [] = returna [];
map_sum_bot f (x : xs) =
  binda (f x) (\ y -> binda (map_sum_bot f xs) (\ ys -> returna (y : ys)));

many ::
  forall a b.
    [Char] ->
      (Xml -> Sum_bot [Char] a) -> ([a] -> b) -> Xml -> Sum_bot [Char] b;
many tag p f (XML name atts cs) =
  (if name == tag && null atts then binda (map_sum_bot p cs) (returna . f)
    else fail tag (XML name atts cs));
many tag p f (XML_text v) = fail tag (XML_text v);

source :: forall a b c d. Transition_rule a b c d -> d;
source (Transition l uu uv) = l;

target :: forall a b c d. Transition_rule a b c d -> d;
target (Transition uu r uv) = r;

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

index_mat_impl :: forall a. Mat_impl a -> (Nat, Nat) -> a;
index_mat_impl xa =
  (case rep_mat_impl xa of {
    (nr, (_, m)) ->
      (\ (i, j) ->
        (if less_nat i nr then sub (sub m i) j
          else sub (IArray.of_list (nth [] (minus_nat i nr))) j));
  });

index_mat :: forall a. Mat a -> (Nat, Nat) -> a;
index_mat (Mat_impl m) ij = index_mat_impl m ij;

dim_row_impl :: forall a. Mat_impl a -> Nat;
dim_row_impl xa = fst (rep_mat_impl xa);

dim_row :: forall a. Mat a -> Nat;
dim_row (Mat_impl m) = dim_row_impl m;

of_fun :: forall a. (Nat -> a) -> Nat -> IArray.IArray a;
of_fun f n = IArray.tabulate (integer_of_nat n, f . nat_of_integer);

vec_of_fun :: forall a. Nat -> (Nat -> a) -> Vec_impl a;
vec_of_fun xb xc = Abs_vec_impl (xb, of_fun xc xb);

vec :: forall a. Nat -> (Nat -> a) -> Vec a;
vec n f = Vec_impl (vec_of_fun n f);

col :: forall a. Mat a -> Nat -> Vec a;
col a j = vec (dim_row a) (\ i -> index_mat a (i, j));

mat_of_fun :: forall a. Nat -> Nat -> ((Nat, Nat) -> a) -> Mat_impl a;
mat_of_fun xc xd xe =
  Abs_mat_impl (xc, (xd, of_fun (\ i -> of_fun (\ j -> xe (i, j)) xd) xc));

mat :: forall a. Nat -> Nat -> ((Nat, Nat) -> a) -> Mat a;
mat nr nc f = Mat_impl (mat_of_fun nr nc f);

dim_col_impl :: forall a. Mat_impl a -> Nat;
dim_col_impl xa = fst (snd (rep_mat_impl xa));

dim_col :: forall a. Mat a -> Nat;
dim_col (Mat_impl m) = dim_col_impl m;

row :: forall a. Mat a -> Nat -> Vec a;
row a i = vec (dim_col a) (\ j -> index_mat a (i, j));

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_ins ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins f k v (Branch R l x y r) = (case compare k x of {
                                     Eqa -> Branch R l x (f k y v) r;
                                     Lt -> Branch R (rbt_ins f k v l) x y r;
                                     Gt -> Branch R l x y (rbt_ins f k v r);
                                   });
rbt_ins f k v (Branch B l x y r) = (case compare k x of {
                                     Eqa -> Branch B l x (f k y v) r;
                                     Lt -> balance (rbt_ins f k v l) x y r;
                                     Gt -> balance l x y (rbt_ins f k v r);
                                   });
rbt_ins f k v Empty = Branch R Empty k v Empty;

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_insert_with_key ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key f k v t = paint B (rbt_ins f k v t);

rbt_insert :: forall a b. (Compare_order a) => a -> b -> Rbta a b -> Rbta a b;
rbt_insert = rbt_insert_with_key (\ _ _ nv -> nv);

impl_of :: forall b a. (Linorder b) => Rbt b a -> Rbta b a;
impl_of (RBT x) = x;

insert :: forall a b. (Compare_order a) => a -> b -> Rbt a b -> Rbt a b;
insert xc xd xe = RBT (rbt_insert xc xd (impl_of xe));

rbt_lookup :: forall a b. (Compare_order a) => Rbta a b -> a -> Maybe b;
rbt_lookup (Branch uu l x y r) k = (case compare k x of {
                                     Eqa -> Just y;
                                     Lt -> rbt_lookup l k;
                                     Gt -> rbt_lookup r k;
                                   });
rbt_lookup Empty k = Nothing;

lookup :: forall a b. (Compare_order a) => Rbt a b -> a -> Maybe b;
lookup x = rbt_lookup (impl_of x);

fun_upda :: forall a b. (a -> a -> Bool) -> (a -> b) -> a -> b -> a -> b;
fun_upda equal f aa b a = (if equal aa a then b else f a);

rbt_comp_ins ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_ins c f k v Empty = Branch R Empty k v Empty;
rbt_comp_ins c f k v (Branch B l x y r) =
  (case c k x of {
    Eqa -> Branch B l x (f k y v) r;
    Lt -> balance (rbt_comp_ins c f k v l) x y r;
    Gt -> balance l x y (rbt_comp_ins c f k v r);
  });
rbt_comp_ins c f k v (Branch R l x y r) =
  (case c k x of {
    Eqa -> Branch R l x (f k y v) r;
    Lt -> Branch R (rbt_comp_ins c f k v l) x y r;
    Gt -> Branch R l x y (rbt_comp_ins c f k v r);
  });

rbt_comp_insert_with_key ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_insert_with_key c f k v t = paint B (rbt_comp_ins c f k v t);

rbt_comp_insert ::
  forall a b. (a -> a -> Ordera) -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_insert c = rbt_comp_insert_with_key c (\ _ _ nv -> nv);

impl_ofb :: forall b a. (Ccompare b) => Mapping_rbt b a -> Rbta b a;
impl_ofb (Mapping_RBTa x) = x;

the :: forall a. Maybe a -> a;
the (Just x2) = x2;

insertc ::
  forall a b. (Ccompare a) => a -> b -> Mapping_rbt a b -> Mapping_rbt a b;
insertc xc xd xe =
  Mapping_RBTa (rbt_comp_insert (the ccompare) xc xd (impl_ofb xe));

list_of_dlist :: forall a. (Ceq a) => Set_dlist a -> [a];
list_of_dlist (Abs_dlist x) = x;

list_member :: forall a. (a -> a -> Bool) -> [a] -> a -> Bool;
list_member equal (x : xs) y = equal x y || list_member equal xs y;
list_member equal [] y = False;

list_insert :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_insert equal x xs = (if list_member equal xs x then xs else x : xs);

insertb :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
insertb xb xc = Abs_dlist (list_insert (the ceq) xb (list_of_dlist xc));

balance_right :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance_right a k x (Branch R b s y c) = Branch R a k x (Branch B b s y c);
balance_right (Branch B a k x b) s y Empty =
  balance (Branch R a k x b) s y Empty;
balance_right (Branch B a k x b) s y (Branch B va vb vc vd) =
  balance (Branch R a k x b) s y (Branch B va vb vc vd);
balance_right (Branch R a k x (Branch B b s y c)) t z Empty =
  Branch R (balance (paint R a) k x b) s y (Branch B c t z Empty);
balance_right (Branch R a k x (Branch B b s y c)) t z (Branch B va vb vc vd) =
  Branch R (balance (paint R a) k x b) s y
    (Branch B c t z (Branch B va vb vc vd));
balance_right Empty k x Empty = Empty;
balance_right (Branch R va vb vc Empty) k x Empty = Empty;
balance_right (Branch R va vb vc (Branch R ve vf vg vh)) k x Empty = Empty;
balance_right Empty k x (Branch B va vb vc vd) = Empty;
balance_right (Branch R ve vf vg Empty) k x (Branch B va vb vc vd) = Empty;
balance_right (Branch R ve vf vg (Branch R vi vj vk vl)) k x
  (Branch B va vb vc vd) = Empty;

balance_left :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance_left (Branch R a k x b) s y c = Branch R (Branch B a k x b) s y c;
balance_left Empty k x (Branch B a s y b) =
  balance Empty k x (Branch R a s y b);
balance_left (Branch B va vb vc vd) k x (Branch B a s y b) =
  balance (Branch B va vb vc vd) k x (Branch R a s y b);
balance_left Empty k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B Empty k x a) s y (balance b t z (paint R c));
balance_left (Branch B va vb vc vd) k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B (Branch B va vb vc vd) k x a) s y
    (balance b t z (paint R c));
balance_left Empty k x Empty = Empty;
balance_left Empty k x (Branch R Empty vb vc vd) = Empty;
balance_left Empty k x (Branch R (Branch R ve vf vg vh) vb vc vd) = Empty;
balance_left (Branch B va vb vc vd) k x Empty = Empty;
balance_left (Branch B va vb vc vd) k x (Branch R Empty vf vg vh) = Empty;
balance_left (Branch B va vb vc vd) k x
  (Branch R (Branch R vi vj vk vl) vf vg vh) = Empty;

combine :: forall a b. Rbta a b -> Rbta a b -> Rbta a b;
combine Empty x = x;
combine (Branch v va vb vc vd) Empty = Branch v va vb vc vd;
combine (Branch R a k x b) (Branch R c s y d) =
  (case combine b c of {
    Empty -> Branch R a k x (Branch R Empty s y d);
    Branch R b2 t z c2 -> Branch R (Branch R a k x b2) t z (Branch R c2 s y d);
    Branch B b2 t z c2 -> Branch R a k x (Branch R (Branch B b2 t z c2) s y d);
  });
combine (Branch B a k x b) (Branch B c s y d) =
  (case combine b c of {
    Empty -> balance_left a k x (Branch B Empty s y d);
    Branch R b2 t z c2 -> Branch R (Branch B a k x b2) t z (Branch B c2 s y d);
    Branch B b2 t z c2 ->
      balance_left a k x (Branch B (Branch B b2 t z c2) s y d);
  });
combine (Branch B va vb vc vd) (Branch R b k x c) =
  Branch R (combine (Branch B va vb vc vd) b) k x c;
combine (Branch R a k x b) (Branch B va vb vc vd) =
  Branch R a k x (combine b (Branch B va vb vc vd));

rbt_comp_del :: forall a b. (a -> a -> Ordera) -> a -> Rbta a b -> Rbta a b;
rbt_comp_del c x Empty = Empty;
rbt_comp_del c x (Branch uu a y s b) =
  (case c x y of {
    Eqa -> combine a b;
    Lt -> rbt_comp_del_from_left c x a y s b;
    Gt -> rbt_comp_del_from_right c x a y s b;
  });

rbt_comp_del_from_left ::
  forall a b.
    (a -> a -> Ordera) -> a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_del_from_left c x (Branch B lt z v rt) y s b =
  balance_left (rbt_comp_del c x (Branch B lt z v rt)) y s b;
rbt_comp_del_from_left c x Empty y s b =
  Branch R (rbt_comp_del c x Empty) y s b;
rbt_comp_del_from_left c x (Branch R va vb vc vd) y s b =
  Branch R (rbt_comp_del c x (Branch R va vb vc vd)) y s b;

rbt_comp_del_from_right ::
  forall a b.
    (a -> a -> Ordera) -> a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_comp_del_from_right c x a y s (Branch B lt z v rt) =
  balance_right a y s (rbt_comp_del c x (Branch B lt z v rt));
rbt_comp_del_from_right c x a y s Empty =
  Branch R a y s (rbt_comp_del c x Empty);
rbt_comp_del_from_right c x a y s (Branch R va vb vc vd) =
  Branch R a y s (rbt_comp_del c x (Branch R va vb vc vd));

rbt_comp_delete :: forall a b. (a -> a -> Ordera) -> a -> Rbta a b -> Rbta a b;
rbt_comp_delete c k t = paint B (rbt_comp_del c k t);

delete :: forall a b. (Ccompare a) => a -> Mapping_rbt a b -> Mapping_rbt a b;
delete xb xc = Mapping_RBTa (rbt_comp_delete (the ccompare) xb (impl_ofb xc));

list_remove1 :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_remove1 equal x (y : xs) =
  (if equal x y then xs else y : list_remove1 equal x xs);
list_remove1 equal x [] = [];

removea :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
removea xb xc = Abs_dlist (list_remove1 (the ceq) xb (list_of_dlist xc));

inserta :: forall a. (Ceq a, Ccompare a) => a -> Set a -> Set a;
inserta xa (Complement x) = Complement (remove xa x);
inserta x (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert RBT_set: ccompare = None" (\ _ -> inserta x (RBT_set rbt));
    Just _ -> RBT_set (insertc x () rbt);
  });
inserta x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert DList_set: ceq = None" (\ _ -> inserta x (DList_set dxs));
    Just _ -> DList_set (insertb x dxs);
  });
inserta x (Set_Monad xs) = Set_Monad (x : xs);
inserta x (Collect_set a) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert Collect_set: ceq = None" (\ _ -> inserta x (Collect_set a));
    Just eq -> Collect_set (fun_upda eq a x True);
  });

remove :: forall a. (Ceq a, Ccompare a) => a -> Set a -> Set a;
remove x (Complement a) = Complement (inserta x a);
remove x (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "remove RBT_set: ccompare = None" (\ _ -> remove x (RBT_set rbt));
    Just _ -> RBT_set (delete x rbt);
  });
remove x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "remove DList_set: ceq = None" (\ _ -> remove x (DList_set dxs));
    Just _ -> DList_set (removea x dxs);
  });
remove x (Collect_set a) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "remove Collect: ceq = None"
        (\ _ -> remove x (Collect_set a));
    Just eq -> Collect_set (fun_upda eq a x False);
  });

fun_upd :: forall a b. (Eq a) => (a -> b) -> a -> b -> a -> b;
fun_upd f a b = (\ x -> (if x == a then b else f x));

subst :: forall a b. (Eq a) => a -> Term b a -> a -> Term b a;
subst x t = fun_upd Var x t;

debug :: forall a. (String -> String) -> String -> a -> a;
debug i t x = x;

guard ::
  forall a.
    (Xml -> Bool) ->
      (Xml -> Sum_bot [Char] a) ->
        (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] a;
guard p p1 p2 x = (if p x then p1 x else p2 x);

member :: forall a. (Eq a) => [a] -> a -> Bool;
member [] y = False;
member (x : xs) y = x == y || member xs y;

bind :: forall a b. Maybe a -> (a -> Maybe b) -> Maybe b;
bind Nothing f = Nothing;
bind (Just x) f = f x;

letters :: [Char];
letters =
  [Char True False False False False True True False,
    Char False True False False False True True False,
    Char True True False False False True True False,
    Char False False True False False True True False,
    Char True False True False False True True False,
    Char False True True False False True True False,
    Char True True True False False True True False,
    Char False False False True False True True False,
    Char True False False True False True True False,
    Char False True False True False True True False,
    Char True True False True False True True False,
    Char False False True True False True True False,
    Char True False True True False True True False,
    Char False True True True False True True False,
    Char True True True True False True True False,
    Char False False False False True True True False,
    Char True False False False True True True False,
    Char False True False False True True True False,
    Char True True False False True True True False,
    Char False False True False True True True False,
    Char True False True False True True True False,
    Char False True True False True True True False,
    Char True True True False True True True False,
    Char False False False True True True True False,
    Char True False False True True True True False,
    Char False True False True True True True False,
    Char True False False False False False True False,
    Char False True False False False False True False,
    Char True True False False False False True False,
    Char False False True False False False True False,
    Char True False True False False False True False,
    Char False True True False False False True False,
    Char True True True False False False True False,
    Char False False False True False False True False,
    Char True False False True False False True False,
    Char False True False True False False True False,
    Char True True False True False False True False,
    Char False False True True False False True False,
    Char True False True True False False True False,
    Char False True True True False False True False,
    Char True True True True False False True False,
    Char False False False False True False True False,
    Char True False False False True False True False,
    Char False True False False True False True False,
    Char True True False False True False True False,
    Char False False True False True False True False,
    Char True False True False True False True False,
    Char False True True False True False True False,
    Char True True True False True False True False,
    Char False False False True True False True False,
    Char True False False True True False True False,
    Char False True False True True False True False,
    Char True True True True True False True False,
    Char False False False False True True False False,
    Char True False False False True True False False,
    Char False True False False True True False False,
    Char True True False False True True False False,
    Char False False True False True True False False,
    Char True False True False True True False False,
    Char False True True False True True False False,
    Char True True True False True True False False,
    Char False False False True True True False False,
    Char True False False True True True False False,
    Char False True True False False True False False,
    Char True True False True True True False False,
    Char False True False True True True False False,
    Char True False True True False True False False];

list3elements :: forall a. [a] -> Maybe (a, (a, a));
list3elements [x, y, z] = Just (x, (y, z));
list3elements [] = Nothing;
list3elements [v] = Nothing;
list3elements [v, vb] = Nothing;
list3elements (v : vb : vd : vf : vg) = Nothing;

triple ::
  forall a b c d.
    [Char] ->
      (Xml -> Sum_bot [Char] a) ->
        (Xml -> Sum_bot [Char] b) ->
          (Xml -> Sum_bot [Char] c) ->
            (a -> b -> c -> d) -> Xml -> Sum_bot [Char] d;
triple tag p1 p2 p3 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list3elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, (cs2, cs3)) ->
                 binda (p1 cs1)
                   (\ a ->
                     binda (p2 cs2)
                       (\ b -> binda (p3 cs3) (\ c -> returna (f a b c))));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

list4elements :: forall a. [a] -> Maybe (a, (a, (a, a)));
list4elements [x, y, z, u] = Just (x, (y, (z, u)));
list4elements [] = Nothing;
list4elements [v] = Nothing;
list4elements [v, vb] = Nothing;
list4elements [v, vb, vd] = Nothing;
list4elements (v : vb : vd : vf : vh : vi) = Nothing;

tuple4 ::
  forall a b c d e.
    [Char] ->
      (Xml -> Sum_bot [Char] a) ->
        (Xml -> Sum_bot [Char] b) ->
          (Xml -> Sum_bot [Char] c) ->
            (Xml -> Sum_bot [Char] d) ->
              (a -> b -> c -> d -> e) -> Xml -> Sum_bot [Char] e;
tuple4 tag p1 p2 p3 p4 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list4elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, (cs2, (cs3, cs4))) ->
                 binda (p1 cs1)
                   (\ a ->
                     binda (p2 cs2)
                       (\ b ->
                         binda (p3 cs3)
                           (\ c ->
                             binda (p4 cs4) (\ d -> returna (f a b c d)))));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

bind2 ::
  forall a b c d.
    Sum_bot a b -> (a -> Sum_bot c d) -> (b -> Sum_bot c d) -> Sum_bot c d;
bind2 (Sumbot a) f g = (case a of {
                         Inl aa -> f aa;
                         Inr aa -> g aa;
                       });

update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
update k v [] = [(k, v)];
update k v (p : ps) = (if fst p == k then (k, v) : ps else p : update k v ps);

emptya :: forall a b. Alist a b;
emptya = Alist [];

extract :: forall a. (a -> Bool) -> [a] -> Maybe ([a], (a, [a]));
extract p (x : xs) =
  (if p x then Just ([], (x, xs))
    else (case extract p xs of {
           Nothing -> Nothing;
           Just (ys, (y, zs)) -> Just (x : ys, (y, zs));
         }));
extract p [] = Nothing;

hd :: forall a. [a] -> a;
hd (x21 : x22) = x21;

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if member xs x then remdups xs else x : remdups xs);

ma_coeff :: Mini_alg -> Rat;
ma_coeff xa = fst (snd (rep_mini_alg xa));

mau_coeff :: Mini_alg_unique -> Rat;
mau_coeff xa = ma_coeff (rep_mini_alg_unique xa);

root_int_maina :: Nat -> Int -> Int -> Int -> Int -> (Int, Bool);
root_int_maina pm ipm ip x n =
  let {
    xpm = power x pm;
    xp = times_int xpm x;
  } in (if less_eq_int xp n then (x, equal_int xp n)
         else root_int_maina pm ipm ip
                (divide_int (plus_int (divide_int n xpm) (times_int x ipm)) ip)
                n);

root_int_main :: Nat -> Int -> (Int, Bool);
root_int_main p n =
  (if equal_nat p zero_nat then (one_int, equal_int n one_int)
    else let {
           pm = minus_nat p one_nat;
         } in root_int_maina pm (int_of_nat pm) (int_of_nat p) (start_value n p)
                n);

root_int_floor_pos :: Nat -> Int -> Int;
root_int_floor_pos p x =
  (if equal_nat p zero_nat then zero_int else fst (root_int_main p x));

root_nat_floor :: Nat -> Nat -> Int;
root_nat_floor p x = root_int_floor_pos p (int_of_nat x);

sqrt_int :: Int -> [Int];
sqrt_int x =
  (if less_int x zero_int then []
    else (case sqrt_int_main x of {
           (y, True) ->
             (if equal_int y zero_int then [zero_int] else [y, uminus_int y]);
           (_, False) -> [];
         }));

sqrt_nat :: Nat -> [Nat];
sqrt_nat x = map nat (take one_nat (sqrt_int (int_of_nat x)));

dvd :: forall a. (Eq a, Semidom_modulo a) => a -> a -> Bool;
dvd a b = modulo b a == zeroa;

prime_product_factor_main :: Nat -> Nat -> Nat -> Nat -> Nat -> (Nat, Nat);
prime_product_factor_main factor_sq factor_pr limit n i =
  (if less_eq_nat i limit && less_eq_nat (nat_of_integer (2 :: Integer)) i
    then (if dvd i n
           then let {
                  na = divide_nat n i;
                } in (if dvd i na
                       then let {
                              nb = divide_nat na i;
                            } in prime_product_factor_main
                                   (times_nat factor_sq i) factor_pr
                                   (nat (root_nat_floor
  (nat_of_integer (3 :: Integer)) nb))
                                   nb i
                       else (case sqrt_nat na of {
                              [] -> prime_product_factor_main factor_sq
                                      (times_nat factor_pr i)
                                      (nat
(root_nat_floor (nat_of_integer (3 :: Integer)) na))
                                      na (suc i);
                              sn : _ ->
                                (times_nat factor_sq sn, times_nat factor_pr i);
                            }))
           else prime_product_factor_main factor_sq factor_pr limit n (suc i))
    else (factor_sq, times_nat factor_pr n));

prime_product_factor :: Nat -> (Nat, Nat);
prime_product_factor n =
  (case sqrt_nat n of {
    [] -> prime_product_factor_main one_nat one_nat
            (nat (root_nat_floor (nat_of_integer (3 :: Integer)) n)) n
            (nat_of_integer (2 :: Integer));
    s : _ -> (s, one_nat);
  });

ma_sqrt :: Mini_alg -> Mini_alg;
ma_sqrt xa =
  Abs_mini_alg
    (case rep_mini_alg xa of {
      (p, (_, _)) ->
        let {
          a = quotient_of p;
        } in (case a of {
               (aa, b) ->
                 let {
                   aaa = abs_int (times_int aa b);
                 } in (case sqrt_int aaa of {
                        [] -> (zero_rat, (inverse_rat (of_int b), nat aaa));
                        s : _ ->
                          (divide_rat (of_int s) (of_int b),
                            (zero_rat, zero_nat));
                      });
             });
    });

ma_rat :: Mini_alg -> Rat;
ma_rat xa = fst (rep_mini_alg xa);

mau_sqrt :: Mini_alg_unique -> Mini_alg_unique;
mau_sqrt xa =
  Abs_mini_alg_unique
    (let {
       a = quotient_of (ma_rat (rep_mini_alg_unique xa));
     } in (case a of {
            (aa, b) ->
              (case prime_product_factor (nat (times_int (abs_int aa) b)) of {
                (sq, fact) ->
                  let {
                    ma = ma_of_rat
                           (divide_rat
                             (times_rat (of_int (sgn_int aa)) (of_nat sq))
                             (of_int b));
                  } in ma_times ma (ma_sqrt (ma_of_rat (of_nat fact)));
              });
          }));

sqrt :: Real -> Real;
sqrt (Real_of_u r) =
  (if equal_rat (mau_coeff r) zero_rat then Real_of_u (mau_sqrt r)
    else (error :: forall a. String -> (() -> a) -> a)
           "cannot represent sqrt of irrational number"
           (\ _ -> sqrt (Real_of_u r)));

explode :: String -> [Char];
explode s =
  map char_of_integer
    (map (let ord k | (k < 128) = Prelude.toInteger k in ord . (Prelude.fromEnum :: Prelude.Char -> Prelude.Int))
      s);

left :: forall a b. a -> Sum_bot a b;
left x = Sumbot (Inl x);

xml_error ::
  forall a b c d.
    String -> ([Xml], (a, (b, (c, [String])))) -> Sum_bot (Xml_error String) d;
xml_error str x =
  (case x of {
    (xmls, (_, (_, (_, pos)))) ->
      let {
        next =
          (case xmls of {
            [] -> "tag close";
            XML tag _ _ : _ -> ("<" ++ implode tag) ++ ">";
            XML_text stra : _ -> ("text element \"" ++ implode stra) ++ "\"";
          });
      } in left (Fatal
                  ((((("parse error on " ++ next) ++ " at ") ++
                      default_showsl_list showsl_lit pos "") ++
                     ":\\") ++
                    str));
  });

mismatch ::
  forall a b.
    String ->
      ([Xml], (a, (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) b;
mismatch tag x =
  (case x of {
    (_, (_, (True, (cands, _)))) -> left (TagMismatch (tag : cands));
    (_, (_, (False, (cands, _)))) ->
      xml_error
        ("expecting " ++ default_showsl_list showsl_lit (tag : cands) "") x;
  });

xml_do ::
  forall a.
    String ->
      (([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
        (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) a;
xml_do tag p x =
  (case x of {
    (XML nam atts xmls, (_, (_, (_, pos)))) ->
      (if nam == explode tag then p (xmls, (atts, (False, ([], tag : pos))))
        else mismatch tag ([fst x], snd x));
    (XML_text _, _) -> mismatch tag ([fst x], snd x);
  });

right :: forall a b. a -> Sum_bot b a;
right x = Sumbot (Inr x);

xml_or ::
  forall a b c d e f g.
    ((a, (b, (Bool, (c, d)))) -> Sum_bot (Xml_error e) f) ->
      ((a, (b, (g, ([String], d)))) -> Sum_bot (Xml_error e) f) ->
        (a, (b, (g, (c, d)))) -> Sum_bot (Xml_error e) f;
xml_or p1 p2 x =
  (case x of {
    (x1, (atts, (flag, (cands, rest)))) ->
      bind2 (p1 (x1, (atts, (True, (cands, rest)))))
        (\ a ->
          (case a of {
            TagMismatch cands1 -> p2 (x1, (atts, (flag, (cands1, rest))));
            Fatal aa -> left (Fatal aa);
          }))
        right;
  });

impl_ofa :: forall b a. Alist b a -> [(b, a)];
impl_ofa (Alist x) = x;

lookupa :: forall a b. (Eq a) => Alist a b -> a -> Maybe b;
lookupa xa = map_of (impl_ofa xa);

updatea :: forall a b. (Eq a) => a -> b -> Alist a b -> Alist a b;
updatea xc xd xe = Alist (update xc xd (impl_ofa xe));

emptyd :: forall a b. (Ccompare a) => Mapping_rbt a b;
emptyd = Mapping_RBTa Empty;

emptyc :: forall a. (Ceq a) => Set_dlist a;
emptyc = Abs_dlist [];

set_empty_choose :: forall a. (Ceq a, Ccompare a) => Set a;
set_empty_choose = (case (ccompare :: Maybe (a -> a -> Ordera)) of {
                     Nothing -> (case (ceq :: Maybe (a -> a -> Bool)) of {
                                  Nothing -> Set_Monad [];
                                  Just _ -> DList_set emptyc;
                                });
                     Just _ -> RBT_set emptyd;
                   });

set_empty :: forall a. (Ceq a, Ccompare a) => Set_impla -> Set a;
set_empty Set_Choose = set_empty_choose;
set_empty Set_Monada = Set_Monad [];
set_empty Set_RBT = RBT_set emptyd;
set_empty Set_DList = DList_set emptyc;
set_empty Set_Collect = Collect_set (\ _ -> False);

set_aux :: forall a. (Ceq a, Ccompare a) => Set_impla -> [a] -> Set a;
set_aux Set_Monada = Set_Monad;
set_aux Set_Choose =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing -> (case (ceq :: Maybe (a -> a -> Bool)) of {
                 Nothing -> Set_Monad;
                 Just _ -> foldl (\ s x -> inserta x s) (DList_set emptyc);
               });
    Just _ -> foldl (\ s x -> inserta x s) (RBT_set emptyd);
  });
set_aux impl = foldl (\ s x -> inserta x s) (set_empty impl);

set :: forall a. (Ceq a, Ccompare a, Set_impl a) => [a] -> Set a;
set xs = set_aux (of_phantom (set_impl :: Phantom a Set_impla)) xs;

mapping_empty_choose :: forall a b. (Ccompare a) => Mapping a b;
mapping_empty_choose = (case (ccompare :: Maybe (a -> a -> Ordera)) of {
                         Nothing -> Assoc_List_Mapping emptya;
                         Just _ -> RBT_Mapping emptyd;
                       });

mapping_empty :: forall a b. (Ccompare a) => Mapping_impla -> Mapping a b;
mapping_empty Mapping_RBT = RBT_Mapping emptyd;
mapping_empty Mapping_Assoc_List = Assoc_List_Mapping emptya;
mapping_empty Mapping_Mapping = Mapping (\ _ -> Nothing);
mapping_empty Mapping_Choose = mapping_empty_choose;

emptyb :: forall a b. (Ccompare a, Mapping_impl a) => Mapping a b;
emptyb = mapping_empty (of_phantom (mapping_impl :: Phantom a Mapping_impla));

add ::
  forall a b. Partial_object_ext a (Monoid_ext a (Ring_ext a b)) -> a -> a -> a;
add (Partial_object_ext carrier (Monoid_ext mult one (Ring_ext zero add more)))
  = add;

is_letter :: Char -> Bool;
is_letter c =
  less_eq_char (Char True False False False False True True False) c &&
    less_eq_char c (Char False True False True True True True False) ||
    (less_eq_char (Char True False False False False False True False) c &&
       less_eq_char c (Char False True False True True False True False) ||
      (less_eq_char (Char False False False False True True False False) c &&
         less_eq_char c (Char True False False True True True False False) ||
        member
          [Char True True True True True False True False,
            Char False True True False False True False False,
            Char True True False True True True False False,
            Char False True False True True True False False,
            Char True False True True False True False False]
          c));

update_tokens :: forall a. ([a] -> [a]) -> [a] -> Sum [Char] ([a], [a]);
update_tokens f ts = Inr (ts, f ts);

remove_comments_aux_acc :: [Char] -> Bool -> [Char] -> [Char];
remove_comments_aux_acc a False (c : cs) =
  (if equal_char c (Char False False True True True True False False) &&
        take (nat_of_integer (3 :: Integer)) cs ==
          [Char True False False False False True False False,
            Char True False True True False True False False,
            Char True False True True False True False False]
    then remove_comments_aux_acc a True (tl cs)
    else remove_comments_aux_acc (c : a) False cs);
remove_comments_aux_acc a True (c : cs) =
  (if equal_char c (Char True False True True False True False False) &&
        take (nat_of_integer (2 :: Integer)) cs ==
          [Char True False True True False True False False,
            Char False True True True True True False False]
    then remove_comments_aux_acc a False
           (drop (nat_of_integer (2 :: Integer)) cs)
    else remove_comments_aux_acc a True cs);
remove_comments_aux_acc a uu [] = a;

remove_comments_aux :: Bool -> [Char] -> [Char];
remove_comments_aux False (c : cs) =
  (if equal_char c (Char False False True True True True False False) &&
        take (nat_of_integer (3 :: Integer)) cs ==
          [Char True False False False False True False False,
            Char True False True True False True False False,
            Char True False True True False True False False]
    then remove_comments_aux True (tl cs)
    else c : remove_comments_aux False cs);
remove_comments_aux True (c : cs) =
  (if equal_char c (Char True False True True False True False False) &&
        take (nat_of_integer (2 :: Integer)) cs ==
          [Char True False True True False True False False,
            Char False True True True True True False False]
    then remove_comments_aux False (drop (nat_of_integer (2 :: Integer)) cs)
    else remove_comments_aux True cs);
remove_comments_aux uu [] = [];

remove_comments :: [Char] -> [Char];
remove_comments =
  (if False then reverse . remove_comments_aux_acc [] False
    else remove_comments_aux False);

returnb :: forall a b. a -> [b] -> Sum [Char] (a, [b]);
returnb x = (\ ts -> Inr (x, ts));

bindb :: forall a b c. Sum a b -> (b -> Sum a c) -> Sum a c;
bindb m f = (case m of {
              Inl a -> Inl a;
              Inr a -> f a;
            });

bindc ::
  forall a b c.
    ([a] -> Sum [Char] (b, [a])) ->
      (b -> [a] -> Sum [Char] (c, [a])) -> [a] -> Sum [Char] (c, [a]);
bindc m f ts = bindb (m ts) (\ (a, b) -> f a b);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

shows_quote :: ([Char] -> [Char]) -> [Char] -> [Char];
shows_quote s =
  (shows_prec_char zero_nat (Char True True True False False True False False) .
    s) .
    shows_prec_char zero_nat (Char True True True False False True False False);

scan_upto :: [Char] -> [Char] -> Sum [Char] ([Char], [Char]);
scan_upto end (t : ts) =
  (if map snd (zip end (t : ts)) == end
    then Inr (end, drop (size_list end) (t : ts))
    else bindb (scan_upto end ts) (\ (res, tsa) -> Inr (t : res, tsa)));
scan_upto end [] =
  Inl ([Char False False True False False True True False,
         Char True False False True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char False True True True False True True False,
         Char True True True True False True True False,
         Char False False True False True True True False,
         Char False False False False False True False False,
         Char False True True False False True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char False False True False False True True False,
         Char False False False False False True False False,
         Char True False True False False True True False,
         Char False True True True False True True False,
         Char False False True False False True True False,
         Char True False True True False True False False,
         Char True False True True False True True False,
         Char True False False False False True True False,
         Char False True False False True True True False,
         Char True True False True False True True False,
         Char True False True False False True True False,
         Char False True False False True True True False,
         Char False False False False False True False False] ++
        shows_quote (shows_prec_list zero_nat end) []);

trim :: [Char] -> [Char];
trim =
  dropWhile
    (member
      [Char False False False False False True False False,
        Char False True False True False False False False,
        Char True False False True False False False False,
        Char True False True True False False False False]);

manya :: (Char -> Bool) -> [Char] -> Sum [Char] ([Char], [Char]);
manya p (t : ts) =
  (if p t then bindb (manya p ts) (\ (rs, tsa) -> Inr (t : rs, tsa))
    else Inr ([], t : ts));
manya p [] = Inr ([], []);

parse_header :: [Char] -> Sum [Char] ([[Char]], [Char]);
parse_header ts =
  (if take (nat_of_integer (2 :: Integer)) (trim ts) ==
        [Char False False True True True True False False,
          Char True True True True True True False False]
    then bindc (scan_upto
                 [Char True True True True True True False False,
                   Char False True True True True True False False])
           (\ h -> bindc parse_header (\ hs -> returnb (h : hs))) ts
    else bindc (bindc
                 (manya
                   (member
                     [Char False False False False False True False False,
                       Char False True False True False False False False,
                       Char True False False True False False False False,
                       Char True False True True False False False False]))
                 (\ _ -> returnb ()))
           (\ _ -> returnb []) ts);

err_expecting :: forall a b. (Showa a) => [Char] -> [a] -> Sum [Char] (b, [a]);
err_expecting msg ts =
  Inl ([Char True False True False False True True False,
         Char False False False True True True True False,
         Char False False False False True True True False,
         Char True False True False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True True True False False True True False,
         Char False False False False False True False False] ++
        msg ++
          [Char False False True True False True False False,
            Char False False False False False True False False,
            Char False True False False False True True False,
            Char True False True False True True True False,
            Char False False True False True True True False,
            Char False False False False False True False False,
            Char False True True False False True True False,
            Char True True True True False True True False,
            Char True False True False True True True False,
            Char False True True True False True True False,
            Char False False True False False True True False,
            Char False True False True True True False False,
            Char False False False False False True False False] ++
            shows_quote
              (shows_prec_list zero_nat
                (take (nat_of_integer (30 :: Integer)) ts))
              []);

eoi :: forall a. (Showa a) => [a] -> Sum [Char] ((), [a]);
eoi [] = Inr ((), []);
eoi (v : va) =
  err_expecting
    [Char True False True False False True True False,
      Char False True True True False True True False,
      Char False False True False False True True False,
      Char False False False False False True False False,
      Char True True True True False True True False,
      Char False True True False False True True False,
      Char False False False False False True False False,
      Char True False False True False True True False,
      Char False True True True False True True False,
      Char False False False False True True True False,
      Char True False True False True True True False,
      Char False False True False True True True False]
    (v : va);

exactly_aux ::
  [Char] -> [Char] -> [Char] -> [Char] -> Sum [Char] ([Char], [Char]);
exactly_aux s i (x : xs) (y : ys) =
  (if equal_char x y then exactly_aux s i xs ys
    else err_expecting
           ([Char False True False False False True False False] ++
             s ++ [Char False True False False False True False False])
           i);
exactly_aux s i [] xs = Inr (s, trim xs);
exactly_aux s i (x : xs) [] =
  err_expecting
    ([Char False True False False False True False False] ++
      s ++ [Char False True False False False True False False])
    i;

exactly :: [Char] -> [Char] -> Sum [Char] ([Char], [Char]);
exactly s x = exactly_aux s x s x;

parse_attribute_value :: [Char] -> Sum [Char] ([Char], [Char]);
parse_attribute_value =
  bindc (exactly [Char False True False False False True False False])
    (\ _ ->
      bindc (manya
              (\ y ->
                not (equal_char
                      (Char False True False False False True False False) y)))
        (\ v ->
          bindc (exactly [Char False True False False False True False False])
            (\ _ -> returnb v)));

errorb :: forall a b. [Char] -> [a] -> Sum [Char] (b, [a]);
errorb e = (\ _ -> Inl e);

parse_name :: [Char] -> Sum [Char] ([Char], [Char]);
parse_name s =
  bindc (manya is_letter)
    (\ n ->
      bindc (bindc
              (manya
                (member
                  [Char False False False False False True False False,
                    Char False True False True False False False False,
                    Char True False False True False False False False,
                    Char True False True True False False False False]))
              (\ _ -> returnb ()))
        (\ _ ->
          (if null n
            then errorb
                   ([Char True False True False False True True False,
                      Char False False False True True True True False,
                      Char False False False False True True True False,
                      Char True False True False False True True False,
                      Char True True False False False True True False,
                      Char False False True False True True True False,
                      Char True False True False False True True False,
                      Char False False True False False True True False,
                      Char False False False False False True False False,
                      Char False False True True False True True False,
                      Char True False True False False True True False,
                      Char False False True False True True True False,
                      Char False False True False True True True False,
                      Char True False True False False True True False,
                      Char False True False False True True True False,
                      Char False False False False False True False False] ++
                     letters ++
                       [Char False False False False False True False False,
                         Char False True False False False True True False,
                         Char True False True False True True True False,
                         Char False False True False True True True False,
                         Char False False False False False True False False,
                         Char False True True False False True True False,
                         Char True False False True False True True False,
                         Char False True False False True True True False,
                         Char True True False False True True True False,
                         Char False False True False True True True False,
                         Char False False False False False True False False,
                         Char True True False False True True True False,
                         Char True False False True True True True False,
                         Char True False True True False True True False,
                         Char False True False False False True True False,
                         Char True True True True False True True False,
                         Char False False True True False True True False,
                         Char False False False False False True False False,
                         Char True False False True False True True False,
                         Char True True False False True True True False,
                         Char False False False False False True False False,
                         Char False True False False False True False False] ++
                         take one_nat s ++
                           [Char False True False False False True False False])
            else returnb n)))
    s;

parse_attributes :: [Char] -> Sum [Char] ([([Char], [Char])], [Char]);
parse_attributes [] = Inr ([], []);
parse_attributes (c : s) =
  (if member
        [Char True True True True False True False False,
          Char False True True True True True False False]
        c
    then Inr ([], c : s)
    else bindc parse_name
           (\ k ->
             bindc (exactly [Char True False True True True True False False])
               (\ _ ->
                 bindc parse_attribute_value
                   (\ v ->
                     bindc parse_attributes
                       (\ atts -> returnb ((k, v) : atts)))))
           (c : s));

oneof_closed :: [Char] -> Sum [Char] ([Char], [Char]);
oneof_closed (x : xs) =
  (if equal_char x (Char False True True True True True False False)
    then Inr ([Char False True True True True True False False], trim xs)
    else (if equal_char x (Char True True True True False True False False) &&
               (case xs of {
                 [] -> False;
                 y : _ ->
                   equal_char y
                     (Char False True True True True True False False);
               })
           then Inr ([Char True True True True False True False False,
                       Char False True True True True True False False],
                      trim (tl xs))
           else err_expecting
                  [Char True True True True False True True False,
                    Char False True True True False True True False,
                    Char True False True False False True True False,
                    Char False False False False False True False False,
                    Char True True True True False True True False,
                    Char False True True False False True True False,
                    Char False False False False False True False False,
                    Char True True False True True False True False,
                    Char True True True True False True False False,
                    Char False True True True True True False False,
                    Char False False True True False True False False,
                    Char False False False False False True False False,
                    Char False True True True True True False False,
                    Char True False True True True False True False]
                  (x : xs)));
oneof_closed [] =
  err_expecting
    [Char True True True True False True True False,
      Char False True True True False True True False,
      Char True False True False False True True False,
      Char False False False False False True False False,
      Char True True True True False True True False,
      Char False True True False False True True False,
      Char False False False False False True False False,
      Char True True False True True False True False,
      Char True True True True False True False False,
      Char False True True True True True False False,
      Char False False True True False True False False,
      Char False False False False False True False False,
      Char False True True True True True False False,
      Char True False True True True False True False]
    [];

parse_text :: [Char] -> Sum [Char] (Maybe [Char], [Char]);
parse_text =
  bindc (manya
          (\ y ->
            not (equal_char (Char False False True True True True False False)
                  y)))
    (\ ts ->
      let {
        text = trim ts;
      } in (if null text then returnb Nothing
             else returnb (Just (reverse (trim (reverse text))))));

parse_nodes :: [Char] -> Sum [Char] ([Xml], [Char]);
parse_nodes ts =
  (if null ts ||
        take (nat_of_integer (2 :: Integer)) ts ==
          [Char False False True True True True False False,
            Char True True True True False True False False]
    then returnb [] ts
    else (if not (equal_char (hd ts)
                   (Char False False True True True True False False))
           then bindc parse_text
                  (\ t ->
                    bindc parse_nodes (\ ns -> returnb (XML_text (the t) : ns)))
                  ts
           else bindc (exactly
                        [Char False False True True True True False False])
                  (\ _ ->
                    bindc parse_name
                      (\ n ->
                        bindc parse_attributes
                          (\ atts ->
                            bindc oneof_closed
                              (\ e ->
                                (if e == [Char True True True True False True
    False False,
   Char False True True True True True False False]
                                  then bindc parse_nodes
 (\ cs -> returnb (XML n atts [] : cs))
                                  else bindc parse_nodes
 (\ cs ->
   bindc (exactly
           [Char False False True True True True False False,
             Char True True True True False True False False])
     (\ _ ->
       bindc (exactly n)
         (\ _ ->
           bindc (exactly [Char False True True True True True False False])
             (\ _ ->
               bindc parse_nodes (\ ns -> returnb (XML n atts cs : ns)))))))))))
                  ts));

parse_node :: [Char] -> Sum [Char] (Xml, [Char]);
parse_node =
  bindc (exactly [Char False False True True True True False False])
    (\ _ ->
      bindc parse_name
        (\ n ->
          bindc parse_attributes
            (\ atts ->
              bindc oneof_closed
                (\ e ->
                  (if e == [Char True True True True False True False False,
                             Char False True True True True True False False]
                    then returnb (XML n atts [])
                    else bindc parse_nodes
                           (\ cs ->
                             bindc (exactly
                                     [Char False False True True True True False
False,
                                       Char True True True True False True False
 False])
                               (\ _ ->
                                 bindc (exactly n)
                                   (\ _ ->
                                     bindc (exactly
     [Char False True True True True True False False])
                                       (\ _ -> returnb (XML n atts cs))))))))));

parse_doc :: [Char] -> Sum [Char] (Xmldoc, [Char]);
parse_doc =
  bindc (update_tokens remove_comments)
    (\ _ ->
      bindc parse_header
        (\ h ->
          bindc parse_node
            (\ xml -> bindc eoi (\ _ -> returnb (XMLDOC h xml)))));

nat_of_digit :: Char -> Maybe Nat;
nat_of_digit x =
  (if equal_char x (Char False False False False True True False False)
    then Just zero_nat
    else (if equal_char x (Char True False False False True True False False)
           then Just one_nat
           else (if equal_char x
                      (Char False True False False True True False False)
                  then Just (nat_of_integer (2 :: Integer))
                  else (if equal_char x
                             (Char True True False False True True False False)
                         then Just (nat_of_integer (3 :: Integer))
                         else (if equal_char x
                                    (Char False False True False True True False
                                      False)
                                then Just (nat_of_integer (4 :: Integer))
                                else (if equal_char x
   (Char True False True False True True False False)
                                       then Just (nat_of_integer (5 :: Integer))
                                       else (if equal_char x
          (Char False True True False True True False False)
      then Just (nat_of_integer (6 :: Integer))
      else (if equal_char x (Char True True True False True True False False)
             then Just (nat_of_integer (7 :: Integer))
             else (if equal_char x
                        (Char False False False True True True False False)
                    then Just (nat_of_integer (8 :: Integer))
                    else (if equal_char x
                               (Char True False False True True True False
                                 False)
                           then Just (nat_of_integer (9 :: Integer))
                           else Nothing))))))))));

nat_of_string_aux :: Nat -> [Char] -> Maybe Nat;
nat_of_string_aux n [] = Just n;
nat_of_string_aux n (d : s) =
  bind (nat_of_digit d)
    (\ m ->
      nat_of_string_aux
        (plus_nat (times_nat (nat_of_integer (10 :: Integer)) n) m) s);

nat_of_string :: [Char] -> Sum String Nat;
nat_of_string s =
  (case (if null s then Nothing else nat_of_string_aux zero_nat s) of {
    Nothing -> Inl (("cannot convert \"" ++ implode s) ++ "\" to a number");
    Just a -> Inr a;
  });

safe_head :: forall a. [a] -> Maybe a;
safe_head [] = Nothing;
safe_head (x : xs) = Just x;

int_of_stringa :: [Char] -> Sum String Int;
int_of_stringa s =
  (if safe_head s == Just (Char True False True True False True False False)
    then bindb (nat_of_string (tl s)) (\ n -> Inr (uminus_int (int_of_nat n)))
    else bindb (nat_of_string s) (\ n -> Inr (int_of_nat n)));

xml_take_int ::
  forall a.
    (Int ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
xml_take_int p xs =
  (case xs of {
    ([], _) -> xml_error "expecting an integer" xs;
    (XML _ _ _ : _, _) -> xml_error "expecting an integer" xs;
    (XML_text text : xmls, s) -> (case int_of_stringa text of {
                                   Inl x -> xml_error x xs;
                                   Inr n -> p n (xmls, s);
                                 });
  });

xml_return ::
  forall a.
    a -> ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
           Sum_bot (Xml_error String) a;
xml_return v x = (case x of {
                   ([], _) -> right v;
                   (_ : _, _) -> xml_error "expecting tag close" x;
                 });

xml_int ::
  String ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) Int;
xml_int tag = xml_do tag (xml_take_int xml_return);

xml_take_nat ::
  forall a.
    (Nat ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
xml_take_nat p xs =
  (case xs of {
    ([], _) -> xml_error "expecting a number" xs;
    (XML _ _ _ : _, _) -> xml_error "expecting a number" xs;
    (XML_text text : xmls, s) -> (case nat_of_string text of {
                                   Inl x -> xml_error x xs;
                                   Inr n -> p n (xmls, s);
                                 });
  });

xml_nat ::
  String ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) Nat;
xml_nat tag = xml_do tag (xml_take_nat xml_return);

zero_enat :: Enat;
zero_enat = Enat zero_nat;

minus_enat :: Enat -> Enat -> Enat;
minus_enat (Enat a) Infinity_enat = zero_enat;
minus_enat Infinity_enat n = Infinity_enat;
minus_enat (Enat a) (Enat b) = Enat (minus_nat a b);

equal_enat :: Enat -> Enat -> Bool;
equal_enat (Enat nat) Infinity_enat = False;
equal_enat Infinity_enat (Enat nat) = False;
equal_enat (Enat nata) (Enat nat) = equal_nat nata nat;
equal_enat Infinity_enat Infinity_enat = True;

one_enat :: Enat;
one_enat = Enat one_nat;

xml_take_many_sub ::
  forall a b.
    [a] ->
      Nat ->
        Enat ->
          ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
            Sum_bot (Xml_error String) a) ->
            ([a] ->
              ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
                Sum_bot (Xml_error String) b) ->
              ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
                Sum_bot (Xml_error String) b;
xml_take_many_sub acc minOccurs maxOccurs p1 p2 ([], (atts, (allow, rest))) =
  (if equal_nat minOccurs zero_nat
    then p2 (reverse acc) ([], (atts, (allow, rest)))
    else bind2 (p1 (XML [] [] [], (atts, (False, rest)))) left
           (\ _ -> left (Fatal "unexpected")));
xml_take_many_sub acc minOccurs maxOccurs p1 p2
  (xml : xmls, (atts, (allow, (cands, rest)))) =
  (if equal_enat maxOccurs zero_enat
    then p2 (reverse acc) (xml : xmls, (atts, (allow, (cands, rest))))
    else bind2 (p1 (xml, (atts, (equal_nat minOccurs zero_nat, (cands, rest)))))
           (\ e ->
             (case e of {
               TagMismatch _ ->
                 p2 (reverse acc) (xml : xmls, (atts, (allow, (cands, rest))));
               Fatal _ -> left e;
             }))
           (\ a ->
             xml_take_many_sub (a : acc) (minus_nat minOccurs one_nat)
               (minus_enat maxOccurs one_enat) p1 p2
               (xmls, (atts, (False, ([], rest))))));

position ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Nat;
position =
  xml_do "position" (xml_take_nat (\ n -> xml_return (minus_nat n one_nat)));

xml_change ::
  forall a b.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (a -> ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
              Sum_bot (Xml_error String) b) ->
        (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) b;
xml_change p f x = bind2 (p x) left (\ a -> (case x of {
      (_, rest) -> f a ([], rest);
    }));

xml_take ::
  forall a b.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (a -> ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
              Sum_bot (Xml_error String) b) ->
        ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) b;
xml_take p1 p2 x =
  (case x of {
    ([], rest) ->
      bind2 (p1 (XML [] [] [], rest)) left (\ _ -> left (Fatal "unexpected"));
    (xa : xs, rest) ->
      (case rest of {
        (atts, (flag, (cands, resta))) ->
          bind2 (p1 (xa, (atts, (flag, (cands, resta))))) left
            (\ a -> p2 a (xs, (atts, (False, ([], resta)))));
      });
  });

afs ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), Af_entry)];
afs xml2name =
  xml_do "argumentFilter"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "argumentFilterEntry"
        (xml_take xml2name
          (\ name ->
            xml_take (xml_nat "arity")
              (\ arity ->
                xml_take
                  (xml_or
                    (xml_change (xml_nat "collapsing")
                      (\ n -> xml_return (Collapse (minus_nat n one_nat))))
                    (xml_do "nonCollapsing"
                      (xml_take_many_sub [] zero_nat Infinity_enat position
                        (\ ls -> xml_return (AFList ls)))))
                  (\ main -> xml_return ((name, arity), main))))))
      xml_return);

scg_position ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Nat;
scg_position = xml_nat "position";

xml_take_default ::
  forall a b.
    a -> ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
           Sum_bot (Xml_error String) a) ->
           (a -> ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) b) ->
             ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
               Sum_bot (Xml_error String) b;
xml_take_default a p1 p2 xs =
  (case xs of {
    ([], _) -> p2 a xs;
    (xml : xmls, (atts, (allow, (cands, rest)))) ->
      bind2 (p1 (xml, (atts, (True, (cands, rest)))))
        (\ e ->
          (case e of {
            TagMismatch cands1 ->
              p2 a (xml : xmls, (atts, (allow, (cands1, rest))));
            Fatal _ -> left e;
          }))
        (\ aa -> p2 aa (xmls, (atts, (False, ([], rest)))));
  });

xml_take_text ::
  forall a.
    ([Char] ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
xml_take_text p xs = (case xs of {
                       ([], _) -> xml_error "expecting a text" xs;
                       (XML _ _ _ : _, _) -> xml_error "expecting a text" xs;
                       (XML_text text : xmls, s) -> p text (xmls, s);
                     });

xml_text ::
  String ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) [Char];
xml_text tag = xml_do tag (xml_take_text xml_return);

plain_var ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Char];
plain_var = xml_text "var";

var ::
  forall a.
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Term a [Char]);
var = xml_change plain_var (xml_return . Var);

term ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Term a [Char]);
term xml2name x =
  xml_or var
    (xml_do "funapp"
      (xml_take xml2name
        (\ name ->
          xml_take_many_sub [] zero_nat Infinity_enat
            (xml_or (term xml2name)
              (xml_do "arg" (xml_take (term xml2name) xml_return)))
            (\ args -> xml_return (Fun name args)))))
    x;

conditions ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String)
                         [(Term a [Char], Term a [Char])];
conditions xml2name tag =
  xml_do tag
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "condition"
        (xml_take (xml_do "lhs" (xml_take (term xml2name) xml_return))
          (\ l ->
            xml_take (xml_do "rhs" (xml_take (term xml2name) xml_return))
              (\ r -> xml_return (l, r)))))
      xml_return);

crule ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String)
                         ((Term a [Char], Term a [Char]),
                           [(Term a [Char], Term a [Char])]);
crule xml2name tag =
  xml_do tag
    (xml_take (xml_do "lhs" (xml_take (term xml2name) xml_return))
      (\ l ->
        xml_take (xml_do "rhs" (xml_take (term xml2name) xml_return))
          (\ r ->
            xml_take_default [] (conditions xml2name "conditions")
              (\ conds -> xml_return ((l, r), conds)))));

rule ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Term a [Char], Term a [Char]);
rule xml2name =
  xml_change (crule xml2name "rule")
    (\ (lr, conds) ->
      (if null conds then xml_return lr
        else xml_error "conditional rule is not allowed here"));

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) = (case f x of {
                          Nothing -> map_filter f xs;
                          Just y -> y : map_filter f xs;
                        });

bool_of_string :: [Char] -> Sum String Bool;
bool_of_string s =
  (if s == [Char False False True False True True True False,
             Char False True False False True True True False,
             Char True False True False True True True False,
             Char True False True False False True True False]
    then Inr True
    else (if s == [Char False True True False False True True False,
                    Char True False False False False True True False,
                    Char False False True True False True True False,
                    Char True True False False True True True False,
                    Char True False True False False True True False]
           then Inr False
           else Inl (("cannot convert \"" ++ implode s) ++ "\" into Boolean")));

xml_bool ::
  String ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) Bool;
xml_bool tag x =
  bind2 (xml_text tag x) left
    (\ str -> (case bool_of_string str of {
                Inl err -> xml_error err ([fst x], snd x);
                Inr a -> right a;
              }));

scg ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       ((Term a [Char], Term a [Char]),
                         ([(Nat, Nat)], [(Nat, Nat)]));
scg xml2name =
  xml_do "sizeChangeGraph"
    (xml_take (rule xml2name)
      (\ lr ->
        xml_take_many_sub [] zero_nat Infinity_enat
          (xml_do "edge"
            (xml_take scg_position
              (\ p ->
                xml_take (xml_bool "strict")
                  (\ s ->
                    xml_take scg_position (\ q -> xml_return (s, (p, q)))))))
          (\ edges ->
            xml_return
              (lr, (map_filter
                      (\ x -> (if fst x then Just (snd x) else Nothing)) edges,
                     map_filter
                       (\ x -> (if not (fst x) then Just (snd x) else Nothing))
                       edges)))));

partition :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
partition p [] = ([], []);
partition p (x : xs) =
  (case partition p xs of {
    (yes, no) -> (if p x then (x : yes, no) else (yes, x : no));
  });

rbt_comp_lookup :: forall a b. (a -> a -> Ordera) -> Rbta a b -> a -> Maybe b;
rbt_comp_lookup c Empty k = Nothing;
rbt_comp_lookup c (Branch uu l x y r) k = (case c k x of {
    Eqa -> Just y;
    Lt -> rbt_comp_lookup c l k;
    Gt -> rbt_comp_lookup c r k;
  });

lookupc :: forall a b. (Ccompare a) => Mapping_rbt a b -> a -> Maybe b;
lookupc xa = rbt_comp_lookup (the ccompare) (impl_ofb xa);

lookupb :: forall a b. (Ccompare a, Eq a) => Mapping a b -> a -> Maybe b;
lookupb (RBT_Mapping t) = lookupc t;
lookupb (Assoc_List_Mapping al) = lookupa al;

updateb ::
  forall a b. (Ccompare a, Eq a) => a -> b -> Mapping a b -> Mapping a b;
updateb k v (RBT_Mapping t) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "update RBT_Mapping: ccompare = None"
        (\ _ -> updateb k v (RBT_Mapping t));
    Just _ -> RBT_Mapping (insertc k v t);
  });
updateb k v (Assoc_List_Mapping al) = Assoc_List_Mapping (updatea k v al);
updateb k v (Mapping m) = Mapping (fun_upd m k (Just v));

rep_vec_impl :: forall a. Vec_impl a -> (Nat, IArray.IArray a);
rep_vec_impl (Abs_vec_impl x) = x;

dim_vec_impl :: forall a. Vec_impl a -> Nat;
dim_vec_impl xa = fst (rep_vec_impl xa);

dim_vec :: forall a. Vec a -> Nat;
dim_vec (Vec_impl v) = dim_vec_impl v;

one_mat :: forall a. (One a, Zero a) => Nat -> Mat a;
one_mat n = mat n n (\ (i, j) -> (if equal_nat i j then onea else zeroa));

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

zero :: forall a b. Partial_object_ext a (Monoid_ext a (Ring_ext a b)) -> a;
zero (Partial_object_ext carrier (Monoid_ext mult one (Ring_ext zero add more)))
  = zero;

list2position :: [Nat] -> [Nat];
list2position [] = [];
list2position (n : ns) = n : list2position ns;

pos ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Nat];
pos = xml_do "positionInTerm"
        (xml_take_many_sub [] zero_nat Infinity_enat position
          (\ lst -> xml_return (list2position lst)));

many1_gen ::
  forall a b c.
    [Char] ->
      (Xml -> Sum_bot [Char] a) ->
        (a -> Xml -> Sum_bot [Char] b) ->
          (a -> [b] -> c) -> Xml -> Sum_bot [Char] c;
many1_gen tag p1 p2 f (XML name atts cs) =
  (if name == tag && null atts && not (null cs)
    then (case cs of {
           h : t ->
             binda (p1 h)
               (\ x -> binda (map_sum_bot (p2 x) t) (\ xs -> returna (f x xs)));
         })
    else fail tag (XML name atts cs));
many1_gen tag p1 p2 f (XML_text v) = fail tag (XML_text v);

list1element :: forall a. [a] -> Maybe a;
list1element [x] = Just x;
list1element [] = Nothing;
list1element (v : vb : vc) = Nothing;

singleton ::
  forall a b.
    [Char] -> (Xml -> Sum_bot [Char] a) -> (a -> b) -> Xml -> Sum_bot [Char] b;
singleton tag p1 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list1element cs of {
               Nothing -> fail tag xml;
               Just cs1 -> binda (p1 cs1) (returna . f);
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

xml_leaf ::
  forall a.
    String ->
      a -> (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
             Sum_bot (Xml_error String) a;
xml_leaf tag ret = xml_do tag (xml_return ret);

ctxt ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Ctxt a [Char]);
ctxt xml2name x =
  xml_or (xml_do "box" (xml_return Hole))
    (xml_do "funContext"
      (xml_take xml2name
        (\ name ->
          xml_take
            (xml_do "before"
              (xml_take_many_sub [] zero_nat Infinity_enat (term xml2name)
                xml_return))
            (\ left ->
              xml_take (ctxt xml2name)
                (\ mid ->
                  xml_take
                    (xml_do "after"
                      (xml_take_many_sub [] zero_nat Infinity_enat
                        (term xml2name) xml_return))
                    (\ right -> xml_return (More name left mid right)))))))
    x;

xml_take_optional ::
  forall a b.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Maybe a ->
        ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) b) ->
        ([Xml], ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) b;
xml_take_optional p1 p2 xs =
  (case xs of {
    ([], _) -> p2 Nothing xs;
    (xml : xmls, (atts, (allow, (cands, rest)))) ->
      bind2 (p1 (xml, (atts, (True, (cands, rest)))))
        (\ e ->
          (case e of {
            TagMismatch cands1 ->
              p2 Nothing (xml : xmls, (atts, (allow, (cands1, rest))));
            Fatal _ -> left e;
          }))
        (\ a -> p2 (Just a) (xmls, (atts, (False, ([], rest)))));
  });

relstep ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       ([Nat],
                         ((Term a [Char], Term a [Char]),
                           (Bool, Term a [Char])));
relstep xml2name =
  xml_do "rewriteStep"
    (xml_take pos
      (\ p ->
        xml_take (rule xml2name)
          (\ r ->
            xml_take_optional (xml_leaf "relative" ())
              (\ rel ->
                xml_take (term xml2name)
                  (\ t -> xml_return (p, (r, (is_none rel, t))))))));

relsteps ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Term a [Char],
                         [([Nat],
                            ((Term a [Char], Term a [Char]),
                              (Bool, Term a [Char])))]);
relsteps xml2name =
  xml_do "rewriteSequence"
    (xml_take
      (xml_do "startTerm" (xml_take (term xml2name) (\ x -> xml_return (id x))))
      (\ start ->
        xml_take_many_sub [] zero_nat Infinity_enat (relstep xml2name)
          (\ steps -> xml_return (start, steps))));

substa ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [([Char], Term a [Char])];
substa xml2name =
  xml_do "substitution"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "substEntry"
        (xml_take (xml_do "var" (xml_take_text xml_return))
          (\ var -> xml_take (term xml2name) (\ trm -> xml_return (var, trm)))))
      xml_return);

loop ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Term a [Char],
                         ([([Nat],
                             ((Term a [Char], Term a [Char]),
                               (Bool, Term a [Char])))],
                           ([([Char], Term a [Char])], Ctxt a [Char])));
loop xml2name =
  xml_do "loop"
    (xml_take (relsteps xml2name)
      (\ (s, rseq) ->
        xml_take (substa xml2name)
          (\ sigma ->
            xml_take (ctxt xml2name)
              (\ c -> xml_return (s, (rseq, (sigma, c)))))));

proj ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (ProjL a);
proj xml2name =
  xml_change (afs xml2name)
    (\ afl ->
      xml_return
        (Projection (map (\ (fa, a) -> (case a of {
 Collapse aa -> (fa, aa);
 AFList _ -> (fa, snd fa);
                                       }))
                      afl)));

catch_error :: forall a b c. Sum_bot a b -> (a -> Sum_bot c b) -> Sum_bot c b;
catch_error (Sumbot a) f = (case a of {
                             Inl aa -> f aa;
                             Inr aa -> Sumbot (Inr aa);
                           });

real :: Xml -> Sum_bot [Char] Real;
real x =
  catch_error (change rat ratreal x)
    (\ _ ->
      triple
        [Char True False False False False True True False,
          Char False False True True False True True False,
          Char True True True False False True True False,
          Char True False True False False True True False,
          Char False True False False False True True False,
          Char False True False False True True True False,
          Char True False False False False True True False,
          Char True False False True False True True False,
          Char True True False False False True True False]
        rat rat rat
        (\ a b c ->
          plus_real (ratreal a) (times_real (ratreal b) (sqrt (ratreal c))))
        x);

proj_term :: forall a b. ((a, Nat) -> Nat) -> Term a b -> Term a b;
proj_term p (Var x) = Var x;
proj_term p (Fun f ts) = let {
                           n = size_list ts;
                           i = p (f, n);
                         } in (if less_nat i n then nth ts i else Fun f ts);

start_term ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    Term a [Char] ->
                      (Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                        Sum_bot (Xml_error String) (Term a [Char]);
start_term xml2name t =
  xml_do "startTerm"
    (xml_take (term xml2name)
      (\ s ->
        (if equal_term s t then xml_return t
          else xml_error "<startTerm> does not match lhs")));

rstep ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       ([Nat], ((Term a [Char], Term a [Char]), Term a [Char]));
rstep xml2name =
  xml_do "rewriteStep"
    (xml_take pos
      (\ p ->
        xml_take (rule xml2name)
          (\ r -> xml_take (term xml2name) (\ t -> xml_return (p, (r, t))))));

rseq ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    ((a, Nat) -> Nat) ->
                      (Term a [Char], Term a [Char]) ->
                        (Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                          Sum_bot (Xml_error String)
                            ((Term a [Char], Term a [Char]),
                              [([Nat],
                                 ((Term a [Char], Term a [Char]),
                                   Term a [Char]))]);
rseq xml2name pi r =
  xml_do "rewriteSequence"
    (xml_take (start_term xml2name (proj_term pi (fst r)))
      (\ _ ->
        xml_take_many_sub [] zero_nat Infinity_enat (rstep xml2name)
          (\ rseq -> xml_return (r, rseq))));

sum_list :: forall a. (Monoid_add a) => [a] -> a;
sum_list xs = foldr plus xs zeroa;

vec_index_impl :: forall a. Vec_impl a -> Nat -> a;
vec_index_impl xa = (case rep_vec_impl xa of {
                      (_, a) -> sub a;
                    });

vec_index :: forall a. Vec a -> Nat -> a;
vec_index (Vec_impl v) i = vec_index_impl v i;

scalar_prod :: forall a. (Semiring_0 a) => Vec a -> Vec a -> a;
scalar_prod v w =
  sum_list
    (map (\ i -> times (vec_index v i) (vec_index w i))
      (upt zero_nat (dim_vec w)));

times_mat :: forall a. (Semiring_0 a) => Mat a -> Mat a -> Mat a;
times_mat a b =
  mat (dim_row a) (dim_col b) (\ (i, j) -> scalar_prod (row a i) (col b j));

plus_mat :: forall a. (Plus a) => Mat a -> Mat a -> Mat a;
plus_mat a b =
  mat (dim_row b) (dim_col b) (\ ij -> plus (index_mat a ij) (index_mat b ij));

carrier_mat :: forall a. Nat -> Nat -> Set (Mat a);
carrier_mat nr nc =
  Collect_set (\ a -> equal_nat (dim_row a) nr && equal_nat (dim_col a) nc);

zero_mat :: forall a. (Zero a) => Nat -> Nat -> Mat a;
zero_mat nr nc = mat nr nc (\ _ -> zeroa);

ring_mat ::
  forall a b.
    (Semiring_1 a) => Itself a ->
                        Nat ->
                          b -> Partial_object_ext (Mat a)
                                 (Monoid_ext (Mat a) (Ring_ext (Mat a) b));
ring_mat ty n b =
  Partial_object_ext (carrier_mat n n)
    (Monoid_ext times_mat (one_mat n) (Ring_ext (zero_mat n n) plus_mat b));

xml_error_to_string :: Xml_error String -> [Char];
xml_error_to_string (Fatal e) = explode ("Fatal: " ++ e);
xml_error_to_string (TagMismatch e) =
  explode ("tag mismatch: " ++ default_showsl_list showsl_lit e "");

parse_xml ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      Xml -> Sum_bot [Char] a;
parse_xml p xml =
  bind2 (xml_take p xml_return ([xml], ([], (False, ([], [])))))
    (left . xml_error_to_string) right;

mk_subst ::
  forall a b c. (Eq a) => (a -> Term b c) -> [(a, Term b c)] -> a -> Term b c;
mk_subst d xts = (\ x -> (case map_of xts x of {
                           Nothing -> d x;
                           Just t -> t;
                         }));

cstep ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Cstep_proof (Lab a b) [Char]);
cstep xml2name x =
  xml_do "conditionalRewriteStep"
    (xml_take (crule xml2name "rule")
      (\ a ->
        xml_take pos
          (\ b ->
            xml_take (substa xml2name)
              (\ c ->
                xml_take
                  (xml_do "source"
                    (xml_take (term xml2name) (\ xa -> xml_return (id xa))))
                  (\ d ->
                    xml_take
                      (xml_do "target"
                        (xml_take (term xml2name) (\ xa -> xml_return (id xa))))
                      (\ e ->
                        xml_take
                          (xml_do "conditions"
                            (xml_take_many_sub [] zero_nat Infinity_enat
                              (csteps xml2name) (\ aa -> xml_return (id aa))))
                          (\ f ->
                            xml_return
                              (Cstep_step a b (mk_subst Var c) d e f))))))))
    x;

csteps ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) [Cstep_proof (Lab a b) [Char]];
csteps xml2name x =
  xml_do "conditionalRewritingSequence"
    (xml_take_many_sub [] zero_nat Infinity_enat (cstep xml2name)
      (\ a -> xml_return (id a)))
    x;

estep ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       ([Nat],
                         ((Term a [Char], Term a [Char]),
                           (Bool, Term a [Char])));
estep xml2name =
  xml_do "equationStep"
    (xml_take pos
      (\ p ->
        xml_take (rule xml2name)
          (\ r ->
            xml_take
              (xml_or (xml_leaf "leftRight" True) (xml_leaf "rightLeft" False))
              (\ b ->
                xml_take (term xml2name)
                  (\ t -> xml_return (p, (r, (b, t))))))));

state ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Char];
state = xml_text "state";

case_sum_bot :: forall a b c. a -> (b -> a) -> (c -> a) -> Sum_bot b c -> a;
case_sum_bot f g h (Sumbot p) = (case p of {
                                  Inl a -> g a;
                                  Inr a -> h a;
                                });

xmlt2 ::
  forall a.
    (Xml -> Sum_bot [Char] a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
xmlt2 xmlt x =
  (case x of {
    (xml, (_, (_, (_, p)))) ->
      case_sum_bot (error "undefined")
        (\ err -> xml_error (implode err) ([fst x], snd x))
        (\ v -> xml_return v ([], ([], (False, ([], p))))) (xmlt xml);
  });

one :: forall a b. Partial_object_ext a (Monoid_ext a b) -> a;
one (Partial_object_ext carrier (Monoid_ext mult one more)) = one;

of_alist ::
  forall a b. (Ccompare a, Eq a, Mapping_impl a) => [(a, b)] -> Mapping a b;
of_alist xs = foldr (\ (a, b) -> updateb a b) xs emptyb;

rules ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       [(Term a [Char], Term a [Char])];
rules xml2name =
  xml_do "rules"
    (xml_take_many_sub [] zero_nat Infinity_enat (rule xml2name) xml_return);

num_children :: Xml -> Nat;
num_children (XML uu uv cs) = size_list cs;
num_children (XML_text uw) = zero_nat;

string ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) [Lab a b];
string xml2name =
  xml_do "string"
    (xml_take_many_sub [] zero_nat Infinity_enat xml2name
      (\ a -> xml_return (id a)));

oc_srs ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) ([Lab a b], [Lab a b]);
oc_srs xml2name =
  xml_do "overlapClosureSRS"
    (xml_take (string xml2name)
      (\ a -> xml_take (string xml2name) (\ b -> xml_return (a, b))));

rsteps ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Term a [Char],
                         [([Nat],
                            ((Term a [Char], Term a [Char]), Term a [Char]))]);
rsteps xml2name =
  xml_do "rewriteSequence"
    (xml_take
      (xml_do "startTerm" (xml_take (term xml2name) (\ x -> xml_return (id x))))
      (\ start ->
        xml_take_many_sub [] zero_nat Infinity_enat (rstep xml2name)
          (\ steps -> xml_return (start, steps))));

mult :: forall a b. Partial_object_ext a (Monoid_ext a b) -> a -> a -> a;
mult (Partial_object_ext carrier (Monoid_ext mult one more)) = mult;

in_poss :: forall a b. [Nat] -> Term a b -> Bool;
in_poss [] uu = True;
in_poss (i : p) (Fun f ts) = less_nat i (size_list ts) && in_poss p (nth ts i);
in_poss (i : p) (Var uv) = False;

subt_at :: forall a b. Term a b -> [Nat] -> Term a b;
subt_at s [] = s;
subt_at (Fun f ss) (i : p) = subt_at (nth ss i) p;

doc_of_string :: [Char] -> Sum [Char] Xmldoc;
doc_of_string s = bindb (parse_doc s) (\ (doc, _) -> Inr doc);

special_map :: [Char] -> Maybe [Char];
special_map =
  map_of
    [([Char True False False False True True True False,
        Char True False True False True True True False,
        Char True True True True False True True False,
        Char False False True False True True True False],
       [Char False True False False False True False False]),
      ([Char True True False False False True False False,
         Char True True False False True True False False,
         Char False False True False True True False False],
        [Char False True False False False True False False]),
      ([Char True False False False False True True False,
         Char True False True True False True True False,
         Char False False False False True True True False],
        [Char False True True False False True False False]),
      ([Char True True False False False True False False,
         Char True True False False True True False False,
         Char False False False True True True False False],
        [Char False True True False False True False False]),
      ([Char True False False False False True True False,
         Char False False False False True True True False,
         Char True True True True False True True False,
         Char True True False False True True True False],
        [Char True True True False False True False False]),
      ([Char True True False False False True False False,
         Char True True False False True True False False,
         Char True False False True True True False False],
        [Char True True True False False True False False]),
      ([Char False False True True False True True False,
         Char False False True False True True True False],
        [Char False False True True True True False False]),
      ([Char True True False False False True False False,
         Char False True True False True True False False,
         Char False False False False True True False False],
        [Char False False True True True True False False]),
      ([Char True True True False False True True False,
         Char False False True False True True True False],
        [Char False True True True True True False False]),
      ([Char True True False False False True False False,
         Char False True True False True True False False,
         Char False True False False True True False False],
        [Char False True True True True True False False])];

pat_eqv_prf ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Pat_eqv_prf a [Char]);
pat_eqv_prf xml2name =
  let {
    sub = substa xml2name;
  } in xml_do "patternEquivalence"
         (xml_take
           (xml_or
             (xml_do "domainRenaming"
               (xml_take sub (\ n -> xml_return (Pat_Dom_Renaming n))))
             (xml_or
               (xml_do "irrelevant"
                 (xml_take sub
                   (\ n ->
                     xml_take sub (\ n2 -> xml_return (Pat_Irrelevant n n2)))))
               (xml_do "simplification"
                 (xml_take sub
                   (\ n ->
                     xml_take sub (\ n2 -> xml_return (Pat_Simplify n n2)))))))
           (\ x -> xml_return (id x)));

pat_term ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Term a [Char],
                         ([([Char], Term a [Char])],
                           [([Char], Term a [Char])]));
pat_term xml2name =
  xml_do "patternTerm"
    (xml_take (term xml2name)
      (\ t ->
        xml_take (substa xml2name)
          (\ s1 ->
            xml_take (substa xml2name) (\ s2 -> xml_return (t, (s1, s2))))));

pat_rule_prf ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Pat_rule_prf a [Char]);
pat_rule_prf xml2name x =
  let {
    pat = pat_rule_prf xml2name;
    sub = substa xml2name;
    pt = pat_term xml2name;
    var = xml_text "var";
  } in xml_do "patternRule"
         (xml_take pt
           (\ _ ->
             xml_take pt
               (\ _ ->
                 xml_take
                   (xml_or
                     (xml_do "originalRule"
                       (xml_take (rule xml2name)
                         (\ r ->
                           xml_take (xml_bool "isPair")
                             (\ b -> xml_return (Pat_OrigRule r b)))))
                     (xml_or
                       (xml_do "initialPumping"
                         (xml_take pat
                           (\ a ->
                             xml_take sub
                               (\ b ->
                                 xml_take sub
                                   (\ c -> xml_return (Pat_InitPump a b c))))))
                       (xml_or
                         (xml_do "initialPumpingContext"
                           (xml_take pat
                             (\ a ->
                               xml_take sub
                                 (\ b ->
                                   xml_take pos
                                     (\ c ->
                                       xml_take var
 (\ d -> xml_return (Pat_InitPumpCtxt a b c d)))))))
                         (xml_or
                           (xml_do "equivalence"
                             (xml_take pat
                               (\ a ->
                                 xml_take
                                   (xml_or (xml_leaf "left" True)
                                     (xml_leaf "right" False))
                                   (\ b ->
                                     xml_take (pat_eqv_prf xml2name)
                                       (\ c -> xml_return (Pat_Equiv a b c))))))
                           (xml_or
                             (xml_do "narrowing"
                               (xml_take pat
                                 (\ a ->
                                   xml_take pat
                                     (\ b ->
                                       xml_take pos
 (\ c -> xml_return (Pat_Narrow a b c))))))
                             (xml_or
                               (xml_do "instantiation"
                                 (xml_take pat
                                   (\ a ->
                                     xml_take sub
                                       (\ b ->
 xml_take
   (xml_or (xml_leaf "base" Pat_Base)
     (xml_or (xml_leaf "pumping" Pat_Pump) (xml_leaf "closing" Pat_Close)))
   (\ c -> xml_return (Pat_Inst a b c))))))
                               (xml_or
                                 (xml_do "instantiationPumping"
                                   (xml_take pat
                                     (\ a ->
                                       xml_take (xml_nat "power")
 (\ b -> xml_return (Pat_Exp_Sigma a b)))))
                                 (xml_do "rewriting"
                                   (xml_take pat
                                     (\ a ->
                                       xml_take (rsteps xml2name)
 (\ b ->
   xml_take
     (xml_or (xml_leaf "base" (Pat_Base, []))
       (xml_or
         (xml_do "pumping" (xml_take var (\ v -> xml_return (Pat_Pump, v))))
         (xml_do "closing" (xml_take var (\ v -> xml_return (Pat_Close, v))))))
     (\ (po, va) -> xml_return (Pat_Rewr a b po va)))))))))))))
                   xml_return)))
         x;

nonloop ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Non_loop_prf (Lab a b) [Char]);
nonloop xml2name =
  xml_do "nonLoop"
    (xml_take (pat_rule_prf xml2name)
      (\ a ->
        xml_take (substa xml2name)
          (\ b ->
            xml_take (substa xml2name)
              (\ c ->
                xml_take (xml_nat "natural")
                  (\ d ->
                    xml_take (xml_nat "natural")
                      (\ e ->
                        xml_take pos
                          (\ f -> xml_return (Non_loop_prf a b c d e f))))))));

mat_of_cols :: forall a. Nat -> [Vec a] -> Mat a;
mat_of_cols n cs = mat n (size_list cs) (\ (i, j) -> vec_index (nth cs j) i);

vec_of_list_impl :: forall a. [a] -> Vec_impl a;
vec_of_list_impl xa = Abs_vec_impl (size_list xa, IArray.of_list xa);

vec_of_list :: forall a. [a] -> Vec a;
vec_of_list v = Vec_impl (vec_of_list_impl v);

subst_apply_term :: forall a b c. Term a b -> (b -> Term a c) -> Term a c;
subst_apply_term (Var x) alpha = alpha x;
subst_apply_term (Fun f ss) alpha =
  Fun f (map (\ s -> subst_apply_term s alpha) ss);

subst_compose ::
  forall a b c d. (a -> Term b c) -> (c -> Term b d) -> a -> Term b d;
subst_compose sigma tau = (\ x -> subst_apply_term (sigma x) tau);

add_funs_term :: forall a b. Term a b -> [a] -> [a];
add_funs_term (Var uu) fs = fs;
add_funs_term (Fun f ts) fs = f : foldr add_funs_term ts fs;

add_funs_rule :: forall a b. (Term a b, Term a b) -> [a] -> [a];
add_funs_rule r fs = add_funs_term (fst r) (add_funs_term (snd r) fs);

funs_rule_list :: forall a b. (Term a b, Term a b) -> [a];
funs_rule_list r = add_funs_rule r [];

symbols ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) [(a, Nat)];
symbols xml2name tagname =
  xml_do tagname
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "symbol"
        (xml_take xml2name
          (\ a -> xml_take (xml_nat "arity") (\ b -> xml_return (a, b)))))
      xml_return);

map_xml_text :: ([Char] -> [Char]) -> Xml -> Xml;
map_xml_text f (XML t asa cs) = XML t asa (map (map_xml_text f) cs);
map_xml_text f (XML_text txt) = XML_text (f txt);

orig_term :: forall a b. (a -> Maybe b) -> Term a b -> Term a b;
orig_term m (Var x) = Var x;
orig_term m (Fun f []) = (case m f of {
                           Nothing -> Fun f [];
                           Just a -> Var a;
                         });
orig_term m (Fun f (v : va)) = Fun f (map (orig_term m) (v : va));

sum_lpoly ::
  forall a.
    Partial_object_ext a (Monoid_ext a (Ring_ext a ())) -> [a] -> [a] -> [a];
sum_lpoly c [] ys = ys;
sum_lpoly c (v : va) [] = v : va;
sum_lpoly c (x : xs) (y : ys) = add c x y : sum_lpoly c xs ys;

lpoly_of ::
  forall a.
    (Eq a) => Partial_object_ext a (Monoid_ext a (Ring_ext a ())) ->
                Tpoly Nat a -> Sum_bot [Char] (a, [a]);
lpoly_of c (PNum i) = returna (i, []);
lpoly_of c (PVar x) = returna (zero c, replicate x (zero c) ++ [one c]);
lpoly_of c (PSum []) = returna (zero c, []);
lpoly_of c (PSum (p : ps)) =
  binda (lpoly_of c p)
    (\ (cp, ncp) ->
      binda (lpoly_of c (PSum ps))
        (\ (cq, ncq) -> returna (add c cp cq, sum_lpoly c ncp ncq)));
lpoly_of c (PMult []) = returna (one c, []);
lpoly_of c (PMult (p : ps)) =
  binda (lpoly_of c p)
    (\ (cp, ncp) ->
      binda (lpoly_of c (PMult ps))
        (\ (cq, ncq) ->
          (if all (\ a -> zero c == a) ncp
            then returna (mult c cp cq, map (mult c cp) ncq)
            else (if all (\ a -> zero c == a) ncq
                   then returna (mult c cp cq, map (\ x -> mult c x cq) ncp)
                   else errora
                          [Char True True False False False True True False,
                            Char True False False False False True True False,
                            Char False True True True False True True False,
                            Char False True True True False True True False,
                            Char True True True True False True True False,
                            Char False False True False True True True False,
                            Char False False False False False True False False,
                            Char False False True False True True True False,
                            Char False True False False True True True False,
                            Char True False False False False True True False,
                            Char False True True True False True True False,
                            Char True True False False True True True False,
                            Char False True True False False True True False,
                            Char True True True True False True True False,
                            Char False True False False True True True False,
                            Char True False True True False True True False,
                            Char False False False False False True False False,
                            Char False True True True False True True False,
                            Char True True True True False True True False,
                            Char False True True True False True True False,
                            Char True False True True False True False False,
                            Char False False True True False True True False,
                            Char True False False True False True True False,
                            Char False True True True False True True False,
                            Char True False True False False True True False,
                            Char True False False False False True True False,
                            Char False True False False True True True False,
                            Char False False False False False True False False,
                            Char False False False False True True True False,
                            Char True True True True False True True False,
                            Char False False True True False True True False,
                            Char True False False True True True True False,
                            Char False True True True False True True False,
                            Char True True True True False True True False,
                            Char True False True True False True True False,
                            Char True False False True False True True False,
                            Char True False False False False True True False,
                            Char False False True True False True True False,
                            Char False False False False False True False False,
                            Char False False True False True True True False,
                            Char True True True True False True True False,
                            Char False False False False False True False False,
                            Char False False True True False True True False,
                            Char True False False True False True True False,
                            Char False True True True False True True False,
                            Char True False True False False True True False,
                            Char True False False False False True True False,
                            Char False True False False True True True False,
                            Char False False False False False True False False,
                            Char False False False False True True True False,
                            Char True True True True False True True False,
                            Char False False True True False True True False,
                            Char True False False True True True True False,
                            Char False True True True False True True False,
                            Char True True True True False True True False,
                            Char True False True True False True True False,
                            Char True False False True False True True False,
                            Char True False False False False True True False,
                            Char False False True True False True True
                              False]))));

renaming ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [(a, a)];
renaming xml2name =
  xml_do "renaming"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "renamingEntry"
        (xml_take xml2name
          (\ a -> xml_take xml2name (\ b -> xml_return (a, b)))))
      xml_return);

trans_id ::
  forall a.
    (String ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
trans_id trans_id_parser = trans_id_parser "transitionId";

one_monom :: forall a. (Linorder a) => Monom a;
one_monom = Abs_monom [];

zero_poly :: forall a b. [(Monom a, b)];
zero_poly = [];

var_monom :: forall a. (Linorder a) => a -> Monom a;
var_monom xa = Abs_monom [(xa, one_nat)];

monom_mult_list ::
  forall a. (Eq a, Linorder a) => [(a, Nat)] -> [(a, Nat)] -> [(a, Nat)];
monom_mult_list [] n = n;
monom_mult_list ((x, p) : m) n =
  (case n of {
    [] -> (x, p) : m;
    (y, q) : na ->
      (if x == y then (x, plus_nat p q) : monom_mult_list m na
        else (if less x y then (x, p) : monom_mult_list m n
               else (y, q) : monom_mult_list ((x, p) : m) na));
  });

times_monom :: forall a. (Eq a, Linorder a) => Monom a -> Monom a -> Monom a;
times_monom xb xc = Abs_monom (monom_mult_list (rep_monom xb) (rep_monom xc));

monom_mult_poly ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Semiring_0 b) => (Monom a, b) -> [(Monom a, b)] -> [(Monom a, b)];
monom_mult_poly uu [] = [];
monom_mult_poly (ma, c) ((m, d) : p) =
  (if times c d == zeroa then monom_mult_poly (ma, c) p
    else (times_monom ma m, times c d) : monom_mult_poly (ma, c) p);

poly_add ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Semiring_0 b) => [(Monom a, b)] -> [(Monom a, b)] -> [(Monom a, b)];
poly_add [] q = q;
poly_add ((m, c) : p) q =
  (case extract (\ mc -> fst mc == m) q of {
    Nothing -> (m, c) : poly_add p q;
    Just (q1, ((_, d), q2)) ->
      (if plus c d == zeroa then poly_add p (q1 ++ q2)
        else (m, plus c d) : poly_add p (q1 ++ q2));
  });

poly_mult ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Semiring_0 b) => [(Monom a, b)] -> [(Monom a, b)] -> [(Monom a, b)];
poly_mult [] q = [];
poly_mult (mc : p) q = poly_add (monom_mult_poly mc q) (poly_mult p q);

one_poly :: forall a b. (Linorder a, Semiring_1 b) => [(Monom a, b)];
one_poly = [(one_monom, onea)];

poly_of ::
  forall a b.
    (Eq a, Linorder a, Eq b, Comm_semiring_1 b) => Tpoly a b -> [(Monom a, b)];
poly_of (PNum i) = (if i == zeroa then [] else [(one_monom, i)]);
poly_of (PVar x) = [(var_monom x, onea)];
poly_of (PSum []) = zero_poly;
poly_of (PSum (p : ps)) = poly_add (poly_of p) (poly_of (PSum ps));
poly_of (PMult []) = one_poly;
poly_of (PMult (p : ps)) = poly_mult (poly_of p) (poly_of (PMult ps));

innermostLhss ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [Term a [Char]];
innermostLhss xml2name =
  xml_do "innermostLhss"
    (xml_take_many_sub [] zero_nat Infinity_enat (term xml2name) xml_return);

strategy ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Strategy a [Char]);
strategy xml2name =
  xml_do "strategy"
    (xml_take
      (xml_or (xml_leaf "innermost" Innermost)
        (xml_change (innermostLhss xml2name) (xml_return . Innermost_Q)))
      xml_return);

map_option :: forall a b. (a -> b) -> Maybe a -> Maybe b;
map_option f Nothing = Nothing;
map_option f (Just x2) = Just (f x2);

extract_special :: [Char] -> [Char] -> Maybe ([Char], [Char]);
extract_special acc [] = Nothing;
extract_special acc (x : xs) =
  (if equal_char x (Char True True False True True True False False)
    then map_option (\ s -> (s, xs)) (special_map (reverse acc))
    else extract_special (x : acc) xs);

normalize_special :: [Char] -> [Char];
normalize_special [] = [];
normalize_special (x : xs) =
  (if equal_char x (Char False True True False False True False False)
    then (case extract_special [] xs of {
           Nothing ->
             [Char False True True False False True False False] ++
               normalize_special xs;
           Just (spec, ys) -> spec ++ normalize_special ys;
         })
    else x : normalize_special xs);

parse_xmlfile ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      [Char] -> Sum_bot [Char] a;
parse_xmlfile p str =
  (case doc_of_string str of {
    Inl a -> left a;
    Inr (XMLDOC _ xml) -> parse_xml p (map_xml_text normalize_special xml);
  });

xmlt_of_xmlt2 ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      Xml -> Sum_bot [Char] a;
xmlt_of_xmlt2 p xml =
  bind2 (xml_take p xml_return ([xml], ([], (False, ([], ["??"])))))
    (left . xml_error_to_string) right;

orig_crule ::
  forall a b.
    (a -> Maybe b) ->
      ((Term a b, Term a b), [(Term a b, Term a b)]) ->
        ((Term a b, Term a b), [(Term a b, Term a b)]);
orig_crule m r =
  ((orig_term m (fst (fst r)), orig_term m (snd (fst r))),
    map (\ (s, t) -> (orig_term m s, orig_term m t)) (snd r));

orig_cstep :: forall a b. (a -> Maybe b) -> Cstep_proof a b -> Cstep_proof a b;
orig_cstep m (Cstep_step rho p sigma s t css) =
  Cstep_step (orig_crule m rho) p (orig_term m . sigma) (orig_term m s)
    (orig_term m t) (map (map (orig_cstep m)) css);

arith_fun :: Xml -> Sum_bot [Char] ArithFun;
arith_fun xml =
  singleton
    [Char True False False False False True True False,
      Char False True False False True True True False,
      Char True False False True False True True False,
      Char False False True False True True True False,
      Char False False False True False True True False,
      Char False True True False False False True False,
      Char True False True False True True True False,
      Char False True True True False True True False,
      Char True True False False False True True False,
      Char False False True False True True True False,
      Char True False False True False True True False,
      Char True True True True False True True False,
      Char False True True True False True True False]
    (options
      [([Char False True True True False True True False,
          Char True False False False False True True False,
          Char False False True False True True True False,
          Char True False True False True True True False,
          Char False True False False True True True False,
          Char True False False False False True True False,
          Char False False True True False True True False],
         change
           (nata [Char False True True True False True True False,
                   Char True False False False False True True False,
                   Char False False True False True True True False,
                   Char True False True False True True True False,
                   Char False True False False True True True False,
                   Char True False False False False True True False,
                   Char False False True True False True True False])
           Const),
        ([Char False True True False True True True False,
           Char True False False False False True True False,
           Char False True False False True True True False,
           Char True False False True False True True False,
           Char True False False False False True True False,
           Char False True False False False True True False,
           Char False False True True False True True False,
           Char True False True False False True True False],
          change
            (nata [Char False True True False True True True False,
                    Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char True False False False False True True False,
                    Char False True False False False True True False,
                    Char False False True True False True True False,
                    Char True False True False False True True False])
            (\ n -> Arg (minus_nat n one_nat))),
        ([Char True True False False True True True False,
           Char True False True False True True True False,
           Char True False True True False True True False],
          many [Char True True False False True True True False,
                 Char True False True False True True True False,
                 Char True False True True False True True False]
            arith_fun Sum),
        ([Char False False False False True True True False,
           Char False True False False True True True False,
           Char True True True True False True True False,
           Char False False True False False True True False,
           Char True False True False True True True False,
           Char True True False False False True True False,
           Char False False True False True True True False],
          many [Char False False False False True True True False,
                 Char False True False False True True True False,
                 Char True True True True False True True False,
                 Char False False True False False True True False,
                 Char True False True False True True True False,
                 Char True True False False False True True False,
                 Char False False True False True True True False]
            arith_fun Prod),
        ([Char True False True True False True True False,
           Char True False False True False True True False,
           Char False True True True False True True False],
          many [Char True False True True False True True False,
                 Char True False False True False True True False,
                 Char False True True True False True True False]
            arith_fun Min),
        ([Char True False True True False True True False,
           Char True False False False False True True False,
           Char False False False True True True True False],
          many [Char True False True True False True True False,
                 Char True False False False False True True False,
                 Char False False False True True True True False]
            arith_fun Max),
        ([Char True False False True False True True False,
           Char False True True False False True True False,
           Char True False True False False False True False,
           Char True False False False True True True False,
           Char True False True False True True True False,
           Char True False False False False True True False,
           Char False False True True False True True False],
          tuple4
            [Char True False False True False True True False,
              Char False True True False False True True False,
              Char True False True False False False True False,
              Char True False False False True True True False,
              Char True False True False True True True False,
              Char True False False False False True True False,
              Char False False True True False True True False]
            arith_fun arith_fun arith_fun arith_fun IfEqual)])
    id xml;

int_coeff :: Xml -> Sum_bot [Char] Int;
int_coeff =
  int [Char True False False True False True True False,
        Char False True True True False True True False,
        Char False False True False True True True False,
        Char True False True False False True True False,
        Char True True True False False True True False,
        Char True False True False False True True False,
        Char False True False False True True True False];

vec_coeff ::
  forall a. (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] (Vec a);
vec_coeff xml2coeff =
  many [Char False True True False True True True False,
         Char True False True False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char True True True True False True True False,
         Char False True False False True True True False]
    (singleton
      [Char True True False False False True True False,
        Char True True True True False True True False,
        Char True False True False False True True False,
        Char False True True False False True True False,
        Char False True True False False True True False,
        Char True False False True False True True False,
        Char True True False False False True True False,
        Char True False False True False True True False,
        Char True False True False False True True False,
        Char False True True True False True True False,
        Char False False True False True True True False]
      xml2coeff id)
    vec_of_list;

mat_coeff ::
  forall a.
    Nat -> a -> (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] (Mat a);
mat_coeff n ze xml2coeff =
  options
    [([Char True False True True False True True False,
        Char True False False False False True True False,
        Char False False True False True True True False,
        Char False True False False True True True False,
        Char True False False True False True True False,
        Char False False False True True True True False],
       many [Char True False True True False True True False,
              Char True False False False False True True False,
              Char False False True False True True True False,
              Char False True False False True True True False,
              Char True False False True False True True False,
              Char False False False True True True True False]
         (vec_coeff xml2coeff) (mat_of_cols n)),
      ([Char False True True False True True True False,
         Char True False True False False True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char True True True True False True True False,
         Char False True False False True True True False],
        change (vec_coeff xml2coeff)
          (\ v ->
            mat n n
              (\ (i, j) ->
                (if equal_nat j zero_nat then vec_index v i else ze))))];

closed_criterion ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Ta_relation [Char]);
closed_criterion =
  xml_do "criterion"
    (xml_take
      (xml_or (xml_leaf "compatibility" Id_Relation)
        (xml_or
          (xml_do "stateCompatibility"
            (xml_take
              (xml_do "relation"
                (xml_take_many_sub [] zero_nat Infinity_enat
                  (xml_do "entry"
                    (xml_take state
                      (\ a -> xml_take state (\ b -> xml_return (a, b)))))
                  xml_return))
              (\ x -> xml_return (Some_Relation x))))
          (xml_or (xml_leaf "decisionProcedure" Decision_Proc)
            (xml_leaf "decisionProcedureOld" Decision_Proc_Old))))
      xml_return);

final_states ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [[Char]];
final_states =
  xml_do "finalStates"
    (xml_take_many_sub [] zero_nat Infinity_enat state xml_return);

transition ::
  forall a b.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Sum (a, [[Char]]) b)) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Sum (Ta_rule [Char] a) (b, [Char]));
transition xml2lhs =
  xml_do "transition"
    (xml_take xml2lhs
      (\ a ->
        xml_take (xml_do "rhs" (xml_take state (\ x -> xml_return (id x))))
          (\ b -> xml_return (case a of {
                               Inl (f, qs) -> Inl (TA_rule f qs b);
                               Inr q -> Inr (q, b);
                             }))));

transitions ::
  forall a b.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Sum (a, [[Char]]) b)) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) ([Ta_rule [Char] a], [(b, [Char])]);
transitions xml2lhs =
  xml_do "transitions"
    (xml_take_many_sub [] zero_nat Infinity_enat (transition xml2lhs)
      (\ rls -> (case partition (\ a -> (case a of {
  Inl _ -> True;
  Inr _ -> False;
}))
                        rls
                  of {
                  (rules, eps) -> let {
                                    ruls = map (\ (Inl r) -> r) rules;
                                    ep = map (\ (Inr e) -> e) eps;
                                  } in xml_return (ruls, ep);
                })));

tree_automaton ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Sum (a, [[Char]]) [Char])) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Tree_automaton [Char] a);
tree_automaton xml2lhs =
  xml_do "treeAutomaton"
    (xml_take final_states
      (\ a ->
        xml_take (transitions xml2lhs)
          (\ b -> xml_return (case b of {
                               (ba, c) -> Tree_Automaton a ba c;
                             }))));

ta_normal_lhs ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Sum (a, [[Char]]) [Char]);
ta_normal_lhs xml2name =
  xml_do "lhs"
    (xml_or (xml_take state (\ a -> xml_return (Inr a)))
      (xml_take xml2name
        (\ a ->
          xml_take_many_sub [] zero_nat Infinity_enat state
            (\ b -> xml_return (Inl (a, b))))));

not_wn_ta ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Not_wn_ta_prf (Lab a b) [Char]);
not_wn_ta xml2name =
  xml_do "notWNTreeAutomaton"
    (xml_take (tree_automaton (ta_normal_lhs xml2name))
      (\ a ->
        xml_take closed_criterion (\ b -> xml_return (Not_wn_ta_prf a b))));

precedence_weight_ac ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Nat -> ([((a, Nat), (Nat, (Nat, Bool)))], Nat));
precedence_weight_ac xml2name =
  xml_do "precedenceWeight"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "precedenceWeightEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take (xml_nat "precedence")
                  (\ p ->
                    xml_take (xml_nat "weight")
                      (\ w ->
                        xml_take_default False (xml_bool "isAC")
                          (\ e -> xml_return ((f, a), (p, (w, e))))))))))
      (\ ret -> xml_return (\ a -> (ret, a))));

ac_knuth_bendix_order ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Redtriple_impl a);
ac_knuth_bendix_order xml2name =
  xml_do "ACKBO"
    (xml_take (xml_nat "w0")
      (\ w0 ->
        xml_take (precedence_weight_ac xml2name)
          (\ prw ->
            xml_take_default [] (afs xml2name)
              (\ afsa -> xml_return (ACKBO (prw w0) afsa)))));

precedence_weight ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Nat -> ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat));
precedence_weight xml2name =
  xml_do "precedenceWeight"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "precedenceWeightEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take (xml_nat "precedence")
                  (\ p ->
                    xml_take (xml_nat "weight")
                      (\ w ->
                        xml_take_optional
                          (xml_do "subtermCoefficientEntries"
                            (xml_take_many_sub [] zero_nat Infinity_enat
                              (xml_nat "entry") xml_return))
                          (\ e -> xml_return ((f, a), (p, (w, e))))))))))
      (\ ret -> xml_return (\ a -> (ret, a))));

knuth_bendix_order ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Redtriple_impl a);
knuth_bendix_order xml2name =
  xml_do "knuthBendixOrder"
    (xml_take (xml_nat "w0")
      (\ w0 ->
        xml_take (precedence_weight xml2name)
          (\ prw ->
            xml_take_default [] (afs xml2name)
              (\ afsa -> xml_return (KBO (prw w0) afsa)))));

arctic_rat_linear_poly ::
  forall a.
    Interpretation a -> ((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]));
arctic_rat_linear_poly (Arctic_rat_linear_poly x4) = x4;

real_non_linear_poly ::
  forall a. Interpretation a -> ((a, Nat), [(Monom Nat, Real)]);
real_non_linear_poly (Real_non_linear_poly x13) = x13;

rat_non_linear_poly ::
  forall a. Interpretation a -> ((a, Nat), [(Monom Nat, Rat)]);
rat_non_linear_poly (Rat_non_linear_poly x12) = x12;

int_non_linear_poly ::
  forall a. Interpretation a -> ((a, Nat), [(Monom Nat, Int)]);
int_non_linear_poly (Int_non_linear_poly x11) = x11;

arctic_linear_poly ::
  forall a. Interpretation a -> ((a, Nat), (Arctic, [Arctic]));
arctic_linear_poly (Arctic_linear_poly x3) = x3;

arctic_rat_matrix ::
  forall a.
    Interpretation a ->
      ((a, Nat), (Mat (Arctic_delta Rat), [Mat (Arctic_delta Rat)]));
arctic_rat_matrix (Arctic_rat_matrix x9) = x9;

real_linear_poly :: forall a. Interpretation a -> ((a, Nat), (Real, [Real]));
real_linear_poly (Real_linear_poly x5) = x5;

rat_linear_poly :: forall a. Interpretation a -> ((a, Nat), (Rat, [Rat]));
rat_linear_poly (Rat_linear_poly x2) = x2;

int_linear_poly :: forall a. Interpretation a -> ((a, Nat), (Int, [Int]));
int_linear_poly (Int_linear_poly x1) = x1;

arctic_matrix ::
  forall a. Interpretation a -> ((a, Nat), (Mat Arctic, [Mat Arctic]));
arctic_matrix (Arctic_matrix x8) = x8;

real_matrix :: forall a. Interpretation a -> ((a, Nat), (Mat Real, [Mat Real]));
real_matrix (Real_matrix x10) = x10;

rat_matrix :: forall a. Interpretation a -> ((a, Nat), (Mat Rat, [Mat Rat]));
rat_matrix (Rat_matrix x7) = x7;

int_matrix :: forall a. Interpretation a -> ((a, Nat), (Mat Int, [Mat Int]));
int_matrix (Int_matrix x6) = x6;

uminus_set :: forall a. Set a -> Set a;
uminus_set (Complement b) = b;
uminus_set (Collect_set p) = Collect_set (\ x -> not (p x));
uminus_set a = Complement a;

bot_set :: forall a. (Ceq a, Ccompare a, Set_impl a) => Set a;
bot_set = set_empty (of_phantom (set_impl :: Phantom a Set_impla));

top_set :: forall a. (Ceq a, Ccompare a, Set_impl a) => Set a;
top_set = uminus_set bot_set;

class_semiring ::
  forall a b.
    (Ceq a, Ccompare a, One a, Plus a, Times a, Zero a,
      Set_impl a) => Itself a ->
                       b -> Partial_object_ext a (Monoid_ext a (Ring_ext a b));
class_semiring uu b =
  Partial_object_ext top_set (Monoid_ext times onea (Ring_ext zeroa plus b));

real_domain :: Xml -> Sum_bot [Char] Real;
real_domain =
  singleton
    [Char True False False False False True True False,
      Char False False True True False True True False,
      Char True True True False False True True False,
      Char True False True False False True True False,
      Char False True False False False True True False,
      Char False True False False True True True False,
      Char True False False False False True True False,
      Char True False False True False True True False,
      Char True True False False False True True False,
      Char False True True True False False True False,
      Char True False True False True True True False,
      Char True False True True False True True False,
      Char False True False False False True True False,
      Char True False True False False True True False,
      Char False True False False True True True False,
      Char True True False False True True True False]
    (singleton
      [Char False False True False False True True False,
        Char True False True False False True True False,
        Char False False True True False True True False,
        Char False False True False True True True False,
        Char True False False False False True True False]
      real id)
    id;

rat_domain :: Xml -> Sum_bot [Char] Rat;
rat_domain =
  singleton
    [Char False True False False True True True False,
      Char True False False False False True True False,
      Char False False True False True True True False,
      Char True False False True False True True False,
      Char True True True True False True True False,
      Char False True True True False True True False,
      Char True False False False False True True False,
      Char False False True True False True True False,
      Char True True False False True True True False]
    (singleton
      [Char False False True False False True True False,
        Char True False True False False True True False,
        Char False False True True False True True False,
        Char False False True False True True True False,
        Char True False False False False True True False]
      rat id)
    id;

basic_domain :: Xml -> Sum_bot [Char] (Nat -> Domain);
basic_domain =
  options
    [([Char False True True True False True True False,
        Char True False False False False True True False,
        Char False False True False True True True False,
        Char True False True False True True True False,
        Char False True False False True True True False,
        Char True False False False False True True False,
        Char False False True True False True True False,
        Char True True False False True True True False],
       leaf [Char False True True True False True True False,
              Char True False False False False True True False,
              Char False False True False True True True False,
              Char True False True False True True True False,
              Char False True False False True True True False,
              Char True False False False False True True False,
              Char False False True True False True True False,
              Char True True False False True True True False]
         Natural),
      ([Char True False False True False True True False,
         Char False True True True False True True False,
         Char False False True False True True True False,
         Char True False True False False True True False,
         Char True True True False False True True False,
         Char True False True False False True True False,
         Char False True False False True True True False,
         Char True True False False True True True False],
        leaf [Char True False False True False True True False,
               Char False True True True False True True False,
               Char False False True False True True True False,
               Char True False True False False True True False,
               Char True True True False False True True False,
               Char True False True False False True True False,
               Char False True False False True True True False,
               Char True True False False True True True False]
          (\ _ -> Integera)),
      ([Char True False False False False True True False,
         Char False True False False True True True False,
         Char True True False False False True True False,
         Char False False True False True True True False,
         Char True False False True False True True False,
         Char True True False False False True True False],
        singleton
          [Char True False False False False True True False,
            Char False True False False True True True False,
            Char True True False False False True True False,
            Char False False True False True True True False,
            Char True False False True False True True False,
            Char True True False False False True True False]
          (singleton
            [Char False False True False False True True False,
              Char True True True True False True True False,
              Char True False True True False True True False,
              Char True False False False False True True False,
              Char True False False True False True True False,
              Char False True True True False True True False]
            (options
              [([Char False True True True False True True False,
                  Char True False False False False True True False,
                  Char False False True False True True True False,
                  Char True False True False True True True False,
                  Char False True False False True True True False,
                  Char True False False False False True True False,
                  Char False False True True False True True False,
                  Char True True False False True True True False],
                 leaf [Char False True True True False True True False,
                        Char True False False False False True True False,
                        Char False False True False True True True False,
                        Char True False True False True True True False,
                        Char False True False False True True True False,
                        Char True False False False False True True False,
                        Char False False True True False True True False,
                        Char True True False False True True True False]
                   (\ _ -> Arctic)),
                ([Char True False False True False True True False,
                   Char False True True True False True True False,
                   Char False False True False True True True False,
                   Char True False True False False True True False,
                   Char True True True False False True True False,
                   Char True False True False False True True False,
                   Char False True False False True True True False,
                   Char True True False False True True True False],
                  leaf [Char True False False True False True True False,
                         Char False True True True False True True False,
                         Char False False True False True True True False,
                         Char True False True False False True True False,
                         Char True True True False False True True False,
                         Char True False True False False True True False,
                         Char False True False False True True True False,
                         Char True True False False True True True False]
                    (\ _ -> Arctic)),
                ([Char False True False False True True True False,
                   Char True False False False False True True False,
                   Char False False True False True True True False,
                   Char True False False True False True True False,
                   Char True True True True False True True False,
                   Char False True True True False True True False,
                   Char True False False False False True True False,
                   Char False False True True False True True False,
                   Char True True False False True True True False],
                  change rat_domain (\ _ _ -> Arctic_rat))])
            id)
          id),
      ([Char False True False False True True True False,
         Char True False False False False True True False,
         Char False False True False True True True False,
         Char True False False True False True True False,
         Char True True True True False True True False,
         Char False True True True False True True False,
         Char True False False False False True True False,
         Char False False True True False True True False,
         Char True True False False True True True False],
        change rat_domain Rational),
      ([Char True False False False False True True False,
         Char False False True True False True True False,
         Char True True True False False True True False,
         Char True False True False False True True False,
         Char False True False False False True True False,
         Char False True False False True True True False,
         Char True False False False False True True False,
         Char True False False True False True True False,
         Char True True False False False True True False,
         Char False True True True False False True False,
         Char True False True False True True True False,
         Char True False True True False True True False,
         Char False True False False False True True False,
         Char True False True False False True True False,
         Char False True False False True True True False,
         Char True True False False True True True False],
        change real_domain Mini_Alg)];

interpretation_type :: Xml -> Sum_bot [Char] Domain;
interpretation_type =
  singleton
    [Char False False True False True True True False,
      Char True False False True True True True False,
      Char False False False False True True True False,
      Char True False True False False True True False]
    (options
      [([Char False False False False True True True False,
          Char True True True True False True True False,
          Char False False True True False True True False,
          Char True False False True True True True False,
          Char False True True True False True True False,
          Char True True True True False True True False,
          Char True False True True False True True False,
          Char True False False True False True True False,
          Char True False False False False True True False,
          Char False False True True False True True False],
         pair [Char False False False False True True True False,
                Char True True True True False True True False,
                Char False False True True False True True False,
                Char True False False True True True True False,
                Char False True True True False True True False,
                Char True True True True False True True False,
                Char True False True True False True True False,
                Char True False False True False True True False,
                Char True False False False False True True False,
                Char False False True True False True True False]
           (singleton
             [Char False False True False False True True False,
               Char True True True True False True True False,
               Char True False True True False True True False,
               Char True False False False False True True False,
               Char True False False True False True True False,
               Char False True True True False True True False]
             (options
               [([Char False True True True False True True False,
                   Char True False False False False True True False,
                   Char False False True False True True True False,
                   Char True False True False True True True False,
                   Char False True False False True True True False,
                   Char True False False False False True True False,
                   Char False False True True False True True False,
                   Char True True False False True True True False],
                  basic_domain),
                 ([Char True False False True False True True False,
                    Char False True True True False True True False,
                    Char False False True False True True True False,
                    Char True False True False False True True False,
                    Char True True True False False True True False,
                    Char True False True False False True True False,
                    Char False True False False True True True False,
                    Char True True False False True True True False],
                   basic_domain),
                 ([Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True True False False False True True False,
                    Char False False True False True True True False,
                    Char True False False True False True True False,
                    Char True True False False False True True False],
                   basic_domain),
                 ([Char False True False False True True True False,
                    Char True False False False False True True False,
                    Char False False True False True True True False,
                    Char True False False True False True True False,
                    Char True True True True False True True False,
                    Char False True True True False True True False,
                    Char True False False False False True True False,
                    Char False False True True False True True False,
                    Char True True False False True True True False],
                   basic_domain),
                 ([Char True False False False False True True False,
                    Char False False True True False True True False,
                    Char True True True False False True True False,
                    Char True False True False False True True False,
                    Char False True False False False True True False,
                    Char False True False False True True True False,
                    Char True False False False False True True False,
                    Char True False False True False True True False,
                    Char True True False False False True True False,
                    Char False True True True False False True False,
                    Char True False True False True True True False,
                    Char True False True True False True True False,
                    Char False True False False False True True False,
                    Char True False True False False True True False,
                    Char False True False False True True True False,
                    Char True True False False True True True False],
                   basic_domain),
                 ([Char True False True True False True True False,
                    Char True False False False False True True False,
                    Char False False True False True True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char True True False False False True True False,
                    Char True False True False False True True False,
                    Char True True False False True True True False],
                   triple
                     [Char True False True True False True True False,
                       Char True False False False False True True False,
                       Char False False True False True True True False,
                       Char False True False False True True True False,
                       Char True False False True False True True False,
                       Char True True False False False True True False,
                       Char True False True False False True True False,
                       Char True True False False True True True False]
                     (nata [Char False False True False False True True False,
                             Char True False False True False True True False,
                             Char True False True True False True True False,
                             Char True False True False False True True False,
                             Char False True True True False True True False,
                             Char True True False False True True True False,
                             Char True False False True False True True False,
                             Char True True True True False True True False,
                             Char False True True True False True True False])
                     (nata [Char True True False False True True True False,
                             Char False False True False True True True False,
                             Char False True False False True True True False,
                             Char True False False True False True True False,
                             Char True True False False False True True False,
                             Char False False True False True True True False,
                             Char False False True False False False True False,
                             Char True False False True False True True False,
                             Char True False True True False True True False,
                             Char True False True False False True True False,
                             Char False True True True False True True False,
                             Char True True False False True True True False,
                             Char True False False True False True True False,
                             Char True True True True False True True False,
                             Char False True True True False True True False])
                     (singleton
                       [Char False False True False False True True False,
                         Char True True True True False True True False,
                         Char True False True True False True True False,
                         Char True False False False False True True False,
                         Char True False False True False True True False,
                         Char False True True True False True True False]
                       basic_domain id)
                     (\ di sd domain d ->
                       (case domain d of {
                         Natural _ -> Int_mat di sd;
                         Integera -> Int_mat di sd;
                         Arctic -> Arctic_mat di;
                         Arctic_rat -> Arctic_rat_mat di;
                         Rational _ _ -> Rat_mat di sd;
                         Mini_Alg _ _ -> Mini_Alg_mat di sd;
                       })))])
             id)
           (nata [Char False False True False False True True False,
                   Char True False True False False True True False,
                   Char True True True False False True True False,
                   Char False True False False True True True False,
                   Char True False True False False True True False,
                   Char True False True False False True True False])
           (\ typea -> typea)),
        ([Char True False True True False True True False,
           Char True False False False False True True False,
           Char False False True False True True True False,
           Char False True False False True True True False,
           Char True False False True False True True False,
           Char False False False True True True True False,
           Char True False False True False False True False,
           Char False True True True False True True False,
           Char False False True False True True True False,
           Char True False True False False True True False,
           Char False True False False True True True False,
           Char False False False False True True True False,
           Char False True False False True True True False,
           Char True False True False False True True False,
           Char False False True False True True True False,
           Char True False False False False True True False,
           Char False False True False True True True False,
           Char True False False True False True True False,
           Char True True True True False True True False,
           Char False True True True False True True False],
          triple
            [Char True False True True False True True False,
              Char True False False False False True True False,
              Char False False True False True True True False,
              Char False True False False True True True False,
              Char True False False True False True True False,
              Char False False False True True True True False,
              Char True False False True False False True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False,
              Char True False False False False True True False,
              Char False False True False True True True False,
              Char True False False True False True True False,
              Char True True True True False True True False,
              Char False True True True False True True False]
            (singleton
              [Char False False True False False True True False,
                Char True True True True False True True False,
                Char True False True True False True True False,
                Char True False False False False True True False,
                Char True False False True False True True False,
                Char False True True True False True True False]
              basic_domain id)
            (nata [Char False False True False False True True False,
                    Char True False False True False True True False,
                    Char True False True True False True True False,
                    Char True False True False False True True False,
                    Char False True True True False True True False,
                    Char True True False False True True True False,
                    Char True False False True False True True False,
                    Char True True True True False True True False,
                    Char False True True True False True True False])
            (nata [Char True True False False True True True False,
                    Char False False True False True True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char True True False False False True True False,
                    Char False False True False True True True False,
                    Char False False True False False False True False,
                    Char True False False True False True True False,
                    Char True False True True False True True False,
                    Char True False True False False True True False,
                    Char False True True True False True True False,
                    Char True True False False True True True False,
                    Char True False False True False True True False,
                    Char True True True True False True True False,
                    Char False True True True False True True False])
            (\ domain di sd -> (case domain zero_nat of {
                                 Natural _ -> Int_mat di sd;
                                 Integera -> Int_mat di sd;
                                 Arctic -> Arctic_mat di;
                                 Arctic_rat -> Arctic_rat_mat di;
                                 Rational _ _ -> Rat_mat di sd;
                                 Mini_Alg _ _ -> Mini_Alg_mat di sd;
                               })))])
    id;

arctic_rat_coeff :: Xml -> Sum_bot [Char] (Arctic_delta Rat);
arctic_rat_coeff =
  options
    [([Char True False False True False True True False,
        Char False True True True False True True False,
        Char False False True False True True True False,
        Char True False True False False True True False,
        Char True True True False False True True False,
        Char True False True False False True True False,
        Char False True False False True True True False],
       change rat Num_arc_delta),
      ([Char False True False False True True True False,
         Char True False False False False True True False,
         Char False False True False True True True False,
         Char True False False True False True True False,
         Char True True True True False True True False,
         Char False True True True False True True False,
         Char True False False False False True True False,
         Char False False True True False True True False],
        change rat Num_arc_delta),
      ([Char True False True True False True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True False True False True True True False,
         Char True True False False True True True False,
         Char True False False True False False True False,
         Char False True True True False True True False,
         Char False True True False False True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True False False True False True True False,
         Char False False True False True True True False,
         Char True False False True True True True False],
        leaf [Char True False True True False True True False,
               Char True False False True False True True False,
               Char False True True True False True True False,
               Char True False True False True True True False,
               Char True True False False True True True False,
               Char True False False True False False True False,
               Char False True True True False True True False,
               Char False True True False False True True False,
               Char True False False True False True True False,
               Char False True True True False True True False,
               Char True False False True False True True False,
               Char False False True False True True True False,
               Char True False False True True True True False]
          MinInfty_delta)];

arctic_coeff :: Xml -> Sum_bot [Char] Arctic;
arctic_coeff =
  options
    [([Char True False False True False True True False,
        Char False True True True False True True False,
        Char False False True False True True True False,
        Char True False True False False True True False,
        Char True True True False False True True False,
        Char True False True False False True True False,
        Char False True False False True True True False],
       change
         (int [Char True False False True False True True False,
                Char False True True True False True True False,
                Char False False True False True True True False,
                Char True False True False False True True False,
                Char True True True False False True True False,
                Char True False True False False True True False,
                Char False True False False True True True False])
         Num_arc),
      ([Char True False True True False True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True False True False True True True False,
         Char True True False False True True True False,
         Char True False False True False False True False,
         Char False True True True False True True False,
         Char False True True False False True True False,
         Char True False False True False True True False,
         Char False True True True False True True False,
         Char True False False True False True True False,
         Char False False True False True True True False,
         Char True False False True True True True False],
        leaf [Char True False True True False True True False,
               Char True False False True False True True False,
               Char False True True True False True True False,
               Char True False True False True True True False,
               Char True True False False True True True False,
               Char True False False True False False True False,
               Char False True True True False True True False,
               Char False True True False False True True False,
               Char True False False True False True True False,
               Char False True True True False True True False,
               Char True False False True False True True False,
               Char False False True False True True True False,
               Char True False False True True True True False]
          MinInfty)];

polynomial ::
  forall a. (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] (Tpoly Nat a);
polynomial xml2coeff x =
  singleton
    [Char False False False False True True True False,
      Char True True True True False True True False,
      Char False False True True False True True False,
      Char True False False True True True True False,
      Char False True True True False True True False,
      Char True True True True False True True False,
      Char True False True True False True True False,
      Char True False False True False True True False,
      Char True False False False False True True False,
      Char False False True True False True True False]
    (options
      [([Char True True False False False True True False,
          Char True True True True False True True False,
          Char True False True False False True True False,
          Char False True True False False True True False,
          Char False True True False False True True False,
          Char True False False True False True True False,
          Char True True False False False True True False,
          Char True False False True False True True False,
          Char True False True False False True True False,
          Char False True True True False True True False,
          Char False False True False True True True False],
         singleton
           [Char True True False False False True True False,
             Char True True True True False True True False,
             Char True False True False False True True False,
             Char False True True False False True True False,
             Char False True True False False True True False,
             Char True False False True False True True False,
             Char True True False False False True True False,
             Char True False False True False True True False,
             Char True False True False False True True False,
             Char False True True True False True True False,
             Char False False True False True True True False]
           xml2coeff PNum),
        ([Char False True True False True True True False,
           Char True False False False False True True False,
           Char False True False False True True True False,
           Char True False False True False True True False,
           Char True False False False False True True False,
           Char False True False False False True True False,
           Char False False True True False True True False,
           Char True False True False False True True False],
          change
            (nata [Char False True True False True True True False,
                    Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char True False False False False True True False,
                    Char False True False False False True True False,
                    Char False False True True False True True False,
                    Char True False True False False True True False])
            (\ n -> PVar (minus_nat n one_nat))),
        ([Char True True False False True True True False,
           Char True False True False True True True False,
           Char True False True True False True True False],
          many [Char True True False False True True True False,
                 Char True False True False True True True False,
                 Char True False True True False True True False]
            (polynomial xml2coeff) PSum),
        ([Char False False False False True True True False,
           Char False True False False True True True False,
           Char True True True True False True True False,
           Char False False True False False True True False,
           Char True False True False True True True False,
           Char True True False False False True True False,
           Char False False True False True True True False],
          many [Char False False False False True True True False,
                 Char False True False False True True True False,
                 Char True True True True False True True False,
                 Char False False True False False True True False,
                 Char True False True False True True True False,
                 Char True True False False False True True False,
                 Char False False True False True True True False]
            (polynomial xml2coeff) PMult)])
    id x;

fit_length ::
  forall a.
    Partial_object_ext a (Monoid_ext a (Ring_ext a ())) -> Nat -> [a] -> [a];
fit_length c n uu =
  (if equal_nat n zero_nat then []
    else (case uu of {
           [] -> replicate (suc (minus_nat n one_nat)) (zero c);
           b : bs -> b : fit_length c (minus_nat n one_nat) bs;
         }));

interpretation ::
  forall a.
    Bool ->
      (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] (Redtriple_impl a);
interpretation bi xml2name =
  many1_gen
    [Char True False False True False True True False,
      Char False True True True False True True False,
      Char False False True False True True True False,
      Char True False True False False True True False,
      Char False True False False True True True False,
      Char False False False False True True True False,
      Char False True False False True True True False,
      Char True False True False False True True False,
      Char False False True False True True True False,
      Char True False False False False True True False,
      Char False False True False True True True False,
      Char True False False True False True True False,
      Char True True True True False True True False,
      Char False True True True False True True False]
    interpretation_type
    (\ a ->
      (case a of {
        Natural deg ->
          (if less_eq_nat deg one_nat && not bi
            then triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial int_coeff x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Int_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial int_coeff x)
                       (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Int_non_linear_poly ((f, aa), poly)));
        Integera ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x -> binda (polynomial int_coeff x) (\ p -> returna (poly_of p)))
            (\ f aa poly -> Int_non_linear_poly ((f, aa), poly));
        Arctic ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial arctic_coeff x)
                (lpoly_of (class_semiring Type ())))
            (\ f aa poly ->
              Arctic_linear_poly
                ((f, aa),
                  (fst poly,
                    fit_length (class_semiring Type ()) aa (snd poly))));
        Arctic_rat ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial arctic_rat_coeff x)
                (lpoly_of (class_semiring Type ())))
            (\ f aa poly ->
              Arctic_rat_linear_poly
                ((f, aa),
                  (fst poly,
                    fit_length (class_semiring Type ()) aa (snd poly))));
        Int_mat n _ ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial (mat_coeff n zero_int int_coeff) x)
                (lpoly_of (ring_mat Type n ())))
            (\ f aa poly ->
              Int_matrix
                ((f, aa),
                  (fst poly, fit_length (ring_mat Type n ()) aa (snd poly))));
        Arctic_mat n ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial (mat_coeff n MinInfty arctic_coeff) x)
                (lpoly_of (ring_mat Type n ())))
            (\ f aa poly ->
              Arctic_matrix
                ((f, aa),
                  (fst poly, fit_length (ring_mat Type n ()) aa (snd poly))));
        Arctic_rat_mat n ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial (mat_coeff n MinInfty_delta arctic_rat_coeff) x)
                (lpoly_of (ring_mat Type n ())))
            (\ f aa poly ->
              Arctic_rat_matrix
                ((f, aa),
                  (fst poly, fit_length (ring_mat Type n ()) aa (snd poly))));
        Rational _ deg ->
          (if less_eq_nat deg one_nat && not bi
            then triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial rat x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Rat_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial rat x) (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Rat_non_linear_poly ((f, aa), poly)));
        Rat_mat n _ ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial (mat_coeff n zero_rat rat) x)
                (lpoly_of (ring_mat Type n ())))
            (\ f aa poly ->
              Rat_matrix
                ((f, aa),
                  (fst poly, fit_length (ring_mat Type n ()) aa (snd poly))));
        Mini_Alg _ deg ->
          (if less_eq_nat deg one_nat && not bi
            then triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial real x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Real_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple
                   [Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char False False False False True True True False,
                     Char False True False False True True True False,
                     Char True False True False False True True False,
                     Char False False True False True True True False]
                   xml2name
                   (nata [Char True False False False False True True False,
                           Char False True False False True True True False,
                           Char True False False True False True True False,
                           Char False False True False True True True False,
                           Char True False False True True True True False])
                   (\ x ->
                     binda (polynomial real x) (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Real_non_linear_poly ((f, aa), poly)));
        Mini_Alg_mat n _ ->
          triple
            [Char True False False True False True True False,
              Char False True True True False True True False,
              Char False False True False True True True False,
              Char True False True False False True True False,
              Char False True False False True True True False,
              Char False False False False True True True False,
              Char False True False False True True True False,
              Char True False True False False True True False,
              Char False False True False True True True False]
            xml2name
            (nata [Char True False False False False True True False,
                    Char False True False False True True True False,
                    Char True False False True False True True False,
                    Char False False True False True True True False,
                    Char True False False True True True True False])
            (\ x ->
              binda (polynomial (mat_coeff n zero_real real) x)
                (lpoly_of (ring_mat Type n ())))
            (\ f aa poly ->
              Real_matrix
                ((f, aa),
                  (fst poly, fit_length (ring_mat Type n ()) aa (snd poly))));
      }))
    (\ typea pi ->
      (case typea of {
        Natural deg ->
          (if less_eq_nat deg one_nat && not bi
            then Int_carrier (map int_linear_poly pi)
            else Int_nl_carrier (map int_non_linear_poly pi));
        Integera -> Int_nl_carrier (map int_non_linear_poly pi);
        Arctic -> Arctic_carrier (map arctic_linear_poly pi);
        Arctic_rat -> Arctic_rat_carrier (map arctic_rat_linear_poly pi);
        Int_mat n sd -> Int_mat_carrier n sd (map int_matrix pi);
        Arctic_mat n -> Arctic_mat_carrier n (map arctic_matrix pi);
        Arctic_rat_mat n -> Arctic_rat_mat_carrier n (map arctic_rat_matrix pi);
        Rational d deg ->
          (if less_eq_nat deg one_nat && not bi
            then Rat_carrier (map rat_linear_poly pi)
            else Rat_nl_carrier d (map rat_non_linear_poly pi));
        Rat_mat n sd -> Rat_mat_carrier n sd (map rat_matrix pi);
        Mini_Alg d deg ->
          (if less_eq_nat deg one_nat && not bi
            then Real_carrier (map real_linear_poly pi)
            else Real_nl_carrier d (map real_non_linear_poly pi));
        Mini_Alg_mat n sd -> Real_mat_carrier n sd (map real_matrix pi);
      }));

wpo_params ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), (Nat, [Nat]))];
wpo_params xml2name =
  xml_do "precedenceStatus"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "precedenceStatusEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take (xml_nat "precedence")
                  (\ p ->
                    xml_take
                      (xml_do "status"
                        (xml_take_many_sub [] zero_nat Infinity_enat position
                          xml_return))
                      (\ s -> xml_return ((f, a), (p, s))))))))
      xml_return);

status_precedence ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), (Nat, Order_tag))];
status_precedence xml2name =
  xml_do "statusPrecedence"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "statusPrecedenceEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take (xml_nat "precedence")
                  (\ p ->
                    xml_take (xml_or (xml_leaf "lex" Lex) (xml_leaf "mul" Mul))
                      (\ s -> xml_return ((f, a), (p, s))))))))
      xml_return);

path_order ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Redtriple_impl a);
path_order xml2name =
  xml_do "pathOrder"
    (xml_take (status_precedence xml2name)
      (\ prec_tau ->
        xml_take_default [] (afs xml2name)
          (\ af -> xml_return (RPO prec_tau af))));

redtriple ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   Bool ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) (Redtriple_impl a);
redtriple xml2name bi x =
  xml_or (path_order xml2name)
    (xml_or (knuth_bendix_order xml2name)
      (xml_or (ac_knuth_bendix_order xml2name)
        (xml_or
          (xml_do "weightedPathOrder"
            (xml_take (wpo_params xml2name)
              (\ a ->
                xml_take (redtriple xml2name bi)
                  (\ b -> xml_return (WPO a b)))))
          (xmlt2 (interpretation bi (xmlt_of_xmlt2 xml2name))))))
    x;

joinable_critical_pairs ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       [(Term a [Char],
                          ([([Nat],
                              ((Term a [Char], Term a [Char]), Term a [Char]))],
                            (Term a [Char],
                              [([Nat],
                                 ((Term a [Char], Term a [Char]),
                                   Term a [Char]))])))];
joinable_critical_pairs xml2name =
  let {
    rew = rsteps xml2name;
  } in xml_do "joinableCriticalPairs"
         (xml_take_many_sub [] zero_nat Infinity_enat
           (xml_do "joinableCriticalPair"
             (xml_take rew
               (\ (s, sseq) ->
                 xml_take rew
                   (\ (t, tseq) -> xml_return (s, (sseq, (t, tseq)))))))
           xml_return);

wcr_proof ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Join_info a);
wcr_proof xml2name =
  xml_do "wcrProof"
    (xml_take
      (xml_or
        (xml_change (joinable_critical_pairs xml2name) (xml_return . Guided))
        (xml_or
          (xml_change (xml_nat "joinableCriticalPairsBFS")
            (xml_return . Join_BFS))
          (xml_leaf "joinableCriticalPairsAuto" Join_NF)))
      (\ x -> xml_return (id x)));

exp_parsera ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Term Sig (a, Ty));
exp_parsera v xml =
  xml_or
    (xml_do "product"
      (xml_take_many_sub [] zero_nat Infinity_enat (exp_parsera v)
        (\ exps -> xml_return (Fun (ProdF (size_list exps)) exps))))
    (xml_or
      (xml_do "sum"
        (xml_take_many_sub [] zero_nat Infinity_enat (exp_parsera v)
          (\ exps -> xml_return (Fun (SumF (size_list exps)) exps))))
      (xml_or
        (xml_change (xml_int "constant")
          (\ i -> xml_return (Fun (ConstF i) [])))
        (xml_change v (\ x -> xml_return (Var (x, IntT))))))
    xml;

bexp_parser ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Term Sig (a, Ty));
bexp_parser v =
  xml_or
    (xml_do "leq"
      (xml_take (exp_parsera v)
        (\ l -> xml_take (exp_parsera v) (\ r -> xml_return (Fun LeF [l, r])))))
    (xml_or
      (xml_do "less"
        (xml_take (exp_parsera v)
          (\ l ->
            xml_take (exp_parsera v) (\ r -> xml_return (Fun LessF [l, r])))))
      (xml_do "eq"
        (xml_take (exp_parsera v)
          (\ l ->
            xml_take (exp_parsera v) (\ r -> xml_return (Fun EqF [l, r]))))));

variable_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Char];
variable_parser = xml_text "variableId";

trans_var_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Trans_var [Char]);
trans_var_parser =
  xml_or (xml_do "post" (xml_take variable_parser (\ v -> xml_return (Post v))))
    (xml_or (xml_change (xml_text "aux") (xml_return . Intermediate))
      (xml_change variable_parser (xml_return . Pre)));

tatom_parsera ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Formula (Term Sig (Trans_var [Char], Ty)));
tatom_parsera = xml_change (bexp_parser trans_var_parser) (xml_return . Atom);

formula_parser ::
  forall a b c.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Formula (Term a (b, c)))) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Formula (Term a (b, c)));
formula_parser atom_parser x =
  xml_or
    (xml_do "disjunction"
      (xml_take_many_sub [] zero_nat Infinity_enat (formula_parser atom_parser)
        (\ fs -> xml_return (Disjunction fs))))
    (xml_or
      (xml_do "conjunction"
        (xml_take_many_sub [] zero_nat Infinity_enat
          (formula_parser atom_parser) (\ fs -> xml_return (Conjunction fs))))
      atom_parser)
    x;

transition_parser ::
  forall a b c d e.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) b) ->
        ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) (Formula (Term c (Trans_var d, e)))) ->
          (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
            Sum_bot (Xml_error String) (b, Transition_rule c d e a);
transition_parser location_parser trans_parser tatom_parser =
  xml_do "transition"
    (xml_take trans_parser
      (\ tr ->
        xml_take (xml_do "source" (xml_take location_parser xml_return))
          (\ l ->
            xml_take (xml_do "target" (xml_take location_parser xml_return))
              (\ r ->
                xml_take
                  (xml_do "formula"
                    (xml_take (formula_parser tatom_parser) xml_return))
                  (\ phi -> xml_return (tr, Transition l r phi))))));

lts_parser ::
  forall a b c d e.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) b) ->
        ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) (Formula (Term c (Trans_var d, e)))) ->
          String ->
            (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
              Sum_bot (Xml_error String) (Lts_impl c d e a b);
lts_parser location_parser trans_parser tatom_parser tag =
  xml_do tag
    (xml_take
      (xml_do "initial"
        (xml_take_many_sub [] one_nat Infinity_enat location_parser xml_return))
      (\ i ->
        xml_take_many_sub [] zero_nat Infinity_enat
          (transition_parser location_parser trans_parser tatom_parser)
          (\ t -> xml_return (Lts_Impl i t []))));

safety_input_parser ::
  forall a b c d e.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) b) ->
        ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) (Formula (Term c (Trans_var d, e)))) ->
          (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
            Sum_bot (Xml_error String) (Lts_impl c d e a b, [a]);
safety_input_parser location_parser trans_parser tatom_parser =
  xml_do "ltsSafetyInput"
    (xml_take (lts_parser location_parser trans_parser tatom_parser "lts")
      (\ lts ->
        xml_take
          (xml_do "error"
            (xml_take_many_sub [] one_nat Infinity_enat location_parser
              xml_return))
          (\ err -> xml_return (lts, err))));

location_parser ::
  forall a.
    (String ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a;
location_parser location_id_parser = location_id_parser "locationId";

lts_safety_input_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lts_impl Sig [Char] Ty [Char] [Char], [[Char]]);
lts_safety_input_parser =
  safety_input_parser (location_parser xml_text) (trans_id xml_text)
    tatom_parsera;

precedence_weighta ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Nat -> ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat));
precedence_weighta xml2name =
  xml_do "precedenceWeight"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "precedenceWeightEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take (xml_nat "precedence")
                  (\ p ->
                    xml_take (xml_nat "weight")
                      (\ w ->
                        xml_take_optional
                          (xml_do "subtermCoefficientEntries"
                            (xml_take_many_sub [] zero_nat Infinity_enat
                              (xml_nat "entry") xml_return))
                          (\ e -> xml_return ((f, a), (p, (w, e))))))))))
      (\ ret -> xml_return (\ a -> (ret, a))));

kbo_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Reduction_order_input a);
kbo_input xml2name =
  xml_do "knuthBendixOrder"
    (xml_take (xml_nat "w0")
      (\ w0 ->
        xml_take (precedence_weighta xml2name)
          (\ prw -> xml_return (KBO_Input (prw w0)))));

xml2ordered_completion_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2ordered_completion_input xml2name =
  xml_do "orderedCompletionInput"
    (xml_take (xml_do "equations" (xml_take (rules xml2name) xml_return))
      (\ es0 ->
        xml_take (xml_do "trs" (xml_take (rules xml2name) xml_return))
          (\ rs ->
            xml_take (xml_do "equations" (xml_take (rules xml2name) xml_return))
              (\ es ->
                xml_take
                  (xml_do "reductionOrder"
                    (xml_take (kbo_input xml2name) xml_return))
                  (\ ro -> xml_return (OCOMP_input es0 es rs ro))))));

lts_input_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lts_impl Sig [Char] Ty [Char] [Char]);
lts_input_parser =
  lts_parser (location_parser xml_text) (trans_id xml_text) tatom_parsera "lts";

xml2equational_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2equational_input xml2name =
  xml_do "equationalReasoningInput"
    (xml_take (xml_do "equations" (xml_take (rules xml2name) xml_return))
      (\ eqs ->
        xml_take
          (xml_or
            (xml_do "equation"
              (xml_take (term xml2name)
                (\ a ->
                  xml_take (term xml2name)
                    (\ b -> xml_return (Equation (a, b))))))
            (xml_do "inequality"
              (xml_take (term xml2name)
                (\ a ->
                  xml_take (term xml2name)
                    (\ b -> xml_return (Inequality (a, b)))))))
          (\ goal -> xml_return (EQ_input eqs goal))));

xml2completion_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2completion_input xml2name =
  xml_do "completionInput"
    (xml_take (xml_do "equations" (xml_take (rules xml2name) xml_return))
      (\ a ->
        xml_take (xml_do "trs" (xml_take (rules xml2name) xml_return))
          (\ b -> xml_return (COMP_input a b))));

cPFsignature ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [(a, Nat)];
cPFsignature xml2name = symbols xml2name "signature";

complexity_measure ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Complexity_measure a [Char]);
complexity_measure xml2name =
  xml_or
    (xml_do "derivationalComplexity"
      (xml_take (cPFsignature xml2name)
        (\ a -> xml_return (Derivational_Complexity a))))
    (xml_do "runtimeComplexity"
      (xml_take (cPFsignature xml2name)
        (\ a ->
          xml_take (cPFsignature xml2name)
            (\ b -> xml_return (Runtime_Complexity a b)))));

complexity_class ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Complexity_class;
complexity_class = xml_change (xml_nat "polynomial") (xml_return . Comp_Poly);

ctxt_of_pos_term :: forall a b. [Nat] -> Term a b -> Ctxt a b;
ctxt_of_pos_term [] t = Hole;
ctxt_of_pos_term (i : ps) (Fun f ts) =
  More f (take i ts) (ctxt_of_pos_term ps (nth ts i)) (drop (suc i) ts);

forbidden_pattern ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Ctxt a [Char], (Term a [Char], Location));
forbidden_pattern xml2name =
  xml_do "forbiddenPattern"
    (xml_take (term xml2name)
      (\ t ->
        xml_take pos
          (\ p ->
            xml_take
              (xml_or (xml_leaf "here" H)
                (xml_or (xml_leaf "above" A)
                  (xml_or (xml_leaf "below" Ba) (xml_leaf "below" Ra))))
              (\ l ->
                (if in_poss p t
                  then xml_return (ctxt_of_pos_term p t, (subt_at t p, l))
                  else xml_error "position does not exist in term")))));

forbidden_patterns ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       [(Ctxt a [Char], (Term a [Char], Location))];
forbidden_patterns xml2name =
  xml_do "forbiddenPatterns"
    (xml_take_many_sub [] zero_nat Infinity_enat (forbidden_pattern xml2name)
      xml_return);

replacement_map ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), [Nat])];
replacement_map xml2name =
  xml_do "contextSensitive"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "replacementMapEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take_many_sub [] zero_nat Infinity_enat position
                  (\ is -> xml_return ((f, a), is))))))
      xml_return);

inn_fp_strategy ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Sum (Strategy a [Char]) (Fp_strategy a [Char]));
inn_fp_strategy xml2name =
  xml_do "strategy"
    (xml_take
      (xml_or (xml_leaf "innermost" (Inl Innermost))
        (xml_or (xml_leaf "outermost" (Inr Outermost))
          (xml_or
            (xml_change (replacement_map xml2name)
              (\ p -> xml_return (Inr (Context_Sensitive p))))
            (xml_or
              (xml_change (forbidden_patterns xml2name)
                (\ p -> xml_return (Inr (Forbidden_Patterns p))))
              (xml_change (innermostLhss xml2name)
                (\ q -> xml_return (Inl (Innermost_Q q))))))))
      xml_return);

xml2_trs_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2_trs_input xml2name =
  xml_do "trsInput"
    (xml_take (xml_do "trs" (xml_take (rules xml2name) xml_return))
      (\ r ->
        xml_take_default (Inl No_Strategy) (inn_fp_strategy xml2name)
          (\ str ->
            xml_take_default []
              (xml_do "relativeRules" (xml_take (rules xml2name) xml_return))
              (\ rel ->
                (case str of {
                  Inl istrat -> xml_return (Inn_TRS_input istrat r rel Full);
                  Inr fpstrat ->
                    (if null rel then xml_return (FP_TRS_input fpstrat r)
                      else xml_error
                             "the combination of relative rules with strategies is only supported for innermost");
                })))));

xml2complexity_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2complexity_input xml2name =
  xml_do "complexityInput"
    (xml_take
      (xml_change (xml2_trs_input xml2name)
        (\ a ->
          (case a of {
            DP_input _ _ _ _ -> xml_error "require innermost trs at this point";
            Inn_TRS_input q r s start -> xml_return (q, (r, (s, start)));
            CPX_input _ _ _ _ _ ->
              xml_error "require innermost trs at this point";
            COMP_input _ _ -> xml_error "require innermost trs at this point";
            OCOMP_input _ _ _ _ ->
              xml_error "require innermost trs at this point";
            EQ_input _ _ -> xml_error "require innermost trs at this point";
            FP_TRS_input _ _ -> xml_error "require innermost trs at this point";
            CTRS_input _ -> xml_error "require innermost trs at this point";
            TA_input _ _ -> xml_error "require innermost trs at this point";
            AC_input _ _ _ -> xml_error "require innermost trs at this point";
            LTS_input _ -> xml_error "require innermost trs at this point";
            LTS_safety_input _ _ ->
              xml_error "require innermost trs at this point";
            Unknown_input _ -> xml_error "require innermost trs at this point";
          })))
      (\ (q, (r, (s, _))) ->
        xml_take (complexity_measure xml2name)
          (\ cm ->
            xml_take complexity_class
              (\ cc -> xml_return (CPX_input q r s cm cc)))));

xml2unknown_input ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Char];
xml2unknown_input = xml_text "unknownInput";

symbols_no_arity ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) [a];
symbols_no_arity xml2name tagname =
  xml_do tagname
    (xml_take_many_sub [] zero_nat Infinity_enat xml2name xml_return);

xml2ac_tp_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2ac_tp_input xml2name =
  xml_do "acRewriteSystem"
    (xml_take
      (xml_do "trs" (xml_take (rules xml2name) (\ x -> xml_return (id x))))
      (\ a ->
        xml_take (symbols_no_arity xml2name "Asymbols")
          (\ b ->
            xml_take (symbols_no_arity xml2name "Csymbols")
              (\ c -> xml_return (AC_input a b c)))));

xml2ctrs_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2ctrs_input xml2name =
  xml_do "ctrsInput"
    (xml_take
      (xml_do "rules"
        (xml_take_many_sub [] zero_nat Infinity_enat (crule xml2name "rule")
          xml_return))
      (\ a -> xml_return (CTRS_input a)));

xml2dp_input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2dp_input xml2name =
  xml_do "dpInput"
    (xml_take
      (xml_do "trs" (xml_take (rules xml2name) (\ x -> xml_return (id x))))
      (\ r ->
        xml_take
          (xml_do "dps" (xml_take (rules xml2name) (\ x -> xml_return (id x))))
          (\ p ->
            xml_take_default No_Strategy (strategy xml2name)
              (\ s ->
                xml_take (xml_bool "minimal")
                  (\ m -> xml_return (DP_input m p s r))))));

xml2input ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Input a [Char]);
xml2input xml2name =
  xml_do "input"
    (xml_take
      (xml_or (xml2dp_input xml2name)
        (xml_or (xml2completion_input xml2name)
          (xml_or (xml2ordered_completion_input xml2name)
            (xml_or (xml2_trs_input xml2name)
              (xml_or (xml2equational_input xml2name)
                (xml_or (xml2complexity_input xml2name)
                  (xml_or (xml2ctrs_input xml2name)
                    (xml_or
                      (xml_do "treeAutomatonProblem"
                        (xml_take (tree_automaton (ta_normal_lhs xml2name))
                          (\ a ->
                            xml_take
                              (xml_do "trs"
                                (xml_take (rules xml2name)
                                  (\ x -> xml_return (id x))))
                              (\ b -> xml_return (TA_input a b)))))
                      (xml_or (xml2ac_tp_input xml2name)
                        (xml_or
                          (xml_change lts_input_parser (xml_return . LTS_input))
                          (xml_or
                            (xml_change lts_safety_input_parser
                              (\ (x, y) -> xml_return (LTS_safety_input x y)))
                            (xml_change xml2unknown_input
                              (xml_return . Unknown_input)))))))))))))
      (\ x -> xml_return (id x)));

subst_of :: forall a b. (Eq a) => [(a, Term b a)] -> a -> Term b a;
subst_of ss = foldr (\ (x, t) sigma -> subst_compose sigma (subst x t)) ss Var;

conversion ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (Term a [Char],
                         [([Nat],
                            ((Term a [Char], Term a [Char]),
                              (Bool, Term a [Char])))]);
conversion xml2name =
  xml_do "conversion"
    (xml_take
      (xml_do "startTerm" (xml_take (term xml2name) (\ x -> xml_return (id x))))
      (\ a ->
        xml_take_many_sub [] zero_nat Infinity_enat (estep xml2name)
          (\ b -> xml_return (a, b))));

plain_name ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lab [Char] [Nat]);
plain_name x =
  xml_or (xml_change (xml_text "name") (xml_return . UnLab))
    (xml_or
      (xml_do "sharp" (xml_take plain_name (\ xa -> xml_return (Sharp xa))))
      (xml_do "labeledSymbol"
        (xml_take plain_name
          (\ a ->
            xml_take
              (xml_or
                (xml_do "numberLabel"
                  (xml_take_many_sub [] zero_nat Infinity_enat
                    (xml_nat "number") (\ aa -> xml_return (Inl aa))))
                (xml_do "symbolLabel"
                  (xml_take_many_sub [] zero_nat Infinity_enat plain_name
                    (\ aa -> xml_return (Inr aa)))))
              (\ b -> xml_return (case b of {
                                   Inl ba -> Lab a ba;
                                   Inr ba -> FunLab a ba;
                                 }))))))
    x;

level_mapping ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), [(Nat, Nat)])];
level_mapping xml2name =
  xml_do "levelMapping"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "levelMappingEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take_many_sub [] zero_nat Infinity_enat
                  (xml_do "positionLevelEntry"
                    (xml_take (xml_nat "position")
                      (\ aa ->
                        xml_take (xml_nat "level")
                          (\ b -> xml_return (aa, b)))))
                  (\ ps ->
                    xml_return
                      ((f, a),
                        map (\ (p, b) ->
                              ((if equal_nat p zero_nat then a
                                 else minus_nat p one_nat),
                                b))
                          ps))))))
      xml_return);

redtriplea ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   Bool ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String)
                         (Sum (Root_redtriple_impl a) (Redtriple_impl a));
redtriplea xml2name bi =
  xml_do "redPair"
    (xml_take
      (xml_or
        (xml_do "scnp"
          (xml_take
            (xml_do "status"
              (xml_take
                (xml_or (xml_leaf "ms" MS_Ext)
                  (xml_or (xml_leaf "min" Min_Ext)
                    (xml_or (xml_leaf "dms" Dms_Ext) (xml_leaf "max" Max_Ext))))
                xml_return))
            (\ a ->
              xml_take (level_mapping xml2name)
                (\ b ->
                  xml_take
                    (xml_do "redPair"
                      (xml_take (redtriple xml2name False)
                        (\ x -> xml_return (id x))))
                    (\ c -> xml_return (Inl (SCNP a b c)))))))
        (xml_change (redtriple xml2name bi) (xml_return . Inr)))
      xml_return);

rule_pairs ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   String ->
                     String ->
                       (Xml, ([([Char], [Char])],
                               (Bool, ([String], [String])))) ->
                         Sum_bot (Xml_error String)
                           [((Term a [Char], Term a [Char]),
                              (Term a [Char], Term a [Char]))];
rule_pairs xml2name s p =
  xml_do s
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do p
        (xml_take (rule xml2name)
          (\ a -> xml_take (rule xml2name) (\ b -> xml_return (a, b)))))
      xml_return);

xml1or2many_elements ::
  forall a b c d.
    [Char] ->
      (Xml -> Sum_bot [Char] a) ->
        (Xml -> Sum_bot [Char] b) ->
          (Xml -> Sum_bot [Char] c) ->
            (a -> Maybe b -> [c] -> d) -> Xml -> Sum_bot [Char] d;
xml1or2many_elements tag p1 p2 p3 f (XML name atts cs) =
  (if name == tag && null atts && not (null cs)
    then (case cs of {
           cs0 : tt ->
             binda (p1 cs0)
               (\ x ->
                 (case tt of {
                   [] -> returna (f x Nothing []);
                   cs1 : t ->
                     catch_error
                       (binda (p2 cs1)
                         (\ y ->
                           binda (map_sum_bot p3 t)
                             (\ xs -> returna (f x (Just y) xs))))
                       (\ _ ->
                         binda (map_sum_bot p3 tt)
                           (\ xs -> returna (f x Nothing xs)));
                 }));
         })
    else fail tag (XML name atts cs));
xml1or2many_elements tag p1 p2 p3 f (XML_text v) = fail tag (XML_text v);

sl_variant ::
  forall a.
    (Xml -> Sum_bot [Char] a) -> Xml -> Sum_bot [Char] (Sl_variant a [Char]);
sl_variant xml2name =
  singleton
    [Char True False True True False True True False,
      Char True True True True False True True False,
      Char False False True False False True True False,
      Char True False True False False True True False,
      Char False False True True False True True False]
    (options
      [([Char False True True False False True True False,
          Char True False False True False True True False,
          Char False True True True False True True False,
          Char True False False True False True True False,
          Char False False True False True True True False,
          Char True False True False False True True False,
          Char True False True True False False True False,
          Char True True True True False True True False,
          Char False False True False False True True False,
          Char True False True False False True True False,
          Char False False True True False True True False],
         xml1or2many_elements
           [Char False True True False False True True False,
             Char True False False True False True True False,
             Char False True True True False True True False,
             Char True False False True False True True False,
             Char False False True False True True True False,
             Char True False True False False True True False,
             Char True False True True False False True False,
             Char True True True True False True True False,
             Char False False True False False True True False,
             Char True False True False False True True False,
             Char False False True True False True True False]
           (change
             (nata [Char True True False False False True True False,
                     Char True False False False False True True False,
                     Char False True False False True True True False,
                     Char False True False False True True True False,
                     Char True False False True False True True False,
                     Char True False True False False True True False,
                     Char False True False False True True True False,
                     Char True True False False True False True False,
                     Char True False False True False True True False,
                     Char False True False True True True True False,
                     Char True False True False False True True False])
             (\ n -> minus_nat n one_nat))
           (singleton
             [Char False False True False True True True False,
               Char True False True False True True True False,
               Char False False False False True True True False,
               Char False False True True False True True False,
               Char True False True False False True True False,
               Char True True True True False False True False,
               Char False True False False True True True False,
               Char False False True False False True True False,
               Char True False True False False True True False,
               Char False True False False True True True False]
             (leaf [Char False False False False True True True False,
                     Char True True True True False True True False,
                     Char True False False True False True True False,
                     Char False True True True False True True False,
                     Char False False True False True True True False,
                     Char True True True False True False True False,
                     Char True False False True False True True False,
                     Char True True False False True True True False,
                     Char True False True False False True True False]
               ())
             id)
           (triple
             [Char True False False True False True True False,
               Char False True True True False True True False,
               Char False False True False True True True False,
               Char True False True False False True True False,
               Char False True False False True True True False,
               Char False False False False True True True False,
               Char False True False False True True True False,
               Char True False True False False True True False,
               Char False False True False True True True False]
             xml2name
             (nata [Char True False False False False True True False,
                     Char False True False False True True True False,
                     Char True False False True False True True False,
                     Char False False True False True True True False,
                     Char True False False True True True True False])
             arith_fun (\ f a -> (\ b -> ((f, a), b))))
           (\ n model xs ->
             (if is_none model then Finitelab (SL_Inter n xs)
               else QuasiFinitelab (SL_Inter n xs) []))),
        ([Char False True False False True True True False,
           Char True True True True False True True False,
           Char True True True True False True True False,
           Char False False True False True True True False,
           Char False False True True False False True False,
           Char True False False False False True True False,
           Char False True False False False True True False,
           Char True False True False False True True False,
           Char False False True True False True True False,
           Char True False False True False True True False,
           Char False True True True False True True False,
           Char True True True False False True True False],
          guard (\ x -> equal_nat (num_children x) zero_nat)
            (leaf [Char False True False False True True True False,
                    Char True True True True False True True False,
                    Char True True True True False True True False,
                    Char False False True False True True True False,
                    Char False False True True False False True False,
                    Char True False False False False True True False,
                    Char False True False False False True True False,
                    Char True False True False False True True False,
                    Char False False True True False True True False,
                    Char True False False True False True True False,
                    Char False True True True False True True False,
                    Char True True True False False True True False]
              (Rootlab Nothing))
            (singleton
              [Char False True False False True True True False,
                Char True True True True False True True False,
                Char True True True True False True True False,
                Char False False True False True True True False,
                Char False False True True False False True False,
                Char True False False False False True True False,
                Char False True False False False True True False,
                Char True False True False False True True False,
                Char False False True True False True True False,
                Char True False False True False True True False,
                Char False True True True False True True False,
                Char True True True False False True True False]
              xml2name (\ f -> Rootlab (Just (f, one_nat)))))])
    id;

default_hint :: forall a. (Default a) => Hint a;
default_hint = Default;

formula_pos_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Nat;
formula_pos_parser =
  xml_or (xml_do "conclusion" (xml_return zero_nat))
    (xml_or (xml_do "assertion" (xml_return (nat_of_integer (2 :: Integer))))
      (xml_or (xml_do "transition" (xml_return (nat_of_integer (3 :: Integer))))
        (xml_do "targetAssertion"
          (xml_return (nat_of_integer (4 :: Integer))))));

hints_parser ::
  forall a.
    (Default a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) a) ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) (Hint a);
hints_parser hint_parser xml =
  xml_or (xml_do "auto" (xml_return default_hint))
    (xml_or
      (xml_do "distribute"
        (xml_take formula_pos_parser
          (\ pos ->
            xml_take_many_sub [] zero_nat Infinity_enat
              (hints_parser hint_parser)
              (\ hints -> xml_return (Distribute pos hints)))))
      (xml_or
        (xml_do "erase"
          (xml_take formula_pos_parser
            (\ pos ->
              xml_take (hints_parser hint_parser)
                (\ hint -> xml_return (Erase pos hint)))))
        (xml_or
          (xml_do "lexWeak"
            (xml_take_many_sub [] zero_nat Infinity_enat
              (hints_parser hint_parser)
              (\ hints -> xml_return (LexWeak hints))))
          (xml_or
            (xml_do "lexStrict"
              (xml_take_many_sub [] zero_nat Infinity_enat
                (hints_parser hint_parser)
                (\ hints -> xml_return (LexStrict hints))))
            (xml_change hint_parser (xml_return . Base))))))
    xml;

art_node_parser ::
  forall a b c d e f g.
    (Default g) => (String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) a) ->
                     ((Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) b) ->
                       ((Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                         Sum_bot (Xml_error String) c) ->
                         ((Xml, ([([Char], [Char])],
                                  (Bool, ([String], [String])))) ->
                           Sum_bot (Xml_error String)
                             (Formula (Term d (e, f)))) ->
                           ((Xml, ([([Char], [Char])],
                                    (Bool, ([String], [String])))) ->
                             Sum_bot (Xml_error String) g) ->
                             (Xml, ([([Char], [Char])],
                                     (Bool, ([String], [String])))) ->
                               Sum_bot (Xml_error String)
                                 (Art_node_impl d e f b a c (Hint g), [a]);
art_node_parser art_node_id_parser location_parser trans_parser atom_parser
  hint_parser =
  xml_do "node"
    (xml_take_default False (xml_do "initial" (xml_return True))
      (\ init ->
        xml_take (art_node_id_parser "nodeId")
          (\ nodeId ->
            xml_take
              (xml_do "invariant"
                (xml_take (formula_parser atom_parser) xml_return))
              (\ invariant ->
                xml_take
                  (xml_do "location" (xml_take location_parser xml_return))
                  (\ location ->
                    xml_take
                      (xml_or
                        (xml_do "children"
                          (xml_take_many_sub [] zero_nat Infinity_enat
                            (xml_do "child"
                              (xml_take trans_parser
                                (\ tr ->
                                  xml_take (art_node_id_parser "nodeId")
                                    (\ n ->
                                      xml_take_default default_hint
(xml_do "hints" (xml_take (hints_parser hint_parser) xml_return))
(\ h -> xml_return (tr, (n, h)))))))
                            (\ chs -> xml_return (Children_Edge chs))))
                        (xml_do "coverEdge"
                          (xml_take (art_node_id_parser "nodeId")
                            (\ n ->
                              xml_take_default default_hint
                                (xml_do "hints"
                                  (xml_take (hints_parser hint_parser)
                                    xml_return))
                                (\ h -> xml_return (Cover_Edge n h))))))
                      (\ edges ->
                        xml_return
                          (Art_Node nodeId invariant location edges,
                            (if init then [nodeId] else []))))))));

art_parser ::
  forall a b c d e f g.
    (Default g) => (String ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) a) ->
                     ((Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) b) ->
                       ((Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                         Sum_bot (Xml_error String) c) ->
                         ((Xml, ([([Char], [Char])],
                                  (Bool, ([String], [String])))) ->
                           Sum_bot (Xml_error String)
                             (Formula (Term d (e, f)))) ->
                           ((Xml, ([([Char], [Char])],
                                    (Bool, ([String], [String])))) ->
                             Sum_bot (Xml_error String) g) ->
                             (Xml, ([([Char], [Char])],
                                     (Bool, ([String], [String])))) ->
                               Sum_bot (Xml_error String)
                                 (Art_impl_ext d e f b a c (Hint g) ());
art_parser art_node_id_parser location_parser trans_parser atom_parser
  hint_parser =
  xml_do "impact"
    (xml_take_default []
      (xml_change (art_node_id_parser "initial") (\ x -> xml_return [x]))
      (\ init ->
        xml_take
          (xml_do "nodes"
            (xml_take_many_sub [] zero_nat Infinity_enat
              (art_node_parser art_node_id_parser location_parser trans_parser
                atom_parser hint_parser)
              xml_return))
          (\ pairs -> let {
                        nodes = map fst pairs;
                        inits = init ++ concatMap snd pairs;
                      } in xml_return (Art_impl_ext inits nodes ()))));

lookup_default :: forall a b. (Ccompare b, Eq b) => a -> Mapping b a -> b -> a;
lookup_default d m k = (case lookupb m k of {
                         Nothing -> d;
                         Just v -> v;
                       });

map_of_default ::
  forall a b. (Ccompare b, Eq b, Mapping_impl b) => a -> [(b, a)] -> b -> a;
map_of_default d xs = lookup_default d (of_alist xs);

ta_bounds_lhs ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Sum ((a, Nat), [[Char]]) [Char]);
ta_bounds_lhs xml2name =
  xml_do "lhs"
    (xml_or (xml_take state (\ a -> xml_return (Inr a)))
      (xml_take xml2name
        (\ f ->
          xml_take (xml_nat "height")
            (\ h ->
              xml_take_many_sub [] zero_nat Infinity_enat state
                (\ qs -> xml_return (Inl ((f, h), qs)))))));

bounds_bound ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Nat;
bounds_bound = xml_nat "bound";

bounds_type ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Boundstype;
bounds_type =
  xml_do "type"
    (xml_take (xml_or (xml_leaf "roof" Roof) (xml_leaf "match" Match))
      (\ x -> xml_return (id x)));

bounds_info ::
  forall a.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Bounds_info a [Char]);
bounds_info xml2name =
  xml_do "bounds"
    (xml_take bounds_type
      (\ a ->
        xml_take bounds_bound
          (\ b ->
            xml_take final_states
              (\ c ->
                xml_take (tree_automaton (ta_bounds_lhs xml2name))
                  (\ d ->
                    xml_take_default Id_Relation closed_criterion
                      (\ e -> xml_return (Bounds_Info a b c d e)))))));

multiset_af ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [((a, Nat), [Nat])];
multiset_af xml2name =
  xml_do "multisetArgumentFilter"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "multisetArgumentFilterEntry"
        (xml_take xml2name
          (\ f ->
            xml_take (xml_nat "arity")
              (\ a ->
                xml_take
                  (xml_do "status"
                    (xml_take_many_sub [] zero_nat Infinity_enat position
                      xml_return))
                  (\ p -> xml_return ((f, a), p))))))
      xml_return);

word_pattern ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        ([Lab a b], ((Nat, (Nat, [Lab a b])), [Lab a b]));
word_pattern xml2name =
  xml_do "wordPattern"
    (xml_take (string xml2name)
      (\ l ->
        xml_take (string xml2name)
          (\ m ->
            xml_take (xml_nat "factor")
              (\ f ->
                xml_take (xml_nat "constant")
                  (\ c ->
                    xml_take (string xml2name)
                      (\ r -> xml_return (l, ((f, (c, m)), r))))))));

derivation_pattern ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (([Lab a b], ((Nat, (Nat, [Lab a b])), [Lab a b])),
                          ([Lab a b], ((Nat, (Nat, [Lab a b])), [Lab a b])));
derivation_pattern xml2name =
  xml_do "derivationPattern"
    (xml_take (word_pattern xml2name)
      (\ a -> xml_take (word_pattern xml2name) (\ b -> xml_return (a, b))));

derivation_pattern_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Dp_proof_step (Lab a b));
derivation_pattern_proof xml2name =
  let {
    oc = oc_srs xml2name;
    dp = derivation_pattern xml2name;
    s = string xml2name;
  } in xml_do "derivationPatternProof"
         (xml_take
           (xml_or
             (xml_do "OC1"
               (xml_take oc
                 (\ a ->
                   xml_take (xml_bool "isPair") (\ b -> xml_return (OC1 a b)))))
             (xml_or
               (xml_do "OC2"
                 (xml_take oc
                   (\ a ->
                     xml_take oc
                       (\ b ->
                         xml_take oc
                           (\ c ->
                             xml_take s
                               (\ d ->
                                 xml_take s
                                   (\ e ->
                                     xml_take s
                                       (\ f ->
 xml_return (OC2 a b c d e f)))))))))
               (xml_or
                 (xml_do "OC2prime"
                   (xml_take oc
                     (\ a ->
                       xml_take oc
                         (\ b ->
                           xml_take oc
                             (\ c ->
                               xml_take s
                                 (\ d ->
                                   xml_take s
                                     (\ e ->
                                       xml_take s
 (\ f -> xml_return (OC2p a b c d e f)))))))))
                 (xml_or
                   (xml_do "OC3"
                     (xml_take oc
                       (\ a ->
                         xml_take oc
                           (\ b ->
                             xml_take oc
                               (\ c ->
                                 xml_take s
                                   (\ d ->
                                     xml_take s
                                       (\ e -> xml_return (OC3 a b c d e))))))))
                   (xml_or
                     (xml_do "OC3prime"
                       (xml_take oc
                         (\ a ->
                           xml_take oc
                             (\ b ->
                               xml_take oc
                                 (\ c ->
                                   xml_take s
                                     (\ d ->
                                       xml_take s
 (\ e -> xml_return (OC3p a b c d e))))))))
                     (xml_or
                       (xml_do "OCintoDP1"
                         (xml_take dp
                           (\ a ->
                             xml_take oc (\ b -> xml_return (OCDP1 a b)))))
                       (xml_or
                         (xml_do "OCintoDP2"
                           (xml_take dp
                             (\ a ->
                               xml_take oc (\ b -> xml_return (OCDP2 a b)))))
                         (xml_or
                           (xml_do "equivalent"
                             (xml_take dp
                               (\ a ->
                                 xml_take dp (\ b -> xml_return (WPEQ a b)))))
                           (xml_or
                             (xml_do "lift"
                               (xml_take dp
                                 (\ a ->
                                   xml_take dp (\ b -> xml_return (Lift a b)))))
                             (xml_or
                               (xml_do "DP_OC_1_1"
                                 (xml_take dp
                                   (\ a ->
                                     xml_take dp
                                       (\ b ->
 xml_take oc
   (\ c ->
     xml_take s (\ d -> xml_take s (\ e -> xml_return (DPOC1_1 a b c d e))))))))
                               (xml_or
                                 (xml_do "DP_OC_1_2"
                                   (xml_take dp
                                     (\ a ->
                                       xml_take dp
 (\ b ->
   xml_take oc
     (\ c ->
       xml_take s
         (\ d ->
           xml_take s
             (\ e -> xml_take s (\ f -> xml_return (DPOC1_2 a b c d e f)))))))))
                                 (xml_or
                                   (xml_do "DP_OC_2"
                                     (xml_take dp
                                       (\ a ->
 xml_take dp
   (\ b ->
     xml_take oc
       (\ c ->
         xml_take s
           (\ d -> xml_take s (\ e -> xml_return (DPOC2 a b c d e))))))))
                                   (xml_or
                                     (xml_do "DP_OC_3_1"
                                       (xml_take dp
 (\ a ->
   xml_take dp
     (\ b ->
       xml_take oc
         (\ c ->
           xml_take s
             (\ d -> xml_take s (\ e -> xml_return (DPOC3_1 a b c d e))))))))
                                     (xml_or
                                       (xml_do "DP_OC_3_2"
 (xml_take dp
   (\ a ->
     xml_take dp
       (\ b ->
         xml_take oc
           (\ c ->
             xml_take s
               (\ d ->
                 xml_take s
                   (\ e ->
                     xml_take s (\ f -> xml_return (DPOC3_2 a b c d e f)))))))))
                                       (xml_or
 (xml_do "DP_DP_1_1"
   (xml_take dp
     (\ a ->
       xml_take dp
         (\ b ->
           xml_take dp
             (\ c ->
               xml_take s
                 (\ d ->
                   xml_take s (\ e -> xml_return (DPDP1_1 a b c d e))))))))
 (xml_or
   (xml_do "DP_DP_1_2"
     (xml_take dp
       (\ a ->
         xml_take dp
           (\ b ->
             xml_take dp
               (\ c ->
                 xml_take s
                   (\ d ->
                     xml_take s (\ e -> xml_return (DPDP1_2 a b c d e))))))))
   (xml_or
     (xml_do "DP_DP_2_1"
       (xml_take dp
         (\ a ->
           xml_take dp
             (\ b ->
               xml_take dp
                 (\ c ->
                   xml_take s
                     (\ d ->
                       xml_take s (\ e -> xml_return (DPDP2_1 a b c d e))))))))
     (xml_do "DP_DP_2_2"
       (xml_take dp
         (\ a ->
           xml_take dp
             (\ b ->
               xml_take dp
                 (\ c ->
                   xml_take s
                     (\ d ->
                       xml_take s
                         (\ e ->
                           xml_return
                             (DPDP2_2 a b c d e)))))))))))))))))))))))))
           (\ x -> xml_return (id x)));

nonloop_srs_reason ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        ([Dp_proof_step (Lab a b)] ->
                          Non_loop_srs_proof (Lab a b));
nonloop_srs_reason xml2name =
  xml_or
    (xml_do "selfEmbeddingOC"
      (xml_take (string xml2name)
        (\ a ->
          xml_take (string xml2name)
            (\ b ->
              xml_take (string xml2name)
                (\ c -> xml_return (SE_OC (b, a ++ b ++ c) a c))))))
    (xml_do "selfEmbeddingDP"
      (xml_take (derivation_pattern xml2name)
        (\ a ->
          xml_take (string xml2name)
            (\ b ->
              xml_take (string xml2name) (\ c -> xml_return (SE_DP a b c))))));

nonloop_srs ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Non_loop_srs_proof (Lab a b));
nonloop_srs xml2name =
  xml_do "nonterminatingSRS"
    (xml_take
      (xml_do "derivationPatterns"
        (xml_take_many_sub [] zero_nat Infinity_enat
          (derivation_pattern_proof xml2name) (\ a -> xml_return (id a))))
      (\ a ->
        xml_take (nonloop_srs_reason xml2name) (\ b -> xml_return (b a))));

g_list_to_map_rm_basic_ops ::
  forall a b. (Compare_order a) => [(a, b)] -> Rbt a b;
g_list_to_map_rm_basic_ops l =
  foldl (\ m (k, v) -> insert k v m) empty (reverse l);

ceta_map_of :: forall a b. (Compare_order a) => [(a, b)] -> a -> Maybe b;
ceta_map_of ps = lookup (g_list_to_map_rm_basic_ops ps);

nat_or_empty ::
  forall a b c.
    ([Xml], (a, (b, (c, [String])))) -> Sum_bot (Xml_error String) (Maybe Nat);
nat_or_empty ([], s) = right Nothing;
nat_or_empty ([XML_text txt], s) = (case int_of_stringa txt of {
                                     Inl err -> xml_error err ([], s);
                                     Inr n -> right (Just (nat n));
                                   });

uncurry_info ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       (a, ([((a, Nat), [a])],
                             ([(Term a [Char], Term a [Char])],
                               [(Term a [Char], Term a [Char])])));
uncurry_info xml2name =
  xml_do "uncurryInformation"
    (xml_take xml2name
      (\ a ->
        xml_take
          (xml_do "uncurriedSymbols"
            (xml_take_many_sub [] zero_nat Infinity_enat
              (xml_do "uncurriedSymbolEntry"
                (xml_take xml2name
                  (\ f ->
                    xml_take (xml_nat "arity")
                      (\ n ->
                        xml_take_many_sub [] zero_nat Infinity_enat xml2name
                          (\ fs -> xml_return ((f, n), fs))))))
              xml_return))
          (\ sml ->
            xml_take
              (xml_do "uncurryRules"
                (xml_take (rules xml2name) (\ x -> xml_return (id x))))
              (\ u ->
                xml_take
                  (xml_do "etaRules"
                    (xml_take (rules xml2name) (\ x -> xml_return (id x))))
                  (\ e -> xml_return (a, (sml, (u, e))))))));

convertible_critical_peaks ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       [(Term a [Char],
                          (Term a [Char],
                            ([([Nat],
                                ((Term a [Char], Term a [Char]),
                                  (Bool, Term a [Char])))],
                              ([([Nat],
                                  ((Term a [Char], Term a [Char]),
                                    Term a [Char]))],
                                ([([Nat],
                                    ((Term a [Char], Term a [Char]),
                                      (Bool, Term a [Char])))],
                                  (Term a [Char],
                                    ([([Nat],
((Term a [Char], Term a [Char]), (Bool, Term a [Char])))],
                                      ([([Nat],
  ((Term a [Char], Term a [Char]), Term a [Char]))],
[([Nat], ((Term a [Char], Term a [Char]), (Bool, Term a [Char])))]))))))))];
convertible_critical_peaks xml2name =
  let {
    rew = rsteps xml2name;
    conv = conversion xml2name;
  } in xml_do "convertibleCriticalPeaks"
         (xml_take_many_sub [] zero_nat Infinity_enat
           (xml_do "convertibleCriticalPeak"
             (xml_take
               (xml_do "source"
                 (xml_take (term xml2name) (\ x -> xml_return (id x))))
               (\ s ->
                 xml_take
                   (xml_do "conversionLeft"
                     (xml_take conv
                       (\ (sa, c1) ->
                         xml_take rew
                           (\ (_, r) ->
                             xml_take conv
                               (\ (_, c2) -> xml_return (sa, (c1, (r, c2))))))))
                   (\ (s1, (cl1, (sl, cl2))) ->
                     xml_take
                       (xml_do "conversionRight"
                         (xml_take conv
                           (\ (sa, c1) ->
                             xml_take rew
                               (\ (_, r) ->
                                 xml_take conv
                                   (\ (_, c2) ->
                                     xml_return (sa, (c1, (r, c2))))))))
                       (\ (s2, (cr1, (sr, cr2))) ->
                         xml_return
                           (s, (s1, (cl1, (sl,
    (cl2, (s2, (cr1, (sr, cr2)))))))))))))
           xml_return);

ordering_constraint_proof ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   Bool ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) (Redtriple_impl a);
ordering_constraint_proof xml2name bi =
  xml_do "orderingConstraintProof"
    (xml_take
      (xml_do "redPair"
        (xml_take (redtriple xml2name bi) (\ x -> xml_return (id x))))
      (\ x -> xml_return (id x)));

ordering_constraint_proofa ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   Bool ->
                     (Xml, ([([Char], [Char])],
                             (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String)
                         (Sum (Root_redtriple_impl a) (Redtriple_impl a));
ordering_constraint_proofa xml2name bi =
  xml_do "orderingConstraintProof"
    (xml_take (redtriplea xml2name bi) (\ x -> xml_return (id x)));

create_proj :: forall a. (Compare_order a) => ProjL a -> (a, Nat) -> Nat;
create_proj (Projection p) = let {
                               i = ceta_map_of p;
                             } in (\ f -> (case i f of {
    Nothing -> zero_nat;
    Just n -> n;
  }));

xml2cond_constraint ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Cond_constraint a [Char]);
xml2cond_constraint xml2name x =
  xml_do "conditionalConstraint"
    (xml_take
      (xml_or
        (xml_do "all"
          (xml_take (xml_text "var")
            (\ a ->
              xml_take (xml2cond_constraint xml2name)
                (\ b -> xml_return (CC_all a b)))))
        (xml_or
          (xml_do "implication"
            (xml_take (xml2cond_constraint xml2name)
              (\ c ->
                xml_take_many_sub [] zero_nat Infinity_enat
                  (xml2cond_constraint xml2name)
                  (\ cs ->
                    let {
                      ccs = c : cs;
                    } in xml_return
                           (CC_impl (take (size_list cs) ccs) (last ccs))))))
          (xml_do "constraint"
            (xml_take (term xml2name)
              (\ s ->
                xml_take
                  (xml_or (xml_leaf "rewrite" Nothing)
                    (xml_or (xml_leaf "strict" (Just True))
                      (xml_leaf "nonStrict" (Just False))))
                  (\ rel ->
                    xml_take (term xml2name)
                      (\ t ->
                        xml_return (case rel of {
                                     Nothing -> CC_rewr s t;
                                     Just stri -> CC_cond stri (s, t);
                                   }))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2cond_constraint_prf ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Cond_constraint_prf a [Char]);
xml2cond_constraint_prf xml2name x =
  let {
    cc = xml2cond_constraint xml2name;
  } in xml_do "conditionalConstraintProof"
         (xml_take
           (xml_or (xml_leaf "final" Final)
             (xml_or
               (xml_do "differentConstructor"
                 (xml_take cc (\ a -> xml_return (Different_Constructor a))))
               (xml_or
                 (xml_do "sameConstructor"
                   (xml_take cc
                     (\ a ->
                       xml_take cc
                         (\ b ->
                           xml_take (xml2cond_constraint_prf xml2name)
                             (\ c -> xml_return (Same_Constructor a b c))))))
                 (xml_or
                   (xml_do "variableEquation"
                     (xml_take (xml_text "var")
                       (\ a ->
                         xml_take (term xml2name)
                           (\ b ->
                             xml_take cc
                               (\ c ->
                                 xml_take (xml2cond_constraint_prf xml2name)
                                   (\ d ->
                                     xml_return
                                       (Variable_Equation a b c d)))))))
                   (xml_or
                     (xml_do "funargIntoVar"
                       (xml_take cc
                         (\ a ->
                           xml_take position
                             (\ b ->
                               xml_take (xml_text "var")
                                 (\ c ->
                                   xml_take cc
                                     (\ d ->
                                       xml_take
 (xml2cond_constraint_prf xml2name)
 (\ e -> xml_return (Funarg_Into_Var a b c d e))))))))
                     (xml_or
                       (xml_do "simplifyCondition"
                         (xml_take cc
                           (\ a ->
                             xml_take (substa xml2name)
                               (\ b ->
                                 xml_take cc
                                   (\ c ->
                                     xml_take (xml2cond_constraint_prf xml2name)
                                       (\ d ->
 xml_return (Simplify_Condition a b c d)))))))
                       (xml_or
                         (xml_do "induction"
                           (xml_take cc
                             (\ a ->
                               xml_take
                                 (xml_do "conjuncts"
                                   (xml_take_many_sub [] zero_nat Infinity_enat
                                     cc xml_return))
                                 (\ b ->
                                   xml_take
                                     (xml_do "ruleConstraintProofs"
                                       (xml_take_many_sub [] zero_nat
 Infinity_enat
 (xml_do "ruleConstraintProof"
   (xml_take (rule xml2name)
     (\ lr ->
       xml_take
         (xml_do "subtermVarEntries"
           (xml_take_many_sub [] zero_nat Infinity_enat
             (xml_do "subtermVarEntry"
               (xml_take (term xml2name)
                 (\ aa ->
                   xml_take_many_sub [] zero_nat Infinity_enat (xml_text "var")
                     (\ ba -> xml_return (aa, ba)))))
             xml_return))
         (\ rys ->
           xml_take cc
             (\ cca ->
               xml_take (xml2cond_constraint_prf xml2name)
                 (\ p -> xml_return (lr, (rys, (cca, p)))))))))
 xml_return))
                                     (\ c -> xml_return (Induction a b c))))))
                         (xml_do "deleteCondition"
                           (xml_take cc
                             (\ a ->
                               xml_take (xml2cond_constraint_prf xml2name)
                                 (\ b ->
                                   xml_return (Delete_Condition a b))))))))))))
           (\ xa -> xml_return (id xa)))
         x;

xml2cond_red_pair_proof ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Cond_red_pair_prf a [Char]);
xml2cond_red_pair_proof xml2name =
  xml_do "condRedPairProof"
    (xml_take xml2name
      (\ c ->
        xml_take (xml_nat "before")
          (\ b ->
            xml_take (xml_nat "after")
              (\ a ->
                xml_take
                  (xml_do "conditions"
                    (xml_take_many_sub [] zero_nat Infinity_enat
                      (xml_do "condition"
                        (xml_take (xml2cond_constraint xml2name)
                          (\ ca ->
                            xml_take
                              (xml_do "dpSequence"
                                (xml_take (rules xml2name)
                                  (\ x -> xml_return (id x))))
                              (\ s ->
                                xml_take (xml2cond_constraint_prf xml2name)
                                  (\ p -> xml_return (ca, (s, p)))))))
                      xml_return))
                  (\ ccs -> xml_return (Cond_Red_Pair_Prf c ccs b a))))));

projected_rseq ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    ((a, Nat) -> Nat) ->
                      (Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                        Sum_bot (Xml_error String)
                          ((Term a [Char], Term a [Char]),
                            [([Nat],
                               ((Term a [Char], Term a [Char]),
                                 Term a [Char]))]);
projected_rseq xml2name pi =
  xml_do "projectedRewriteSequence"
    (xml_take (rule xml2name)
      (\ r -> xml_take (rseq xml2name pi r) xml_return));

default_nfs_nt_dp :: Bool;
default_nfs_nt_dp = False;

strategy_to_Q ::
  forall a b.
    (Eq a, Eq b) => Strategy a b -> [(Term a b, Term a b)] -> [Term a b];
strategy_to_Q No_Strategy uu = [];
strategy_to_Q Innermost r = remdups (map fst r);
strategy_to_Q (Innermost_Q q) uv = q;

default_nfs_dp :: Bool;
default_nfs_dp = True;

xml2dp_inputa ::
  forall a b c.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    Bool ->
                      (Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                        Sum_bot (Xml_error String)
                          (Bool,
                            (Bool,
                              ([(Term a [Char], Term a [Char])],
                                ([b], ([Term a [Char]],
([c], [(Term a [Char], Term a [Char])]))))));
xml2dp_inputa xml2name termination =
  xml_change (xml2dp_input xml2name)
    (\ (DP_input m p q r) ->
      xml_return
        ((if termination then default_nfs_dp else default_nfs_nt_dp),
          (m, (p, ([], (strategy_to_Q q r, ([], r)))))));

flat_contexts ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) [Ctxt a [Char]];
flat_contexts xml2name =
  xml_do "flatContexts"
    (xml_take_many_sub [] zero_nat Infinity_enat (ctxt xml2name) xml_return);

equal_start_term :: Start_term -> Start_term -> Bool;
equal_start_term Full Constructor_Based = False;
equal_start_term Constructor_Based Full = False;
equal_start_term Constructor_Based Constructor_Based = True;
equal_start_term Full Full = True;

o_to_fp_term :: forall a b. Term a b -> (Ctxt a b, (Term a b, Location));
o_to_fp_term t = (Hole, (t, Ba));

o_to_fp_impl :: forall a b. [Term a b] -> [(Ctxt a b, (Term a b, Location))];
o_to_fp_impl = map o_to_fp_term;

string_of_digit :: Nat -> [Char];
string_of_digit n =
  (if equal_nat n zero_nat
    then [Char False False False False True True False False]
    else (if equal_nat n one_nat
           then [Char True False False False True True False False]
           else (if equal_nat n (nat_of_integer (2 :: Integer))
                  then [Char False True False False True True False False]
                  else (if equal_nat n (nat_of_integer (3 :: Integer))
                         then [Char True True False False True True False False]
                         else (if equal_nat n (nat_of_integer (4 :: Integer))
                                then [Char False False True False True True
False False]
                                else (if equal_nat n
   (nat_of_integer (5 :: Integer))
                                       then [Char True False True False True
       True False False]
                                       else (if equal_nat n
          (nat_of_integer (6 :: Integer))
      then [Char False True True False True True False False]
      else (if equal_nat n (nat_of_integer (7 :: Integer))
             then [Char True True True False True True False False]
             else (if equal_nat n (nat_of_integer (8 :: Integer))
                    then [Char False False False True True True False False]
                    else [Char True False False True True True False
                            False])))))))));

showsp_nat :: Nat -> Nat -> [Char] -> [Char];
showsp_nat p n =
  (if less_nat n (nat_of_integer (10 :: Integer))
    then shows_string (string_of_digit n)
    else showsp_nat p (divide_nat n (nat_of_integer (10 :: Integer))) .
           shows_string
             (string_of_digit (modulo_nat n (nat_of_integer (10 :: Integer)))));

shows_prec_nat :: Nat -> Nat -> [Char] -> [Char];
shows_prec_nat = showsp_nat;

fresh_strings_list :: [Char] -> Nat -> [[Char]] -> Nat -> [[Char]];
fresh_strings_list name offset used n =
  take n
    (filter (\ s -> not (member (remdups used) s))
      (map (\ i -> name ++ shows_prec_nat zero_nat (plus_nat i offset) [])
        (upt zero_nat (plus_nat n (size_list (remdups used))))));

mu_to_fp_impl ::
  forall a.
    (Eq a) => [((a, Nat), [Nat])] ->
                [(Ctxt a [Char], (Term a [Char], Location))];
mu_to_fp_impl mu =
  let {
    fs = remdups (map fst mu);
    m = map_of mu;
    a = concatMap
          (\ f ->
            let {
              xs = map Var
                     (fresh_strings_list
                       [Char False False False True True True True False]
                       zero_nat [] (snd f));
            } in map (\ i -> (f, (xs, i)))
                   (concatMap
                     (\ i -> (if not (member (the (m f)) i) then [i] else []))
                     (upt zero_nat (snd f))))
          fs;
  } in concatMap
         (\ (aa, b) ->
           (case aa of {
             (f, _) ->
               (\ (xs, i) ->
                 map (\ loc ->
                       (ctxt_of_pos_term [i] (Fun f xs), (nth xs i, loc)))
                   [Ba, H]);
           })
             b)
         a;

strategy_to_fp ::
  forall a.
    (Eq a) => Fp_strategy a [Char] ->
                [(Term a [Char], Term a [Char])] ->
                  [(Ctxt a [Char], (Term a [Char], Location))];
strategy_to_fp (Forbidden_Patterns p) r = p;
strategy_to_fp Outermost r = o_to_fp_impl (map fst r);
strategy_to_fp (Context_Sensitive mu) r = mu_to_fp_impl mu;

default_nfs_trs :: Bool;
default_nfs_trs = False;

xml2inn_fp_trs_assm ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Sum (Bool,
                               ([Term a [Char]],
                                 ([(Term a [Char], Term a [Char])],
                                   [(Term a [Char], Term a [Char])])))
                          ([(Ctxt a [Char], (Term a [Char], Location))],
                            [(Term a [Char], Term a [Char])]));
xml2inn_fp_trs_assm xml2name =
  xml_change (xml2_trs_input xml2name)
    (\ a ->
      (case a of {
        DP_input _ _ _ _ -> xml_error "trs as input required";
        Inn_TRS_input inn r s start ->
          (if not (equal_start_term start Full)
            then xml_error "start term is not allowed here"
            else xml_return
                   (Inl (default_nfs_trs, (strategy_to_Q inn r, (r, s)))));
        CPX_input _ _ _ _ _ -> xml_error "trs as input required";
        COMP_input _ _ -> xml_error "trs as input required";
        OCOMP_input _ _ _ _ -> xml_error "trs as input required";
        EQ_input _ _ -> xml_error "trs as input required";
        FP_TRS_input fp r -> xml_return (Inr (strategy_to_fp fp r, r));
        CTRS_input _ -> xml_error "trs as input required";
        TA_input _ _ -> xml_error "trs as input required";
        AC_input _ _ _ -> xml_error "trs as input required";
        LTS_input _ -> xml_error "trs as input required";
        LTS_safety_input _ _ -> xml_error "trs as input required";
        Unknown_input _ -> xml_error "trs as input required";
      }));

xml2inn_trs_assm ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Bool,
                          ([Term a [Char]],
                            ([(Term a [Char], Term a [Char])],
                              [(Term a [Char], Term a [Char])])));
xml2inn_trs_assm xml2name =
  xml_change (xml2inn_fp_trs_assm xml2name)
    (\ a ->
      (case a of {
        Inl aa -> xml_return aa;
        Inr _ -> xml_error "innermost (relative) TRS expected at this point";
      }));

xml2trs_termination_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Trs_termination_proof a b [Char]);
xml2trs_termination_proof xml2name x =
  xml_or
    (xml_do "trsTerminationProof"
      (xml_take (xml2trs_termination_proof_inner xml2name)
        (\ xa -> xml_return (id xa))))
    (xml_do "relativeTerminationProof"
      (xml_take (xml2trs_termination_proof_inner xml2name)
        (\ xa -> xml_return (id xa))))
    x;

xml2dp_termination_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Dp_termination_proof a b [Char]);
xml2dp_termination_proof xml2name x =
  xml_do "dpProof"
    (xml_take
      (xml_or (xml_leaf "pIsEmpty" P_is_Empty)
        (xml_or
          (xml_do "depGraphProc"
            (xml_take_many_sub [] zero_nat Infinity_enat
              (xml_do "component"
                (xml_take
                  (xml_do "dps"
                    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                  (\ dps ->
                    xml_take_optional (xml_bool "realScc")
                      (\ _ ->
                        xml_take_optional
                          (xml_do "arcs"
                            (xml_take_many_sub [] zero_nat Infinity_enat
                              (\ xa -> right (fst xa)) (\ _ -> xml_return ())))
                          (\ _ ->
                            xml_take_optional
                              (xml2dp_termination_proof xml2name)
                              (\ prfOpt -> xml_return (prfOpt, dps)))))))
              (\ a -> xml_return (Dep_Graph_Proc a))))
          (xml_or
            (xml_do "redPairProc"
              (xml_take (ordering_constraint_proofa xml2name False)
                (\ a ->
                  xml_take
                    (xml_do "dps"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ b ->
                      xml_take (xml2dp_termination_proof xml2name)
                        (\ c -> xml_return (Redpair_Proc a b c))))))
            (xml_or
              (xml_do "usableRulesProc"
                (xml_take
                  (xml_do "usableRules"
                    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                  (\ a ->
                    xml_take (xml2dp_termination_proof xml2name)
                      (\ b -> xml_return (Usable_Rules_Proc a b)))))
              (xml_or
                (xml_do "innermostLhssRemovalProc"
                  (xml_take (innermostLhss xml2name)
                    (\ a ->
                      xml_take (xml2dp_termination_proof xml2name)
                        (\ b -> xml_return (Q_Reduction_Proc a b)))))
                (xml_or
                  (xml_do "rewritingProc"
                    (xml_take (rule xml2name)
                      (\ (s, t) ->
                        xml_take (rstep xml2name)
                          (\ (p, (lr, ta)) ->
                            xml_take_default (s, ta) (rule xml2name)
                              (\ st ->
                                xml_take_optional
                                  (xml_do "usableRules"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ ur ->
                                    xml_take (xml2dp_termination_proof xml2name)
                                      (\ prof ->
xml_return (Rewriting_Proc ur (s, t) (s, ta) st lr p prof))))))))
                  (xml_or
                    (xml_do "narrowingProc"
                      (xml_take (rule xml2name)
                        (\ a ->
                          xml_take pos
                            (\ b ->
                              xml_take
                                (xml_do "narrowings"
                                  (xml_take (rules xml2name)
                                    (\ xa -> xml_return (id xa))))
                                (\ c ->
                                  xml_take (xml2dp_termination_proof xml2name)
                                    (\ d ->
                                      xml_return (Narrowing_Proc a b c d)))))))
                    (xml_or
                      (xml_do "instantiationProc"
                        (xml_take (rule xml2name)
                          (\ a ->
                            xml_take
                              (xml_do "instantiations"
                                (xml_take (rules xml2name)
                                  (\ xa -> xml_return (id xa))))
                              (\ b ->
                                xml_take (xml2dp_termination_proof xml2name)
                                  (\ c ->
                                    xml_return (Instantiation_Proc a b c))))))
                      (xml_or
                        (xml_do "forwardInstantiationProc"
                          (xml_take (rule xml2name)
                            (\ a ->
                              xml_take
                                (xml_do "instantiations"
                                  (xml_take (rules xml2name)
                                    (\ xa -> xml_return (id xa))))
                                (\ b ->
                                  xml_take_optional
                                    (xml_do "usableRules"
                                      (xml_take (rules xml2name)
(\ xa -> xml_return (id xa))))
                                    (\ c ->
                                      xml_take
(xml2dp_termination_proof xml2name)
(\ d -> xml_return (Forward_Instantiation_Proc a b c d)))))))
                        (xml_or
                          (xml_do "semlabProc"
                            (xml_take
                              (xmlt2 (sl_variant (xmlt_of_xmlt2 xml2name)))
                              (\ sli ->
                                xml_take
                                  (xml_do "dps"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ lp ->
                                    xml_take
                                      (xml_do "trs"
(xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                                      (\ lr ->
xml_take_default [] (innermostLhss xml2name)
  (\ lq ->
    xml_take (xml2dp_termination_proof xml2name)
      (\ p -> xml_return (Semlab_Proc sli lp lq lr p))))))))
                          (xml_or
                            (xml_do "subtermProc"
                              (xml_take
                                (xml_or
                                  (xml_change (proj xml2name)
                                    (xml_return . Inl))
                                  (xml_change (multiset_af xml2name)
                                    (xml_return . Inr)))
                                (\ pi_mpi ->
                                  xml_take_many_sub [] zero_nat Infinity_enat
                                    (projected_rseq xml2name
                                      (create_proj (case pi_mpi of {
             Inl lpi -> lpi;
             Inr _ -> Projection [];
           })))
                                    (\ seq ->
                                      xml_take
(xml_do "dps" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
(\ dps ->
  xml_take (xml2dp_termination_proof xml2name)
    (\ prf ->
      xml_return (case pi_mpi of {
                   Inl lpi -> Subterm_Criterion_Proc lpi seq dps prf;
                   Inr mpi -> Gen_Subterm_Criterion_Proc mpi dps prf;
                 })))))))
                            (xml_or
                              (xml_do "redPairUrProc"
                                (xml_take
                                  (ordering_constraint_proofa xml2name False)
                                  (\ a ->
                                    xml_take
                                      (xml_do "dps"
(xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                                      (\ b ->
xml_take
  (xml_do "usableRules"
    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
  (\ c ->
    xml_take (xml2dp_termination_proof xml2name)
      (\ d -> xml_return (Redpair_UR_Proc a b c d)))))))
                              (xml_or
                                (xml_do "monoRedPairUrProc"
                                  (xml_take
                                    (ordering_constraint_proof xml2name False)
                                    (\ a ->
                                      xml_take
(xml_do "dps" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
(\ b ->
  xml_take
    (xml_do "trs" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
    (\ c ->
      xml_take
        (xml_do "usableRules"
          (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
        (\ d ->
          xml_take (xml2dp_termination_proof xml2name)
            (\ e -> xml_return (Mono_Redpair_UR_Proc a b c d e))))))))
                                (xml_or
                                  (xml_do "monoRedPairProc"
                                    (xml_take
                                      (ordering_constraint_proof xml2name False)
                                      (\ a ->
xml_take (xml_do "dps" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
  (\ b ->
    xml_take
      (xml_do "trs" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
      (\ c ->
        xml_take (xml2dp_termination_proof xml2name)
          (\ d -> xml_return (Mono_Redpair_Proc a b c d)))))))
                                  (xml_or
                                    (xml_do "innermostMonoRedPairProc"
                                      (xml_take
(ordering_constraint_proof xml2name False)
(\ a ->
  xml_take
    (xml_do "deleted"
      (xml_take
        (xml_do "dps" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
        (\ aa ->
          xml_take
            (xml_do "trs"
              (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
            (\ b -> xml_return (aa, b)))))
    (\ b ->
      xml_take (xml2dp_termination_proof xml2name)
        (\ c -> xml_return ((case b of {
                              (ba, ca) -> Mono_URM_Redpair_Proc a ba ca;
                            })
                             c))))))
                                    (xml_or
                                      (xml_do "uncurryProc"
(xml_take_optional (xml_nat "applicativeTop")
  (\ a ->
    xml_take (uncurry_info xml2name)
      (\ b ->
        xml_take
          (xml_do "dps"
            (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
          (\ c ->
            xml_take
              (xml_do "trs"
                (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
              (\ d ->
                xml_take (xml2dp_termination_proof xml2name)
                  (\ e -> xml_return (Uncurry_Proc a b c d e))))))))
                                      (xml_or
(xml_do "flatContextClosureProc"
  (xml_take
    (xml_do "freshSymbol" (xml_take xml2name (\ xa -> xml_return (id xa))))
    (\ a ->
      xml_take (flat_contexts xml2name)
        (\ b ->
          xml_take
            (xml_do "dps"
              (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
            (\ c ->
              xml_take
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ d ->
                  xml_take (xml2dp_termination_proof xml2name)
                    (\ e -> xml_return (Fcc_Proc a b c d e))))))))
(xml_or
  (xml_do "switchInnermostProc"
    (xml_take (wcr_proof xml2name)
      (\ a ->
        xml_take (xml2dp_termination_proof xml2name)
          (\ b -> xml_return (Switch_Innermost_Proc a b)))))
  (xml_or
    (xml_do "splitProc"
      (xml_take
        (xml_do "dps" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
        (\ a ->
          xml_take
            (xml_do "trs"
              (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
            (\ b ->
              xml_take (xml2dp_termination_proof xml2name)
                (\ c ->
                  xml_take (xml2dp_termination_proof xml2name)
                    (\ d -> xml_return (Split_Proc a b c d)))))))
    (xml_or
      (xml_do "finitenessAssumption"
        (xml_take (xml2dp_inputa xml2name True)
          (\ xa -> xml_return (Assume_Finite xa []))))
      (xml_or
        (xml_do "unknownProof"
          (xml_take (xml_text "description")
            (\ _ ->
              xml_take (xml2dp_inputa xml2name True)
                (\ b ->
                  xml_take_many_sub [] zero_nat Infinity_enat
                    (\ xa -> right (fst xa))
                    (\ _ -> xml_return (Assume_Finite b []))))))
        (xml_or
          (xml_do "switchToTRS"
            (xml_take (xml2trs_termination_proof xml2name)
              (\ xa -> xml_return (To_Trs_Proc xa))))
          (xml_or
            (xml_do "unlabProc"
              (xml_take
                (xml_do "dps"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ a ->
                  xml_take
                    (xml_do "trs"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ b ->
                      xml_take (xml2dp_termination_proof xml2name)
                        (\ c -> xml_return (Unlab_Proc a b c))))))
            (xml_or
              (xml_do "generalRedPairProc"
                (xml_take (ordering_constraint_proof xml2name True)
                  (\ rp ->
                    xml_take
                      (xml_do "strict"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ s ->
                        xml_take
                          (xml_do "bound"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ b ->
                            xml_take (xml2cond_red_pair_proof xml2name)
                              (\ c ->
                                xml_take (xml2dp_termination_proof xml2name)
                                  (\ ps ->
                                    xml_take_optional
                                      (xml2dp_termination_proof xml2name)
                                      (\ pbo ->
xml_return (General_Redpair_Proc rp s b c (case pbo of {
    Nothing -> [ps];
    Just pb -> [ps, pb];
  }))))))))))
              (xml_or
                (xml_do "complexConstantRemovalProc"
                  (xml_take (term xml2name)
                    (\ a ->
                      xml_take
                        (xml_do "ruleMap"
                          (xml_take_many_sub [] zero_nat Infinity_enat
                            (xml_do "ruleMapEntry"
                              (xml_take (rule xml2name)
                                (\ aa ->
                                  xml_take (rule xml2name)
                                    (\ b -> xml_return (aa, b)))))
                            (\ aa -> xml_return (id aa))))
                        (\ b ->
                          xml_take (xml2dp_termination_proof xml2name)
                            (\ c ->
                              xml_return
                                (Complex_Constant_Removal_Proc
                                  (Complex_Constant_Removal_Proof a b) c))))))
                (xml_do "sizeChangeProc"
                  (xml_take
                    (xml_or (xml_leaf "subtermCriterion" Nothing)
                      (xml_do "reductionPair"
                        (xml_take (ordering_constraint_proof xml2name False)
                          (\ redp ->
                            xml_take_optional
                              (xml_do "usableRules"
                                (xml_take (rules xml2name)
                                  (\ xa -> xml_return (id xa))))
                              (\ ur -> xml_return (Just (redp, ur)))))))
                    (\ version ->
                      xml_take_many_sub [] zero_nat Infinity_enat (scg xml2name)
                        (\ b ->
                          (case version of {
                            Nothing -> xml_return (Size_Change_Subterm_Proc b);
                            Just redp_ur ->
                              xml_return
                                (Size_Change_Redpair_Proc (fst redp_ur)
                                  (snd redp_ur) b);
                          }))))))))))))))))))))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2trs_termination_proof_inner ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Trs_termination_proof a b [Char]);
xml2trs_termination_proof_inner xml2name x =
  xml_or (xml_leaf "rIsEmpty" R_is_Empty)
    (xml_or
      (xml_do "sIsEmpty"
        (xml_take (xml2trs_termination_proof xml2name) xml_return))
      (xml_or
        (xml_do "semlab"
          (xml_take (xmlt2 (sl_variant (xmlt_of_xmlt2 xml2name)))
            (\ sli ->
              xml_take
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ lr ->
                  xml_take_default []
                    (xml_do "trs"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ lrw ->
                      xml_take_default [] (innermostLhss xml2name)
                        (\ lq ->
                          xml_take (xml2trs_termination_proof xml2name)
                            (\ p ->
                              xml_return (Semlab sli lq (lr ++ lrw) p))))))))
        (xml_or
          (xml_do "split"
            (xml_take
              (xml_do "trs"
                (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
              (\ a ->
                xml_take (xml2trs_termination_proof xml2name)
                  (\ b ->
                    xml_take (xml2trs_termination_proof xml2name)
                      (\ c -> xml_return (Split a b c))))))
          (xml_or
            (xml_do "dpTrans"
              (xml_take
                (xml_do "dps"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ a ->
                  xml_take (xml_bool "markedSymbols")
                    (\ _ ->
                      xml_take (xml2dp_termination_proof xml2name)
                        (\ c ->
                          xml_return (DP_Trans default_nfs_dp True a c))))))
            (xml_or
              (xml_do "ruleRemoval"
                (xml_take (ordering_constraint_proof xml2name False)
                  (\ ord ->
                    xml_take
                      (xml_do "trs"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ r ->
                        xml_take_default []
                          (xml_do "trs"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ s ->
                            xml_take (xml2trs_termination_proof xml2name)
                              (\ p ->
                                xml_return (Rule_Removal ord (r ++ s) p)))))))
              (xml_or (xml_change (bounds_info xml2name) (xml_return . Bounds))
                (xml_or
                  (xml_do "stringReversal"
                    (xml_take
                      (xml_do "trs"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ _ ->
                        xml_take_optional
                          (xml_do "trs"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ _ ->
                            xml_take (xml2trs_termination_proof xml2name)
                              (\ prf -> xml_return (String_Reversal prf))))))
                  (xml_or
                    (xml_do "equalityRemoval"
                      (xml_take (xml2trs_termination_proof xml2name)
                        (\ xa -> xml_return (Drop_Equality xa))))
                    (xml_or
                      (xml_do "constantToUnary"
                        (xml_take plain_var
                          (\ v ->
                            xml_take (renaming xml2name)
                              (\ ren ->
                                xml_take
                                  (xml_do "trs"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ s ->
                                    xml_take_default []
                                      (xml_do "trs"
(xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                                      (\ sw ->
xml_take (xml2trs_termination_proof xml2name)
  (\ p ->
    xml_return (Constant_String (Const_string_sound_proof v ren s sw) p))))))))
                      (xml_or
                        (xml_do "removeNonApplicableRules"
                          (xml_take
                            (xml_do "trs"
                              (xml_take (rules xml2name)
                                (\ xa -> xml_return (id xa))))
                            (\ a ->
                              xml_take (xml2trs_termination_proof xml2name)
                                (\ b ->
                                  xml_return
                                    (Remove_Nonapplicable_Rules a b)))))
                        (xml_or
                          (xml_do "uncurry"
                            (xml_take (uncurry_info xml2name)
                              (\ i ->
                                xml_take
                                  (xml_do "trs"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ r ->
                                    xml_take_default []
                                      (xml_do "trs"
(xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                                      (\ s ->
xml_take (xml2trs_termination_proof xml2name)
  (\ p -> xml_return (Uncurry i (r ++ s) p)))))))
                          (xml_or
                            (xml_do "flatContextClosure"
                              (xml_take (flat_contexts xml2name)
                                (\ i ->
                                  xml_take
                                    (xml_do "trs"
                                      (xml_take (rules xml2name)
(\ xa -> xml_return (id xa))))
                                    (\ r ->
                                      xml_take_default []
(xml_do "trs" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
(\ s ->
  xml_take (xml2trs_termination_proof xml2name)
    (\ p -> xml_return (Fcc i (r ++ s) p)))))))
                            (xml_or
                              (xml_do "switchInnermost"
                                (xml_take (wcr_proof xml2name)
                                  (\ a ->
                                    xml_take
                                      (xml2trs_termination_proof xml2name)
                                      (\ b ->
xml_return (Switch_Innermost a b)))))
                              (xml_or
                                (xml_do "permutingArgumentFilter"
                                  (xml_take (afs xml2name)
                                    (\ a ->
                                      xml_take
(xml2trs_termination_proof xml2name) (\ b -> xml_return (Permuting_AFS a b)))))
                                (xml_or
                                  (xml_do "terminationAssumption"
                                    (xml_take (xml2inn_trs_assm xml2name)
                                      (\ xa -> xml_return (Assume_SN xa []))))
                                  (xml_or
                                    (xml_do "relativeTerminationAssumption"
                                      (xml_take
(xml_do "trsInput"
  (xml_take
    (xml_do "trs" (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
    (\ r ->
      xml_take_default []
        (xml_do "relativeRules"
          (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
        (\ rw -> xml_return (Assume_SN (default_nfs_trs, ([], (r, rw))) [])))))
xml_return))
                                    (xml_do "unknownProof"
                                      (xml_take (xml_text "description")
(\ _ ->
  xml_take (xml2inn_trs_assm xml2name)
    (\ b ->
      xml_take_many_sub [] zero_nat Infinity_enat (\ xa -> right (fst xa))
        (\ _ -> xml_return (Assume_SN b []))))))))))))))))))))))
    x;

rule_labeling_function ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [((Term (Lab a b) [Char], Term (Lab a b) [Char]), Nat)];
rule_labeling_function xml2name =
  xml_do "ruleLabelingFunction"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "ruleLabelingFunctionEntry"
        (xml_take (rule xml2name)
          (\ a -> xml_take (xml_nat "label") (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (id a)));

add_source_lab_proof ::
  forall a b c.
    Cr_proof a b c ->
      Maybe Nat -> Trs_termination_proof a b c -> Cr_proof a b c;
add_source_lab_proof (Rule_Labeling rl js uu) uv prf =
  Rule_Labeling rl js (Just prf);
add_source_lab_proof (Rule_Labeling_Conv rl cs uw) (Just n) prf =
  Rule_Labeling_Conv rl cs (Just (n, prf));

xml2ms_signature ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [(Lab a b, ([[Char]], [Char]))];
xml2ms_signature xml2name =
  xml_do "manySortedSignature"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "manySortedFunction"
        (xml_take xml2name
          (\ a ->
            xml_take
              (xml_do "args"
                (xml_take_many_sub [] zero_nat Infinity_enat (xml_text "sort")
                  (\ aa -> xml_return (id aa))))
              (\ b ->
                xml_take
                  (xml_do "result"
                    (xml_take (xml_text "sort") (\ x -> xml_return (id x))))
                  (\ c -> xml_return (a, (b, c)))))))
      (\ a -> xml_return (id a)));

xml2cr_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Cr_proof a b [Char]);
xml2cr_proof xml2name x =
  xml_do "crProof"
    (xml_take
      (xml_or
        (xml_do "wcrAndSN"
          (xml_take (wcr_proof xml2name)
            (\ a ->
              xml_take (xml2trs_termination_proof xml2name)
                (\ b -> xml_return (SN_WCR a b)))))
        (xml_or (xml_leaf "orthogonal" Weakly_Orthogonal)
          (xml_or
            (xml_change (xml_nat "stronglyClosed")
              (xml_return . Strongly_Closed))
            (xml_or
              (xml_change (xml_do "parallelClosed" nat_or_empty)
                (xml_return . Parallel_Closed))
              (xml_or
                (xml_do "criticalPairClosingSystem"
                  (xml_take
                    (xml_do "trs"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ a ->
                      xml_take (xml2trs_termination_proof xml2name)
                        (\ b ->
                          xml_take (xml_nat "nrSteps")
                            (\ c ->
                              xml_return
                                (Critical_Pair_Closing_System a b c))))))
                (xml_or
                  (xml_do "ruleLabeling"
                    (xml_take (rule_labeling_function xml2name)
                      (\ a ->
                        xml_take (joinable_critical_pairs xml2name)
                          (\ b -> xml_return (Rule_Labeling a b Nothing)))))
                  (xml_or
                    (xml_do "decreasingDiagrams"
                      (xml_take_optional (xml2trs_termination_proof xml2name)
                        (\ a ->
                          xml_take
                            (xml_or
                              (xml_do "ruleLabeling"
                                (xml_take (rule_labeling_function xml2name)
                                  (\ rl ->
                                    xml_take (joinable_critical_pairs xml2name)
                                      (\ js ->
(case a of {
  Nothing -> xml_return (Rule_Labeling rl js Nothing);
  Just prf ->
    xml_return (add_source_lab_proof (Rule_Labeling rl js Nothing) Nothing prf);
})))))
                              (xml_do "ruleLabelingConv"
                                (xml_take (rule_labeling_function xml2name)
                                  (\ rl ->
                                    xml_take
                                      (convertible_critical_peaks xml2name)
                                      (\ cs ->
(case a of {
  Nothing -> xml_return (Rule_Labeling_Conv rl cs Nothing);
  Just prf ->
    xml_take (xml_nat "nrSteps")
      (\ n ->
        xml_return
          (add_source_lab_proof (Rule_Labeling_Conv rl cs Nothing) (Just n)
            prf));
}))))))
                            xml_return)))
                    (xml_or
                      (xml_do "redundantRules"
                        (xml_take
                          (xml_do "trs"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ trs ->
                            xml_take (xml_nat "nrSteps")
                              (\ n ->
                                xml_take_default []
                                  (xml_do "conversions"
                                    (xml_take_many_sub [] zero_nat Infinity_enat
                                      (conversion xml2name)
                                      (\ a -> xml_return (map snd a))))
                                  (\ cs ->
                                    xml_take (xml2cr_proof xml2name)
                                      (\ prf ->
xml_return (Redundant_Rules trs n cs prf)))))))
                      (xml_do "persistentDecomposition"
                        (xml_take (xml2ms_signature xml2name)
                          (\ sig ->
                            xml_take_many_sub [] zero_nat Infinity_enat
                              (xml_do "component"
                                (xml_take
                                  (xml_do "trs"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ a ->
                                    xml_take (xml2cr_proof xml2name)
                                      (\ b -> xml_return (a, b)))))
                              (\ subs ->
                                xml_return
                                  (Persistent_Decomposition sig
                                    subs)))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2eq_proof ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) (Eq_proof a [Char]);
xml2eq_proof xml2name x =
  xml_or
    (xml_do "refl" (xml_take (term xml2name) (\ xa -> xml_return (Refl xa))))
    (xml_or
      (xml_do "sym"
        (xml_take (xml2eq_proof xml2name) (\ xa -> xml_return (Sym xa))))
      (xml_or
        (xml_do "trans"
          (xml_take (xml2eq_proof xml2name)
            (\ a ->
              xml_take (xml2eq_proof xml2name)
                (\ b -> xml_return (Trans a b)))))
        (xml_or
          (xml_do "assm"
            (xml_take (rule xml2name)
              (\ a ->
                xml_take (substa xml2name)
                  (\ b -> xml_return (Assm a (mk_subst Var b))))))
          (xml_do "cong"
            (xml_take xml2name
              (\ a ->
                xml_take_many_sub [] zero_nat Infinity_enat
                  (xml2eq_proof xml2name) (\ b -> xml_return (Cong a b))))))))
    x;

compatible_ta ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    String ->
                      (Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                        Sum_bot (Xml_error String)
                          (Tree_automaton [Char] (Lab a b), Ta_relation [Char]);
compatible_ta xml2name tag =
  xml_do tag
    (xml_take (tree_automaton (ta_normal_lhs xml2name))
      (\ a ->
        xml_take_default Id_Relation closed_criterion
          (\ b -> xml_return (a, b))));

xml2const_map ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Lab a b -> Maybe [Char]);
xml2const_map xml2name =
  xml_do "constMap"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "entry"
        (xml_take
          (xml_do "symbol" (xml_take xml2name (\ x -> xml_return (id x))))
          (\ a -> xml_take (xml_text "const") (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (map_of a)));

default_grd_fun ::
  forall a.
    Term (Lab [Char] a) [Char] ->
      Term (Lab [Char] a) [Char] -> [Char] -> Term (Lab [Char] a) [Char];
default_grd_fun s t =
  let {
    f = funs_rule_list (s, t);
    m = fold (\ fa m -> (case fa of {
                          Lab _ _ -> m;
                          FunLab _ _ -> m;
                          UnLab _ -> m;
                          Sharp (Lab _ _) -> m;
                          Sharp (FunLab _ _) -> m;
                          Sharp (UnLab g) -> max (size_list g) m;
                          Sharp (Sharp _) -> m;
                        }))
          f zero_nat;
    suffix =
      replicate (suc m) (Char True False False False False True True False);
  } in (\ x -> Fun (Sharp (UnLab (x ++ suffix))) []);

xml2non_join_info ::
  ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lab [Char] [Nat])) ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String)
        (Non_join_info (Lab [Char] [Nat]) [Char] [Char]);
xml2non_join_info xml2name x =
  xml_or (xml_leaf "distinctNormalForms" Diff_NFs)
    (xml_or (xml_leaf "capNotUnif" (Tcap_Non_Unif default_grd_fun))
      (xml_or
        (xml_do "subterm"
          (xml_take pos
            (\ a ->
              xml_take (xml2non_join_info xml2name)
                (\ b -> xml_return (Subterm_NJ a b)))))
        (xml_or
          (xml_do "grounding"
            (xml_take (substa xml2name)
              (\ a ->
                xml_take (xml2non_join_info xml2name)
                  (\ b -> xml_return (Grounding a b)))))
          (xml_or
            (xml_do "emptyTreeAutomataIntersection"
              (xml_take (compatible_ta xml2name "firstAutomaton")
                (\ a ->
                  xml_take (compatible_ta xml2name "secondAutomaton")
                    (\ b ->
                      xml_return
                        ((case a of {
                           (ta1, rel1) ->
                             (\ (aa, ba) ->
                               Tree_Aut_Intersect_Empty ta1 rel1 aa ba);
                         })
                          b)))))
            (xml_or
              (xml_do "differentInterpretation"
                (xml_take (xmlt2 (sl_variant (xmlt_of_xmlt2 xml2name)))
                  (\ xa -> xml_return (Finite_Model_Gt xa))))
              (xml_or
                (xml_do "strictDecrease"
                  (xml_take (ordering_constraint_proof xml2name False)
                    (\ xa -> xml_return (Reduction_Pair_Gt xa))))
                (xml_or
                  (xml_do "argumentFilterNonJoin"
                    (xml_take (afs xml2name)
                      (\ a ->
                        xml_take (xml2non_join_info xml2name)
                          (\ b -> xml_return (Argument_Filter_NJ a b)))))
                  (xml_do "usableRulesNonJoin"
                    (xml_take_optional
                      (xml_or (xml_leaf "left" True) (xml_leaf "right" False))
                      (\ a ->
                        (case a of {
                          Nothing ->
                            xml_take (xml2non_join_info xml2name)
                              (\ b -> xml_return (Usable_Rules_Reach_NJ b));
                          Just left ->
                            xml_take
                              (xml_do "usableRules"
                                (xml_take (rules xml2name)
                                  (\ xa -> xml_return (id xa))))
                              (\ u ->
                                xml_take (xml2non_join_info xml2name)
                                  (\ p ->
                                    xml_return
                                      (Usable_Rules_Reach_Unif_NJ
(if left then Inl u else Inr u) p)));
                        })))))))))))
    x;

xml2ncr_proof ::
  ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lab [Char] [Nat])) ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Ncr_proof [Char] [Nat] [Char] [Char]);
xml2ncr_proof xml2name x =
  let {
    rew = rsteps xml2name;
  } in xml_do "crDisproof"
         (xml_take
           (xml_or
             (xml_do "nonWcrAndSN"
               (xml_take (\ xa -> right (fst xa))
                 (\ _ ->
                   xml_take (xml2trs_termination_proof xml2name)
                     (\ prf -> xml_return (SN_NWCR prf)))))
             (xml_or
               (xml_do "nonJoinableFork"
                 (xml_take rew
                   (\ a ->
                     xml_take rew
                       (\ b ->
                         xml_take (xml2non_join_info xml2name)
                           (\ c ->
                             xml_return
                               ((case a of {
                                  (s, seq1) ->
                                    (\ (_, aa) -> Non_Join s seq1 aa);
                                })
                                  b
                                 c))))))
               (xml_or
                 (xml_do "modularityDisjoint"
                   (xml_take
                     (xml_do "trs"
                       (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                     (\ a ->
                       xml_take (xml2ncr_proof xml2name)
                         (\ b -> xml_return (NCR_Disj_Subtrs a b)))))
                 (xml_or
                   (xml_do "redundantRules"
                     (xml_take
                       (xml_do "trs"
                         (xml_take (rules xml2name)
                           (\ xa -> xml_return (id xa))))
                       (\ a ->
                         xml_take (xml_nat "nrSteps")
                           (\ b ->
                             xml_take (xml2ncr_proof xml2name)
                               (\ c ->
                                 xml_return (NCR_Redundant_Rules a b c))))))
                   (xml_do "persistentDecomposition"
                     (xml_take (xml2ms_signature xml2name)
                       (\ a ->
                         xml_take
                           (xml_do "component"
                             (xml_take
                               (xml_do "trs"
                                 (xml_take (rules xml2name)
                                   (\ xa -> xml_return (id xa))))
                               (\ aa ->
                                 xml_take (xml2ncr_proof xml2name)
                                   (\ b -> xml_return (aa, b)))))
                           (\ b ->
                             xml_return
                               (case b of {
                                 (ba, c) -> NCR_Persistent_Decomposition a ba c;
                               })))))))))
           (\ xa -> xml_return (id xa)))
         x;

xml2state_map ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        ([Char] -> Term (Lab a b) [Char]);
xml2state_map xml2name =
  xml_do "stateMap"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "entry"
        (xml_take state
          (\ a -> xml_take (term xml2name) (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (\ x -> the (map_of a x))));

sharp_trans_id ::
  forall a.
    (String ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Sharp a);
sharp_trans_id trans_id_parser =
  xml_or
    (xml_change (trans_id_parser "transitionDuplicate") (xml_return . Sharpa))
    (xml_change (trans_id_parser "transitionId") (xml_return . Flat));

unraveling_info ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [(((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                            [(Term (Lab a b) [Char], Term (Lab a b) [Char])]),
                           [(Term (Lab a b) [Char], Term (Lab a b) [Char])])];
unraveling_info xml2name =
  xml_do "unravelingInformation"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "unravelingEntry"
        (xml_take (crule xml2name "conditionalRule")
          (\ a ->
            xml_take_many_sub [] zero_nat Infinity_enat (rule xml2name)
              (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (id a)));

invariant_proof_parser ::
  forall a b c d e f.
    (Default f) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) a) ->
                     ((Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) b) ->
                       ((Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                         Sum_bot (Xml_error String)
                           (Formula (Term c (d, e)))) ->
                         ((Xml, ([([Char], [Char])],
                                  (Bool, ([String], [String])))) ->
                           Sum_bot (Xml_error String) f) ->
                           [(a, Formula (Term c (d, e)))] ->
                             (Xml, ([([Char], [Char])],
                                     (Bool, ([String], [String])))) ->
                               Sum_bot (Xml_error String)
                                 (Invariant_proof c d e a [Char] b f);
invariant_proof_parser location_parser trans_parser atom_parser hint_parser i =
  xml_change
    (art_parser xml_text location_parser trans_parser atom_parser hint_parser)
    (\ prf -> xml_return (Impact i prf));

sharp_location_parser ::
  forall a.
    (String ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Sharp a);
sharp_location_parser location_id_parser =
  xml_or
    (xml_change (location_id_parser "locationDuplicate") (xml_return . Sharpa))
    (xml_change (location_id_parser "locationId") (xml_return . Flat));

invariant_parser ::
  forall a b c d.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Formula (Term b (c, d)))) ->
        (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) (a, Formula (Term b (c, d)));
invariant_parser location_parser atom_parser =
  xml_do "invariant"
    (xml_take (xml_do "location" (xml_take location_parser xml_return))
      (\ l ->
        xml_take
          (xml_do "formula" (xml_take (formula_parser atom_parser) xml_return))
          (\ phi -> xml_return (l, phi))));

invariants_parser ::
  forall a b c d.
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) a) ->
      ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) (Formula (Term b (c, d)))) ->
        (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) [(a, Formula (Term b (c, d)))];
invariants_parser location_parser atom_parser =
  xml_do "invariants"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (invariant_parser location_parser atom_parser) xml_return);

cooperation_proof_parser ::
  forall a b c d e f.
    (Ccompare a, Eq a, Default e, Ccompare f, Eq f,
      Mapping_impl f) => (String ->
                           (Xml, ([([Char], [Char])],
                                   (Bool, ([String], [String])))) ->
                             Sum_bot (Xml_error String) a) ->
                           ((Xml, ([([Char], [Char])],
                                    (Bool, ([String], [String])))) ->
                             Sum_bot (Xml_error String) (Term b (c, d))) ->
                             ((Xml, ([([Char], [Char])],
                                      (Bool, ([String], [String])))) ->
                               Sum_bot (Xml_error String)
                                 (Formula (Term b (c, d)))) ->
                               ((Xml, ([([Char], [Char])],
(Bool, ([String], [String])))) ->
                                 Sum_bot (Xml_error String)
                                   (Formula (Term b (Trans_var c, d)))) ->
                                 ((Xml, ([([Char], [Char])],
  (Bool, ([String], [String])))) ->
                                   Sum_bot (Xml_error String) c) ->
                                   ((Xml, ([([Char], [Char])],
    (Bool, ([String], [String])))) ->
                                     Sum_bot (Xml_error String) e) ->
                                     ((Xml,
([([Char], [Char])], (Bool, ([String], [String])))) ->
                                       Sum_bot (Xml_error String) d) ->
                                       d ->
 ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
   Sum_bot (Xml_error String) f) ->
   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
     Sum_bot (Xml_error String) (Cooperation_proof b c d a f e);
cooperation_proof_parser location_id_parser exp_parser atom_parser tatom_parser
  variable_parser hint_parser type_parser dom_type trans_parser xs =
  xml_or (xml_do "trivial" (xml_return Triviala))
    (xml_or
      (xml_do "newInvariants"
        (xml_take
          (invariants_parser (sharp_location_parser location_id_parser)
            atom_parser)
          (\ i ->
            xml_take
              (invariant_proof_parser (sharp_location_parser location_id_parser)
                trans_parser atom_parser hint_parser i)
              (\ p ->
                xml_take
                  (cooperation_proof_parser location_id_parser exp_parser
                    atom_parser tatom_parser variable_parser hint_parser
                    type_parser dom_type trans_parser)
                  (\ cp -> xml_return (Invariants_Update p cp))))))
      (xml_or
        (xml_do "transitionRemoval"
          (xml_take
            (xml_do "rankingFunctions"
              (xml_take_many_sub [] zero_nat Infinity_enat
                (xml_do "rankingFunction"
                  (xml_take
                    (xml_do "location"
                      (xml_take (sharp_location_parser location_id_parser)
                        xml_return))
                    (\ l ->
                      xml_take
                        (xml_do "expression"
                          (xml_take_many_sub [] one_nat Infinity_enat exp_parser
                            xml_return))
                        (\ es -> xml_return (l, es)))))
                xml_return))
            (\ rs ->
              xml_take
                (xml_do "bound"
                  (xml_take_many_sub [] zero_nat Infinity_enat exp_parser
                    xml_return))
                (\ bounds ->
                  xml_take
                    (xml_do "remove"
                      (xml_take_many_sub [] zero_nat Infinity_enat trans_parser
                        xml_return))
                    (\ removed ->
                      xml_take_default (\ _ -> default_hint)
                        (xml_do "hints"
                          (xml_take_many_sub [] zero_nat Infinity_enat
                            (xml_do "hint"
                              (xml_take trans_parser
                                (\ tr ->
                                  xml_take_default default_hint
                                    (hints_parser hint_parser)
                                    (\ hint -> xml_return (tr, hint)))))
                            (\ pairs ->
                              xml_return (map_of_default default_hint pairs))))
                        (\ hinter ->
                          xml_take
                            (cooperation_proof_parser location_id_parser
                              exp_parser atom_parser tatom_parser
                              variable_parser hint_parser type_parser dom_type
                              trans_parser)
                            (\ inner ->
                              let {
                                rf = map_of_default [] rs;
                              } in xml_return
                                     (Transition_Removal
                                       (Transition_removal_info rf removed
 dom_type bounds hinter)
                                       inner))))))))
        (xml_or
          (xml_do "locationAddition"
            (xml_take
              (transition_parser (sharp_location_parser location_id_parser)
                trans_parser tatom_parser)
              (\ tr ->
                xml_take
                  (cooperation_proof_parser location_id_parser exp_parser
                    atom_parser tatom_parser variable_parser hint_parser
                    type_parser dom_type trans_parser)
                  (\ prof ->
                    (case tr of {
                      (tr_id, tau) ->
                        xml_return
                          (Location_Addition
                            (Location_Addition_Info (source tau) (target tau)
                              tr_id tau)
                            prof);
                    })))))
          (xml_or
            (xml_do "freshVariableAddition"
              (xml_take variable_parser
                (\ x1 ->
                  xml_take type_parser
                    (\ x2 ->
                      xml_take
                        (xml_do "additionalFormulas"
                          (xml_take_many_sub [] zero_nat Infinity_enat
                            (xml_do "additionalFormula"
                              (xml_take trans_parser
                                (\ tr ->
                                  xml_take (formula_parser tatom_parser)
                                    (\ phi -> xml_return (tr, phi)))))
                            xml_return))
                        (\ x3 ->
                          xml_take
                            (cooperation_proof_parser location_id_parser
                              exp_parser atom_parser tatom_parser
                              variable_parser hint_parser type_parser dom_type
                              trans_parser)
                            (\ prof ->
                              xml_return
                                (Fresh_Variable_Addition
                                  (Fresh_Variable_Addition_Info x1 x2 x3)
                                  prof)))))))
            (xml_or
              (xml_do "cutTransitionSplit"
                (xml_take_many_sub [] zero_nat Infinity_enat
                  (xml_do "cutTransitionsWithProof"
                    (xml_take
                      (xml_do "cutTransitions"
                        (xml_take_many_sub [] zero_nat Infinity_enat
                          trans_parser xml_return))
                      (\ cuts ->
                        xml_take
                          (cooperation_proof_parser location_id_parser
                            exp_parser atom_parser tatom_parser variable_parser
                            hint_parser type_parser dom_type trans_parser)
                          (\ prof -> xml_return (cuts, prof)))))
                  (\ ps -> xml_return (Cut_Transition_Split ps))))
              (xml_do "sccDecomposition"
                (xml_take_many_sub [] zero_nat Infinity_enat
                  (xml_do "sccWithProof"
                    (xml_take
                      (xml_do "scc"
                        (xml_take_many_sub [] one_nat Infinity_enat
                          (sharp_location_parser location_id_parser)
                          xml_return))
                      (\ scc ->
                        xml_take
                          (cooperation_proof_parser location_id_parser
                            exp_parser atom_parser tatom_parser variable_parser
                            hint_parser type_parser dom_type trans_parser)
                          (\ prof -> xml_return (scc, prof)))))
                  (\ sccs -> xml_return (Scc_Decomp sccs)))))))))
    xs;

cut_points_to_transitions ::
  forall a b c d e.
    [(Sharp a, Transition_rule b c d (Sharp e))] ->
      [(e, (a, Formula (Term b (Trans_var c, d))))] ->
        [(Sharp a, Transition_rule b c d (Sharp e))];
cut_points_to_transitions ts [] = ts;
cut_points_to_transitions ts ((l, (tr, phi)) : cps) =
  cut_points_to_transitions ((Flat tr, Transition (Flat l) (Sharpa l) phi) : ts)
    cps;

cutPoints_parser ::
  forall a b c d e.
    (String ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String) a) ->
      (String ->
        (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) b) ->
        ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
          Sum_bot (Xml_error String) (Formula (Term c (Trans_var d, e)))) ->
          (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
            Sum_bot (Xml_error String)
              [(Sharp b, Transition_rule c d e (Sharp a))];
cutPoints_parser location_id_parser trans_id_parser tatom_parser =
  xml_do "cutPoints"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "cutPoint"
        (xml_take (location_id_parser "locationId")
          (\ l ->
            xml_take (trans_id_parser "skipId")
              (\ tr ->
                xml_take
                  (xml_do "skipFormula"
                    (xml_take (formula_parser tatom_parser) xml_return))
                  (\ phi -> xml_return (l, (tr, phi)))))))
      (\ tuples -> xml_return (cut_points_to_transitions [] tuples)));

termination_proof_parser ::
  forall a b c d e f.
    (Ccompare a, Eq a, Ccompare b, Eq b,
      Default f) => (String ->
                      (Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                        Sum_bot (Xml_error String) a) ->
                      (String ->
                        (Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                          Sum_bot (Xml_error String) b) ->
                        ((Xml, ([([Char], [Char])],
                                 (Bool, ([String], [String])))) ->
                          Sum_bot (Xml_error String) (Term c (d, e))) ->
                          ((Xml, ([([Char], [Char])],
                                   (Bool, ([String], [String])))) ->
                            Sum_bot (Xml_error String)
                              (Formula (Term c (d, e)))) ->
                            ((Xml, ([([Char], [Char])],
                                     (Bool, ([String], [String])))) ->
                              Sum_bot (Xml_error String)
                                (Formula (Term c (Trans_var d, e)))) ->
                              ((Xml, ([([Char], [Char])],
                                       (Bool, ([String], [String])))) ->
                                Sum_bot (Xml_error String) d) ->
                                ((Xml, ([([Char], [Char])],
 (Bool, ([String], [String])))) ->
                                  Sum_bot (Xml_error String) f) ->
                                  ((Xml, ([([Char], [Char])],
   (Bool, ([String], [String])))) ->
                                    Sum_bot (Xml_error String) e) ->
                                    e -> (Xml,
   ([([Char], [Char])], (Bool, ([String], [String])))) ->
   Sum_bot (Xml_error String) (Termination_proof c d e a b f);
termination_proof_parser location_id_parser trans_id_parser exp_parser
  atom_parser tatom_parser variable_parser hint_parser type_parser dom_type xml
  = xml_or (xml_do "trivial" (xml_return Trivialb))
      (xml_or
        (xml_do "newInvariants"
          (xml_take
            (invariants_parser (location_parser location_id_parser) atom_parser)
            (\ i ->
              xml_take
                (invariant_proof_parser (location_parser location_id_parser)
                  (trans_id trans_id_parser) atom_parser hint_parser i)
                (\ p ->
                  xml_take
                    (termination_proof_parser location_id_parser trans_id_parser
                      exp_parser atom_parser tatom_parser variable_parser
                      hint_parser type_parser dom_type)
                    (\ cp -> xml_return (Invariants_Update_LTS p cp))))))
        (xml_do "switchToCooperationTermination"
          (xml_take
            (cutPoints_parser location_id_parser trans_id_parser tatom_parser)
            (\ cp ->
              xml_take
                (cooperation_proof_parser location_id_parser exp_parser
                  atom_parser tatom_parser variable_parser hint_parser
                  type_parser dom_type (sharp_trans_id trans_id_parser))
                (\ p -> xml_return (Via_Cooperation [(cp, p)]))))))
      xml;

tatom_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Formula (Term Sig (Trans_var [Char], Ty)));
tatom_parser = xml_change (bexp_parser trans_var_parser) (xml_return . Atom);

type_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Ty;
type_parser =
  xml_or (xml_do "int" (xml_return IntT)) (xml_do "bool" (xml_return BoolT));

hint_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) Hints;
hint_parser =
  xml_do "linearCombination"
    (xml_take_many_sub [] zero_nat Infinity_enat (xml_int "constant")
      (\ xs -> xml_return (Hints xs)));

atom_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Formula (Term Sig ([Char], Ty)));
atom_parser = xml_change (bexp_parser variable_parser) (xml_return . Atom);

exp_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Term Sig ([Char], Ty));
exp_parser = exp_parsera variable_parser;

lts_termination_proof_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String)
      (Termination_proof Sig [Char] Ty [Char] [Char] Hints);
lts_termination_proof_parser =
  termination_proof_parser xml_text xml_text exp_parser atom_parser tatom_parser
    variable_parser hint_parser type_parser IntT;

safety_proof_parser ::
  forall a b c d e f.
    (Default f) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String) a) ->
                     ((Xml, ([([Char], [Char])],
                              (Bool, ([String], [String])))) ->
                       Sum_bot (Xml_error String) b) ->
                       ((Xml, ([([Char], [Char])],
                                (Bool, ([String], [String])))) ->
                         Sum_bot (Xml_error String)
                           (Formula (Term c (d, e)))) ->
                         ((Xml, ([([Char], [Char])],
                                  (Bool, ([String], [String])))) ->
                           Sum_bot (Xml_error String) f) ->
                           (Xml, ([([Char], [Char])],
                                   (Bool, ([String], [String])))) ->
                             Sum_bot (Xml_error String)
                               (Safety_proof c d e a [Char] b f);
safety_proof_parser location_parser trans_parser atom_parser hint_parser =
  xml_do "safetyViaInvariants"
    (xml_take (invariants_parser location_parser atom_parser)
      (\ i ->
        xml_take
          (invariant_proof_parser location_parser trans_parser atom_parser
            hint_parser i)
          (\ p -> xml_return (Invariant_Assertion p Trivial))));

lts_safety_proof_parser ::
  (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String)
      (Safety_proof Sig [Char] Ty [Char] [Char] [Char] Hints);
lts_safety_proof_parser =
  safety_proof_parser (location_parser xml_text) (trans_id xml_text) atom_parser
    hint_parser;

xml2dp_nontermination_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Dp_nontermination_proof a b [Char]);
xml2dp_nontermination_proof xml2name x =
  xml_do "dpNonterminationProof"
    (xml_take
      (xml_or
        (xml_do "dpRuleRemoval"
          (xml_take_optional
            (xml_do "dps"
              (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
            (\ p ->
              xml_take_optional
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ r ->
                  xml_take (xml2dp_nontermination_proof xml2name)
                    (\ prf ->
                      xml_return
                        (DP_Rule_Removal (Rule_removal_nonterm_dp_prf p r)
                          prf))))))
        (xml_or
          (xml_change (loop xml2name)
            (\ (s, (rseq, (sigma, c))) ->
              xml_return (DP_Loop (DP_loop_prf s rseq sigma c))))
          (xml_or (xml_change (nonloop xml2name) (xml_return . DP_Nonloop))
            (xml_or
              (xml_do "innermostLhssRemovalProc"
                (xml_take (innermostLhss xml2name)
                  (\ a ->
                    xml_take (xml2dp_nontermination_proof xml2name)
                      (\ b ->
                        xml_return
                          (DP_Q_Reduction (DP_q_reduction_nonterm_prf a) b)))))
              (xml_or
                (xml_do "innermostLhssIncreaseProc"
                  (xml_take (innermostLhss xml2name)
                    (\ a ->
                      xml_take (xml2dp_nontermination_proof xml2name)
                        (\ b ->
                          xml_return
                            (DP_Q_Increase (Q_increase_nonterm_dp_prf a) b)))))
                (xml_or
                  (xml_do "instantiationProc"
                    (xml_take
                      (xml_do "dps"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ a ->
                        xml_take (xml2dp_nontermination_proof xml2name)
                          (\ b ->
                            xml_return
                              (DP_Instantiation
                                (Instantiation_complete_proc_prf a) b)))))
                  (xml_or
                    (xml_do "narrowingProc"
                      (xml_take (rule xml2name)
                        (\ a ->
                          xml_take pos
                            (\ b ->
                              xml_take
                                (xml_do "narrowings"
                                  (xml_take (rules xml2name)
                                    (\ xa -> xml_return (id xa))))
                                (\ c ->
                                  xml_take
                                    (xml2dp_nontermination_proof xml2name)
                                    (\ d ->
                                      xml_return
(DP_Narrowing (Narrowing_complete_proc_prf a b c) d)))))))
                    (xml_or
                      (xml_do "rewritingProc"
                        (xml_take (rule xml2name)
                          (\ (s, t) ->
                            xml_take (rstep xml2name)
                              (\ (p, (lr, ta)) ->
                                xml_take_optional (rule xml2name)
                                  (\ c ->
                                    xml_take_optional
                                      (xml_do "usableRules"
(xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                                      (\ uopt ->
xml_take (xml2dp_nontermination_proof xml2name)
  (\ prf ->
    let {
      st = (case c of {
             Nothing -> (s, ta);
             Just v -> v;
           });
    } in xml_return
           (DP_Rewriting
             (Rewriting_complete_proc_prf uopt (s, t) (s, ta) st lr p)
             prf))))))))
                      (xml_or
                        (xml_do "switchFullStrategyProc"
                          (xml_take (wcr_proof xml2name)
                            (\ a ->
                              xml_take (xml2dp_nontermination_proof xml2name)
                                (\ b ->
                                  xml_return (DP_Termination_Switch a b)))))
                        (xml_or
                          (xml_do "infinitenessAssumption"
                            (xml_take (xml2dp_inputa xml2name False)
                              (\ xa -> xml_return (DP_Assume_Infinite xa []))))
                          (xml_do "unknownProof"
                            (xml_take (xml_text "description")
                              (\ _ ->
                                xml_take (xml2dp_inputa xml2name False)
                                  (\ b ->
                                    xml_take_many_sub [] zero_nat Infinity_enat
                                      (\ xa -> right (fst xa))
                                      (\ _ ->
xml_return (DP_Assume_Infinite b []))))))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

default_nfs_nt_trs :: Bool;
default_nfs_nt_trs = False;

xml2inn_nt_trs_assm ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Bool,
                          ([Term (Lab a b) [Char]],
                            [(Term (Lab a b) [Char], Term (Lab a b) [Char])]));
xml2inn_nt_trs_assm xml2name =
  xml_change (xml2_trs_input xml2name)
    (\ (Inn_TRS_input inn r s start) ->
      (if not (null s)
        then xml_error "(innermost) TRS without relative rules expected"
        else (if not (equal_start_term start Full)
               then xml_error "start term is not allowed here"
               else xml_return
                      (default_nfs_nt_trs, (strategy_to_Q inn r, r)))));

xml2trs_nontermination_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Trs_nontermination_proof a b [Char]);
xml2trs_nontermination_proof xml2name x =
  xml_do "trsNonterminationProof"
    (xml_take
      (xml_or (xml_leaf "variableConditionViolated" TRS_Not_Well_Formed)
        (xml_or
          (xml_change (loop xml2name)
            (\ (s, (rseq, (sigma, c))) ->
              xml_return
                (TRS_Loop
                  (TRS_loop_prf s
                    (map (\ (xa, (y, (_, z))) -> (xa, (y, z))) rseq) sigma c))))
          (xml_or (xml_change (nonloop xml2name) (xml_return . TRS_Nonloop))
            (xml_or
              (xml_change (nonloop_srs xml2name) (xml_return . TRS_Nonloop_SRS))
              (xml_or
                (xml_do "ruleRemoval"
                  (xml_take
                    (xml_do "trs"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ a ->
                      xml_take (xml2trs_nontermination_proof xml2name)
                        (\ b ->
                          xml_return
                            (TRS_Rule_Removal (Rule_removal_nonterm_trs_prf a)
                              b)))))
                (xml_or
                  (xml_do "dpTrans"
                    (xml_take
                      (xml_do "dps"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ a ->
                        xml_take (xml_bool "markedSymbols")
                          (\ _ ->
                            xml_take (xml2dp_nontermination_proof xml2name)
                              (\ c ->
                                xml_return
                                  (TRS_DP_Trans
                                    (DP_trans_nontermination_tt_prf a) c))))))
                  (xml_or
                    (xml_do "stringReversal"
                      (xml_take
                        (xml_do "trs"
                          (xml_take (rules xml2name)
                            (\ xa -> xml_return (id xa))))
                        (\ _ ->
                          xml_take (xml2trs_nontermination_proof xml2name)
                            (\ b -> xml_return (TRS_String_Reversal b)))))
                    (xml_or
                      (xml_do "constantToUnary"
                        (xml_take plain_var
                          (\ a ->
                            xml_take (renaming xml2name)
                              (\ b ->
                                xml_take
                                  (xml_do "trs"
                                    (xml_take (rules xml2name)
                                      (\ xa -> xml_return (id xa))))
                                  (\ c ->
                                    xml_take
                                      (xml2trs_nontermination_proof xml2name)
                                      (\ d ->
xml_return (TRS_Constant_String (Const_string_complete_proof a b c) d)))))))
                      (xml_or
                        (xml_do "innermostLhssIncrease"
                          (xml_take (innermostLhss xml2name)
                            (\ a ->
                              xml_take (xml2trs_nontermination_proof xml2name)
                                (\ b ->
                                  xml_return
                                    (TRS_Q_Increase
                                      (Q_increase_nonterm_trs_prf a) b)))))
                        (xml_or
                          (xml_do "switchFullStrategy"
                            (xml_take (wcr_proof xml2name)
                              (\ a ->
                                xml_take (xml2trs_nontermination_proof xml2name)
                                  (\ b ->
                                    xml_return (TRS_Termination_Switch a b)))))
                          (xml_or
                            (xml_do "uncurry"
                              (xml_take (uncurry_info xml2name)
                                (\ a ->
                                  xml_take
                                    (xml_do "trs"
                                      (xml_take (rules xml2name)
(\ xa -> xml_return (id xa))))
                                    (\ b ->
                                      xml_take
(xml2trs_nontermination_proof xml2name)
(\ c -> xml_return (TRS_Uncurry (Uncurry_nt_proof a b) c))))))
                            (xml_or
                              (xml_change (not_wn_ta xml2name)
                                (xml_return . TRS_Not_WN_Tree_Automaton))
                              (xml_or
                                (xml_do "nonterminationAssumption"
                                  (xml_take (xml2inn_nt_trs_assm xml2name)
                                    (\ xa ->
                                      xml_return (TRS_Assume_Not_SN xa []))))
                                (xml_do "unknownProof"
                                  (xml_take (xml_text "description")
                                    (\ _ ->
                                      xml_take (xml2inn_nt_trs_assm xml2name)
(\ b ->
  xml_take_many_sub [] zero_nat Infinity_enat (\ xa -> right (fst xa))
    (\ _ -> xml_return (TRS_Assume_Not_SN b [])))))))))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2inn_rel_nt_trs_assm ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Bool,
                          ([Term (Lab a b) [Char]],
                            ([(Term (Lab a b) [Char], Term (Lab a b) [Char])],
                              [(Term (Lab a b) [Char],
                                 Term (Lab a b) [Char])])));
xml2inn_rel_nt_trs_assm xml2name =
  xml_change (xml2_trs_input xml2name)
    (\ (Inn_TRS_input inn r s start) ->
      (if not (equal_start_term start Full)
        then xml_error "start term is not allowed here"
        else xml_return (default_nfs_nt_trs, (strategy_to_Q inn r, (r, s)))));

xml2reltrs_nontermination_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Reltrs_nontermination_proof a b [Char]);
xml2reltrs_nontermination_proof xml2name x =
  xml_do "relativeNonterminationProof"
    (xml_take
      (xml_or (xml_leaf "variableConditionViolated" Rel_Not_Well_Formed)
        (xml_or
          (xml_change (loop xml2name)
            (\ (s, (rseq, (sigma, c))) ->
              xml_return (Rel_Loop (Rel_trs_loop_prf s rseq sigma c))))
          (xml_or
            (xml_change (xml2trs_nontermination_proof xml2name)
              (xml_return . Rel_R_Not_SN))
            (xml_or
              (xml_do "ruleRemoval"
                (xml_take
                  (xml_do "trs"
                    (xml_take (rules xml2name) (\ xa -> xml_return (Just xa))))
                  (\ a ->
                    xml_take
                      (xml_do "trs"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (Just xa))))
                      (\ b ->
                        xml_take (xml2reltrs_nontermination_proof xml2name)
                          (\ c ->
                            xml_return
                              (Rel_Rule_Removal
                                (Rule_removal_nonterm_reltrs_prf a b) c))))))
              (xml_or
                (xml_do "stringReversal"
                  (xml_take
                    (xml_do "trs"
                      (xml_take (rules xml2name)
                        (\ xa -> xml_return (Just xa))))
                    (\ _ ->
                      xml_take
                        (xml_do "trs"
                          (xml_take (rules xml2name)
                            (\ xa -> xml_return (Just xa))))
                        (\ _ ->
                          xml_take (xml2reltrs_nontermination_proof xml2name)
                            (\ c -> xml_return (Rel_TRS_String_Reversal c))))))
                (xml_or
                  (xml_do "nonterminationAssumption"
                    (xml_take (xml2inn_rel_nt_trs_assm xml2name)
                      (\ xa -> xml_return (Rel_TRS_Assume_Not_SN xa []))))
                  (xml_do "unknownProof"
                    (xml_take (xml_text "description")
                      (\ _ ->
                        xml_take (xml2inn_rel_nt_trs_assm xml2name)
                          (\ b ->
                            xml_take_many_sub [] zero_nat Infinity_enat
                              (\ xa -> right (fst xa))
                              (\ _ ->
                                xml_return
                                  (Rel_TRS_Assume_Not_SN b []))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2ordered_completion_step ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Oc_irule (Lab a b) [Char]);
xml2ordered_completion_step xml2name =
  xml_or
    (xml_do "deduce"
      (xml_take (term xml2name)
        (\ a ->
          xml_take (term xml2name)
            (\ b ->
              xml_take (term xml2name) (\ c -> xml_return (OC_Deduce a b c))))))
    (xml_or
      (xml_do "orientl"
        (xml_take (term xml2name)
          (\ a ->
            xml_take (term xml2name) (\ b -> xml_return (OC_Orientl a b)))))
      (xml_or
        (xml_do "orientr"
          (xml_take (term xml2name)
            (\ a ->
              xml_take (term xml2name) (\ b -> xml_return (OC_Orientr a b)))))
        (xml_or
          (xml_do "delete"
            (xml_take (term xml2name) (\ x -> xml_return (OC_Delete x))))
          (xml_or
            (xml_do "compose"
              (xml_take (term xml2name)
                (\ a ->
                  xml_take (term xml2name)
                    (\ b ->
                      xml_take (term xml2name)
                        (\ c -> xml_return (OC_Compose a b c))))))
            (xml_or
              (xml_do "simplifyl"
                (xml_take (term xml2name)
                  (\ a ->
                    xml_take (term xml2name)
                      (\ b ->
                        xml_take (term xml2name)
                          (\ c -> xml_return (OC_Simplifyl a b c))))))
              (xml_or
                (xml_do "simplifyr"
                  (xml_take (term xml2name)
                    (\ a ->
                      xml_take (term xml2name)
                        (\ b ->
                          xml_take (term xml2name)
                            (\ c -> xml_return (OC_Simplifyr a b c))))))
                (xml_do "collapse"
                  (xml_take (term xml2name)
                    (\ a ->
                      xml_take (term xml2name)
                        (\ b ->
                          xml_take (term xml2name)
                            (\ c -> xml_return (OC_Collapse a b c))))))))))));

xml2ordered_completion_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Ordered_completion_proof a b [Char]);
xml2ordered_completion_proof xml2name =
  xml_do "orderedCompletionProof"
    (xml_take
      (xml_do "run"
        (xml_take_many_sub [] zero_nat Infinity_enat
          (xml_do "orderedCompletionStep"
            (xml_take (xml2ordered_completion_step xml2name)
              (\ x -> xml_return (id x))))
          (\ a -> xml_return (id a))))
      (\ x -> xml_return (OKB x)));

xml2quasi_reductive_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Quasi_reductive_proof a b [Char]);
xml2quasi_reductive_proof xml2name =
  xml_do "quasiReductiveProof"
    (xml_take
      (xml_do "unraveling"
        (xml_take (unraveling_info xml2name)
          (\ a ->
            xml_take (xml2trs_termination_proof xml2name)
              (\ b -> xml_return (Unravel a b)))))
      (\ x -> xml_return (id x)));

r_lhs_states :: forall a b. Ta_rule a b -> [a];
r_lhs_states (TA_rule x1 x2 x3) = x2;

r_root :: forall a b. Ta_rule a b -> b;
r_root (TA_rule x1 x2 x3) = x1;

r_rhs :: forall a b. Ta_rule a b -> a;
r_rhs (TA_rule x1 x2 x3) = x3;

map_r_states :: forall a b c. (a -> b) -> Ta_rule a c -> Ta_rule b c;
map_r_states f r = TA_rule (r_root r) (map f (r_lhs_states r)) (f (r_rhs r));

map_states_impl ::
  forall a b c. (a -> b) -> Tree_automaton a c -> Tree_automaton b c;
map_states_impl f (Tree_Automaton qs ts eps) =
  Tree_Automaton (map f qs) (map (map_r_states f) ts)
    (map (\ (p, q) -> (f p, f q)) eps);

xml2nonreachable_etac_info ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Nonreachability_proof (Lab a b) [Char]);
xml2nonreachable_etac_info xml2name =
  xml_do "nonreachableEtac"
    (xml_take (cPFsignature xml2name)
      (\ a ->
        xml_take xml2name
          (\ b ->
            xml_take xml2name
              (\ c ->
                xml_take (tree_automaton (ta_normal_lhs xml2name))
                  (\ d ->
                    xml_take (xml2state_map xml2name)
                      (\ e ->
                        xml_return
                          (Nonreachable_ETAC a b c (map_states_impl e d))))))));

xml2nonreachability_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Nonreachability_proof (Lab a b) [Char]);
xml2nonreachability_proof xml2name x =
  xml_do "nonreachabilityProof"
    (xml_take
      (xml_or (xml_leaf "nonreachableTcap" Nonreachable_Gtcap)
        (xml_or (xml2nonreachable_etac_info xml2name)
          (xml_or
            (xml_do "nonreachableSubstApprox"
              (xml_take (rules xml2name)
                (\ a ->
                  xml_take (xml2nonreachability_proof xml2name)
                    (\ b -> xml_return (Nonreachable_Subst_Approx a b)))))
            (xml_do "nonreachableReverse"
              (xml_take (xml2nonreachability_proof xml2name)
                (\ xa -> xml_return (Nonreachable_Reverse xa)))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2nonjoinability_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Nonjoinability_proof (Lab a b) [Char]);
xml2nonjoinability_proof xml2name =
  xml_do "nonjoinabilityProof"
    (xml_take
      (xml_or (xml_leaf "nonjoinableTcap" Nonjoinable_Tcap)
        (xml_change (xml2nonreachability_proof xml2name)
          (xml_return . Nonjoinable_Ground_NF)))
      (\ x -> xml_return (id x)));

xml2infeasibility_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Infeasibility_proof (Lab a b) [Char]);
xml2infeasibility_proof xml2name x =
  xml_do "infeasibilityProof"
    (xml_take
      (xml_or
        (xml_do "infeasibleCompoundConditions"
          (xml_take xml2name
            (\ a ->
              xml_take (xml2nonreachability_proof xml2name)
                (\ b -> xml_return (Infeasible_Compound_Conditions a b)))))
        (xml_or
          (xml_do "infeasibleEquation"
            (xml_take (rule xml2name)
              (\ a ->
                xml_take (xml2nonreachability_proof xml2name)
                  (\ b ->
                    xml_return ((case a of {
                                  (aa, ba) -> Infeasible_Equation aa ba;
                                })
                                 b)))))
          (xml_or
            (xml_do "infeasibleSubset"
              (xml_take (rules xml2name)
                (\ a ->
                  xml_take (xml2infeasibility_proof xml2name)
                    (\ b -> xml_return (Infeasible_Subset a b)))))
            (xml_or
              (xml_do "infeasibleRhssEqual"
                (xml_take (term xml2name)
                  (\ a ->
                    xml_take (term xml2name)
                      (\ b ->
                        xml_take (term xml2name)
                          (\ c ->
                            xml_take (xml2nonjoinability_proof xml2name)
                              (\ d ->
                                xml_return (Infeasible_Rhss_Equal a b c d)))))))
              (xml_do "infeasibleTrans"
                (xml_take (term xml2name)
                  (\ a ->
                    xml_take (term xml2name)
                      (\ b ->
                        xml_take (term xml2name)
                          (\ c ->
                            xml_take (xml2nonreachability_proof xml2name)
                              (\ d ->
                                xml_return (Infeasible_Trans a b c d)))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2infeasible_rules_info ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [(((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                            [(Term (Lab a b) [Char], Term (Lab a b) [Char])]),
                           Infeasibility_proof (Lab a b) [Char])];
xml2infeasible_rules_info xml2name =
  xml_do "infeasibleRules"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "infeasibleRule"
        (xml_take (crule xml2name "rule")
          (\ a ->
            xml_take (xml2infeasibility_proof xml2name)
              (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (id a)));

xml2inline_cond_info ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [(((Term (Lab a b) [Char], Term (Lab a b) [Char]),
                            [(Term (Lab a b) [Char], Term (Lab a b) [Char])]),
                           [(Term (Lab a b) [Char], Term (Lab a b) [Char])])];
xml2inline_cond_info xml2name =
  xml_do "inlinedRules"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "inlinedRule"
        (xml_take (crule xml2name "rule")
          (\ rule ->
            xml_take (conditions xml2name "inlinedConditions")
              (\ conds -> xml_return (rule, conds)))))
      xml_return);

xml2conditional_ncr_proof ::
  ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) (Lab [Char] [Nat])) ->
    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String)
        (Conditional_ncr_proof [Char] [Nat] [Char] [Char]);
xml2conditional_ncr_proof xml2name x =
  xml_do "conditionalCrDisproof"
    (xml_take
      (xml_or
        (xml_do "unconditional"
          (xml_take (xml2ncr_proof xml2name)
            (\ xa -> xml_return (Unconditional_CNCR xa))))
        (xml_or
          (xml_do "inlineConditions"
            (xml_take
              (xml_do "rules"
                (xml_take_many_sub [] zero_nat Infinity_enat
                  (crule xml2name "rule") xml_return))
              (\ a ->
                xml_take (xml2inline_cond_info xml2name)
                  (\ b ->
                    xml_take (xml2conditional_ncr_proof xml2name)
                      (\ c ->
                        xml_return
                          ((Transformation_CNCR . Inline_Conditions_CCRT a) b
                            c))))))
          (xml_or
            (xml_do "infeasibleRuleRemoval"
              (xml_take (xml2infeasible_rules_info xml2name)
                (\ a ->
                  xml_take (xml2conditional_ncr_proof xml2name)
                    (\ b ->
                      xml_return
                        ((Transformation_CNCR . Infeasible_Rule_Removal_CCRT) a
                          b)))))
            (xml_do "nonJoinableFork"
              (xml_take
                (xml_do "terms"
                  (xml_take (term xml2name)
                    (\ a ->
                      xml_take (term xml2name)
                        (\ b ->
                          xml_take (term xml2name)
                            (\ c -> xml_return (a, (b, c)))))))
                (\ a ->
                  xml_take (csteps xml2name)
                    (\ b ->
                      xml_take (csteps xml2name)
                        (\ c ->
                          xml_take (xml2non_join_info xml2name)
                            (\ d ->
                              xml_return
                                ((case a of {
                                   (s, aa) ->
                                     (case aa of {
                                       (ab, ba) -> Non_Join_CNCR s ab ba;
                                     });
                                 })
                                   b
                                   c
                                  d))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2context_joinable_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Context_joinable_proof (Lab a b) [Char]);
xml2context_joinable_proof xml2name =
  xml_do "contextJoinabilityProof"
    (xml_take (term xml2name)
      (\ a ->
        xml_take (csteps xml2name)
          (\ b ->
            xml_take (csteps xml2name)
              (\ c ->
                xml_take (xml2const_map xml2name)
                  (\ d ->
                    xml_return
                      (Contextual_Join (orig_term d a) (map (orig_cstep d) b)
                        (map (orig_cstep d) c)))))));

xml2context_joinable_ccps ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [(Term (Lab a b) [Char],
                           (Term (Lab a b) [Char],
                             ([(Term (Lab a b) [Char], Term (Lab a b) [Char])],
                               Context_joinable_proof (Lab a b) [Char])))];
xml2context_joinable_ccps xml2name =
  xml_do "contextJoinableCCPs"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "contextJoinableCCP"
        (xml_take (term xml2name)
          (\ s ->
            xml_take (term xml2name)
              (\ t ->
                xml_take (conditions xml2name "conditions")
                  (\ cs ->
                    xml_take (xml2context_joinable_proof xml2name)
                      (\ p -> xml_return (s, (t, (cs, p)))))))))
      xml_return);

xml2ao_infeasibility_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Ao_infeasibility_proof (Lab a b) [Char]);
xml2ao_infeasibility_proof xml2name =
  xml_do "aoInfeasibilityProof"
    (xml_take
      (xml_or
        (xml_change (xml2infeasibility_proof xml2name)
          (xml_return . AO_Infeasibility_Proof))
        (xml_do "aoLhssEqual"
          (xml_take (term xml2name)
            (\ a ->
              xml_take (term xml2name)
                (\ b ->
                  xml_take (term xml2name)
                    (\ c ->
                      xml_take (xml2nonjoinability_proof xml2name)
                        (\ d -> xml_return (AO_Lhss_Equal a b c d))))))))
      (\ x -> xml_return (id x)));

xml2ao_infeasible_conds ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [([(Term (Lab a b) [Char], Term (Lab a b) [Char])],
                           ([(Term (Lab a b) [Char], Term (Lab a b) [Char])],
                             Ao_infeasibility_proof (Lab a b) [Char]))];
xml2ao_infeasible_conds xml2name =
  xml_do "aoInfeasibleConditions"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "aoInfeasibleCondition"
        (xml_take (conditions xml2name "conditions")
          (\ a ->
            xml_take (conditions xml2name "conditions")
              (\ b ->
                xml_take (xml2ao_infeasibility_proof xml2name)
                  (\ c -> xml_return (a, (b, c)))))))
      (\ a -> xml_return (id a)));

xml2infeasible_conds ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [([(Term (Lab a b) [Char], Term (Lab a b) [Char])],
                           Infeasibility_proof (Lab a b) [Char])];
xml2infeasible_conds xml2name =
  xml_do "infeasibleConditions"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "infeasibleCondition"
        (xml_take (conditions xml2name "conditions")
          (\ a ->
            xml_take (xml2infeasibility_proof xml2name)
              (\ b -> xml_return (a, b)))))
      (\ a -> xml_return (id a)));

xml2unfeasible_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Unfeasible_proof (Lab a b) [Char]);
xml2unfeasible_proof xml2name =
  xml_do "unfeasibilityProof"
    (xml_take
      (xml_do "terms"
        (xml_take (term xml2name)
          (\ a ->
            xml_take (term xml2name)
              (\ b ->
                xml_take (term xml2name) (\ c -> xml_return (a, (b, c)))))))
      (\ a ->
        xml_take (csteps xml2name)
          (\ b ->
            xml_take (csteps xml2name)
              (\ c ->
                xml_take
                  (xml_do "rules"
                    (xml_take (crule xml2name "rule")
                      (\ aa ->
                        xml_take (crule xml2name "rule")
                          (\ ba -> xml_return (aa, ba)))))
                  (\ d ->
                    xml_take (xml2const_map xml2name)
                      (\ e ->
                        xml_return
                          ((case a of {
                             (t, (u, v)) ->
                               (\ ps qs (r, ra) m ->
                                 UnfeasibleOverlap (orig_term m t)
                                   (orig_term m u) (orig_term m v)
                                   (map (orig_cstep m) ps)
                                   (map (orig_cstep m) qs) r ra);
                           })
                             b
                             c
                             d
                            e)))))));

xml2unfeasible_ccps ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        [([Char] -> Term (Lab a b) [Char],
                           Unfeasible_proof (Lab a b) [Char])];
xml2unfeasible_ccps xml2name =
  xml_do "unfeasibleCCPs"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "unfeasibleCCP"
        (xml_take (substa xml2name)
          (\ a ->
            xml_take (xml2unfeasible_proof xml2name)
              (\ b -> xml_return (subst_of a, b)))))
      (\ a -> xml_return (id a)));

xml2conditional_cr_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Conditional_cr_proof a b [Char]);
xml2conditional_cr_proof xml2name x =
  xml_do "conditionalCrProof"
    (xml_take
      (xml_or
        (xml_do "unconditional"
          (xml_take (xml2cr_proof xml2name)
            (\ xa -> xml_return (Unconditional_CR xa))))
        (xml_or
          (xml_do "unraveling"
            (xml_take (unraveling_info xml2name)
              (\ a ->
                xml_take (xml2cr_proof xml2name)
                  (\ b -> xml_return (Unravel_CR a b)))))
          (xml_or
            (xml_do "inlineConditions"
              (xml_take
                (xml_do "rules"
                  (xml_take_many_sub [] zero_nat Infinity_enat
                    (crule xml2name "rule") xml_return))
                (\ a ->
                  xml_take (xml2inline_cond_info xml2name)
                    (\ b ->
                      xml_take (xml2conditional_cr_proof xml2name)
                        (\ c ->
                          xml_return
                            ((Transformation_CR . Inline_Conditions_CCRT a) b
                              c))))))
            (xml_or
              (xml_do "infeasibleRuleRemoval"
                (xml_take (xml2infeasible_rules_info xml2name)
                  (\ a ->
                    xml_take (xml2conditional_cr_proof xml2name)
                      (\ b ->
                        xml_return
                          ((Transformation_CR . Infeasible_Rule_Removal_CCRT) a
                            b)))))
              (xml_or (xml_leaf "almostOrthogonal" Almost_Orthogonal_CR)
                (xml_or
                  (xml_do "almostOrthogonalModuloInfeasibility"
                    (xml_take (xml2ao_infeasible_conds xml2name)
                      (\ xa ->
                        xml_return
                          (Almost_Orthogonal_Modulo_Infeasibility_CRa xa))))
                  (xml_do "al94"
                    (xml_take (xml2quasi_reductive_proof xml2name)
                      (\ a ->
                        xml_take (xml2context_joinable_ccps xml2name)
                          (\ b ->
                            xml_take (xml2infeasible_conds xml2name)
                              (\ c ->
                                xml_take (xml2unfeasible_ccps xml2name)
                                  (\ d ->
                                    xml_return (AL94_CR a b c d)))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2ac_dp_termination_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Ac_dp_termination_proof (Lab a b) [Char]);
xml2ac_dp_termination_proof xml2name x =
  xml_do "acDPTerminationProof"
    (xml_take
      (xml_or
        (xml_do "acRedPairProc"
          (xml_take (ordering_constraint_proof xml2name False)
            (\ a ->
              xml_take
                (xml_do "dps"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ b ->
                  xml_take
                    (xml_do "usableRules"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ c ->
                      xml_take (xml2ac_dp_termination_proof xml2name)
                        (\ d -> xml_return (AC_Redpair_UR_Proc a b c d)))))))
        (xml_or
          (xml_do "acSubtermProc"
            (xml_take (multiset_af xml2name)
              (\ a ->
                xml_take
                  (xml_do "dps"
                    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                  (\ b ->
                    xml_take (xml2ac_dp_termination_proof xml2name)
                      (\ c -> xml_return (AC_Subterm_Proc a b c))))))
          (xml_or (xml_leaf "acTrivialProc" AC_P_is_Empty)
            (xml_or
              (xml_do "acMonoRedPairProc"
                (xml_take (ordering_constraint_proof xml2name False)
                  (\ a ->
                    xml_take
                      (xml_do "dps"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ b ->
                        xml_take
                          (xml_do "trs"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ c ->
                            xml_take
                              (xml_do "usableRules"
                                (xml_take (rules xml2name)
                                  (\ xa -> xml_return (id xa))))
                              (\ d ->
                                xml_take (xml2ac_dp_termination_proof xml2name)
                                  (\ e ->
                                    xml_return
                                      (AC_Mono_Redpair_UR_Proc a b c d e))))))))
              (xml_do "acDepGraphProc"
                (xml_take_many_sub [] zero_nat Infinity_enat
                  (xml_do "component"
                    (xml_take
                      (xml_do "dps"
                        (xml_take (rules xml2name)
                          (\ xa -> xml_return (id xa))))
                      (\ dps ->
                        xml_take_optional (xml_bool "realScc")
                          (\ _ ->
                            xml_take_optional
                              (xml2ac_dp_termination_proof xml2name)
                              (\ prfOpt -> xml_return (prfOpt, dps))))))
                  (\ ret -> xml_return (AC_Dep_Graph_Proc ret))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2ac_termination_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Ac_termination_proof a b [Char]);
xml2ac_termination_proof xml2name x =
  xml_do "acTerminationProof"
    (xml_take
      (xml_or
        (xml_do "acDependencyPairs"
          (xml_take
            (xml_do "equations"
              (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
            (\ e ->
              xml_take
                (xml_do "dpEquations"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ dpe ->
                  xml_take
                    (xml_do "dps"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ dp ->
                      xml_take
                        (xml_do "extensions"
                          (xml_take (rules xml2name)
                            (\ xa -> xml_return (id xa))))
                        (\ rext ->
                          xml_take (xml2ac_dp_termination_proof xml2name)
                            (\ p1 ->
                              xml_take_optional
                                (xml2ac_dp_termination_proof xml2name)
                                (\ a ->
                                  (case a of {
                                    Nothing ->
                                      xml_return
(AC_DP_Trans_Single (AC_dependency_pairs_proof e dp dpe rext) p1);
                                    Just p2 ->
                                      xml_return
(AC_DP_Trans (AC_dependency_pairs_proof e dp dpe rext) p1 p2);
                                  })))))))))
        (xml_or
          (xml_do "acRuleRemoval"
            (xml_take (ordering_constraint_proof xml2name False)
              (\ a ->
                xml_take
                  (xml_do "trs"
                    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                  (\ b ->
                    xml_take (xml2ac_termination_proof xml2name)
                      (\ c -> xml_return (AC_Rule_Removal a b c))))))
          (xml_leaf "acRIsEmpty" AC_R_is_Empty)))
      (\ xa -> xml_return (id xa)))
    x;

subsumption_proof ::
  forall a.
    (Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                   Sum_bot (Xml_error String) a) ->
                   (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                     Sum_bot (Xml_error String)
                       [((Term a [Char], Term a [Char]),
                          [([Nat],
                             ((Term a [Char], Term a [Char]),
                               (Bool, Term a [Char])))])];
subsumption_proof xml2name =
  xml_do "subsumptionProof"
    (xml_take_many_sub [] zero_nat Infinity_enat
      (xml_do "ruleSubsumptionProof"
        (xml_take (rule xml2name)
          (\ r ->
            xml_take (conversion xml2name) (\ (_, e) -> xml_return (r, e)))))
      xml_return);

xml2completion_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Completion_proof a b [Char]);
xml2completion_proof xml2name =
  xml_do "completionProof"
    (xml_take (wcr_proof xml2name)
      (\ w ->
        xml_take (xml2trs_termination_proof xml2name)
          (\ t ->
            xml_take
              (xml_do "equivalenceProof"
                (xml_take (subsumption_proof xml2name)
                  (\ s1 ->
                    xml_take_optional (subsumption_proof xml2name)
                      (\ s2 -> xml_return (s1, s2)))))
              (\ (s1, s2) -> xml_return (SN_WCR_Eq w t s1 s2)))));

xml2equational_disproof ::
  forall a.
    (Compare_order a, Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a [Nat])) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Equational_disproof a [Nat] [Char]);
xml2equational_disproof xml2name =
  xml_do "equationalDisproof"
    (xml_take
      (xml_or
        (xml_do "completionAndNormalization"
          (xml_take
            (xml_do "trs"
              (xml_take (rules xml2name) (\ x -> xml_return (id x))))
            (\ a ->
              xml_take (xml2completion_proof xml2name)
                (\ b ->
                  xml_return (Completion_and_Normalization_Different a b)))))
        (xml_do "convertibleInstance"
          (xml_take (subsumption_proof xml2name)
            (\ x -> xml_return (Convertible_Instance x)))))
      (\ x -> xml_return (id x)));

xml2unknown_disproof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Neg_unknown_proof a b [Char]);
xml2unknown_disproof xml2name x =
  xml_do "unknownInputProof"
    (xml_take
      (xml_or
        (xml_do "unknownAssumption"
          (xml_take xml2unknown_input
            (\ xa -> xml_return (Assume_NT_Unknown xa []))))
        (xml_do "unknownProof"
          (xml_take (xml_text "description")
            (\ _ ->
              xml_take xml2unknown_input
                (\ b ->
                  xml_take_many_sub [] zero_nat Infinity_enat
                    (\ xa -> right (fst xa))
                    (\ _ -> xml_return (Assume_NT_Unknown b [])))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2equational_proof ::
  forall a.
    (Compare_order a, Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a [Nat])) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        (Equational_proof a [Nat] [Char]);
xml2equational_proof xml2name =
  xml_do "equationalProof"
    (xml_take
      (xml_or
        (xml_do "equationalProofTree"
          (xml_take (xml2eq_proof xml2name)
            (\ x -> xml_return (Equational_Proof_Tree x))))
        (xml_or
          (xml_change (conversion xml2name)
            (\ (_, e) -> xml_return (Conversion e)))
          (xml_or
            (xml_change (subsumption_proof xml2name)
              (xml_return . Conversion_With_History))
            (xml_do "completionAndNormalization"
              (xml_take
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ x -> xml_return (id x))))
                (\ a ->
                  xml_take (xml2completion_proof xml2name)
                    (\ b -> xml_return (Completion_and_Normalization a b))))))))
      (\ x -> xml_return (id x)));

xml2complexity_inputa ::
  forall a.
    (Eq a,
      Showl a) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) a) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String)
                        ([Term a [Char]],
                          ([(Term a [Char], Term a [Char])],
                            ([(Term a [Char], Term a [Char])],
                              (Complexity_measure a [Char],
                                Complexity_class))));
xml2complexity_inputa xml2name =
  xml_change (xml2complexity_input xml2name)
    (\ (CPX_input q s w cm cc) ->
      xml_return (strategy_to_Q q (s ++ w), (s, (w, (cm, cc)))));

xml2complexity_proof ::
  forall a b.
    (Compare_order a, Eq a, Showl a, Compare_order b, Eq b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Complexity_proof a b [Char]);
xml2complexity_proof xml2name x =
  xml_do "complexityProof"
    (xml_take
      (xml_or
        (xml_do "ruleShifting"
          (xml_take (ordering_constraint_proof xml2name True)
            (\ rp ->
              xml_take
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ del ->
                  xml_take_optional
                    (xml_do "usableRules"
                      (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                    (\ ur ->
                      xml_take (xml2complexity_proof xml2name)
                        (\ prf ->
                          xml_return (Rule_Shift_Complexity rp del ur prf)))))))
        (xml_or
          (xml_do "usableRules"
            (xml_take
              (xml_do "nonUsableRules"
                (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
              (\ a ->
                xml_take (xml2complexity_proof xml2name)
                  (\ b -> xml_return (Usable_Rules_Complexity a b)))))
          (xml_or
            (xml_do "split"
              (xml_take
                (xml_do "trs"
                  (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                (\ a ->
                  xml_take (xml2complexity_proof xml2name)
                    (\ b ->
                      xml_take (xml2complexity_proof xml2name)
                        (\ c -> xml_return (Split_Complexity a b c))))))
            (xml_or
              (xml_do "removeNonApplicableRules"
                (xml_take
                  (xml_do "trs"
                    (xml_take (rules xml2name) (\ xa -> xml_return (id xa))))
                  (\ a ->
                    xml_take (xml2complexity_proof xml2name)
                      (\ b ->
                        xml_return
                          (Remove_Nonapplicable_Rules_Complexity a b)))))
              (xml_or
                (xml_change (bounds_info xml2name)
                  (xml_return . Matchbounds_Complexity))
                (xml_or
                  (xml_do "relativeBounds"
                    (xml_take (bounds_info xml2name)
                      (\ a ->
                        xml_take
                          (xml_do "trs"
                            (xml_take (rules xml2name)
                              (\ xa -> xml_return (id xa))))
                          (\ b ->
                            xml_take (xml2complexity_proof xml2name)
                              (\ c ->
                                xml_return
                                  (Matchbounds_Rel_Complexity a b c))))))
                  (xml_or (xml_leaf "rIsEmpty" RisEmpty_Complexity)
                    (xml_or
                      (xml_do "dtTransformation"
                        (xml_take (rule_pairs xml2name "strictDTs" "ruleWithDT")
                          (\ a ->
                            xml_take
                              (rule_pairs xml2name "weakDTs" "ruleWithDT")
                              (\ b ->
                                xml_take (innermostLhss xml2name)
                                  (\ c ->
                                    xml_take (xml2complexity_proof xml2name)
                                      (\ d ->
xml_return (DT_Transformation (DT_Transformation_Info a b c) d)))))))
                      (xml_or
                        (xml_do "wdpTransformation"
                          (xml_take (symbols xml2name "compoundSymbols")
                            (\ a ->
                              xml_take
                                (rule_pairs xml2name "strictWDPs" "ruleWithWDP")
                                (\ b ->
                                  xml_take
                                    (rule_pairs xml2name "weakWDPs"
                                      "ruleWithWDP")
                                    (\ c ->
                                      xml_take (innermostLhss xml2name)
(\ d ->
  xml_take (xml2complexity_proof xml2name)
    (\ e ->
      xml_return (WDP_Transformation (WDP_Trans_Info (set a) b c d) e))))))))
                        (xml_or
                          (xml_do "unknownProof"
                            (xml_take (xml_text "description")
                              (\ _ ->
                                xml_take (xml2complexity_inputa xml2name)
                                  (\ b ->
                                    xml_take_many_sub [] zero_nat Infinity_enat
                                      (xml_do "subProof"
(xml_take (xml2complexity_inputa xml2name)
  (\ a ->
    xml_take (xml2complexity_proof xml2name)
      (\ ba -> xml_return (Complexity_assm_proof a ba)))))
                                      (\ c ->
xml_return (Complexity_Assumption b c))))))
                          (xml_do "complexityAssumption"
                            (xml_take (xml2complexity_inputa xml2name)
                              (\ xa ->
                                xml_return
                                  (Complexity_Assumption xa []))))))))))))))
      (\ xa -> xml_return (id xa)))
    x;

xml2unknown_proof ::
  forall a b.
    (Compare_order a, Showl a, Compare_order b,
      Showl b) => ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                    Sum_bot (Xml_error String) (Lab a b)) ->
                    (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
                      Sum_bot (Xml_error String) (Unknown_proof a b [Char]);
xml2unknown_proof xml2name x =
  xml_do "unknownInputProof"
    (xml_take
      (xml_or
        (xml_do "unknownAssumption"
          (xml_take xml2unknown_input
            (\ xa -> xml_return (Assume_Unknown xa []))))
        (xml_do "unknownProof"
          (xml_take (xml_text "description")
            (\ _ ->
              xml_take xml2unknown_input
                (\ b ->
                  xml_take_many_sub [] zero_nat Infinity_enat
                    (\ xa -> right (fst xa))
                    (\ _ -> xml_return (Assume_Unknown b [])))))))
      xml_return)
    x;

xml2cert_problem ::
  ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
    Sum_bot (Xml_error String) [Char]) ->
    ((Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
      Sum_bot (Xml_error String) (Lab [Char] [Nat])) ->
      (Xml, ([([Char], [Char])], (Bool, ([String], [String])))) ->
        Sum_bot (Xml_error String)
          (Maybe (Input (Lab [Char] [Nat]) [Char]), Proof [Char] [Nat] [Char]);
xml2cert_problem xml2uname xml2name =
  xml_do "certificationProblem"
    (xml_take_optional (xml2input xml2name)
      (\ inp ->
        xml_take_optional (xml_text "cpfVersion")
          (\ _ ->
            xml_take
              (xml_do "proof"
                (xml_take
                  (xml_or
                    (xml_change (xml2trs_termination_proof xml2name)
                      (xml_return . TRS_Termination_Proof))
                    (xml_or
                      (xml_change (xml2trs_nontermination_proof xml2name)
                        (xml_return . TRS_Nontermination_Proof))
                      (xml_or
                        (xml_change (xml2reltrs_nontermination_proof xml2name)
                          (xml_return . Relative_TRS_Nontermination_Proof))
                        (xml_or
                          (xml_change (xml2cr_proof xml2name)
                            (xml_return . TRS_Confluence_Proof))
                          (xml_or
                            (xml_change (xml2ncr_proof xml2name)
                              (xml_return . TRS_Non_Confluence_Proof))
                            (xml_or
                              (xml_change (xml2dp_termination_proof xml2name)
                                (xml_return . DP_Termination_Proof))
                              (xml_or
                                (xml_change
                                  (xml2dp_nontermination_proof xml2name)
                                  (xml_return . DP_Nontermination_Proof))
                                (xml_or
                                  (xml_change (xml2completion_proof xml2name)
                                    (xml_return . Completion_Proof))
                                  (xml_or
                                    (xml_change
                                      (xml2ordered_completion_proof xml2name)
                                      (xml_return . Ordered_Completion_Proof))
                                    (xml_or
                                      (xml_change
(xml2equational_proof xml2name) (xml_return . Equational_Proof))
                                      (xml_or
(xml_change (xml2equational_disproof xml2name)
  (xml_return . Equational_Disproof))
(xml_or
  (xml_change (xml2complexity_proof xml2name) (xml_return . Complexity_Proof))
  (xml_or
    (xml_change (xml2quasi_reductive_proof xml2name)
      (xml_return . Quasi_Reductive_Proof))
    (xml_or
      (xml_change (xml2conditional_cr_proof xml2name)
        (xml_return . Conditional_CR_Proof))
      (xml_or
        (xml_change (xml2conditional_ncr_proof xml2name)
          (xml_return . Conditional_Non_CR_Proof))
        (xml_or
          (xml_do "treeAutomatonClosedProof"
            (xml_take closed_criterion
              (\ x -> xml_return (Tree_Automata_Closed_Proof x))))
          (xml_or
            (xml_change (xml2ac_termination_proof xml2name)
              (xml_return . AC_Termination_Proof))
            (xml_or
              (xml_do "ltsTerminationProof"
                (xml_take lts_termination_proof_parser
                  (\ x -> xml_return (LTS_Termination_Proof x))))
              (xml_or
                (xml_do "ltsSafetyProof"
                  (xml_take lts_safety_proof_parser
                    (\ x -> xml_return (LTS_Safety_Proof x))))
                (xml_or
                  (xml_change (xml2unknown_proof xml2name)
                    (xml_return . Unknown_Proof))
                  (xml_change (xml2unknown_disproof xml2name)
                    (xml_return . Unknown_Disproof))))))))))))))))))))))
                  xml_return))
              (\ p ->
                xml_take_optional (\ x -> right (fst x))
                  (\ _ -> xml_return (inp, p))))));

showsl_literal :: String -> String -> String;
showsl_literal s = showsl_lit s;

parse_cert_problem ::
  [Char] ->
    Sum_bot [Char]
      (Maybe (Input (Lab [Char] [Nat]) [Char]), Proof [Char] [Nat] [Char]);
parse_cert_problem =
  parse_xmlfile
    (debug (showsl_literal "0") "parsing xml to certification problem"
      (xml2cert_problem (xml_text "name") plain_name));

}
